/*
 * ExamplePressMe.java
 *
 * Copyright (c) 2006-2008 Operational Dynamics Consulting Pty Ltd
 *
 * The code in this file, and the library it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" See the LICENCE file for the terms governing usage and
 * redistribution.
 */

import org.gnome.gdk.Event;
import org.gnome.gtk.Button;
import org.gnome.gtk.Gtk;
import org.gnome.gtk.Label;
import org.gnome.gtk.VBox;
import org.gnome.gtk.Widget;
import org.gnome.gtk.Window;

public class ExamplePressMe
{
	public static void main(String[] args) {
		final Window w;
		final VBox x;
		final Label l;
		final Button b;

		/*
		 *          * Initialize GTK. You MUST call this to load the library before
		 *                   * trying to use any other elements provided by java-gnome.
		 *                            */

		Gtk.init(args);

		/*
		 *          * Create a top level Window. It's the Container around which the
		 *                   * window manager draws decorations such as a title bar, minimize and
		 *                            * close buttons, resize edges, etc.
		 *                                     */

		w = new Window();

		/*
		 *          * Since a Window is a Bin, it can only have one child Widget. That's
		 *                   * probably not very useful in most cases. To take that one slot and
		 *                            * turn it into many, we use a VBox, a Container that will stack its
		 *                                     * children vertically.
		 *                                              */

		x = new VBox(false, 3);

		/*
		 *          * Create a Label with some text describing the Button that will
		 *                   * follow, then add it to the VBox.
		 *                            */

		l = new Label("Go ahead:\nMake my day");
		x.add(l);

		/*
		 *          * Create our Button, with a nice explicit bit of text labelling it
		 *                   * and what you're to do.
		 *                            */

		b = new Button("Press me!");
		x.add(b);

		b.connect(new Button.Clicked() {
				public void onClicked(Button source) {
				System.out.println("I was clicked: " + b.getLabel());
				}
				});


		b.emitClicked();
		w.add(x);
		w.setTitle("Hello World");
		w.showAll();

		w.connect(new Window.DeleteEvent() {
				public boolean onDeleteEvent(Widget source, Event event) {
				Gtk.mainQuit();
				return false;
				}
				});

		Gtk.main();
	}
}
