/*
 * CairoFontOptions.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.freedesktop.cairo;

import org.freedesktop.cairo.FontOptions;
import org.freedesktop.cairo.HintMetrics;
import org.freedesktop.cairo.Plumbing;
import org.freedesktop.cairo.Status;

final class CairoFontOptions extends Plumbing
{
    private CairoFontOptions() {}

    static final long createFontOptions() {
        long result;

        synchronized (lock) {
            result = cairo_font_options_create();

            return result;
        }
    }

    private static native final long cairo_font_options_create();

    static final void destroy(FontOptions self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            cairo_font_options_destroy(pointerOf(self));
        }
    }

    private static native final void cairo_font_options_destroy(long self);

    static final Status status(FontOptions self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = cairo_font_options_status(pointerOf(self));

            return (Status) enumFor(Status.class, result);
        }
    }

    private static native final int cairo_font_options_status(long self);

    static final void setHintMetrics(FontOptions self, HintMetrics hintMetrics) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hintMetrics == null) {
            throw new IllegalArgumentException("hintMetrics can't be null");
        }

        synchronized (lock) {
            cairo_font_options_set_hint_metrics(pointerOf(self), numOf(hintMetrics));
        }
    }

    private static native final void cairo_font_options_set_hint_metrics(long self, int hintMetrics);
}

