/*
 * CairoMatrix.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.freedesktop.cairo;

import org.freedesktop.cairo.Matrix;
import org.freedesktop.cairo.Plumbing;

final class CairoMatrix extends Plumbing
{
    private CairoMatrix() {}

    static final void rotate(Matrix self, double angle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            cairo_matrix_rotate(pointerOf(self), angle);
        }
    }

    private static native final void cairo_matrix_rotate(long self, double angle);

    static final void translate(Matrix self, double tx, double ty) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            cairo_matrix_translate(pointerOf(self), tx, ty);
        }
    }

    private static native final void cairo_matrix_translate(long self, double tx, double ty);

    static final void scale(Matrix self, double sx, double sy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            cairo_matrix_scale(pointerOf(self), sx, sy);
        }
    }

    private static native final void cairo_matrix_scale(long self, double sx, double sy);
}

