/*
 * AtkHyperlinkImpl.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.Hyperlink;
import org.gnome.atk.HyperlinkImpl;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;

final class AtkHyperlinkImpl extends Plumbing
{
    private AtkHyperlinkImpl() {}

    static final Hyperlink getHyperlink(HyperlinkImpl self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_impl_get_hyperlink(pointerOf((Object) self));

            return (Hyperlink) objectFor(result);
        }
    }

    private static native final long atk_hyperlink_impl_get_hyperlink(long self);

    interface GetHyperlinkSignal extends Signal
    {
        Hyperlink onGetHyperlink(HyperlinkImpl source);
    }

    static final void connect(HyperlinkImpl self, AtkHyperlinkImpl.GetHyperlinkSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkHyperlinkImpl.class, "get-hyperlink", after);
    }

    protected static final long receiveGetHyperlink(Signal handler, long source) {
        Hyperlink result;

        result = ((AtkHyperlinkImpl.GetHyperlinkSignal) handler).onGetHyperlink((HyperlinkImpl) objectFor(source));

        return pointerOf(result);
    }
}

