/*
 * AtkStreamableContent.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.Plumbing;
import org.gnome.atk.StreamableContent;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;

final class AtkStreamableContent extends Plumbing
{
    private AtkStreamableContent() {}

    static final int getNMimeTypes(StreamableContent self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_streamable_content_get_n_mime_types(pointerOf((Object) self));

            return result;
        }
    }

    private static native final int atk_streamable_content_get_n_mime_types(long self);

    static final String getMimeType(StreamableContent self, int i) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_streamable_content_get_mime_type(pointerOf((Object) self), i);

            return result;
        }
    }

    private static native final String atk_streamable_content_get_mime_type(long self, int i);

    static final FIXME getStream(StreamableContent self, String mimeType) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GIOChannel*");
    }

    static final String getUri(StreamableContent self, String mimeType) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mimeType == null) {
            throw new IllegalArgumentException("mimeType can't be null");
        }

        synchronized (lock) {
            result = atk_streamable_content_get_uri(pointerOf((Object) self), mimeType);

            return result;
        }
    }

    private static native final String atk_streamable_content_get_uri(long self, String mimeType);

    interface GetNMimeTypesSignal extends Signal
    {
        int onGetNMimeTypes(StreamableContent source);
    }

    static final void connect(StreamableContent self, AtkStreamableContent.GetNMimeTypesSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkStreamableContent.class, "get-n-mime-types", after);
    }

    protected static final int receiveGetNMimeTypes(Signal handler, long source) {
        int result;

        result = ((AtkStreamableContent.GetNMimeTypesSignal) handler).onGetNMimeTypes((StreamableContent) objectFor(source));

        return result;
    }

    interface GetMimeTypeSignal extends Signal
    {
        String onGetMimeType(StreamableContent source, int i);
    }

    static final void connect(StreamableContent self, AtkStreamableContent.GetMimeTypeSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkStreamableContent.class, "get-mime-type", after);
    }

    protected static final String receiveGetMimeType(Signal handler, long source, int i) {
        String result;

        result = ((AtkStreamableContent.GetMimeTypeSignal) handler).onGetMimeType((StreamableContent) objectFor(source), i);

        return result;
    }

    interface GetStreamSignal extends Signal
    {
        FIXME onGetStream(StreamableContent source, String mimeType);
    }

    static final void connect(StreamableContent self, AtkStreamableContent.GetStreamSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkStreamableContent.class, "get-stream", after);
    }

    protected static final java.lang.Object receiveGetStream(Signal handler, long source, String mimeType) {
        FIXME result;

        result = ((AtkStreamableContent.GetStreamSignal) handler).onGetStream((StreamableContent) objectFor(source), mimeType);

        return result;
    }

    interface GetUriSignal extends Signal
    {
        FIXME onGetUri(StreamableContent source, String mimeType);
    }

    static final void connect(StreamableContent self, AtkStreamableContent.GetUriSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkStreamableContent.class, "get-uri", after);
    }

    protected static final java.lang.Object receiveGetUri(Signal handler, long source, String mimeType) {
        FIXME result;

        result = ((AtkStreamableContent.GetUriSignal) handler).onGetUri((StreamableContent) objectFor(source), mimeType);

        return result;
    }
}

