/*
 * GdkColormap.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Color;
import org.gnome.gdk.Colormap;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Screen;
import org.gnome.gdk.Visual;

final class GdkColormap extends Plumbing
{
    private GdkColormap() {}

    static final int allocColors(Colormap self, Color colors, int ncolors, boolean writeable, boolean bestMatch, boolean[] success) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colors == null) {
            throw new IllegalArgumentException("colors can't be null");
        }

        if (success == null) {
            throw new IllegalArgumentException("success can't be null");
        }

        synchronized (lock) {
            result = gdk_colormap_alloc_colors(pointerOf(self), pointerOf(colors), ncolors, writeable, bestMatch, success);

            return result;
        }
    }

    private static native final int gdk_colormap_alloc_colors(long self, long colors, int ncolors, boolean writeable, boolean bestMatch, boolean[] success);

    static final void freeColors(Colormap self, Color colors, int ncolors) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colors == null) {
            throw new IllegalArgumentException("colors can't be null");
        }

        synchronized (lock) {
            gdk_colormap_free_colors(pointerOf(self), pointerOf(colors), ncolors);
        }
    }

    private static native final void gdk_colormap_free_colors(long self, long colors, int ncolors);

    static final long createColormap(Visual visual, boolean allocate) {
        long result;

        if (visual == null) {
            throw new IllegalArgumentException("visual can't be null");
        }

        synchronized (lock) {
            result = gdk_colormap_new(pointerOf(visual), allocate);

            return result;
        }
    }

    private static native final long gdk_colormap_new(long visual, boolean allocate);

    static final boolean allocColor(Colormap self, Color color, boolean writeable, boolean bestMatch) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            result = gdk_colormap_alloc_color(pointerOf(self), pointerOf(color), writeable, bestMatch);

            return result;
        }
    }

    private static native final boolean gdk_colormap_alloc_color(long self, long color, boolean writeable, boolean bestMatch);

    static final void queryColor(Colormap self, long pixel, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gdk_colormap_query_color(pointerOf(self), pixel, pointerOf(color));
        }
    }

    private static native final void gdk_colormap_query_color(long self, long pixel, long color);

    static final Visual getVisual(Colormap self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_colormap_get_visual(pointerOf(self));

            return (Visual) objectFor(result);
        }
    }

    private static native final long gdk_colormap_get_visual(long self);

    static final Screen getScreen(Colormap self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_colormap_get_screen(pointerOf(self));

            return (Screen) objectFor(result);
        }
    }

    private static native final long gdk_colormap_get_screen(long self);
}

