/*
 * GdkDisplay.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Device;
import org.gnome.gdk.Display;
import org.gnome.gdk.Event;
import org.gnome.gdk.ModifierType;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Screen;
import org.gnome.gdk.Window;
import org.gnome.glib.Signal;

final class GdkDisplay extends Plumbing
{
    private GdkDisplay() {}

    static final long createDisplayplayOpen(String displayName) {
        long result;

        synchronized (lock) {
            result = gdk_display_open(displayName);

            return result;
        }
    }

    private static native final long gdk_display_open(String displayName);

    static final String getName(Display self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gdk_display_get_name(long self);

    static final int getNScreens(Display self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_n_screens(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_display_get_n_screens(long self);

    static final Screen getScreen(Display self, int screenNum) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_screen(pointerOf(self), screenNum);

            return (Screen) objectFor(result);
        }
    }

    private static native final long gdk_display_get_screen(long self, int screenNum);

    static final Screen getDefaultScreen(Display self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_default_screen(pointerOf(self));

            return (Screen) objectFor(result);
        }
    }

    private static native final long gdk_display_get_default_screen(long self);

    static final void pointerUngrab(Display self, int time) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_pointer_ungrab(pointerOf(self), time);
        }
    }

    private static native final void gdk_display_pointer_ungrab(long self, int time);

    static final void keyboardUngrab(Display self, int time) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_keyboard_ungrab(pointerOf(self), time);
        }
    }

    private static native final void gdk_display_keyboard_ungrab(long self, int time);

    static final boolean pointerIsGrabbed(Display self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_pointer_is_grabbed(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_display_pointer_is_grabbed(long self);

    static final void beep(Display self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_beep(pointerOf(self));
        }
    }

    private static native final void gdk_display_beep(long self);

    static final void sync(Display self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_sync(pointerOf(self));
        }
    }

    private static native final void gdk_display_sync(long self);

    static final void close(Display self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_close(pointerOf(self));
        }
    }

    private static native final void gdk_display_close(long self);

    static final FIXME listDevices(Display self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList*");
    }

    static final Event getEvent(Display self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_event(pointerOf(self));

            return (Event) boxedFor(Event.class, result);
        }
    }

    private static native final long gdk_display_get_event(long self);

    static final Event peekEvent(Display self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_peek_event(pointerOf(self));

            return (Event) boxedFor(Event.class, result);
        }
    }

    private static native final long gdk_display_peek_event(long self);

    static final void putEvent(Display self, Event event) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            gdk_display_put_event(pointerOf(self), pointerOf(event));
        }
    }

    private static native final void gdk_display_put_event(long self, long event);

    static final void addClientMessageFilter(Display self, FIXME messageType, FIXME func, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void setDoubleClickTime(Display self, int msec) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_set_double_click_time(pointerOf(self), msec);
        }
    }

    private static native final void gdk_display_set_double_click_time(long self, int msec);

    static final Device getCorePointer(Display self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_core_pointer(pointerOf(self));

            return (Device) objectFor(result);
        }
    }

    private static native final long gdk_display_get_core_pointer(long self);

    static final void getPointer(Display self, Screen[] screen, int[] x, int[] y, ModifierType[] mask) {
        long[] _screen;
        int[] _mask;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (screen == null) {
            throw new IllegalArgumentException("screen can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        _screen = pointersOf(screen);

        _mask = numsOf(mask);

        synchronized (lock) {
            gdk_display_get_pointer(pointerOf(self), _screen, x, y, _mask);
            fillObjectArray(screen, _screen);
            fillFlagArray(ModifierType.class, mask, _mask);
        }
    }

    private static native final void gdk_display_get_pointer(long self, long[] screen, int[] x, int[] y, int[] mask);

    static final Window getWindowAtPointer(Display self, int[] winX, int[] winY) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (winX == null) {
            throw new IllegalArgumentException("winX can't be null");
        }

        if (winY == null) {
            throw new IllegalArgumentException("winY can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_window_at_pointer(pointerOf(self), winX, winY);

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_display_get_window_at_pointer(long self, int[] winX, int[] winY);

    static final FIXME setPointerHooks(Display self, FIXME newHooks) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkDisplayPointerHooks*");
    }

    static final void storeClipboard(Display self, Window clipboardWindow, int time, FIXME targets, int nTargets) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom*");
    }

    static final boolean supportsSelectionNotification(Display self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_supports_selection_notification(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_display_supports_selection_notification(long self);

    static final boolean requestSelectionNotification(Display self, FIXME selection) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final boolean supportsClipboardPersistence(Display self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_supports_clipboard_persistence(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_display_supports_clipboard_persistence(long self);

    static final void flush(Display self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_flush(pointerOf(self));
        }
    }

    private static native final void gdk_display_flush(long self);

    static final void setDoubleClickDistance(Display self, int distance) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_display_set_double_click_distance(pointerOf(self), distance);
        }
    }

    private static native final void gdk_display_set_double_click_distance(long self, int distance);

    static final boolean supportsCursorAlpha(Display self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_supports_cursor_alpha(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_display_supports_cursor_alpha(long self);

    static final boolean supportsCursorColor(Display self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_supports_cursor_color(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_display_supports_cursor_color(long self);

    static final int getDefaultCursorSize(Display self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_default_cursor_size(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_display_get_default_cursor_size(long self);

    static final void getMaximalCursorSize(Display self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gdk_display_get_maximal_cursor_size(pointerOf(self), width, height);
        }
    }

    private static native final void gdk_display_get_maximal_cursor_size(long self, int[] width, int[] height);

    static final Window getDefaultGroup(Display self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_get_default_group(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_display_get_default_group(long self);

    static final void warpPointer(Display self, Screen screen, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (screen == null) {
            throw new IllegalArgumentException("screen can't be null");
        }

        synchronized (lock) {
            gdk_display_warp_pointer(pointerOf(self), pointerOf(screen), x, y);
        }
    }

    private static native final void gdk_display_warp_pointer(long self, long screen, int x, int y);

    interface GetDisplayNameSignal extends Signal
    {
        String onGetDisplayName(Display source);
    }

    static final void connect(Display self, GdkDisplay.GetDisplayNameSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkDisplay.class, "get-display-name", after);
    }

    protected static final String receiveGetDisplayName(Signal handler, long source) {
        String result;

        result = ((GdkDisplay.GetDisplayNameSignal) handler).onGetDisplayName((Display) objectFor(source));

        return result;
    }

    interface GetNScreensSignal extends Signal
    {
        int onGetNScreens(Display source);
    }

    static final void connect(Display self, GdkDisplay.GetNScreensSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkDisplay.class, "get-n-screens", after);
    }

    protected static final int receiveGetNScreens(Signal handler, long source) {
        int result;

        result = ((GdkDisplay.GetNScreensSignal) handler).onGetNScreens((Display) objectFor(source));

        return result;
    }

    interface GetScreenSignal extends Signal
    {
        Screen onGetScreen(Display source, int screenNum);
    }

    static final void connect(Display self, GdkDisplay.GetScreenSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkDisplay.class, "get-screen", after);
    }

    protected static final long receiveGetScreen(Signal handler, long source, int screenNum) {
        Screen result;

        result = ((GdkDisplay.GetScreenSignal) handler).onGetScreen((Display) objectFor(source), screenNum);

        return pointerOf(result);
    }

    interface GetDefaultScreenSignal extends Signal
    {
        Screen onGetDefaultScreen(Display source);
    }

    static final void connect(Display self, GdkDisplay.GetDefaultScreenSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkDisplay.class, "get-default-screen", after);
    }

    protected static final long receiveGetDefaultScreen(Signal handler, long source) {
        Screen result;

        result = ((GdkDisplay.GetDefaultScreenSignal) handler).onGetDefaultScreen((Display) objectFor(source));

        return pointerOf(result);
    }

    interface ClosedSignal extends Signal
    {
        void onClosed(Display source, boolean isError);
    }

    static final void connect(Display self, GdkDisplay.ClosedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkDisplay.class, "closed", after);
    }

    protected static final void receiveClosed(Signal handler, long source, boolean isError) {
        ((GdkDisplay.ClosedSignal) handler).onClosed((Display) objectFor(source), isError);
    }

    static final boolean supportsShapes(Display self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_supports_shapes(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_display_supports_shapes(long self);

    static final boolean supportsInputShapes(Display self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_supports_input_shapes(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_display_supports_input_shapes(long self);
}

