/*
 * GdkEventButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Device;
import org.gnome.gdk.EventType;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Window;

final class GdkEventButton extends Plumbing
{
    private GdkEventButton() {}

    static final EventType getType(EventButton self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_type(pointerOf(self));

            return (EventType) enumFor(EventType.class, result);
        }
    }

    private static native final int gdk_event_button_get_type(long self);

    static final void setType(EventButton self, EventType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gdk_event_button_set_type(long self, int type);

    static final Window getWindow(EventButton self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_event_button_get_window(long self);

    static final void setWindow(EventButton self, Window window) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_window(pointerOf(self), pointerOf(window));
        }
    }

    private static native final void gdk_event_button_set_window(long self, long window);

    static final byte getSendEvent(EventButton self) {
        byte result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_send_event(pointerOf(self));

            return result;
        }
    }

    private static native final byte gdk_event_button_get_send_event(long self);

    static final void setSendEvent(EventButton self, byte sendEvent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_send_event(pointerOf(self), sendEvent);
        }
    }

    private static native final void gdk_event_button_set_send_event(long self, byte sendEvent);

    static final int getTime(EventButton self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_time(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_button_get_time(long self);

    static final void setTime(EventButton self, int time) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_time(pointerOf(self), time);
        }
    }

    private static native final void gdk_event_button_set_time(long self, int time);

    static final double getX(EventButton self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_x(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_event_button_get_x(long self);

    static final void setX(EventButton self, double x) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_x(pointerOf(self), x);
        }
    }

    private static native final void gdk_event_button_set_x(long self, double x);

    static final double getY(EventButton self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_y(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_event_button_get_y(long self);

    static final void setY(EventButton self, double y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_y(pointerOf(self), y);
        }
    }

    private static native final void gdk_event_button_set_y(long self, double y);

    static final double[] getAxes(EventButton self) {
        double[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_axes(pointerOf(self));

            return result;
        }
    }

    private static native final double[] gdk_event_button_get_axes(long self);

    static final void setAxes(EventButton self, double[] axes) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (axes == null) {
            throw new IllegalArgumentException("axes can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_axes(pointerOf(self), axes);
        }
    }

    private static native final void gdk_event_button_set_axes(long self, double[] axes);

    static final int getState(EventButton self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_state(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_button_get_state(long self);

    static final void setState(EventButton self, int state) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_state(pointerOf(self), state);
        }
    }

    private static native final void gdk_event_button_set_state(long self, int state);

    static final int getButton(EventButton self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_button(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_button_get_button(long self);

    static final void setButton(EventButton self, int button) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_button(pointerOf(self), button);
        }
    }

    private static native final void gdk_event_button_set_button(long self, int button);

    static final Device getDevice(EventButton self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_device(pointerOf(self));

            return (Device) objectFor(result);
        }
    }

    private static native final long gdk_event_button_get_device(long self);

    static final void setDevice(EventButton self, Device device) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (device == null) {
            throw new IllegalArgumentException("device can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_device(pointerOf(self), pointerOf(device));
        }
    }

    private static native final void gdk_event_button_set_device(long self, long device);

    static final double getXRoot(EventButton self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_x_root(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_event_button_get_x_root(long self);

    static final void setXRoot(EventButton self, double xRoot) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_x_root(pointerOf(self), xRoot);
        }
    }

    private static native final void gdk_event_button_set_x_root(long self, double xRoot);

    static final double getYRoot(EventButton self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_button_get_y_root(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_event_button_get_y_root(long self);

    static final void setYRoot(EventButton self, double yRoot) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_button_set_y_root(pointerOf(self), yRoot);
        }
    }

    private static native final void gdk_event_button_set_y_root(long self, double yRoot);
}

