/*
 * GdkEventConfigure.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.EventType;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Window;

final class GdkEventConfigure extends Plumbing
{
    private GdkEventConfigure() {}

    static final EventType getType(EventConfigure self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_configure_get_type(pointerOf(self));

            return (EventType) enumFor(EventType.class, result);
        }
    }

    private static native final int gdk_event_configure_get_type(long self);

    static final void setType(EventConfigure self, EventType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gdk_event_configure_set_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gdk_event_configure_set_type(long self, int type);

    static final Window getWindow(EventConfigure self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_configure_get_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_event_configure_get_window(long self);

    static final void setWindow(EventConfigure self, Window window) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            gdk_event_configure_set_window(pointerOf(self), pointerOf(window));
        }
    }

    private static native final void gdk_event_configure_set_window(long self, long window);

    static final byte getSendEvent(EventConfigure self) {
        byte result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_configure_get_send_event(pointerOf(self));

            return result;
        }
    }

    private static native final byte gdk_event_configure_get_send_event(long self);

    static final void setSendEvent(EventConfigure self, byte sendEvent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_configure_set_send_event(pointerOf(self), sendEvent);
        }
    }

    private static native final void gdk_event_configure_set_send_event(long self, byte sendEvent);

    static final int getX(EventConfigure self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_configure_get_x(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_configure_get_x(long self);

    static final void setX(EventConfigure self, int x) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_configure_set_x(pointerOf(self), x);
        }
    }

    private static native final void gdk_event_configure_set_x(long self, int x);

    static final int getY(EventConfigure self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_configure_get_y(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_configure_get_y(long self);

    static final void setY(EventConfigure self, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_configure_set_y(pointerOf(self), y);
        }
    }

    private static native final void gdk_event_configure_set_y(long self, int y);

    static final int getWidth(EventConfigure self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_configure_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_configure_get_width(long self);

    static final void setWidth(EventConfigure self, int width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_configure_set_width(pointerOf(self), width);
        }
    }

    private static native final void gdk_event_configure_set_width(long self, int width);

    static final int getHeight(EventConfigure self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_configure_get_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_configure_get_height(long self);

    static final void setHeight(EventConfigure self, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_configure_set_height(pointerOf(self), height);
        }
    }

    private static native final void gdk_event_configure_set_height(long self, int height);
}

