/*
 * GdkEventOwnerChange.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.EventType;
import org.gnome.gdk.OwnerChange;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Window;

final class GdkEventOwnerChange extends Plumbing
{
    private GdkEventOwnerChange() {}

    static final EventType getType(EventOwnerChange self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_owner_change_get_type(pointerOf(self));

            return (EventType) enumFor(EventType.class, result);
        }
    }

    private static native final int gdk_event_owner_change_get_type(long self);

    static final void setType(EventOwnerChange self, EventType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gdk_event_owner_change_set_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gdk_event_owner_change_set_type(long self, int type);

    static final Window getWindow(EventOwnerChange self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_owner_change_get_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_event_owner_change_get_window(long self);

    static final void setWindow(EventOwnerChange self, Window window) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            gdk_event_owner_change_set_window(pointerOf(self), pointerOf(window));
        }
    }

    private static native final void gdk_event_owner_change_set_window(long self, long window);

    static final byte getSendEvent(EventOwnerChange self) {
        byte result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_owner_change_get_send_event(pointerOf(self));

            return result;
        }
    }

    private static native final byte gdk_event_owner_change_get_send_event(long self);

    static final void setSendEvent(EventOwnerChange self, byte sendEvent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_owner_change_set_send_event(pointerOf(self), sendEvent);
        }
    }

    private static native final void gdk_event_owner_change_set_send_event(long self, byte sendEvent);

    static final FIXME getOwner(EventOwnerChange self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkNativeWidnow");
    }

    static final void setOwner(EventOwnerChange self, FIXME owner) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkNativeWidnow");
    }

    static final OwnerChange getReason(EventOwnerChange self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_owner_change_get_reason(pointerOf(self));

            return (OwnerChange) enumFor(OwnerChange.class, result);
        }
    }

    private static native final int gdk_event_owner_change_get_reason(long self);

    static final void setReason(EventOwnerChange self, OwnerChange reason) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (reason == null) {
            throw new IllegalArgumentException("reason can't be null");
        }

        synchronized (lock) {
            gdk_event_owner_change_set_reason(pointerOf(self), numOf(reason));
        }
    }

    private static native final void gdk_event_owner_change_set_reason(long self, int reason);

    static final FIXME getSelection(EventOwnerChange self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void setSelection(EventOwnerChange self, FIXME selection) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final int getTime(EventOwnerChange self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_owner_change_get_time(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_owner_change_get_time(long self);

    static final void setTime(EventOwnerChange self, int time) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_owner_change_set_time(pointerOf(self), time);
        }
    }

    private static native final void gdk_event_owner_change_set_time(long self, int time);

    static final int getSelectionTime(EventOwnerChange self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_owner_change_get_selection_time(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_owner_change_get_selection_time(long self);

    static final void setSelectionTime(EventOwnerChange self, int selectionTime) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_owner_change_set_selection_time(pointerOf(self), selectionTime);
        }
    }

    private static native final void gdk_event_owner_change_set_selection_time(long self, int selectionTime);
}

