/*
 * GdkKeymapKey.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkKeymapKey extends Plumbing
{
    private GdkKeymapKey() {}

    static final int getKeycode(KeymapKey self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_keymap_key_get_keycode(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_keymap_key_get_keycode(long self);

    static final void setKeycode(KeymapKey self, int keycode) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_keymap_key_set_keycode(pointerOf(self), keycode);
        }
    }

    private static native final void gdk_keymap_key_set_keycode(long self, int keycode);

    static final int getGroup(KeymapKey self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_keymap_key_get_group(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_keymap_key_get_group(long self);

    static final void setGroup(KeymapKey self, int group) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_keymap_key_set_group(pointerOf(self), group);
        }
    }

    private static native final void gdk_keymap_key_set_group(long self, int group);

    static final int getLevel(KeymapKey self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_keymap_key_get_level(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_keymap_key_get_level(long self);

    static final void setLevel(KeymapKey self, int level) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_keymap_key_set_level(pointerOf(self), level);
        }
    }

    private static native final void gdk_keymap_key_set_level(long self, int level);
}

