/*
 * GdkKeyval.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkKeyval extends Plumbing
{
    private GdkKeyval() {}

    static final String name(int keyval) {
        String result;

        synchronized (lock) {
            result = gdk_keyval_name(keyval);

            return result;
        }
    }

    private static native final String gdk_keyval_name(int keyval);

    static final int fromName(String keyvalName) {
        int result;

        if (keyvalName == null) {
            throw new IllegalArgumentException("keyvalName can't be null");
        }

        synchronized (lock) {
            result = gdk_keyval_from_name(keyvalName);

            return result;
        }
    }

    private static native final int gdk_keyval_from_name(String keyvalName);

    static final void convertCase(int symbol, int[] lower, int[] upper) {
        if (lower == null) {
            throw new IllegalArgumentException("lower can't be null");
        }

        if (upper == null) {
            throw new IllegalArgumentException("upper can't be null");
        }

        synchronized (lock) {
            gdk_keyval_convert_case(symbol, lower, upper);
        }
    }

    private static native final void gdk_keyval_convert_case(int symbol, int[] lower, int[] upper);

    static final int toUpper(int keyval) {
        int result;

        synchronized (lock) {
            result = gdk_keyval_to_upper(keyval);

            return result;
        }
    }

    private static native final int gdk_keyval_to_upper(int keyval);

    static final int toLower(int keyval) {
        int result;

        synchronized (lock) {
            result = gdk_keyval_to_lower(keyval);

            return result;
        }
    }

    private static native final int gdk_keyval_to_lower(int keyval);

    static final boolean isUpper(int keyval) {
        boolean result;

        synchronized (lock) {
            result = gdk_keyval_is_upper(keyval);

            return result;
        }
    }

    private static native final boolean gdk_keyval_is_upper(int keyval);

    static final boolean isLower(int keyval) {
        boolean result;

        synchronized (lock) {
            result = gdk_keyval_is_lower(keyval);

            return result;
        }
    }

    private static native final boolean gdk_keyval_is_lower(int keyval);

    static final int toUnicode(int keyval) {
        int result;

        synchronized (lock) {
            result = gdk_keyval_to_unicode(keyval);

            return result;
        }
    }

    private static native final int gdk_keyval_to_unicode(int keyval);

    static final int unicodeToKeyval(int wc) {
        int result;

        synchronized (lock) {
            result = gdk_unicode_to_keyval(wc);

            return result;
        }
    }

    private static native final int gdk_unicode_to_keyval(int wc);
}

