/*
 * GdkPangoRenderer.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Bitmap;
import org.gnome.gdk.Color;
import org.gnome.gdk.Drawable;
import org.gnome.gdk.GC;
import org.gnome.gdk.PangoRenderer;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Screen;
import org.gnome.pango.RenderPart;

final class GdkPangoRenderer extends Plumbing
{
    private GdkPangoRenderer() {}

    static final long createPangoRenderer(Screen screen) {
        long result;

        if (screen == null) {
            throw new IllegalArgumentException("screen can't be null");
        }

        synchronized (lock) {
            result = gdk_pango_renderer_new(pointerOf(screen));

            return result;
        }
    }

    private static native final long gdk_pango_renderer_new(long screen);

    static final void setDrawable(PangoRenderer self, Drawable drawable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_pango_renderer_set_drawable(pointerOf(self), pointerOf(drawable));
        }
    }

    private static native final void gdk_pango_renderer_set_drawable(long self, long drawable);

    static final void setGc(PangoRenderer self, GC gc) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_pango_renderer_set_gc(pointerOf(self), pointerOf(gc));
        }
    }

    private static native final void gdk_pango_renderer_set_gc(long self, long gc);

    static final void setStipple(PangoRenderer self, RenderPart part, Bitmap stipple) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (part == null) {
            throw new IllegalArgumentException("part can't be null");
        }

        synchronized (lock) {
            gdk_pango_renderer_set_stipple(pointerOf(self), numOf(part), pointerOf(stipple));
        }
    }

    private static native final void gdk_pango_renderer_set_stipple(long self, int part, long stipple);

    static final void setOverrideColor(PangoRenderer self, RenderPart part, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (part == null) {
            throw new IllegalArgumentException("part can't be null");
        }

        synchronized (lock) {
            gdk_pango_renderer_set_override_color(pointerOf(self), numOf(part), pointerOf(color));
        }
    }

    private static native final void gdk_pango_renderer_set_override_color(long self, int part, long color);
}

