/*
 * GdkPixbuf.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Bitmap;
import org.gnome.gdk.Colormap;
import org.gnome.gdk.Colorspace;
import org.gnome.gdk.Drawable;
import org.gnome.gdk.InterpType;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Pixmap;
import org.gnome.gdk.Plumbing;
import org.gnome.glib.GlibException;

final class GdkPixbuf extends Plumbing
{
    private GdkPixbuf() {}

    static final long createPixbufFromFile(String filename) throws GlibException {
        long result;

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_new_from_file(filename);

            return result;
        }
    }

    private static native final long gdk_pixbuf_new_from_file(String filename) throws GlibException;

    static final long createPixbufFromFileAtSize(String filename, int width, int height) throws GlibException {
        long result;

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_new_from_file_at_size(filename, width, height);

            return result;
        }
    }

    private static native final long gdk_pixbuf_new_from_file_at_size(String filename, int width, int height) throws GlibException;

    static final long createPixbufFromFileAtScale(String filename, int width, int height, boolean preserveAspectRatio) throws GlibException {
        long result;

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_new_from_file_at_scale(filename, width, height, preserveAspectRatio);

            return result;
        }
    }

    private static native final long gdk_pixbuf_new_from_file_at_scale(String filename, int width, int height, boolean preserveAspectRatio) throws GlibException;

    static final void renderThresholdAlpha(Pixbuf self, Bitmap bitmap, int srcX, int srcY, int destX, int destY, int width, int height, int alphaThreshold) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (bitmap == null) {
            throw new IllegalArgumentException("bitmap can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_render_threshold_alpha(pointerOf(self), pointerOf(bitmap), srcX, srcY, destX, destY, width, height, alphaThreshold);
        }
    }

    private static native final void gdk_pixbuf_render_threshold_alpha(long self, long bitmap, int srcX, int srcY, int destX, int destY, int width, int height, int alphaThreshold);

    static final void renderPixmapAndMaskForColormap(Pixbuf self, Colormap colormap, Pixmap[] pixmapReturn, Bitmap[] maskReturn, int alphaThreshold) {
        long[] _pixmapReturn;
        long[] _maskReturn;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colormap == null) {
            throw new IllegalArgumentException("colormap can't be null");
        }

        if (pixmapReturn == null) {
            throw new IllegalArgumentException("pixmapReturn can't be null");
        }

        if (maskReturn == null) {
            throw new IllegalArgumentException("maskReturn can't be null");
        }

        _pixmapReturn = pointersOf(pixmapReturn);

        _maskReturn = pointersOf(maskReturn);

        synchronized (lock) {
            gdk_pixbuf_render_pixmap_and_mask_for_colormap(pointerOf(self), pointerOf(colormap), _pixmapReturn, _maskReturn, alphaThreshold);
            fillObjectArray(pixmapReturn, _pixmapReturn);
            fillObjectArray(maskReturn, _maskReturn);
        }
    }

    private static native final void gdk_pixbuf_render_pixmap_and_mask_for_colormap(long self, long colormap, long[] pixmapReturn, long[] maskReturn, int alphaThreshold);

    static final void renderPixmapAndMask(Pixbuf self, Pixmap[] pixmapReturn, Bitmap[] maskReturn, int alphaThreshold) {
        long[] _pixmapReturn;
        long[] _maskReturn;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixmapReturn == null) {
            throw new IllegalArgumentException("pixmapReturn can't be null");
        }

        if (maskReturn == null) {
            throw new IllegalArgumentException("maskReturn can't be null");
        }

        _pixmapReturn = pointersOf(pixmapReturn);

        _maskReturn = pointersOf(maskReturn);

        synchronized (lock) {
            gdk_pixbuf_render_pixmap_and_mask(pointerOf(self), _pixmapReturn, _maskReturn, alphaThreshold);
            fillObjectArray(pixmapReturn, _pixmapReturn);
            fillObjectArray(maskReturn, _maskReturn);
        }
    }

    private static native final void gdk_pixbuf_render_pixmap_and_mask(long self, long[] pixmapReturn, long[] maskReturn, int alphaThreshold);

    static final Pixbuf getFromDrawable(Pixbuf self, Drawable src, Colormap cmap, int srcX, int srcY, int destX, int destY, int width, int height) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (src == null) {
            throw new IllegalArgumentException("src can't be null");
        }

        if (cmap == null) {
            throw new IllegalArgumentException("cmap can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_from_drawable(pointerOf(self), pointerOf(src), pointerOf(cmap), srcX, srcY, destX, destY, width, height);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_get_from_drawable(long self, long src, long cmap, int srcX, int srcY, int destX, int destY, int width, int height);

    static final Pixbuf getFromImage(Pixbuf self, FIXME src, Colormap cmap, int srcX, int srcY, int destX, int destY, int width, int height) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkImage*");
    }

    static final Pixbuf rotateSimple(Pixbuf self, int angle) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_rotate_simple(pointerOf(self), angle);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_rotate_simple(long self, int angle);

    static final Colorspace getColorspace(Pixbuf self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_colorspace(pointerOf(self));

            return (Colorspace) enumFor(Colorspace.class, result);
        }
    }

    private static native final int gdk_pixbuf_get_colorspace(long self);

    static final int getNChannels(Pixbuf self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_n_channels(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_pixbuf_get_n_channels(long self);

    static final boolean getHasAlpha(Pixbuf self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_has_alpha(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_pixbuf_get_has_alpha(long self);

    static final int getBitsPerSample(Pixbuf self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_bits_per_sample(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_pixbuf_get_bits_per_sample(long self);

    static final FIXME getPixels(Pixbuf self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final int getWidth(Pixbuf self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_pixbuf_get_width(long self);

    static final int getHeight(Pixbuf self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_pixbuf_get_height(long self);

    static final int getRowstride(Pixbuf self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_rowstride(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_pixbuf_get_rowstride(long self);

    static final long createPixbuf(Colorspace colorspace, boolean hasAlpha, int bitsPerSample, int width, int height) {
        long result;

        if (colorspace == null) {
            throw new IllegalArgumentException("colorspace can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_new(numOf(colorspace), hasAlpha, bitsPerSample, width, height);

            return result;
        }
    }

    private static native final long gdk_pixbuf_new(int colorspace, boolean hasAlpha, int bitsPerSample, int width, int height);

    static final Pixbuf copy(Pixbuf self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_copy(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_copy(long self);

    static final Pixbuf subpixbuf(Pixbuf self, int srcX, int srcY, int width, int height) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_new_subpixbuf(pointerOf(self), srcX, srcY, width, height);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_new_subpixbuf(long self, int srcX, int srcY, int width, int height);

    static final void fill(Pixbuf self, int pixel) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_fill(pointerOf(self), pixel);
        }
    }

    private static native final void gdk_pixbuf_fill(long self, int pixel);

    static final boolean save(Pixbuf self, String filename, String type) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_save(pointerOf(self), filename, type);

            return result;
        }
    }

    private static native final boolean gdk_pixbuf_save(long self, String filename, String type) throws GlibException;

    static final boolean savev(Pixbuf self, String filename, String type, String[] optionKeys, String[] optionValues) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_savev(pointerOf(self), filename, type, optionKeys, optionValues);

            return result;
        }
    }

    private static native final boolean gdk_pixbuf_savev(long self, String filename, String type, String[] optionKeys, String[] optionValues) throws GlibException;

    static final Pixbuf addAlpha(Pixbuf self, boolean substituteColor, char r, char g, char b) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_add_alpha(pointerOf(self), substituteColor, r, g, b);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_add_alpha(long self, boolean substituteColor, char r, char g, char b);

    static final void copyArea(Pixbuf self, int srcX, int srcY, int width, int height, Pixbuf destPixbuf, int destX, int destY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (destPixbuf == null) {
            throw new IllegalArgumentException("destPixbuf can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_copy_area(pointerOf(self), srcX, srcY, width, height, pointerOf(destPixbuf), destX, destY);
        }
    }

    private static native final void gdk_pixbuf_copy_area(long self, int srcX, int srcY, int width, int height, long destPixbuf, int destX, int destY);

    static final void saturateAndPixelate(Pixbuf self, Pixbuf dest, float saturation, boolean pixelate) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_saturate_and_pixelate(pointerOf(self), pointerOf(dest), saturation, pixelate);
        }
    }

    private static native final void gdk_pixbuf_saturate_and_pixelate(long self, long dest, float saturation, boolean pixelate);

    static final void scale(Pixbuf self, Pixbuf dest, int destX, int destY, int destWidth, int destHeight, double offsetX, double offsetY, double scaleX, double scaleY, InterpType interpType) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        if (interpType == null) {
            throw new IllegalArgumentException("interpType can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_scale(pointerOf(self), pointerOf(dest), destX, destY, destWidth, destHeight, offsetX, offsetY, scaleX, scaleY, numOf(interpType));
        }
    }

    private static native final void gdk_pixbuf_scale(long self, long dest, int destX, int destY, int destWidth, int destHeight, double offsetX, double offsetY, double scaleX, double scaleY, int interpType);

    static final void composite(Pixbuf self, Pixbuf dest, int destX, int destY, int destWidth, int destHeight, double offsetX, double offsetY, double scaleX, double scaleY, InterpType interpType, int overallAlpha) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        if (interpType == null) {
            throw new IllegalArgumentException("interpType can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_composite(pointerOf(self), pointerOf(dest), destX, destY, destWidth, destHeight, offsetX, offsetY, scaleX, scaleY, numOf(interpType), overallAlpha);
        }
    }

    private static native final void gdk_pixbuf_composite(long self, long dest, int destX, int destY, int destWidth, int destHeight, double offsetX, double offsetY, double scaleX, double scaleY, int interpType, int overallAlpha);

    static final void compositeColor(Pixbuf self, Pixbuf dest, int destX, int destY, int destWidth, int destHeight, double offsetX, double offsetY, double scaleX, double scaleY, InterpType interpType, int overallAlpha, int checkX, int checkY, int checkSize, int color1, int color2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        if (interpType == null) {
            throw new IllegalArgumentException("interpType can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_composite_color(pointerOf(self), pointerOf(dest), destX, destY, destWidth, destHeight, offsetX, offsetY, scaleX, scaleY, numOf(interpType), overallAlpha, checkX, checkY, checkSize, color1, color2);
        }
    }

    private static native final void gdk_pixbuf_composite_color(long self, long dest, int destX, int destY, int destWidth, int destHeight, double offsetX, double offsetY, double scaleX, double scaleY, int interpType, int overallAlpha, int checkX, int checkY, int checkSize, int color1, int color2);

    static final Pixbuf scaleSimple(Pixbuf self, int destWidth, int destHeight, InterpType interpType) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (interpType == null) {
            throw new IllegalArgumentException("interpType can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_scale_simple(pointerOf(self), destWidth, destHeight, numOf(interpType));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_scale_simple(long self, int destWidth, int destHeight, int interpType);

    static final Pixbuf compositeColorSimple(Pixbuf self, int destWidth, int destHeight, InterpType interpType, int overallAlpha, int checkSize, int color1, int color2) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (interpType == null) {
            throw new IllegalArgumentException("interpType can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_composite_color_simple(pointerOf(self), destWidth, destHeight, numOf(interpType), overallAlpha, checkSize, color1, color2);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_composite_color_simple(long self, int destWidth, int destHeight, int interpType, int overallAlpha, int checkSize, int color1, int color2);

    static final boolean saveToCallbackv(Pixbuf self, FIXME saveFunc, FIXME userData, String type, String[] optionKeys, String[] optionValues) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkPixbufSaveFunc");
    }

    static final boolean saveToBuffer(Pixbuf self, String[] buffer, long[] bufferSize, String type) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (buffer == null) {
            throw new IllegalArgumentException("buffer can't be null");
        }

        if (bufferSize == null) {
            throw new IllegalArgumentException("bufferSize can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_save_to_buffer(pointerOf(self), buffer, bufferSize, type);

            return result;
        }
    }

    private static native final boolean gdk_pixbuf_save_to_buffer(long self, String[] buffer, long[] bufferSize, String type) throws GlibException;

    static final boolean saveToBufferv(Pixbuf self, String[] buffer, long[] bufferSize, String type, String[] optionKeys, String[] optionValues) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (buffer == null) {
            throw new IllegalArgumentException("buffer can't be null");
        }

        if (bufferSize == null) {
            throw new IllegalArgumentException("bufferSize can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        if (optionKeys == null) {
            throw new IllegalArgumentException("optionKeys can't be null");
        }

        if (optionValues == null) {
            throw new IllegalArgumentException("optionValues can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_save_to_bufferv(pointerOf(self), buffer, bufferSize, type, optionKeys, optionValues);

            return result;
        }
    }

    private static native final boolean gdk_pixbuf_save_to_bufferv(long self, String[] buffer, long[] bufferSize, String type, String[] optionKeys, String[] optionValues) throws GlibException;

    static final String getOption(Pixbuf self, String key) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (key == null) {
            throw new IllegalArgumentException("key can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_get_option(pointerOf(self), key);

            return result;
        }
    }

    private static native final String gdk_pixbuf_get_option(long self, String key);

    static final Pixbuf flip(Pixbuf self, boolean horizontal) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_flip(pointerOf(self), horizontal);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_flip(long self, boolean horizontal);
}

