/*
 * GdkPoint.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkPoint extends Plumbing
{
    private GdkPoint() {}

    static final int getX(Point self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_point_get_x(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_point_get_x(long self);

    static final void setX(Point self, int x) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_point_set_x(pointerOf(self), x);
        }
    }

    private static native final void gdk_point_set_x(long self, int x);

    static final int getY(Point self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_point_get_y(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_point_get_y(long self);

    static final void setY(Point self, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_point_set_y(pointerOf(self), y);
        }
    }

    private static native final void gdk_point_set_y(long self, int y);
}

