/*
 * GdkRegion.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.OverlapType;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Region;

final class GdkRegion extends Plumbing
{
    private GdkRegion() {}

    static final void getClipbox(Region self, Rectangle rect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rect == null) {
            throw new IllegalArgumentException("rect can't be null");
        }

        synchronized (lock) {
            gdk_region_get_clipbox(pointerOf(self), pointerOf(rect));
        }
    }

    private static native final void gdk_region_get_clipbox(long self, long rect);

    static final boolean empty(Region self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_region_empty(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_region_empty(long self);

    static final boolean equal(Region self, Region other) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (other == null) {
            throw new IllegalArgumentException("other can't be null");
        }

        synchronized (lock) {
            result = gdk_region_equal(pointerOf(self), pointerOf(other));

            return result;
        }
    }

    private static native final boolean gdk_region_equal(long self, long other);

    static final boolean pointIn(Region self, int x, int y) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_region_point_in(pointerOf(self), x, y);

            return result;
        }
    }

    private static native final boolean gdk_region_point_in(long self, int x, int y);

    static final OverlapType rectIn(Region self, Rectangle rect) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rect == null) {
            throw new IllegalArgumentException("rect can't be null");
        }

        synchronized (lock) {
            result = gdk_region_rect_in(pointerOf(self), pointerOf(rect));

            return (OverlapType) enumFor(OverlapType.class, result);
        }
    }

    private static native final int gdk_region_rect_in(long self, long rect);

    static final long createRegion() {
        long result;

        synchronized (lock) {
            result = gdk_region_new();

            return result;
        }
    }

    private static native final long gdk_region_new();

    static final Region copy(Region self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_region_copy(pointerOf(self));

            return (Region) boxedFor(Region.class, result);
        }
    }

    private static native final long gdk_region_copy(long self);

    static final void destroy(Region self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_region_destroy(pointerOf(self));
        }
    }

    private static native final void gdk_region_destroy(long self);

    static final void getRectangles(Region self, Rectangle[] rectangles, int[] nRectangles) {
        long[] _rectangles;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rectangles == null) {
            throw new IllegalArgumentException("rectangles can't be null");
        }

        if (nRectangles == null) {
            throw new IllegalArgumentException("nRectangles can't be null");
        }

        _rectangles = pointersOf(rectangles);

        synchronized (lock) {
            gdk_region_get_rectangles(pointerOf(self), _rectangles, nRectangles);
            fillBoxedArray(Rectangle.class, rectangles, _rectangles);
        }
    }

    private static native final void gdk_region_get_rectangles(long self, long[] rectangles, int[] nRectangles);

    static final void offset(Region self, int dx, int dy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_region_offset(pointerOf(self), dx, dy);
        }
    }

    private static native final void gdk_region_offset(long self, int dx, int dy);

    static final void shrink(Region self, int dx, int dy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_region_shrink(pointerOf(self), dx, dy);
        }
    }

    private static native final void gdk_region_shrink(long self, int dx, int dy);

    static final void unionWithRect(Region self, Rectangle rect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rect == null) {
            throw new IllegalArgumentException("rect can't be null");
        }

        synchronized (lock) {
            gdk_region_union_with_rect(pointerOf(self), pointerOf(rect));
        }
    }

    private static native final void gdk_region_union_with_rect(long self, long rect);

    static final void intersect(Region self, Region source2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (source2 == null) {
            throw new IllegalArgumentException("source2 can't be null");
        }

        synchronized (lock) {
            gdk_region_intersect(pointerOf(self), pointerOf(source2));
        }
    }

    private static native final void gdk_region_intersect(long self, long source2);

    static final void union(Region self, Region source2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (source2 == null) {
            throw new IllegalArgumentException("source2 can't be null");
        }

        synchronized (lock) {
            gdk_region_union(pointerOf(self), pointerOf(source2));
        }
    }

    private static native final void gdk_region_union(long self, long source2);

    static final void subtract(Region self, Region source2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (source2 == null) {
            throw new IllegalArgumentException("source2 can't be null");
        }

        synchronized (lock) {
            gdk_region_subtract(pointerOf(self), pointerOf(source2));
        }
    }

    private static native final void gdk_region_subtract(long self, long source2);

    static final void xor(Region self, Region source2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (source2 == null) {
            throw new IllegalArgumentException("source2 can't be null");
        }

        synchronized (lock) {
            gdk_region_xor(pointerOf(self), pointerOf(source2));
        }
    }

    private static native final void gdk_region_xor(long self, long source2);

    static final void spansIntersectForeach(Region self, FIXME spans, int nSpans, boolean sorted, FIXME function, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkSpan*");
    }
}

