/*
 * GdkScreen.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.cairo.FontOptions;
import org.gnome.gdk.Colormap;
import org.gnome.gdk.Display;
import org.gnome.gdk.Event;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Screen;
import org.gnome.gdk.Visual;
import org.gnome.gdk.Window;
import org.gnome.glib.Signal;
import org.gnome.glib.Value;

final class GdkScreen extends Plumbing
{
    private GdkScreen() {}

    static final Colormap getDefaultColormap(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_default_colormap(pointerOf(self));

            return (Colormap) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_default_colormap(long self);

    static final void setDefaultColormap(Screen self, Colormap colormap) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colormap == null) {
            throw new IllegalArgumentException("colormap can't be null");
        }

        synchronized (lock) {
            gdk_screen_set_default_colormap(pointerOf(self), pointerOf(colormap));
        }
    }

    private static native final void gdk_screen_set_default_colormap(long self, long colormap);

    static final Colormap getSystemColormap(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_system_colormap(pointerOf(self));

            return (Colormap) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_system_colormap(long self);

    static final Visual getSystemVisual(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_system_visual(pointerOf(self));

            return (Visual) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_system_visual(long self);

    static final Colormap getRgbColormap(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_rgb_colormap(pointerOf(self));

            return (Colormap) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_rgb_colormap(long self);

    static final Colormap getRgbaColormap(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_rgba_colormap(pointerOf(self));

            return (Colormap) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_rgba_colormap(long self);

    static final Visual getRgbVisual(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_rgb_visual(pointerOf(self));

            return (Visual) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_rgb_visual(long self);

    static final Visual getRgbaVisual(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_rgba_visual(pointerOf(self));

            return (Visual) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_rgba_visual(long self);

    static final Window getRootWindow(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_root_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_root_window(long self);

    static final Display getDisplay(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_display(pointerOf(self));

            return (Display) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_display(long self);

    static final int getNumber(Screen self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_number(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_screen_get_number(long self);

    static final int getWidth(Screen self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_screen_get_width(long self);

    static final int getHeight(Screen self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_screen_get_height(long self);

    static final int getWidthMm(Screen self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_width_mm(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_screen_get_width_mm(long self);

    static final int getHeightMm(Screen self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_height_mm(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_screen_get_height_mm(long self);

    static final Visual[] listVisuals(Screen self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_list_visuals(pointerOf(self));

            return (Visual[]) objectArrayFor(result, new Visual[result.length]);
        }
    }

    private static native final long[] gdk_screen_list_visuals(long self);

    static final Window[] getToplevelWindows(Screen self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_toplevel_windows(pointerOf(self));

            return (Window[]) objectArrayFor(result, new Window[result.length]);
        }
    }

    private static native final long[] gdk_screen_get_toplevel_windows(long self);

    static final String makeDisplayName(Screen self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_make_display_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gdk_screen_make_display_name(long self);

    static final int getNMonitors(Screen self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_n_monitors(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_screen_get_n_monitors(long self);

    static final void getMonitorGeometry(Screen self, int monitorNum, Rectangle dest) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        synchronized (lock) {
            gdk_screen_get_monitor_geometry(pointerOf(self), monitorNum, pointerOf(dest));
        }
    }

    private static native final void gdk_screen_get_monitor_geometry(long self, int monitorNum, long dest);

    static final int getMonitorAtPoint(Screen self, int x, int y) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_monitor_at_point(pointerOf(self), x, y);

            return result;
        }
    }

    private static native final int gdk_screen_get_monitor_at_point(long self, int x, int y);

    static final int getMonitorAtWindow(Screen self, Window window) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_monitor_at_window(pointerOf(self), pointerOf(window));

            return result;
        }
    }

    private static native final int gdk_screen_get_monitor_at_window(long self, long window);

    static final void broadcastClientMessage(Screen self, Event event) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            gdk_screen_broadcast_client_message(pointerOf(self), pointerOf(event));
        }
    }

    private static native final void gdk_screen_broadcast_client_message(long self, long event);

    static final boolean getSetting(Screen self, String name, Value value) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_setting(pointerOf(self), name, pointerOf(value));

            return result;
        }
    }

    private static native final boolean gdk_screen_get_setting(long self, String name, long value);

    static final boolean alternativeDialogButtonOrder(Screen self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_alternative_dialog_button_order(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_alternative_dialog_button_order(long self);

    interface SizeChangedSignal extends Signal
    {
        void onSizeChanged(Screen source);
    }

    static final void connect(Screen self, GdkScreen.SizeChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkScreen.class, "size-changed", after);
    }

    protected static final void receiveSizeChanged(Signal handler, long source) {
        ((GdkScreen.SizeChangedSignal) handler).onSizeChanged((Screen) objectFor(source));
    }

    static final boolean isComposited(Screen self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_is_composited(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_screen_is_composited(long self);

    static final void setFontOptions(Screen self, FontOptions options) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (options == null) {
            throw new IllegalArgumentException("options can't be null");
        }

        synchronized (lock) {
            gdk_screen_set_font_options(pointerOf(self), pointerOf(options));
        }
    }

    private static native final void gdk_screen_set_font_options(long self, long options);

    static final FontOptions getFontOptions(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_font_options(pointerOf(self));

            return (FontOptions) entityFor(FontOptions.class,  result);
        }
    }

    private static native final long gdk_screen_get_font_options(long self);

    static final void setResolution(Screen self, double dpi) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_screen_set_resolution(pointerOf(self), dpi);
        }
    }

    private static native final void gdk_screen_set_resolution(long self, double dpi);

    static final double getResolution(Screen self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_resolution(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_screen_get_resolution(long self);

    static final Window getActiveWindow(Screen self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_active_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_active_window(long self);

    static final Window[] getWindowStack(Screen self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_screen_get_window_stack(pointerOf(self));

            return (Window[]) objectArrayFor(result, new Window[result.length]);
        }
    }

    private static native final long[] gdk_screen_get_window_stack(long self);

    interface CompositedChangedSignal extends Signal
    {
        void onCompositedChanged(Screen source);
    }

    static final void connect(Screen self, GdkScreen.CompositedChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkScreen.class, "composited-changed", after);
    }

    protected static final void receiveCompositedChanged(Signal handler, long source) {
        ((GdkScreen.CompositedChangedSignal) handler).onCompositedChanged((Screen) objectFor(source));
    }

    static final Screen getDefault() {
        long result;

        synchronized (lock) {
            result = gdk_screen_get_default();

            return (Screen) objectFor(result);
        }
    }

    private static native final long gdk_screen_get_default();
}

