/*
 * GdkSegment.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkSegment extends Plumbing
{
    private GdkSegment() {}

    static final int getX1(Segment self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_segment_get_x1(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_segment_get_x1(long self);

    static final void setX1(Segment self, int x1) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_segment_set_x1(pointerOf(self), x1);
        }
    }

    private static native final void gdk_segment_set_x1(long self, int x1);

    static final int getY1(Segment self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_segment_get_y1(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_segment_get_y1(long self);

    static final void setY1(Segment self, int y1) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_segment_set_y1(pointerOf(self), y1);
        }
    }

    private static native final void gdk_segment_set_y1(long self, int y1);

    static final int getX2(Segment self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_segment_get_x2(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_segment_get_x2(long self);

    static final void setX2(Segment self, int x2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_segment_set_x2(pointerOf(self), x2);
        }
    }

    private static native final void gdk_segment_set_x2(long self, int x2);

    static final int getY2(Segment self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_segment_get_y2(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_segment_get_y2(long self);

    static final void setY2(Segment self, int y2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_segment_set_y2(pointerOf(self), y2);
        }
    }

    private static native final void gdk_segment_set_y2(long self, int y2);
}

