/*
 * GladeXML.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.glade;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glade.Plumbing;
import org.gnome.glade.XML;
import org.gnome.gtk.Widget;

final class GladeXML extends Plumbing
{
    private GladeXML() {}

    static final long createXML(String fname, String root, String domain) {
        long result;

        if (fname == null) {
            throw new IllegalArgumentException("fname can't be null");
        }

        synchronized (lock) {
            result = glade_xml_new(fname, root, domain);

            return result;
        }
    }

    private static native final long glade_xml_new(String fname, String root, String domain);

    static final boolean construct(XML self, String fname, String root, String domain) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (fname == null) {
            throw new IllegalArgumentException("fname can't be null");
        }

        synchronized (lock) {
            result = glade_xml_construct(pointerOf(self), fname, root, domain);

            return result;
        }
    }

    private static native final boolean glade_xml_construct(long self, String fname, String root, String domain);

    static final void signalConnect(XML self, String handlername, FIXME func) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkSignalFunc");
    }

    static final void signalConnectData(XML self, String handlername, FIXME func, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkSignalFunc");
    }

    static final void signalAutoconnect(XML self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            glade_xml_signal_autoconnect(pointerOf(self));
        }
    }

    private static native final void glade_xml_signal_autoconnect(long self);

    static final void signalConnectFull(XML self, String handlerName, FIXME func, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GladeXMLConnectFunc");
    }

    static final void signalAutoconnectFull(XML self, FIXME func, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GladeXMLConnectFunc");
    }

    static final Widget getWidget(XML self, String name) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = glade_xml_get_widget(pointerOf(self), name);

            return (Widget) objectFor(result);
        }
    }

    private static native final long glade_xml_get_widget(long self, String name);

    static final Widget[] getWidgetPrefix(XML self, String name) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = glade_xml_get_widget_prefix(pointerOf(self), name);

            return (Widget[]) objectArrayFor(result, new Widget[result.length]);
        }
    }

    private static native final long[] glade_xml_get_widget_prefix(long self, String name);

    static final String relativeFile(XML self, String filename) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = glade_xml_relative_file(pointerOf(self), filename);

            return result;
        }
    }

    private static native final String glade_xml_relative_file(long self, String filename);
}

