/*
 * GtkAccelGroup.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.ModifierType;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.AccelFlags;
import org.gnome.gtk.AccelGroup;
import org.gnome.gtk.Plumbing;

final class GtkAccelGroup extends Plumbing
{
    private GtkAccelGroup() {}

    static final long createAccelGroup() {
        long result;

        synchronized (lock) {
            result = gtk_accel_group_new();

            return result;
        }
    }

    private static native final long gtk_accel_group_new();

    static final void lock(AccelGroup self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_accel_group_lock(pointerOf(self));
        }
    }

    private static native final void gtk_accel_group_lock(long self);

    static final void unlock(AccelGroup self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_accel_group_unlock(pointerOf(self));
        }
    }

    private static native final void gtk_accel_group_unlock(long self);

    static final void connect(AccelGroup self, int accelKey, ModifierType accelMods, AccelFlags accelFlags, FIXME closure) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GClosure*");
    }

    static final void connectByPath(AccelGroup self, String accelPath, FIXME closure) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GClosure*");
    }

    static final boolean disconnect(AccelGroup self, FIXME closure) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GClosure*");
    }

    static final boolean disconnectKey(AccelGroup self, int accelKey, ModifierType accelMods) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelMods == null) {
            throw new IllegalArgumentException("accelMods can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_group_disconnect_key(pointerOf(self), accelKey, numOf(accelMods));

            return result;
        }
    }

    private static native final boolean gtk_accel_group_disconnect_key(long self, int accelKey, int accelMods);

    static final boolean activate(AccelGroup self, int accelQuark, Object acceleratable, int accelKey, ModifierType accelMods) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (acceleratable == null) {
            throw new IllegalArgumentException("acceleratable can't be null");
        }

        if (accelMods == null) {
            throw new IllegalArgumentException("accelMods can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_group_activate(pointerOf(self), accelQuark, pointerOf(acceleratable), accelKey, numOf(accelMods));

            return result;
        }
    }

    private static native final boolean gtk_accel_group_activate(long self, int accelQuark, long acceleratable, int accelKey, int accelMods);

    static final FIXME query(AccelGroup self, int accelKey, ModifierType accelMods, int[] nEntries) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkAccelGroupEntry*");
    }

    interface AccelChangedSignal extends Signal
    {
        void onAccelChanged(AccelGroup source, int keyval, ModifierType modifier, FIXME accelClosure);
    }

    static final void connect(AccelGroup self, GtkAccelGroup.AccelChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAccelGroup.class, "accel-changed", after);
    }

    protected static final void receiveAccelChanged(Signal handler, long source, int keyval, int modifier, java.lang.Object accelClosure) {
        ((GtkAccelGroup.AccelChangedSignal) handler).onAccelChanged((AccelGroup) objectFor(source), keyval, (ModifierType) flagFor(ModifierType.class, modifier), (FIXME) accelClosure);
    }
}

