/*
 * GtkAccelKey.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.ModifierType;
import org.gnome.gtk.Plumbing;

final class GtkAccelKey extends Plumbing
{
    private GtkAccelKey() {}

    static final int getAccelKey(AccelKey self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_key_get_accel_key(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_accel_key_get_accel_key(long self);

    static final void setAccelKey(AccelKey self, int accelKey) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_accel_key_set_accel_key(pointerOf(self), accelKey);
        }
    }

    private static native final void gtk_accel_key_set_accel_key(long self, int accelKey);

    static final ModifierType getAccelMods(AccelKey self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_key_get_accel_mods(pointerOf(self));

            return (ModifierType) flagFor(ModifierType.class, result);
        }
    }

    private static native final int gtk_accel_key_get_accel_mods(long self);

    static final void setAccelMods(AccelKey self, ModifierType accelMods) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelMods == null) {
            throw new IllegalArgumentException("accelMods can't be null");
        }

        synchronized (lock) {
            gtk_accel_key_set_accel_mods(pointerOf(self), numOf(accelMods));
        }
    }

    private static native final void gtk_accel_key_set_accel_mods(long self, int accelMods);

    static final int getAccelFlags(AccelKey self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_key_get_accel_flags(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_accel_key_get_accel_flags(long self);

    static final void setAccelFlags(AccelKey self, int accelFlags) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_accel_key_set_accel_flags(pointerOf(self), accelFlags);
        }
    }

    private static native final void gtk_accel_key_set_accel_flags(long self, int accelFlags);

    static final boolean acceleratorValid(int keyval, ModifierType modifiers) {
        boolean result;

        if (modifiers == null) {
            throw new IllegalArgumentException("modifiers can't be null");
        }

        synchronized (lock) {
            result = gtk_accelerator_valid(keyval, numOf(modifiers));

            return result;
        }
    }

    private static native final boolean gtk_accelerator_valid(int keyval, int modifiers);

    static final void acceleratorParse(String accelerator, int[] acceleratorKey, ModifierType[] acceleratorMods) {
        int[] _acceleratorMods;

        if (accelerator == null) {
            throw new IllegalArgumentException("accelerator can't be null");
        }

        if (acceleratorKey == null) {
            throw new IllegalArgumentException("acceleratorKey can't be null");
        }

        if (acceleratorMods == null) {
            throw new IllegalArgumentException("acceleratorMods can't be null");
        }

        _acceleratorMods = numsOf(acceleratorMods);

        synchronized (lock) {
            gtk_accelerator_parse(accelerator, acceleratorKey, _acceleratorMods);
            fillFlagArray(ModifierType.class, acceleratorMods, _acceleratorMods);
        }
    }

    private static native final void gtk_accelerator_parse(String accelerator, int[] acceleratorKey, int[] acceleratorMods);

    static final String acceleratorName(int acceleratorKey, ModifierType acceleratorMods) {
        String result;

        if (acceleratorMods == null) {
            throw new IllegalArgumentException("acceleratorMods can't be null");
        }

        synchronized (lock) {
            result = gtk_accelerator_name(acceleratorKey, numOf(acceleratorMods));

            return result;
        }
    }

    private static native final String gtk_accelerator_name(int acceleratorKey, int acceleratorMods);

    static final void acceleratorSetDefaultModMask(ModifierType defaultModMask) {
        if (defaultModMask == null) {
            throw new IllegalArgumentException("defaultModMask can't be null");
        }

        synchronized (lock) {
            gtk_accelerator_set_default_mod_mask(numOf(defaultModMask));
        }
    }

    private static native final void gtk_accelerator_set_default_mod_mask(int defaultModMask);

    static final ModifierType acceleratorGetDefaultModMask() {
        int result;

        synchronized (lock) {
            result = gtk_accelerator_get_default_mod_mask();

            return (ModifierType) flagFor(ModifierType.class, result);
        }
    }

    private static native final int gtk_accelerator_get_default_mod_mask();

    static final String acceleratorGetLabel(int acceleratorKey, ModifierType acceleratorMods) {
        String result;

        if (acceleratorMods == null) {
            throw new IllegalArgumentException("acceleratorMods can't be null");
        }

        synchronized (lock) {
            result = gtk_accelerator_get_label(acceleratorKey, numOf(acceleratorMods));

            return result;
        }
    }

    private static native final String gtk_accelerator_get_label(int acceleratorKey, int acceleratorMods);
}

