/*
 * GtkAccelMap.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.ModifierType;
import org.gnome.gtk.AccelKey;
import org.gnome.gtk.AccelMap;
import org.gnome.gtk.Plumbing;

final class GtkAccelMap extends Plumbing
{
    private GtkAccelMap() {}

    static final void addEntry(String accelPath, int accelKey, ModifierType accelMods) {
        if (accelPath == null) {
            throw new IllegalArgumentException("accelPath can't be null");
        }

        if (accelMods == null) {
            throw new IllegalArgumentException("accelMods can't be null");
        }

        synchronized (lock) {
            gtk_accel_map_add_entry(accelPath, accelKey, numOf(accelMods));
        }
    }

    private static native final void gtk_accel_map_add_entry(String accelPath, int accelKey, int accelMods);

    static final boolean lookupEntry(String accelPath, AccelKey key) {
        boolean result;

        if (accelPath == null) {
            throw new IllegalArgumentException("accelPath can't be null");
        }

        if (key == null) {
            throw new IllegalArgumentException("key can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_map_lookup_entry(accelPath, pointerOf(key));

            return result;
        }
    }

    private static native final boolean gtk_accel_map_lookup_entry(String accelPath, long key);

    static final boolean changeEntry(String accelPath, int accelKey, ModifierType accelMods, boolean replace) {
        boolean result;

        if (accelPath == null) {
            throw new IllegalArgumentException("accelPath can't be null");
        }

        if (accelMods == null) {
            throw new IllegalArgumentException("accelMods can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_map_change_entry(accelPath, accelKey, numOf(accelMods), replace);

            return result;
        }
    }

    private static native final boolean gtk_accel_map_change_entry(String accelPath, int accelKey, int accelMods, boolean replace);

    static final void load(String fileName) {
        if (fileName == null) {
            throw new IllegalArgumentException("fileName can't be null");
        }

        synchronized (lock) {
            gtk_accel_map_load(fileName);
        }
    }

    private static native final void gtk_accel_map_load(String fileName);

    static final void save(String fileName) {
        if (fileName == null) {
            throw new IllegalArgumentException("fileName can't be null");
        }

        synchronized (lock) {
            gtk_accel_map_save(fileName);
        }
    }

    private static native final void gtk_accel_map_save(String fileName);

    static final void foreach(FIXME data, FIXME foreachFunc) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer");
    }

    static final void loadFd(int fd) {
        synchronized (lock) {
            gtk_accel_map_load_fd(fd);
        }
    }

    private static native final void gtk_accel_map_load_fd(int fd);

    static final void loadScanner(FIXME scanner) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GScanner*");
    }

    static final void saveFd(int fd) {
        synchronized (lock) {
            gtk_accel_map_save_fd(fd);
        }
    }

    private static native final void gtk_accel_map_save_fd(int fd);

    static final void lockPath(String accelPath) {
        if (accelPath == null) {
            throw new IllegalArgumentException("accelPath can't be null");
        }

        synchronized (lock) {
            gtk_accel_map_lock_path(accelPath);
        }
    }

    private static native final void gtk_accel_map_lock_path(String accelPath);

    static final void unlockPath(String accelPath) {
        if (accelPath == null) {
            throw new IllegalArgumentException("accelPath can't be null");
        }

        synchronized (lock) {
            gtk_accel_map_unlock_path(accelPath);
        }
    }

    private static native final void gtk_accel_map_unlock_path(String accelPath);

    static final void addFilter(String filterPattern) {
        if (filterPattern == null) {
            throw new IllegalArgumentException("filterPattern can't be null");
        }

        synchronized (lock) {
            gtk_accel_map_add_filter(filterPattern);
        }
    }

    private static native final void gtk_accel_map_add_filter(String filterPattern);

    static final void foreachUnfiltered(FIXME data, FIXME foreachFunc) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer");
    }

    static final AccelMap get() {
        long result;

        synchronized (lock) {
            result = gtk_accel_map_get();

            return (AccelMap) objectFor(result);
        }
    }

    private static native final long gtk_accel_map_get();
}

