/*
 * GtkAction.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.gtk.AccelGroup;
import org.gnome.gtk.Action;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkAction extends Plumbing
{
    private GtkAction() {}

    static final long createAction(String name, String label, String tooltip, String stockId) {
        long result;

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = gtk_action_new(name, label, tooltip, stockId);

            return result;
        }
    }

    private static native final long gtk_action_new(String name, String label, String tooltip, String stockId);

    static final String getName(Action self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_action_get_name(long self);

    static final boolean isSensitive(Action self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_is_sensitive(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_action_is_sensitive(long self);

    static final boolean getSensitive(Action self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_get_sensitive(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_action_get_sensitive(long self);

    static final boolean isVisible(Action self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_is_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_action_is_visible(long self);

    static final boolean getVisible(Action self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_get_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_action_get_visible(long self);

    static final void activate(Action self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_activate(pointerOf(self));
        }
    }

    private static native final void gtk_action_activate(long self);

    static final Widget createIcon(Action self, IconSize iconSize) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconSize == null) {
            throw new IllegalArgumentException("iconSize can't be null");
        }

        synchronized (lock) {
            result = gtk_action_create_icon(pointerOf(self), numOf(iconSize));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_action_create_icon(long self, int iconSize);

    static final Widget createMenuItem(Action self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_create_menu_item(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_action_create_menu_item(long self);

    static final Widget createMenu(Action self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_create_menu(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_action_create_menu(long self);

    static final Widget createToolItem(Action self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_create_tool_item(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_action_create_tool_item(long self);

    static final void connectProxy(Action self, Widget proxy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (proxy == null) {
            throw new IllegalArgumentException("proxy can't be null");
        }

        synchronized (lock) {
            gtk_action_connect_proxy(pointerOf(self), pointerOf(proxy));
        }
    }

    private static native final void gtk_action_connect_proxy(long self, long proxy);

    static final void disconnectProxy(Action self, Widget proxy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (proxy == null) {
            throw new IllegalArgumentException("proxy can't be null");
        }

        synchronized (lock) {
            gtk_action_disconnect_proxy(pointerOf(self), pointerOf(proxy));
        }
    }

    private static native final void gtk_action_disconnect_proxy(long self, long proxy);

    static final Widget[] getProxies(Action self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_get_proxies(pointerOf(self));

            return (Widget[]) objectArrayFor(result, new Widget[result.length]);
        }
    }

    private static native final long[] gtk_action_get_proxies(long self);

    static final void connectAccelerator(Action self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_connect_accelerator(pointerOf(self));
        }
    }

    private static native final void gtk_action_connect_accelerator(long self);

    static final void disconnectAccelerator(Action self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_disconnect_accelerator(pointerOf(self));
        }
    }

    private static native final void gtk_action_disconnect_accelerator(long self);

    static final String getAccelPath(Action self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_get_accel_path(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_action_get_accel_path(long self);

    static final void blockActivateFrom(Action self, Widget proxy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (proxy == null) {
            throw new IllegalArgumentException("proxy can't be null");
        }

        synchronized (lock) {
            gtk_action_block_activate_from(pointerOf(self), pointerOf(proxy));
        }
    }

    private static native final void gtk_action_block_activate_from(long self, long proxy);

    static final void unblockActivateFrom(Action self, Widget proxy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (proxy == null) {
            throw new IllegalArgumentException("proxy can't be null");
        }

        synchronized (lock) {
            gtk_action_unblock_activate_from(pointerOf(self), pointerOf(proxy));
        }
    }

    private static native final void gtk_action_unblock_activate_from(long self, long proxy);

    static final void setAccelPath(Action self, String accelPath) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelPath == null) {
            throw new IllegalArgumentException("accelPath can't be null");
        }

        synchronized (lock) {
            gtk_action_set_accel_path(pointerOf(self), accelPath);
        }
    }

    private static native final void gtk_action_set_accel_path(long self, String accelPath);

    static final void setAccelGroup(Action self, AccelGroup accelGroup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_set_accel_group(pointerOf(self), pointerOf(accelGroup));
        }
    }

    private static native final void gtk_action_set_accel_group(long self, long accelGroup);

    static final void setSensitive(Action self, boolean sensitive) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_set_sensitive(pointerOf(self), sensitive);
        }
    }

    private static native final void gtk_action_set_sensitive(long self, boolean sensitive);

    static final void setVisible(Action self, boolean visible) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_set_visible(pointerOf(self), visible);
        }
    }

    private static native final void gtk_action_set_visible(long self, boolean visible);

    interface ActivateSignal extends Signal
    {
        void onActivate(Action source);
    }

    static final void connect(Action self, GtkAction.ActivateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAction.class, "activate", after);
    }

    protected static final void receiveActivate(Signal handler, long source) {
        ((GtkAction.ActivateSignal) handler).onActivate((Action) objectFor(source));
    }

    interface ConnectProxySignal extends Signal
    {
        void onConnectProxy(Action source, Widget proxy);
    }

    static final void connect(Action self, GtkAction.ConnectProxySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAction.class, "connect-proxy", after);
    }

    protected static final void receiveConnectProxy(Signal handler, long source, long proxy) {
        ((GtkAction.ConnectProxySignal) handler).onConnectProxy((Action) objectFor(source), (Widget) objectFor(proxy));
    }

    interface CreateMenuItemSignal extends Signal
    {
        Widget onCreateMenuItem(Action source);
    }

    static final void connect(Action self, GtkAction.CreateMenuItemSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAction.class, "create-menu-item", after);
    }

    protected static final long receiveCreateMenuItem(Signal handler, long source) {
        Widget result;

        result = ((GtkAction.CreateMenuItemSignal) handler).onCreateMenuItem((Action) objectFor(source));

        return pointerOf(result);
    }

    interface CreateToolItemSignal extends Signal
    {
        Widget onCreateToolItem(Action source);
    }

    static final void connect(Action self, GtkAction.CreateToolItemSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAction.class, "create-tool-item", after);
    }

    protected static final long receiveCreateToolItem(Signal handler, long source) {
        Widget result;

        result = ((GtkAction.CreateToolItemSignal) handler).onCreateToolItem((Action) objectFor(source));

        return pointerOf(result);
    }

    interface DisconnectProxySignal extends Signal
    {
        void onDisconnectProxy(Action source, Widget proxy);
    }

    static final void connect(Action self, GtkAction.DisconnectProxySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAction.class, "disconnect-proxy", after);
    }

    protected static final void receiveDisconnectProxy(Signal handler, long source, long proxy) {
        ((GtkAction.DisconnectProxySignal) handler).onDisconnectProxy((Action) objectFor(source), (Widget) objectFor(proxy));
    }

    static final FIXME getAccelClosure(Action self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GClosure*");
    }
}

