/*
 * GtkAlignment.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Alignment;
import org.gnome.gtk.Plumbing;

final class GtkAlignment extends Plumbing
{
    private GtkAlignment() {}

    static final long createAlignment(float xalign, float yalign, float xscale, float yscale) {
        long result;

        synchronized (lock) {
            result = gtk_alignment_new(xalign, yalign, xscale, yscale);

            return result;
        }
    }

    private static native final long gtk_alignment_new(float xalign, float yalign, float xscale, float yscale);

    static final void set(Alignment self, float xalign, float yalign, float xscale, float yscale) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_alignment_set(pointerOf(self), xalign, yalign, xscale, yscale);
        }
    }

    private static native final void gtk_alignment_set(long self, float xalign, float yalign, float xscale, float yscale);

    static final void setPadding(Alignment self, int paddingTop, int paddingBottom, int paddingLeft, int paddingRight) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_alignment_set_padding(pointerOf(self), paddingTop, paddingBottom, paddingLeft, paddingRight);
        }
    }

    private static native final void gtk_alignment_set_padding(long self, int paddingTop, int paddingBottom, int paddingLeft, int paddingRight);

    static final void getPadding(Alignment self, int[] paddingTop, int[] paddingBottom, int[] paddingLeft, int[] paddingRight) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (paddingTop == null) {
            throw new IllegalArgumentException("paddingTop can't be null");
        }

        if (paddingBottom == null) {
            throw new IllegalArgumentException("paddingBottom can't be null");
        }

        if (paddingLeft == null) {
            throw new IllegalArgumentException("paddingLeft can't be null");
        }

        if (paddingRight == null) {
            throw new IllegalArgumentException("paddingRight can't be null");
        }

        synchronized (lock) {
            gtk_alignment_get_padding(pointerOf(self), paddingTop, paddingBottom, paddingLeft, paddingRight);
        }
    }

    private static native final void gtk_alignment_get_padding(long self, int[] paddingTop, int[] paddingBottom, int[] paddingLeft, int[] paddingRight);
}

