/*
 * GtkArrow.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Arrow;
import org.gnome.gtk.ArrowType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ShadowType;

final class GtkArrow extends Plumbing
{
    private GtkArrow() {}

    static final long createArrow(ArrowType arrowType, ShadowType shadowType) {
        long result;

        if (arrowType == null) {
            throw new IllegalArgumentException("arrowType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            result = gtk_arrow_new(numOf(arrowType), numOf(shadowType));

            return result;
        }
    }

    private static native final long gtk_arrow_new(int arrowType, int shadowType);

    static final void set(Arrow self, ArrowType arrowType, ShadowType shadowType) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (arrowType == null) {
            throw new IllegalArgumentException("arrowType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_arrow_set(pointerOf(self), numOf(arrowType), numOf(shadowType));
        }
    }

    private static native final void gtk_arrow_set(long self, int arrowType, int shadowType);
}

