/*
 * GtkAssistant.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Pixbuf;
import org.gnome.glib.Signal;
import org.gnome.gtk.Assistant;
import org.gnome.gtk.AssistantPageType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkAssistant extends Plumbing
{
    private GtkAssistant() {}

    static final long createAssistant() {
        long result;

        synchronized (lock) {
            result = gtk_assistant_new();

            return result;
        }
    }

    private static native final long gtk_assistant_new();

    static final int getCurrentPage(Assistant self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_current_page(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_assistant_get_current_page(long self);

    static final void setCurrentPage(Assistant self, int pageNum) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_assistant_set_current_page(pointerOf(self), pageNum);
        }
    }

    private static native final void gtk_assistant_set_current_page(long self, int pageNum);

    static final int getNPages(Assistant self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_n_pages(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_assistant_get_n_pages(long self);

    static final Widget getNthPage(Assistant self, int pageNum) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_nth_page(pointerOf(self), pageNum);

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_assistant_get_nth_page(long self, int pageNum);

    static final int prependPage(Assistant self, Widget page) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_prepend_page(pointerOf(self), pointerOf(page));

            return result;
        }
    }

    private static native final int gtk_assistant_prepend_page(long self, long page);

    static final int appendPage(Assistant self, Widget page) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_append_page(pointerOf(self), pointerOf(page));

            return result;
        }
    }

    private static native final int gtk_assistant_append_page(long self, long page);

    static final int insertPage(Assistant self, Widget page, int position) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_insert_page(pointerOf(self), pointerOf(page), position);

            return result;
        }
    }

    private static native final int gtk_assistant_insert_page(long self, long page, int position);

    static final void setForwardPageFunc(Assistant self, FIXME pageFunc, FIXME data, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkAssistantPageFunc");
    }

    static final void setPageType(Assistant self, Widget page, AssistantPageType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_assistant_set_page_type(pointerOf(self), pointerOf(page), numOf(type));
        }
    }

    private static native final void gtk_assistant_set_page_type(long self, long page, int type);

    static final AssistantPageType getPageType(Assistant self, Widget page) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_page_type(pointerOf(self), pointerOf(page));

            return (AssistantPageType) enumFor(AssistantPageType.class, result);
        }
    }

    private static native final int gtk_assistant_get_page_type(long self, long page);

    static final void setPageTitle(Assistant self, Widget page, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_assistant_set_page_title(pointerOf(self), pointerOf(page), title);
        }
    }

    private static native final void gtk_assistant_set_page_title(long self, long page, String title);

    static final String getPageTitle(Assistant self, Widget page) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_page_title(pointerOf(self), pointerOf(page));

            return result;
        }
    }

    private static native final String gtk_assistant_get_page_title(long self, long page);

    static final void setPageHeaderImage(Assistant self, Widget page, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            gtk_assistant_set_page_header_image(pointerOf(self), pointerOf(page), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_assistant_set_page_header_image(long self, long page, long pixbuf);

    static final Pixbuf getPageHeaderImage(Assistant self, Widget page) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_page_header_image(pointerOf(self), pointerOf(page));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_assistant_get_page_header_image(long self, long page);

    static final void setPageSideImage(Assistant self, Widget page, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            gtk_assistant_set_page_side_image(pointerOf(self), pointerOf(page), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_assistant_set_page_side_image(long self, long page, long pixbuf);

    static final Pixbuf getPageSideImage(Assistant self, Widget page) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_page_side_image(pointerOf(self), pointerOf(page));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_assistant_get_page_side_image(long self, long page);

    static final void setPageComplete(Assistant self, Widget page, boolean complete) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            gtk_assistant_set_page_complete(pointerOf(self), pointerOf(page), complete);
        }
    }

    private static native final void gtk_assistant_set_page_complete(long self, long page, boolean complete);

    static final boolean getPageComplete(Assistant self, Widget page) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (page == null) {
            throw new IllegalArgumentException("page can't be null");
        }

        synchronized (lock) {
            result = gtk_assistant_get_page_complete(pointerOf(self), pointerOf(page));

            return result;
        }
    }

    private static native final boolean gtk_assistant_get_page_complete(long self, long page);

    static final void addActionWidget(Assistant self, Widget child) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_assistant_add_action_widget(pointerOf(self), pointerOf(child));
        }
    }

    private static native final void gtk_assistant_add_action_widget(long self, long child);

    static final void removeActionWidget(Assistant self, Widget child) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_assistant_remove_action_widget(pointerOf(self), pointerOf(child));
        }
    }

    private static native final void gtk_assistant_remove_action_widget(long self, long child);

    static final void updateButtonsState(Assistant self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_assistant_update_buttons_state(pointerOf(self));
        }
    }

    private static native final void gtk_assistant_update_buttons_state(long self);

    interface PrepareSignal extends Signal
    {
        void onPrepare(Assistant source, Widget page);
    }

    static final void connect(Assistant self, GtkAssistant.PrepareSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAssistant.class, "prepare", after);
    }

    protected static final void receivePrepare(Signal handler, long source, long page) {
        ((GtkAssistant.PrepareSignal) handler).onPrepare((Assistant) objectFor(source), (Widget) objectFor(page));
    }

    interface ApplySignal extends Signal
    {
        void onApply(Assistant source);
    }

    static final void connect(Assistant self, GtkAssistant.ApplySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAssistant.class, "apply", after);
    }

    protected static final void receiveApply(Signal handler, long source) {
        ((GtkAssistant.ApplySignal) handler).onApply((Assistant) objectFor(source));
    }

    interface CloseSignal extends Signal
    {
        void onClose(Assistant source);
    }

    static final void connect(Assistant self, GtkAssistant.CloseSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAssistant.class, "close", after);
    }

    protected static final void receiveClose(Signal handler, long source) {
        ((GtkAssistant.CloseSignal) handler).onClose((Assistant) objectFor(source));
    }

    interface CancelSignal extends Signal
    {
        void onCancel(Assistant source);
    }

    static final void connect(Assistant self, GtkAssistant.CancelSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAssistant.class, "cancel", after);
    }

    protected static final void receiveCancel(Signal handler, long source) {
        ((GtkAssistant.CancelSignal) handler).onCancel((Assistant) objectFor(source));
    }
}

