/*
 * GtkBox.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Box;
import org.gnome.gtk.PackType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkBox extends Plumbing
{
    private GtkBox() {}

    static final void packStart(Box self, Widget child, boolean expand, boolean fill, int padding) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_box_pack_start(pointerOf(self), pointerOf(child), expand, fill, padding);
        }
    }

    private static native final void gtk_box_pack_start(long self, long child, boolean expand, boolean fill, int padding);

    static final void packEnd(Box self, Widget child, boolean expand, boolean fill, int padding) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_box_pack_end(pointerOf(self), pointerOf(child), expand, fill, padding);
        }
    }

    private static native final void gtk_box_pack_end(long self, long child, boolean expand, boolean fill, int padding);

    static final void setHomogeneous(Box self, boolean homogeneous) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_box_set_homogeneous(pointerOf(self), homogeneous);
        }
    }

    private static native final void gtk_box_set_homogeneous(long self, boolean homogeneous);

    static final boolean getHomogeneous(Box self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_box_get_homogeneous(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_box_get_homogeneous(long self);

    static final void setSpacing(Box self, int spacing) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_box_set_spacing(pointerOf(self), spacing);
        }
    }

    private static native final void gtk_box_set_spacing(long self, int spacing);

    static final int getSpacing(Box self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_box_get_spacing(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_box_get_spacing(long self);

    static final void reorderChild(Box self, Widget child, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_box_reorder_child(pointerOf(self), pointerOf(child), position);
        }
    }

    private static native final void gtk_box_reorder_child(long self, long child, int position);

    static final void queryChildPacking(Box self, Widget child, boolean[] expand, boolean[] fill, int[] padding, PackType[] packType) {
        int[] _packType;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (expand == null) {
            throw new IllegalArgumentException("expand can't be null");
        }

        if (fill == null) {
            throw new IllegalArgumentException("fill can't be null");
        }

        if (padding == null) {
            throw new IllegalArgumentException("padding can't be null");
        }

        if (packType == null) {
            throw new IllegalArgumentException("packType can't be null");
        }

        _packType = numsOf(packType);

        synchronized (lock) {
            gtk_box_query_child_packing(pointerOf(self), pointerOf(child), expand, fill, padding, _packType);
            fillEnumArray(PackType.class, packType, _packType);
        }
    }

    private static native final void gtk_box_query_child_packing(long self, long child, boolean[] expand, boolean[] fill, int[] padding, int[] packType);

    static final void setChildPacking(Box self, Widget child, boolean expand, boolean fill, int padding, PackType packType) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (packType == null) {
            throw new IllegalArgumentException("packType can't be null");
        }

        synchronized (lock) {
            gtk_box_set_child_packing(pointerOf(self), pointerOf(child), expand, fill, padding, numOf(packType));
        }
    }

    private static native final void gtk_box_set_child_packing(long self, long child, boolean expand, boolean fill, int padding, int packType);
}

