/*
 * GtkCellEditable.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Event;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.CellEditable;
import org.gnome.gtk.Plumbing;

final class GtkCellEditable extends Plumbing
{
    private GtkCellEditable() {}

    static final void startEditing(CellEditable self, Event event) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            gtk_cell_editable_start_editing(pointerOf((Object) self), pointerOf(event));
        }
    }

    private static native final void gtk_cell_editable_start_editing(long self, long event);

    static final void editingDone(CellEditable self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_editable_editing_done(pointerOf((Object) self));
        }
    }

    private static native final void gtk_cell_editable_editing_done(long self);

    static final void removeWidget(CellEditable self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_editable_remove_widget(pointerOf((Object) self));
        }
    }

    private static native final void gtk_cell_editable_remove_widget(long self);

    interface EditingDoneSignal extends Signal
    {
        void onEditingDone(CellEditable source);
    }

    static final void connect(CellEditable self, GtkCellEditable.EditingDoneSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellEditable.class, "editing-done", after);
    }

    protected static final void receiveEditingDone(Signal handler, long source) {
        ((GtkCellEditable.EditingDoneSignal) handler).onEditingDone((CellEditable) objectFor(source));
    }

    interface RemoveWidgetSignal extends Signal
    {
        void onRemoveWidget(CellEditable source);
    }

    static final void connect(CellEditable self, GtkCellEditable.RemoveWidgetSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellEditable.class, "remove-widget", after);
    }

    protected static final void receiveRemoveWidget(Signal handler, long source) {
        ((GtkCellEditable.RemoveWidgetSignal) handler).onRemoveWidget((CellEditable) objectFor(source));
    }

    interface StartEditingSignal extends Signal
    {
        void onStartEditing(CellEditable source, Event event);
    }

    static final void connect(CellEditable self, GtkCellEditable.StartEditingSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellEditable.class, "start-editing", after);
    }

    protected static final void receiveStartEditing(Signal handler, long source, long event) {
        ((GtkCellEditable.StartEditingSignal) handler).onStartEditing((CellEditable) objectFor(source), (Event) boxedFor(Event.class, event));
    }
}

