/*
 * GtkCellLayout.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.CellLayout;
import org.gnome.gtk.CellRenderer;
import org.gnome.gtk.Plumbing;

final class GtkCellLayout extends Plumbing
{
    private GtkCellLayout() {}

    static final void packStart(CellLayout self, CellRenderer cell, boolean expand) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        synchronized (lock) {
            gtk_cell_layout_pack_start(pointerOf((Object) self), pointerOf(cell), expand);
        }
    }

    private static native final void gtk_cell_layout_pack_start(long self, long cell, boolean expand);

    static final void packEnd(CellLayout self, CellRenderer cell, boolean expand) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        synchronized (lock) {
            gtk_cell_layout_pack_end(pointerOf((Object) self), pointerOf(cell), expand);
        }
    }

    private static native final void gtk_cell_layout_pack_end(long self, long cell, boolean expand);

    static final void clear(CellLayout self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_layout_clear(pointerOf((Object) self));
        }
    }

    private static native final void gtk_cell_layout_clear(long self);

    static final void setAttributes(CellLayout self, CellRenderer cell) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        synchronized (lock) {
            gtk_cell_layout_set_attributes(pointerOf((Object) self), pointerOf(cell));
        }
    }

    private static native final void gtk_cell_layout_set_attributes(long self, long cell);

    static final void addAttribute(CellLayout self, CellRenderer cell, String attribute, int column) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        if (attribute == null) {
            throw new IllegalArgumentException("attribute can't be null");
        }

        synchronized (lock) {
            gtk_cell_layout_add_attribute(pointerOf((Object) self), pointerOf(cell), attribute, column);
        }
    }

    private static native final void gtk_cell_layout_add_attribute(long self, long cell, String attribute, int column);

    static final void setCellDataFunc(CellLayout self, CellRenderer cell, FIXME func, FIXME funcData, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkCellLayoutDataFunc");
    }

    static final void clearAttributes(CellLayout self, CellRenderer cell) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        synchronized (lock) {
            gtk_cell_layout_clear_attributes(pointerOf((Object) self), pointerOf(cell));
        }
    }

    private static native final void gtk_cell_layout_clear_attributes(long self, long cell);

    static final void reorder(CellLayout self, CellRenderer cell, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        synchronized (lock) {
            gtk_cell_layout_reorder(pointerOf((Object) self), pointerOf(cell), position);
        }
    }

    private static native final void gtk_cell_layout_reorder(long self, long cell, int position);

    interface PackStartSignal extends Signal
    {
        void onPackStart(CellLayout source, CellRenderer cell, boolean expand);
    }

    static final void connect(CellLayout self, GtkCellLayout.PackStartSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellLayout.class, "pack-start", after);
    }

    protected static final void receivePackStart(Signal handler, long source, long cell, boolean expand) {
        ((GtkCellLayout.PackStartSignal) handler).onPackStart((CellLayout) objectFor(source), (CellRenderer) objectFor(cell), expand);
    }

    interface PackEndSignal extends Signal
    {
        void onPackEnd(CellLayout source, CellRenderer cell, boolean expand);
    }

    static final void connect(CellLayout self, GtkCellLayout.PackEndSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellLayout.class, "pack-end", after);
    }

    protected static final void receivePackEnd(Signal handler, long source, long cell, boolean expand) {
        ((GtkCellLayout.PackEndSignal) handler).onPackEnd((CellLayout) objectFor(source), (CellRenderer) objectFor(cell), expand);
    }

    interface ClearSignal extends Signal
    {
        void onClear(CellLayout source);
    }

    static final void connect(CellLayout self, GtkCellLayout.ClearSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellLayout.class, "clear", after);
    }

    protected static final void receiveClear(Signal handler, long source) {
        ((GtkCellLayout.ClearSignal) handler).onClear((CellLayout) objectFor(source));
    }

    interface AddAttributeSignal extends Signal
    {
        void onAddAttribute(CellLayout source, CellRenderer cell, String attribute, int column);
    }

    static final void connect(CellLayout self, GtkCellLayout.AddAttributeSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellLayout.class, "add-attribute", after);
    }

    protected static final void receiveAddAttribute(Signal handler, long source, long cell, String attribute, int column) {
        ((GtkCellLayout.AddAttributeSignal) handler).onAddAttribute((CellLayout) objectFor(source), (CellRenderer) objectFor(cell), attribute, column);
    }

    interface SetCellDataFuncSignal extends Signal
    {
        void onSetCellDataFunc(CellLayout source, CellRenderer cell, FIXME func, FIXME funcData, FIXME destroy);
    }

    static final void connect(CellLayout self, GtkCellLayout.SetCellDataFuncSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellLayout.class, "set-cell-data-func", after);
    }

    protected static final void receiveSetCellDataFunc(Signal handler, long source, long cell, java.lang.Object func, java.lang.Object funcData, java.lang.Object destroy) {
        ((GtkCellLayout.SetCellDataFuncSignal) handler).onSetCellDataFunc((CellLayout) objectFor(source), (CellRenderer) objectFor(cell), (FIXME) func, (FIXME) funcData, (FIXME) destroy);
    }

    interface ClearAttributesSignal extends Signal
    {
        void onClearAttributes(CellLayout source, CellRenderer cell);
    }

    static final void connect(CellLayout self, GtkCellLayout.ClearAttributesSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellLayout.class, "clear-attributes", after);
    }

    protected static final void receiveClearAttributes(Signal handler, long source, long cell) {
        ((GtkCellLayout.ClearAttributesSignal) handler).onClearAttributes((CellLayout) objectFor(source), (CellRenderer) objectFor(cell));
    }

    interface ReorderSignal extends Signal
    {
        void onReorder(CellLayout source, CellRenderer cell, int position);
    }

    static final void connect(CellLayout self, GtkCellLayout.ReorderSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkCellLayout.class, "reorder", after);
    }

    protected static final void receiveReorder(Signal handler, long source, long cell, int position) {
        ((GtkCellLayout.ReorderSignal) handler).onReorder((CellLayout) objectFor(source), (CellRenderer) objectFor(cell), position);
    }

    static final CellRenderer[] getCells(CellLayout self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_layout_get_cells(pointerOf((Object) self));

            return (CellRenderer[]) objectArrayFor(result, new CellRenderer[result.length]);
        }
    }

    private static native final long[] gtk_cell_layout_get_cells(long self);
}

