/*
 * GtkCellRendererAccel.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.ModifierType;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;

final class GtkCellRendererAccel extends Plumbing
{
    private GtkCellRendererAccel() {}

    static final long createCellRendererAccel() {
        long result;

        synchronized (lock) {
            result = gtk_cell_renderer_accel_new();

            return result;
        }
    }

    private static native final long gtk_cell_renderer_accel_new();

    interface AccelEditedSignal extends Signal
    {
        void onAccelEdited(CellRendererAccel source, String pathString, int accelKey, ModifierType accelMods, int hardwareKeycode);
    }

    static final void connect(CellRendererAccel self, GtkCellRendererAccel.AccelEditedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRendererAccel.class, "accel-edited", after);
    }

    protected static final void receiveAccelEdited(Signal handler, long source, String pathString, int accelKey, int accelMods, int hardwareKeycode) {
        ((GtkCellRendererAccel.AccelEditedSignal) handler).onAccelEdited((CellRendererAccel) objectFor(source), pathString, accelKey, (ModifierType) flagFor(ModifierType.class, accelMods), hardwareKeycode);
    }

    interface AccelClearedSignal extends Signal
    {
        void onAccelCleared(CellRendererAccel source, String pathString);
    }

    static final void connect(CellRendererAccel self, GtkCellRendererAccel.AccelClearedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRendererAccel.class, "accel-cleared", after);
    }

    protected static final void receiveAccelCleared(Signal handler, long source, String pathString) {
        ((GtkCellRendererAccel.AccelClearedSignal) handler).onAccelCleared((CellRendererAccel) objectFor(source), pathString);
    }
}

