/*
 * GtkCellRendererToggle.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.CellRendererToggle;
import org.gnome.gtk.Plumbing;

final class GtkCellRendererToggle extends Plumbing
{
    private GtkCellRendererToggle() {}

    static final long createCellRendererToggle() {
        long result;

        synchronized (lock) {
            result = gtk_cell_renderer_toggle_new();

            return result;
        }
    }

    private static native final long gtk_cell_renderer_toggle_new();

    static final boolean getRadio(CellRendererToggle self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_renderer_toggle_get_radio(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_cell_renderer_toggle_get_radio(long self);

    static final void setRadio(CellRendererToggle self, boolean radio) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_toggle_set_radio(pointerOf(self), radio);
        }
    }

    private static native final void gtk_cell_renderer_toggle_set_radio(long self, boolean radio);

    static final boolean getActive(CellRendererToggle self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_renderer_toggle_get_active(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_cell_renderer_toggle_get_active(long self);

    static final void setActive(CellRendererToggle self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_toggle_set_active(pointerOf(self), setting);
        }
    }

    private static native final void gtk_cell_renderer_toggle_set_active(long self, boolean setting);

    interface ToggledSignal extends Signal
    {
        void onToggled(CellRendererToggle source, String path);
    }

    static final void connect(CellRendererToggle self, GtkCellRendererToggle.ToggledSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRendererToggle.class, "toggled", after);
    }

    protected static final void receiveToggled(Signal handler, long source, String path) {
        ((GtkCellRendererToggle.ToggledSignal) handler).onToggled((CellRendererToggle) objectFor(source), path);
    }
}

