/*
 * GtkCheckButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Rectangle;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;

final class GtkCheckButton extends Plumbing
{
    private GtkCheckButton() {}

    static final long createCheckButton() {
        long result;

        synchronized (lock) {
            result = gtk_check_button_new();

            return result;
        }
    }

    private static native final long gtk_check_button_new();

    static final long createCheckButtonWithLabel(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_check_button_new_with_label(label);

            return result;
        }
    }

    private static native final long gtk_check_button_new_with_label(String label);

    static final long createCheckButtonWithMnemonic(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_check_button_new_with_mnemonic(label);

            return result;
        }
    }

    private static native final long gtk_check_button_new_with_mnemonic(String label);

    interface DrawIndicatorSignal extends Signal
    {
        void onDrawIndicator(CheckButton source, Rectangle area);
    }

    static final void connect(CheckButton self, GtkCheckButton.DrawIndicatorSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCheckButton.class, "draw-indicator", after);
    }

    protected static final void receiveDrawIndicator(Signal handler, long source, long area) {
        ((GtkCheckButton.DrawIndicatorSignal) handler).onDrawIndicator((CheckButton) objectFor(source), (Rectangle) boxedFor(Rectangle.class, area));
    }
}

