/*
 * GtkClipboard.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Display;
import org.gnome.gdk.EventOwnerChange;
import org.gnome.gdk.Pixbuf;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.Clipboard;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SelectionData;
import org.gnome.gtk.TextBuffer;

final class GtkClipboard extends Plumbing
{
    private GtkClipboard() {}

    static final boolean waitIsTargetAvailable(Clipboard self, FIXME target) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void setCanStore(Clipboard self, FIXME targets, int nTargets) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkTargetEntry*");
    }

    static final void store(Clipboard self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_clipboard_store(pointerOf(self));
        }
    }

    private static native final void gtk_clipboard_store(long self);

    static final long createClipboardpboardGetForDisplay(Display display, FIXME selection) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final Display getDisplay(Clipboard self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_clipboard_get_display(pointerOf(self));

            return (Display) objectFor(result);
        }
    }

    private static native final long gtk_clipboard_get_display(long self);

    static final boolean setWithData(Clipboard self, FIXME targets, int nTargets, FIXME getFunc, FIXME clearFunc, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkTargetEntry*");
    }

    static final boolean setWithOwner(Clipboard self, FIXME targets, int nTargets, FIXME getFunc, FIXME clearFunc, Object owner) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkTargetEntry*");
    }

    static final Object getOwner(Clipboard self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_clipboard_get_owner(pointerOf(self));

            return (Object) objectFor(result);
        }
    }

    private static native final long gtk_clipboard_get_owner(long self);

    static final void clear(Clipboard self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_clipboard_clear(pointerOf(self));
        }
    }

    private static native final void gtk_clipboard_clear(long self);

    static final void setText(Clipboard self, String text, int len) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_clipboard_set_text(pointerOf(self), text, len);
        }
    }

    private static native final void gtk_clipboard_set_text(long self, String text, int len);

    static final void requestContents(Clipboard self, FIXME target, FIXME callback, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void requestText(Clipboard self, FIXME callback, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkClipboardTextReceivedFunc");
    }

    static final void requestTargets(Clipboard self, FIXME callback, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkClipboardTargetsReceivedFunc");
    }

    static final SelectionData waitForContents(Clipboard self, FIXME target) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final String waitForText(Clipboard self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_clipboard_wait_for_text(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_clipboard_wait_for_text(long self);

    static final boolean waitIsTextAvailable(Clipboard self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_clipboard_wait_is_text_available(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_clipboard_wait_is_text_available(long self);

    static final boolean waitForTargets(Clipboard self, FIXME targets, int[] nTargets) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom**");
    }

    static final void requestImage(Clipboard self, FIXME callback, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkClipboardImageReceivedFunc");
    }

    static final Pixbuf waitForImage(Clipboard self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_clipboard_wait_for_image(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_clipboard_wait_for_image(long self);

    static final void setImage(Clipboard self, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            gtk_clipboard_set_image(pointerOf(self), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_clipboard_set_image(long self, long pixbuf);

    static final boolean waitIsImageAvailable(Clipboard self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_clipboard_wait_is_image_available(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_clipboard_wait_is_image_available(long self);

    static final void requestRichText(Clipboard self, TextBuffer buffer, FIXME callback, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkClipboardRichTextReceivedFunc");
    }

    static final FIXME waitForRichText(Clipboard self, TextBuffer buffer, FIXME format, long[] length) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guint8*");
    }

    static final boolean waitIsRichTextAvailable(Clipboard self, TextBuffer buffer) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (buffer == null) {
            throw new IllegalArgumentException("buffer can't be null");
        }

        synchronized (lock) {
            result = gtk_clipboard_wait_is_rich_text_available(pointerOf(self), pointerOf(buffer));

            return result;
        }
    }

    private static native final boolean gtk_clipboard_wait_is_rich_text_available(long self, long buffer);

    interface OwnerChangeSignal extends Signal
    {
        void onOwnerChange(Clipboard source, EventOwnerChange event);
    }

    static final void connect(Clipboard self, GtkClipboard.OwnerChangeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkClipboard.class, "owner-change", after);
    }

    protected static final void receiveOwnerChange(Signal handler, long source, long event) {
        ((GtkClipboard.OwnerChangeSignal) handler).onOwnerChange((Clipboard) objectFor(source), (EventOwnerChange) boxedFor(EventOwnerChange.class, event));
    }
}

