/*
 * GtkColorSelection.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Color;
import org.gnome.glib.Signal;
import org.gnome.gtk.ColorSelection;
import org.gnome.gtk.Plumbing;

final class GtkColorSelection extends Plumbing
{
    private GtkColorSelection() {}

    static final long createColorSelection() {
        long result;

        synchronized (lock) {
            result = gtk_color_selection_new();

            return result;
        }
    }

    private static native final long gtk_color_selection_new();

    static final boolean getHasOpacityControl(ColorSelection self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_selection_get_has_opacity_control(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_color_selection_get_has_opacity_control(long self);

    static final void setHasOpacityControl(ColorSelection self, boolean hasOpacity) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_set_has_opacity_control(pointerOf(self), hasOpacity);
        }
    }

    private static native final void gtk_color_selection_set_has_opacity_control(long self, boolean hasOpacity);

    static final boolean getHasPalette(ColorSelection self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_selection_get_has_palette(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_color_selection_get_has_palette(long self);

    static final void setHasPalette(ColorSelection self, boolean hasPalette) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_set_has_palette(pointerOf(self), hasPalette);
        }
    }

    private static native final void gtk_color_selection_set_has_palette(long self, boolean hasPalette);

    static final void setCurrentColor(ColorSelection self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_set_current_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gtk_color_selection_set_current_color(long self, long color);

    static final void setCurrentAlpha(ColorSelection self, char alpha) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_set_current_alpha(pointerOf(self), alpha);
        }
    }

    private static native final void gtk_color_selection_set_current_alpha(long self, char alpha);

    static final void getCurrentColor(ColorSelection self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_get_current_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gtk_color_selection_get_current_color(long self, long color);

    static final char getCurrentAlpha(ColorSelection self) {
        char result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_selection_get_current_alpha(pointerOf(self));

            return result;
        }
    }

    private static native final char gtk_color_selection_get_current_alpha(long self);

    static final void setPreviousColor(ColorSelection self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_set_previous_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gtk_color_selection_set_previous_color(long self, long color);

    static final void setPreviousAlpha(ColorSelection self, char alpha) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_set_previous_alpha(pointerOf(self), alpha);
        }
    }

    private static native final void gtk_color_selection_set_previous_alpha(long self, char alpha);

    static final void getPreviousColor(ColorSelection self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gtk_color_selection_get_previous_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gtk_color_selection_get_previous_color(long self, long color);

    static final char getPreviousAlpha(ColorSelection self) {
        char result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_selection_get_previous_alpha(pointerOf(self));

            return result;
        }
    }

    private static native final char gtk_color_selection_get_previous_alpha(long self);

    static final boolean isAdjusting(ColorSelection self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_selection_is_adjusting(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_color_selection_is_adjusting(long self);

    interface ColorChangedSignal extends Signal
    {
        void onColorChanged(ColorSelection source);
    }

    static final void connect(ColorSelection self, GtkColorSelection.ColorChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkColorSelection.class, "color-changed", after);
    }

    protected static final void receiveColorChanged(Signal handler, long source) {
        ((GtkColorSelection.ColorChangedSignal) handler).onColorChanged((ColorSelection) objectFor(source));
    }
}

