/*
 * GtkEntry.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Border;
import org.gnome.gtk.DeleteType;
import org.gnome.gtk.Entry;
import org.gnome.gtk.EntryCompletion;
import org.gnome.gtk.Menu;
import org.gnome.gtk.MovementStep;
import org.gnome.gtk.Plumbing;
import org.gnome.pango.Layout;

final class GtkEntry extends Plumbing
{
    private GtkEntry() {}

    static final long createEntry() {
        long result;

        synchronized (lock) {
            result = gtk_entry_new();

            return result;
        }
    }

    private static native final long gtk_entry_new();

    static final void setVisibility(Entry self, boolean visible) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_visibility(pointerOf(self), visible);
        }
    }

    private static native final void gtk_entry_set_visibility(long self, boolean visible);

    static final boolean getVisibility(Entry self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_visibility(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_entry_get_visibility(long self);

    static final void setInvisibleChar(Entry self, char ch) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_invisible_char(pointerOf(self), ch);
        }
    }

    private static native final void gtk_entry_set_invisible_char(long self, char ch);

    static final char getInvisibleChar(Entry self) {
        char result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_invisible_char(pointerOf(self));

            return result;
        }
    }

    private static native final char gtk_entry_get_invisible_char(long self);

    static final void setHasFrame(Entry self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_has_frame(pointerOf(self), setting);
        }
    }

    private static native final void gtk_entry_set_has_frame(long self, boolean setting);

    static final boolean getHasFrame(Entry self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_has_frame(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_entry_get_has_frame(long self);

    static final void setMaxLength(Entry self, int max) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_max_length(pointerOf(self), max);
        }
    }

    private static native final void gtk_entry_set_max_length(long self, int max);

    static final int getMaxLength(Entry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_max_length(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_entry_get_max_length(long self);

    static final void setActivatesDefault(Entry self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_activates_default(pointerOf(self), setting);
        }
    }

    private static native final void gtk_entry_set_activates_default(long self, boolean setting);

    static final boolean getActivatesDefault(Entry self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_activates_default(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_entry_get_activates_default(long self);

    static final void setWidthChars(Entry self, int nChars) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_width_chars(pointerOf(self), nChars);
        }
    }

    private static native final void gtk_entry_set_width_chars(long self, int nChars);

    static final int getWidthChars(Entry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_width_chars(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_entry_get_width_chars(long self);

    static final void setText(Entry self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_entry_set_text(long self, String text);

    static final String getText(Entry self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_text(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_entry_get_text(long self);

    static final Layout getLayout(Entry self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_layout(pointerOf(self));

            return (Layout) objectFor(result);
        }
    }

    private static native final long gtk_entry_get_layout(long self);

    static final void getLayoutOffsets(Entry self, int[] x, int[] y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        synchronized (lock) {
            gtk_entry_get_layout_offsets(pointerOf(self), x, y);
        }
    }

    private static native final void gtk_entry_get_layout_offsets(long self, int[] x, int[] y);

    static final void setAlignment(Entry self, float xalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_alignment(pointerOf(self), xalign);
        }
    }

    private static native final void gtk_entry_set_alignment(long self, float xalign);

    static final float getAlignment(Entry self) {
        float result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_alignment(pointerOf(self));

            return result;
        }
    }

    private static native final float gtk_entry_get_alignment(long self);

    static final void setCompletion(Entry self, EntryCompletion completion) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_completion(pointerOf(self), pointerOf(completion));
        }
    }

    private static native final void gtk_entry_set_completion(long self, long completion);

    static final EntryCompletion getCompletion(Entry self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_completion(pointerOf(self));

            return (EntryCompletion) objectFor(result);
        }
    }

    private static native final long gtk_entry_get_completion(long self);

    static final int layoutIndexToTextIndex(Entry self, int layoutIndex) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_layout_index_to_text_index(pointerOf(self), layoutIndex);

            return result;
        }
    }

    private static native final int gtk_entry_layout_index_to_text_index(long self, int layoutIndex);

    static final int textIndexToLayoutIndex(Entry self, int textIndex) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_text_index_to_layout_index(pointerOf(self), textIndex);

            return result;
        }
    }

    private static native final int gtk_entry_text_index_to_layout_index(long self, int textIndex);

    interface PopulatePopupSignal extends Signal
    {
        void onPopulatePopup(Entry source, Menu menu);
    }

    static final void connect(Entry self, GtkEntry.PopulatePopupSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "populate-popup", after);
    }

    protected static final void receivePopulatePopup(Signal handler, long source, long menu) {
        ((GtkEntry.PopulatePopupSignal) handler).onPopulatePopup((Entry) objectFor(source), (Menu) objectFor(menu));
    }

    interface ActivateSignal extends Signal
    {
        void onActivate(Entry source);
    }

    static final void connect(Entry self, GtkEntry.ActivateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "activate", after);
    }

    protected static final void receiveActivate(Signal handler, long source) {
        ((GtkEntry.ActivateSignal) handler).onActivate((Entry) objectFor(source));
    }

    interface MoveCursorSignal extends Signal
    {
        void onMoveCursor(Entry source, MovementStep step, int count, boolean extendSelection);
    }

    static final void connect(Entry self, GtkEntry.MoveCursorSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "move-cursor", after);
    }

    protected static final void receiveMoveCursor(Signal handler, long source, int step, int count, boolean extendSelection) {
        ((GtkEntry.MoveCursorSignal) handler).onMoveCursor((Entry) objectFor(source), (MovementStep) enumFor(MovementStep.class, step), count, extendSelection);
    }

    interface InsertAtCursorSignal extends Signal
    {
        void onInsertAtCursor(Entry source, String str);
    }

    static final void connect(Entry self, GtkEntry.InsertAtCursorSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "insert-at-cursor", after);
    }

    protected static final void receiveInsertAtCursor(Signal handler, long source, String str) {
        ((GtkEntry.InsertAtCursorSignal) handler).onInsertAtCursor((Entry) objectFor(source), str);
    }

    interface DeleteFromCursorSignal extends Signal
    {
        void onDeleteFromCursor(Entry source, DeleteType type, int count);
    }

    static final void connect(Entry self, GtkEntry.DeleteFromCursorSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "delete-from-cursor", after);
    }

    protected static final void receiveDeleteFromCursor(Signal handler, long source, int type, int count) {
        ((GtkEntry.DeleteFromCursorSignal) handler).onDeleteFromCursor((Entry) objectFor(source), (DeleteType) enumFor(DeleteType.class, type), count);
    }

    interface BackspaceSignal extends Signal
    {
        void onBackspace(Entry source);
    }

    static final void connect(Entry self, GtkEntry.BackspaceSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "backspace", after);
    }

    protected static final void receiveBackspace(Signal handler, long source) {
        ((GtkEntry.BackspaceSignal) handler).onBackspace((Entry) objectFor(source));
    }

    interface CutClipboardSignal extends Signal
    {
        void onCutClipboard(Entry source);
    }

    static final void connect(Entry self, GtkEntry.CutClipboardSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "cut-clipboard", after);
    }

    protected static final void receiveCutClipboard(Signal handler, long source) {
        ((GtkEntry.CutClipboardSignal) handler).onCutClipboard((Entry) objectFor(source));
    }

    interface CopyClipboardSignal extends Signal
    {
        void onCopyClipboard(Entry source);
    }

    static final void connect(Entry self, GtkEntry.CopyClipboardSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "copy-clipboard", after);
    }

    protected static final void receiveCopyClipboard(Signal handler, long source) {
        ((GtkEntry.CopyClipboardSignal) handler).onCopyClipboard((Entry) objectFor(source));
    }

    interface PasteClipboardSignal extends Signal
    {
        void onPasteClipboard(Entry source);
    }

    static final void connect(Entry self, GtkEntry.PasteClipboardSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "paste-clipboard", after);
    }

    protected static final void receivePasteClipboard(Signal handler, long source) {
        ((GtkEntry.PasteClipboardSignal) handler).onPasteClipboard((Entry) objectFor(source));
    }

    interface ToggleOverwriteSignal extends Signal
    {
        void onToggleOverwrite(Entry source);
    }

    static final void connect(Entry self, GtkEntry.ToggleOverwriteSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkEntry.class, "toggle-overwrite", after);
    }

    protected static final void receiveToggleOverwrite(Signal handler, long source) {
        ((GtkEntry.ToggleOverwriteSignal) handler).onToggleOverwrite((Entry) objectFor(source));
    }

    static final void setInnerBorder(Entry self, Border border) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_inner_border(pointerOf(self), pointerOf(border));
        }
    }

    private static native final void gtk_entry_set_inner_border(long self, long border);

    static final Border getInnerBorder(Entry self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_inner_border(pointerOf(self));

            return (Border) boxedFor(Border.class, result);
        }
    }

    private static native final long gtk_entry_get_inner_border(long self);

    static final void setCursorHadjustment(Entry self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_entry_set_cursor_hadjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_entry_set_cursor_hadjustment(long self, long adjustment);

    static final Adjustment getCursorHadjustment(Entry self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_entry_get_cursor_hadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_entry_get_cursor_hadjustment(long self);
}

