/*
 * GtkEventBox.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.EventBox;
import org.gnome.gtk.Plumbing;

final class GtkEventBox extends Plumbing
{
    private GtkEventBox() {}

    static final long createEventBox() {
        long result;

        synchronized (lock) {
            result = gtk_event_box_new();

            return result;
        }
    }

    private static native final long gtk_event_box_new();

    static final boolean getVisibleWindow(EventBox self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_event_box_get_visible_window(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_event_box_get_visible_window(long self);

    static final void setVisibleWindow(EventBox self, boolean visibleWindow) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_event_box_set_visible_window(pointerOf(self), visibleWindow);
        }
    }

    private static native final void gtk_event_box_set_visible_window(long self, boolean visibleWindow);

    static final boolean getAboveChild(EventBox self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_event_box_get_above_child(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_event_box_get_above_child(long self);

    static final void setAboveChild(EventBox self, boolean aboveChild) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_event_box_set_above_child(pointerOf(self), aboveChild);
        }
    }

    private static native final void gtk_event_box_set_above_child(long self, boolean aboveChild);
}

