/*
 * GtkExpander.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Expander;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkExpander extends Plumbing
{
    private GtkExpander() {}

    static final long createExpander(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_expander_new(label);

            return result;
        }
    }

    private static native final long gtk_expander_new(String label);

    static final long createExpanderWithMnemonic(String label) {
        long result;

        synchronized (lock) {
            result = gtk_expander_new_with_mnemonic(label);

            return result;
        }
    }

    private static native final long gtk_expander_new_with_mnemonic(String label);

    static final void setExpanded(Expander self, boolean expanded) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_expander_set_expanded(pointerOf(self), expanded);
        }
    }

    private static native final void gtk_expander_set_expanded(long self, boolean expanded);

    static final boolean getExpanded(Expander self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_expander_get_expanded(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_expander_get_expanded(long self);

    static final void setSpacing(Expander self, int spacing) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_expander_set_spacing(pointerOf(self), spacing);
        }
    }

    private static native final void gtk_expander_set_spacing(long self, int spacing);

    static final int getSpacing(Expander self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_expander_get_spacing(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_expander_get_spacing(long self);

    static final void setLabel(Expander self, String label) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_expander_set_label(pointerOf(self), label);
        }
    }

    private static native final void gtk_expander_set_label(long self, String label);

    static final String getLabel(Expander self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_expander_get_label(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_expander_get_label(long self);

    static final void setUseUnderline(Expander self, boolean useUnderline) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_expander_set_use_underline(pointerOf(self), useUnderline);
        }
    }

    private static native final void gtk_expander_set_use_underline(long self, boolean useUnderline);

    static final boolean getUseUnderline(Expander self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_expander_get_use_underline(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_expander_get_use_underline(long self);

    static final void setUseMarkup(Expander self, boolean useMarkup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_expander_set_use_markup(pointerOf(self), useMarkup);
        }
    }

    private static native final void gtk_expander_set_use_markup(long self, boolean useMarkup);

    static final boolean getUseMarkup(Expander self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_expander_get_use_markup(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_expander_get_use_markup(long self);

    static final void setLabelWidget(Expander self, Widget labelWidget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_expander_set_label_widget(pointerOf(self), pointerOf(labelWidget));
        }
    }

    private static native final void gtk_expander_set_label_widget(long self, long labelWidget);

    static final Widget getLabelWidget(Expander self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_expander_get_label_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_expander_get_label_widget(long self);

    interface ActivateSignal extends Signal
    {
        void onActivate(Expander source);
    }

    static final void connect(Expander self, GtkExpander.ActivateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkExpander.class, "activate", after);
    }

    protected static final void receiveActivate(Signal handler, long source) {
        ((GtkExpander.ActivateSignal) handler).onActivate((Expander) objectFor(source));
    }
}

