/*
 * GtkFileChooserButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.FileChooserAction;
import org.gnome.gtk.FileChooserButton;
import org.gnome.gtk.Plumbing;

final class GtkFileChooserButton extends Plumbing
{
    private GtkFileChooserButton() {}

    static final long createFileChooserButton(String title, FileChooserAction action) {
        long result;

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        if (action == null) {
            throw new IllegalArgumentException("action can't be null");
        }

        synchronized (lock) {
            result = gtk_file_chooser_button_new(title, numOf(action));

            return result;
        }
    }

    private static native final long gtk_file_chooser_button_new(String title, int action);

    static final String getTitle(FileChooserButton self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_file_chooser_button_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_file_chooser_button_get_title(long self);

    static final void setTitle(FileChooserButton self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_file_chooser_button_set_title(pointerOf(self), title);
        }
    }

    private static native final void gtk_file_chooser_button_set_title(long self, String title);

    static final int getWidthChars(FileChooserButton self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_file_chooser_button_get_width_chars(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_file_chooser_button_get_width_chars(long self);

    static final void setWidthChars(FileChooserButton self, int nChars) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_file_chooser_button_set_width_chars(pointerOf(self), nChars);
        }
    }

    private static native final void gtk_file_chooser_button_set_width_chars(long self, int nChars);

    static final boolean getFocusOnClick(FileChooserButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_file_chooser_button_get_focus_on_click(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_file_chooser_button_get_focus_on_click(long self);

    static final void setFocusOnClick(FileChooserButton self, boolean focusOnClick) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_file_chooser_button_set_focus_on_click(pointerOf(self), focusOnClick);
        }
    }

    private static native final void gtk_file_chooser_button_set_focus_on_click(long self, boolean focusOnClick);

    interface FileSetSignal extends Signal
    {
        void onFileSet(FileChooserButton source);
    }

    static final void connect(FileChooserButton self, GtkFileChooserButton.FileSetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkFileChooserButton.class, "file-set", after);
    }

    protected static final void receiveFileSet(Signal handler, long source) {
        ((GtkFileChooserButton.FileSetSignal) handler).onFileSet((FileChooserButton) objectFor(source));
    }
}

