/*
 * GtkFileFilter.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gtk.FileFilter;
import org.gnome.gtk.FileFilterFlags;
import org.gnome.gtk.Plumbing;

final class GtkFileFilter extends Plumbing
{
    private GtkFileFilter() {}

    static final long createFileFilter() {
        long result;

        synchronized (lock) {
            result = gtk_file_filter_new();

            return result;
        }
    }

    private static native final long gtk_file_filter_new();

    static final void setName(FileFilter self, String name) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            gtk_file_filter_set_name(pointerOf(self), name);
        }
    }

    private static native final void gtk_file_filter_set_name(long self, String name);

    static final String getName(FileFilter self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_file_filter_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_file_filter_get_name(long self);

    static final void addMimeType(FileFilter self, String mimeType) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mimeType == null) {
            throw new IllegalArgumentException("mimeType can't be null");
        }

        synchronized (lock) {
            gtk_file_filter_add_mime_type(pointerOf(self), mimeType);
        }
    }

    private static native final void gtk_file_filter_add_mime_type(long self, String mimeType);

    static final void addPattern(FileFilter self, String pattern) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pattern == null) {
            throw new IllegalArgumentException("pattern can't be null");
        }

        synchronized (lock) {
            gtk_file_filter_add_pattern(pointerOf(self), pattern);
        }
    }

    private static native final void gtk_file_filter_add_pattern(long self, String pattern);

    static final void addPixbufFormats(FileFilter self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_file_filter_add_pixbuf_formats(pointerOf(self));
        }
    }

    private static native final void gtk_file_filter_add_pixbuf_formats(long self);

    static final void addCustom(FileFilter self, FileFilterFlags needed, FIXME func, FIXME data, FIXME notify) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkFileFilterFunc");
    }

    static final FileFilterFlags getNeeded(FileFilter self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_file_filter_get_needed(pointerOf(self));

            return (FileFilterFlags) flagFor(FileFilterFlags.class, result);
        }
    }

    private static native final int gtk_file_filter_get_needed(long self);

    static final boolean filter(FileFilter self, FIXME filterInfo) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkFileFilterInfo*");
    }
}

