/*
 * GtkFixed.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Fixed;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkFixed extends Plumbing
{
    private GtkFixed() {}

    static final long createFixed() {
        long result;

        synchronized (lock) {
            result = gtk_fixed_new();

            return result;
        }
    }

    private static native final long gtk_fixed_new();

    static final void put(Fixed self, Widget widget, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        synchronized (lock) {
            gtk_fixed_put(pointerOf(self), pointerOf(widget), x, y);
        }
    }

    private static native final void gtk_fixed_put(long self, long widget, int x, int y);

    static final void move(Fixed self, Widget widget, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        synchronized (lock) {
            gtk_fixed_move(pointerOf(self), pointerOf(widget), x, y);
        }
    }

    private static native final void gtk_fixed_move(long self, long widget, int x, int y);

    static final void setHasWindow(Fixed self, boolean hasWindow) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_fixed_set_has_window(pointerOf(self), hasWindow);
        }
    }

    private static native final void gtk_fixed_set_has_window(long self, boolean hasWindow);

    static final boolean getHasWindow(Fixed self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_fixed_get_has_window(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_fixed_get_has_window(long self);
}

