/*
 * GtkFontButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.FontButton;
import org.gnome.gtk.Plumbing;

final class GtkFontButton extends Plumbing
{
    private GtkFontButton() {}

    static final long createFontButton() {
        long result;

        synchronized (lock) {
            result = gtk_font_button_new();

            return result;
        }
    }

    private static native final long gtk_font_button_new();

    static final String getTitle(FontButton self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_button_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_font_button_get_title(long self);

    static final void setTitle(FontButton self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_font_button_set_title(pointerOf(self), title);
        }
    }

    private static native final void gtk_font_button_set_title(long self, String title);

    static final boolean getUseFont(FontButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_button_get_use_font(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_font_button_get_use_font(long self);

    static final void setUseFont(FontButton self, boolean useFont) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_font_button_set_use_font(pointerOf(self), useFont);
        }
    }

    private static native final void gtk_font_button_set_use_font(long self, boolean useFont);

    static final boolean getUseSize(FontButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_button_get_use_size(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_font_button_get_use_size(long self);

    static final void setUseSize(FontButton self, boolean useSize) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_font_button_set_use_size(pointerOf(self), useSize);
        }
    }

    private static native final void gtk_font_button_set_use_size(long self, boolean useSize);

    static final String getFontName(FontButton self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_button_get_font_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_font_button_get_font_name(long self);

    static final boolean setFontName(FontButton self, String fontname) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (fontname == null) {
            throw new IllegalArgumentException("fontname can't be null");
        }

        synchronized (lock) {
            result = gtk_font_button_set_font_name(pointerOf(self), fontname);

            return result;
        }
    }

    private static native final boolean gtk_font_button_set_font_name(long self, String fontname);

    static final boolean getShowStyle(FontButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_button_get_show_style(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_font_button_get_show_style(long self);

    static final void setShowStyle(FontButton self, boolean showStyle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_font_button_set_show_style(pointerOf(self), showStyle);
        }
    }

    private static native final void gtk_font_button_set_show_style(long self, boolean showStyle);

    static final boolean getShowSize(FontButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_button_get_show_size(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_font_button_get_show_size(long self);

    static final void setShowSize(FontButton self, boolean showSize) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_font_button_set_show_size(pointerOf(self), showSize);
        }
    }

    private static native final void gtk_font_button_set_show_size(long self, boolean showSize);

    interface FontSetSignal extends Signal
    {
        void onFontSet(FontButton source);
    }

    static final void connect(FontButton self, GtkFontButton.FontSetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkFontButton.class, "font-set", after);
    }

    protected static final void receiveFontSet(Signal handler, long source) {
        ((GtkFontButton.FontSetSignal) handler).onFontSet((FontButton) objectFor(source));
    }
}

