/*
 * GtkFontSelection.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.FontSelection;
import org.gnome.gtk.Plumbing;

final class GtkFontSelection extends Plumbing
{
    private GtkFontSelection() {}

    static final long createFontSelection() {
        long result;

        synchronized (lock) {
            result = gtk_font_selection_new();

            return result;
        }
    }

    private static native final long gtk_font_selection_new();

    static final String getFontName(FontSelection self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_selection_get_font_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_font_selection_get_font_name(long self);

    static final boolean setFontName(FontSelection self, String fontname) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (fontname == null) {
            throw new IllegalArgumentException("fontname can't be null");
        }

        synchronized (lock) {
            result = gtk_font_selection_set_font_name(pointerOf(self), fontname);

            return result;
        }
    }

    private static native final boolean gtk_font_selection_set_font_name(long self, String fontname);

    static final String getPreviewText(FontSelection self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_font_selection_get_preview_text(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_font_selection_get_preview_text(long self);

    static final void setPreviewText(FontSelection self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_font_selection_set_preview_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_font_selection_set_preview_text(long self, String text);
}

