/*
 * GtkFrame.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Allocation;
import org.gnome.gtk.Frame;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ShadowType;
import org.gnome.gtk.Widget;

final class GtkFrame extends Plumbing
{
    private GtkFrame() {}

    static final long createFrame(String label) {
        long result;

        synchronized (lock) {
            result = gtk_frame_new(label);

            return result;
        }
    }

    private static native final long gtk_frame_new(String label);

    static final void setLabel(Frame self, String label) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_frame_set_label(pointerOf(self), label);
        }
    }

    private static native final void gtk_frame_set_label(long self, String label);

    static final String getLabel(Frame self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_frame_get_label(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_frame_get_label(long self);

    static final void setLabelWidget(Frame self, Widget labelWidget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (labelWidget == null) {
            throw new IllegalArgumentException("labelWidget can't be null");
        }

        synchronized (lock) {
            gtk_frame_set_label_widget(pointerOf(self), pointerOf(labelWidget));
        }
    }

    private static native final void gtk_frame_set_label_widget(long self, long labelWidget);

    static final Widget getLabelWidget(Frame self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_frame_get_label_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_frame_get_label_widget(long self);

    static final void setLabelAlign(Frame self, float xalign, float yalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_frame_set_label_align(pointerOf(self), xalign, yalign);
        }
    }

    private static native final void gtk_frame_set_label_align(long self, float xalign, float yalign);

    static final void getLabelAlign(Frame self, float[] xalign, float[] yalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (xalign == null) {
            throw new IllegalArgumentException("xalign can't be null");
        }

        if (yalign == null) {
            throw new IllegalArgumentException("yalign can't be null");
        }

        synchronized (lock) {
            gtk_frame_get_label_align(pointerOf(self), xalign, yalign);
        }
    }

    private static native final void gtk_frame_get_label_align(long self, float[] xalign, float[] yalign);

    static final void setShadowType(Frame self, ShadowType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_frame_set_shadow_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gtk_frame_set_shadow_type(long self, int type);

    static final ShadowType getShadowType(Frame self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_frame_get_shadow_type(pointerOf(self));

            return (ShadowType) enumFor(ShadowType.class, result);
        }
    }

    private static native final int gtk_frame_get_shadow_type(long self);

    interface ComputeChildAllocationSignal extends Signal
    {
        void onComputeChildAllocation(Frame source, Allocation allocation);
    }

    static final void connect(Frame self, GtkFrame.ComputeChildAllocationSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkFrame.class, "compute-child-allocation", after);
    }

    protected static final void receiveComputeChildAllocation(Signal handler, long source, long allocation) {
        ((GtkFrame.ComputeChildAllocationSignal) handler).onComputeChildAllocation((Frame) objectFor(source), (Allocation) boxedFor(Allocation.class, allocation));
    }
}

