/*
 * GtkIconSet.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Pixbuf;
import org.gnome.gtk.IconSet;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.IconSource;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.StateType;
import org.gnome.gtk.Style;
import org.gnome.gtk.TextDirection;
import org.gnome.gtk.Widget;

final class GtkIconSet extends Plumbing
{
    private GtkIconSet() {}

    static final long createIconSetFromPixbuf(Pixbuf pixbuf) {
        long result;

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_set_new_from_pixbuf(pointerOf(pixbuf));

            return result;
        }
    }

    private static native final long gtk_icon_set_new_from_pixbuf(long pixbuf);

    static final IconSet ref(IconSet self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_set_ref(pointerOf(self));

            return (IconSet) boxedFor(IconSet.class, result);
        }
    }

    private static native final long gtk_icon_set_ref(long self);

    static final void unref(IconSet self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_set_unref(pointerOf(self));
        }
    }

    private static native final void gtk_icon_set_unref(long self);

    static final IconSet copy(IconSet self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_set_copy(pointerOf(self));

            return (IconSet) boxedFor(IconSet.class, result);
        }
    }

    private static native final long gtk_icon_set_copy(long self);

    static final Pixbuf renderIcon(IconSet self, Style style, TextDirection direction, StateType state, IconSize size, Widget widget, String detail) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (style == null) {
            throw new IllegalArgumentException("style can't be null");
        }

        if (direction == null) {
            throw new IllegalArgumentException("direction can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_set_render_icon(pointerOf(self), pointerOf(style), numOf(direction), numOf(state), numOf(size), pointerOf(widget), detail);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_icon_set_render_icon(long self, long style, int direction, int state, int size, long widget, String detail);

    static final void addSource(IconSet self, IconSource source) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (source == null) {
            throw new IllegalArgumentException("source can't be null");
        }

        synchronized (lock) {
            gtk_icon_set_add_source(pointerOf(self), pointerOf(source));
        }
    }

    private static native final void gtk_icon_set_add_source(long self, long source);

    static final void getSizes(IconSet self, FIXME sizes, int[] nSizes) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkIconSize**");
    }
}

