/*
 * GtkIconSource.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Pixbuf;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.IconSource;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.StateType;
import org.gnome.gtk.TextDirection;

final class GtkIconSource extends Plumbing
{
    private GtkIconSource() {}

    static final long createIconSource() {
        long result;

        synchronized (lock) {
            result = gtk_icon_source_new();

            return result;
        }
    }

    private static native final long gtk_icon_source_new();

    static final IconSource copy(IconSource self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_copy(pointerOf(self));

            return (IconSource) boxedFor(IconSource.class, result);
        }
    }

    private static native final long gtk_icon_source_copy(long self);

    static final void free(IconSource self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_free(pointerOf(self));
        }
    }

    private static native final void gtk_icon_source_free(long self);

    static final void setFilename(IconSource self, String filename) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_filename(pointerOf(self), filename);
        }
    }

    private static native final void gtk_icon_source_set_filename(long self, String filename);

    static final void setIconName(IconSource self, String iconName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_icon_name(pointerOf(self), iconName);
        }
    }

    private static native final void gtk_icon_source_set_icon_name(long self, String iconName);

    static final void setPixbuf(IconSource self, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_pixbuf(pointerOf(self), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_icon_source_set_pixbuf(long self, long pixbuf);

    static final String getFilename(IconSource self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_filename(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_icon_source_get_filename(long self);

    static final String getIconName(IconSource self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_icon_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_icon_source_get_icon_name(long self);

    static final Pixbuf getPixbuf(IconSource self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_pixbuf(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_icon_source_get_pixbuf(long self);

    static final void setDirectionWildcarded(IconSource self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_direction_wildcarded(pointerOf(self), setting);
        }
    }

    private static native final void gtk_icon_source_set_direction_wildcarded(long self, boolean setting);

    static final void setStateWildcarded(IconSource self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_state_wildcarded(pointerOf(self), setting);
        }
    }

    private static native final void gtk_icon_source_set_state_wildcarded(long self, boolean setting);

    static final void setSizeWildcarded(IconSource self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_size_wildcarded(pointerOf(self), setting);
        }
    }

    private static native final void gtk_icon_source_set_size_wildcarded(long self, boolean setting);

    static final boolean getSizeWildcarded(IconSource self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_size_wildcarded(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_icon_source_get_size_wildcarded(long self);

    static final boolean getStateWildcarded(IconSource self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_state_wildcarded(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_icon_source_get_state_wildcarded(long self);

    static final boolean getDirectionWildcarded(IconSource self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_direction_wildcarded(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_icon_source_get_direction_wildcarded(long self);

    static final void setDirection(IconSource self, TextDirection direction) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (direction == null) {
            throw new IllegalArgumentException("direction can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_direction(pointerOf(self), numOf(direction));
        }
    }

    private static native final void gtk_icon_source_set_direction(long self, int direction);

    static final void setState(IconSource self, StateType state) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_state(pointerOf(self), numOf(state));
        }
    }

    private static native final void gtk_icon_source_set_state(long self, int state);

    static final void setSize(IconSource self, IconSize size) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            gtk_icon_source_set_size(pointerOf(self), numOf(size));
        }
    }

    private static native final void gtk_icon_source_set_size(long self, int size);

    static final TextDirection getDirection(IconSource self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_direction(pointerOf(self));

            return (TextDirection) enumFor(TextDirection.class, result);
        }
    }

    private static native final int gtk_icon_source_get_direction(long self);

    static final StateType getState(IconSource self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_state(pointerOf(self));

            return (StateType) enumFor(StateType.class, result);
        }
    }

    private static native final int gtk_icon_source_get_state(long self);

    static final IconSize getSize(IconSource self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_source_get_size(pointerOf(self));

            return (IconSize) enumFor(IconSize.class, result);
        }
    }

    private static native final int gtk_icon_source_get_size(long self);
}

