/*
 * GtkImage.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Bitmap;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.PixbufAnimation;
import org.gnome.gdk.Pixmap;
import org.gnome.gtk.IconSet;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.Image;
import org.gnome.gtk.ImageType;
import org.gnome.gtk.Plumbing;

final class GtkImage extends Plumbing
{
    private GtkImage() {}

    static final long createImage() {
        long result;

        synchronized (lock) {
            result = gtk_image_new();

            return result;
        }
    }

    private static native final long gtk_image_new();

    static final long createImageFromPixmap(Pixmap pixmap, Bitmap mask) {
        long result;

        synchronized (lock) {
            result = gtk_image_new_from_pixmap(pointerOf(pixmap), pointerOf(mask));

            return result;
        }
    }

    private static native final long gtk_image_new_from_pixmap(long pixmap, long mask);

    static final long createImageFromFile(String filename) {
        long result;

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = gtk_image_new_from_file(filename);

            return result;
        }
    }

    private static native final long gtk_image_new_from_file(String filename);

    static final long createImageFromPixbuf(Pixbuf pixbuf) {
        long result;

        synchronized (lock) {
            result = gtk_image_new_from_pixbuf(pointerOf(pixbuf));

            return result;
        }
    }

    private static native final long gtk_image_new_from_pixbuf(long pixbuf);

    static final long createImageFromStock(String stockId, IconSize size) {
        long result;

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            result = gtk_image_new_from_stock(stockId, numOf(size));

            return result;
        }
    }

    private static native final long gtk_image_new_from_stock(String stockId, int size);

    static final long createImageFromIconSet(IconSet iconSet, IconSize size) {
        long result;

        if (iconSet == null) {
            throw new IllegalArgumentException("iconSet can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            result = gtk_image_new_from_icon_set(pointerOf(iconSet), numOf(size));

            return result;
        }
    }

    private static native final long gtk_image_new_from_icon_set(long iconSet, int size);

    static final long createImageFromAnimation(PixbufAnimation animation) {
        long result;

        if (animation == null) {
            throw new IllegalArgumentException("animation can't be null");
        }

        synchronized (lock) {
            result = gtk_image_new_from_animation(pointerOf(animation));

            return result;
        }
    }

    private static native final long gtk_image_new_from_animation(long animation);

    static final long createImageFromIconName(String iconName, IconSize size) {
        long result;

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            result = gtk_image_new_from_icon_name(iconName, numOf(size));

            return result;
        }
    }

    private static native final long gtk_image_new_from_icon_name(String iconName, int size);

    static final void clear(Image self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_image_clear(pointerOf(self));
        }
    }

    private static native final void gtk_image_clear(long self);

    static final void setFromPixmap(Image self, Pixmap pixmap, Bitmap mask) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixmap == null) {
            throw new IllegalArgumentException("pixmap can't be null");
        }

        synchronized (lock) {
            gtk_image_set_from_pixmap(pointerOf(self), pointerOf(pixmap), pointerOf(mask));
        }
    }

    private static native final void gtk_image_set_from_pixmap(long self, long pixmap, long mask);

    static final void setFromFile(Image self, String filename) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_image_set_from_file(pointerOf(self), filename);
        }
    }

    private static native final void gtk_image_set_from_file(long self, String filename);

    static final void setFromPixbuf(Image self, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_image_set_from_pixbuf(pointerOf(self), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_image_set_from_pixbuf(long self, long pixbuf);

    static final void setFromStock(Image self, String stockId, IconSize size) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            gtk_image_set_from_stock(pointerOf(self), stockId, numOf(size));
        }
    }

    private static native final void gtk_image_set_from_stock(long self, String stockId, int size);

    static final void setFromIconSet(Image self, IconSet iconSet, IconSize size) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconSet == null) {
            throw new IllegalArgumentException("iconSet can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            gtk_image_set_from_icon_set(pointerOf(self), pointerOf(iconSet), numOf(size));
        }
    }

    private static native final void gtk_image_set_from_icon_set(long self, long iconSet, int size);

    static final void setFromAnimation(Image self, PixbufAnimation animation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (animation == null) {
            throw new IllegalArgumentException("animation can't be null");
        }

        synchronized (lock) {
            gtk_image_set_from_animation(pointerOf(self), pointerOf(animation));
        }
    }

    private static native final void gtk_image_set_from_animation(long self, long animation);

    static final ImageType getStorageType(Image self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_image_get_storage_type(pointerOf(self));

            return (ImageType) enumFor(ImageType.class, result);
        }
    }

    private static native final int gtk_image_get_storage_type(long self);

    static final void getPixmap(Image self, Pixmap[] pixmap, Bitmap[] mask) {
        long[] _pixmap;
        long[] _mask;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixmap == null) {
            throw new IllegalArgumentException("pixmap can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        _pixmap = pointersOf(pixmap);

        _mask = pointersOf(mask);

        synchronized (lock) {
            gtk_image_get_pixmap(pointerOf(self), _pixmap, _mask);
            fillObjectArray(pixmap, _pixmap);
            fillObjectArray(mask, _mask);
        }
    }

    private static native final void gtk_image_get_pixmap(long self, long[] pixmap, long[] mask);

    static final Pixbuf getPixbuf(Image self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_image_get_pixbuf(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_image_get_pixbuf(long self);

    static final void getStock(Image self, String[] stockId, IconSize[] size) {
        int[] _size;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        _size = numsOf(size);

        synchronized (lock) {
            gtk_image_get_stock(pointerOf(self), stockId, _size);
            fillEnumArray(IconSize.class, size, _size);
        }
    }

    private static native final void gtk_image_get_stock(long self, String[] stockId, int[] size);

    static final void getIconSet(Image self, IconSet[] iconSet, IconSize[] size) {
        long[] _iconSet;
        int[] _size;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconSet == null) {
            throw new IllegalArgumentException("iconSet can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        _iconSet = pointersOf(iconSet);

        _size = numsOf(size);

        synchronized (lock) {
            gtk_image_get_icon_set(pointerOf(self), _iconSet, _size);
            fillBoxedArray(IconSet.class, iconSet, _iconSet);
            fillEnumArray(IconSize.class, size, _size);
        }
    }

    private static native final void gtk_image_get_icon_set(long self, long[] iconSet, int[] size);

    static final PixbufAnimation getAnimation(Image self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_image_get_animation(pointerOf(self));

            return (PixbufAnimation) objectFor(result);
        }
    }

    private static native final long gtk_image_get_animation(long self);

    static final void setFromIconName(Image self, String iconName, IconSize size) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            gtk_image_set_from_icon_name(pointerOf(self), iconName, numOf(size));
        }
    }

    private static native final void gtk_image_set_from_icon_name(long self, String iconName, int size);

    static final void setPixelSize(Image self, int pixelSize) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_image_set_pixel_size(pointerOf(self), pixelSize);
        }
    }

    private static native final void gtk_image_set_pixel_size(long self, int pixelSize);

    static final void getIconName(Image self, String[] iconName, IconSize[] size) {
        int[] _size;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        _size = numsOf(size);

        synchronized (lock) {
            gtk_image_get_icon_name(pointerOf(self), iconName, _size);
            fillEnumArray(IconSize.class, size, _size);
        }
    }

    private static native final void gtk_image_get_icon_name(long self, String[] iconName, int[] size);

    static final int getPixelSize(Image self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_image_get_pixel_size(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_image_get_pixel_size(long self);
}

