/*
 * GtkImageMenuItem.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.AccelGroup;
import org.gnome.gtk.ImageMenuItem;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkImageMenuItem extends Plumbing
{
    private GtkImageMenuItem() {}

    static final long createImageMenuItem() {
        long result;

        synchronized (lock) {
            result = gtk_image_menu_item_new();

            return result;
        }
    }

    private static native final long gtk_image_menu_item_new();

    static final long createImageMenuItemWithLabel(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_image_menu_item_new_with_label(label);

            return result;
        }
    }

    private static native final long gtk_image_menu_item_new_with_label(String label);

    static final long createImageMenuItemWithMnemonic(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_image_menu_item_new_with_mnemonic(label);

            return result;
        }
    }

    private static native final long gtk_image_menu_item_new_with_mnemonic(String label);

    static final long createImageMenuItemFromStock(String stockId, AccelGroup accelGroup) {
        long result;

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_image_menu_item_new_from_stock(stockId, pointerOf(accelGroup));

            return result;
        }
    }

    private static native final long gtk_image_menu_item_new_from_stock(String stockId, long accelGroup);

    static final void setImage(ImageMenuItem self, Widget image) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_image_menu_item_set_image(pointerOf(self), pointerOf(image));
        }
    }

    private static native final void gtk_image_menu_item_set_image(long self, long image);

    static final Widget getImage(ImageMenuItem self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_image_menu_item_get_image(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_image_menu_item_get_image(long self);
}

