/*
 * GtkItem.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Item;
import org.gnome.gtk.Plumbing;

final class GtkItem extends Plumbing
{
    private GtkItem() {}

    static final void select(Item self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_item_select(pointerOf(self));
        }
    }

    private static native final void gtk_item_select(long self);

    static final void deselect(Item self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_item_deselect(pointerOf(self));
        }
    }

    private static native final void gtk_item_deselect(long self);

    static final void toggle(Item self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_item_toggle(pointerOf(self));
        }
    }

    private static native final void gtk_item_toggle(long self);

    interface SelectSignal extends Signal
    {
        void onSelect(Item source);
    }

    static final void connect(Item self, GtkItem.SelectSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkItem.class, "select", after);
    }

    protected static final void receiveSelect(Signal handler, long source) {
        ((GtkItem.SelectSignal) handler).onSelect((Item) objectFor(source));
    }

    interface DeselectSignal extends Signal
    {
        void onDeselect(Item source);
    }

    static final void connect(Item self, GtkItem.DeselectSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkItem.class, "deselect", after);
    }

    protected static final void receiveDeselect(Signal handler, long source) {
        ((GtkItem.DeselectSignal) handler).onDeselect((Item) objectFor(source));
    }

    interface ToggleSignal extends Signal
    {
        void onToggle(Item source);
    }

    static final void connect(Item self, GtkItem.ToggleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkItem.class, "toggle", after);
    }

    protected static final void receiveToggle(Signal handler, long source) {
        ((GtkItem.ToggleSignal) handler).onToggle((Item) objectFor(source));
    }
}

