/*
 * GtkLayout.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Layout;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkLayout extends Plumbing
{
    private GtkLayout() {}

    static final long createLayout(Adjustment hadjustment, Adjustment vadjustment) {
        long result;

        synchronized (lock) {
            result = gtk_layout_new(pointerOf(hadjustment), pointerOf(vadjustment));

            return result;
        }
    }

    private static native final long gtk_layout_new(long hadjustment, long vadjustment);

    static final void put(Layout self, Widget childWidget, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childWidget == null) {
            throw new IllegalArgumentException("childWidget can't be null");
        }

        synchronized (lock) {
            gtk_layout_put(pointerOf(self), pointerOf(childWidget), x, y);
        }
    }

    private static native final void gtk_layout_put(long self, long childWidget, int x, int y);

    static final void move(Layout self, Widget childWidget, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childWidget == null) {
            throw new IllegalArgumentException("childWidget can't be null");
        }

        synchronized (lock) {
            gtk_layout_move(pointerOf(self), pointerOf(childWidget), x, y);
        }
    }

    private static native final void gtk_layout_move(long self, long childWidget, int x, int y);

    static final void setSize(Layout self, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_layout_set_size(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_layout_set_size(long self, int width, int height);

    static final void getSize(Layout self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gtk_layout_get_size(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_layout_get_size(long self, int[] width, int[] height);

    static final Adjustment getHadjustment(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_layout_get_hadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_layout_get_hadjustment(long self);

    static final Adjustment getVadjustment(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_layout_get_vadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_layout_get_vadjustment(long self);

    static final void setHadjustment(Layout self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_layout_set_hadjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_layout_set_hadjustment(long self, long adjustment);

    static final void setVadjustment(Layout self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_layout_set_vadjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_layout_set_vadjustment(long self, long adjustment);

    interface SetScrollAdjustmentsSignal extends Signal
    {
        void onSetScrollAdjustments(Layout source, Adjustment hadjustment, Adjustment vadjustment);
    }

    static final void connect(Layout self, GtkLayout.SetScrollAdjustmentsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkLayout.class, "set-scroll-adjustments", after);
    }

    protected static final void receiveSetScrollAdjustments(Signal handler, long source, long hadjustment, long vadjustment) {
        ((GtkLayout.SetScrollAdjustmentsSignal) handler).onSetScrollAdjustments((Layout) objectFor(source), (Adjustment) objectFor(hadjustment), (Adjustment) objectFor(vadjustment));
    }
}

