/*
 * GtkListStore.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Value;
import org.gnome.gtk.ListStore;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreeIter;

final class GtkListStore extends Plumbing
{
    private GtkListStore() {}

    static final void setValue(ListStore self, TreeIter iter, int column, Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            gtk_list_store_set_value(pointerOf(self), pointerOf(iter), column, pointerOf(value));
        }
    }

    private static native final void gtk_list_store_set_value(long self, long iter, int column, long value);

    static final boolean remove(ListStore self, TreeIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_list_store_remove(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_list_store_remove(long self, long iter);

    static final void insert(ListStore self, TreeIter iter, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_list_store_insert(pointerOf(self), pointerOf(iter), position);
        }
    }

    private static native final void gtk_list_store_insert(long self, long iter, int position);

    static final void insertBefore(ListStore self, TreeIter iter, TreeIter sibling) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (sibling == null) {
            throw new IllegalArgumentException("sibling can't be null");
        }

        synchronized (lock) {
            gtk_list_store_insert_before(pointerOf(self), pointerOf(iter), pointerOf(sibling));
        }
    }

    private static native final void gtk_list_store_insert_before(long self, long iter, long sibling);

    static final void insertAfter(ListStore self, TreeIter iter, TreeIter sibling) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (sibling == null) {
            throw new IllegalArgumentException("sibling can't be null");
        }

        synchronized (lock) {
            gtk_list_store_insert_after(pointerOf(self), pointerOf(iter), pointerOf(sibling));
        }
    }

    private static native final void gtk_list_store_insert_after(long self, long iter, long sibling);

    static final void insertWithValues(ListStore self, TreeIter iter, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_list_store_insert_with_values(pointerOf(self), pointerOf(iter), position);
        }
    }

    private static native final void gtk_list_store_insert_with_values(long self, long iter, int position);

    static final void insertWithValuesv(ListStore self, TreeIter iter, int position, int[] columns, Value values, int nValues) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (columns == null) {
            throw new IllegalArgumentException("columns can't be null");
        }

        if (values == null) {
            throw new IllegalArgumentException("values can't be null");
        }

        synchronized (lock) {
            gtk_list_store_insert_with_valuesv(pointerOf(self), pointerOf(iter), position, columns, pointerOf(values), nValues);
        }
    }

    private static native final void gtk_list_store_insert_with_valuesv(long self, long iter, int position, int[] columns, long values, int nValues);

    static final void prepend(ListStore self, TreeIter iter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_list_store_prepend(pointerOf(self), pointerOf(iter));
        }
    }

    private static native final void gtk_list_store_prepend(long self, long iter);

    static final void append(ListStore self, TreeIter iter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_list_store_append(pointerOf(self), pointerOf(iter));
        }
    }

    private static native final void gtk_list_store_append(long self, long iter);

    static final void clear(ListStore self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_list_store_clear(pointerOf(self));
        }
    }

    private static native final void gtk_list_store_clear(long self);

    static final boolean iterIsValid(ListStore self, TreeIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_list_store_iter_is_valid(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_list_store_iter_is_valid(long self, long iter);

    static final void reorder(ListStore self, int[] newOrder) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (newOrder == null) {
            throw new IllegalArgumentException("newOrder can't be null");
        }

        synchronized (lock) {
            gtk_list_store_reorder(pointerOf(self), newOrder);
        }
    }

    private static native final void gtk_list_store_reorder(long self, int[] newOrder);

    static final void swap(ListStore self, TreeIter a, TreeIter b) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (a == null) {
            throw new IllegalArgumentException("a can't be null");
        }

        if (b == null) {
            throw new IllegalArgumentException("b can't be null");
        }

        synchronized (lock) {
            gtk_list_store_swap(pointerOf(self), pointerOf(a), pointerOf(b));
        }
    }

    private static native final void gtk_list_store_swap(long self, long a, long b);

    static final void moveAfter(ListStore self, TreeIter iter, TreeIter position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_list_store_move_after(pointerOf(self), pointerOf(iter), pointerOf(position));
        }
    }

    private static native final void gtk_list_store_move_after(long self, long iter, long position);

    static final void moveBefore(ListStore self, TreeIter iter, TreeIter position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_list_store_move_before(pointerOf(self), pointerOf(iter), pointerOf(position));
        }
    }

    private static native final void gtk_list_store_move_before(long self, long iter, long position);
}

