/*
 * GtkMenuBar.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.MenuBar;
import org.gnome.gtk.PackDirection;
import org.gnome.gtk.Plumbing;

final class GtkMenuBar extends Plumbing
{
    private GtkMenuBar() {}

    static final long createMenuBar() {
        long result;

        synchronized (lock) {
            result = gtk_menu_bar_new();

            return result;
        }
    }

    private static native final long gtk_menu_bar_new();

    static final PackDirection getPackDirection(MenuBar self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_bar_get_pack_direction(pointerOf(self));

            return (PackDirection) enumFor(PackDirection.class, result);
        }
    }

    private static native final int gtk_menu_bar_get_pack_direction(long self);

    static final void setPackDirection(MenuBar self, PackDirection packDir) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (packDir == null) {
            throw new IllegalArgumentException("packDir can't be null");
        }

        synchronized (lock) {
            gtk_menu_bar_set_pack_direction(pointerOf(self), numOf(packDir));
        }
    }

    private static native final void gtk_menu_bar_set_pack_direction(long self, int packDir);

    static final PackDirection getChildPackDirection(MenuBar self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_bar_get_child_pack_direction(pointerOf(self));

            return (PackDirection) enumFor(PackDirection.class, result);
        }
    }

    private static native final int gtk_menu_bar_get_child_pack_direction(long self);

    static final void setChildPackDirection(MenuBar self, PackDirection childPackDir) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childPackDir == null) {
            throw new IllegalArgumentException("childPackDir can't be null");
        }

        synchronized (lock) {
            gtk_menu_bar_set_child_pack_direction(pointerOf(self), numOf(childPackDir));
        }
    }

    private static native final void gtk_menu_bar_set_child_pack_direction(long self, int childPackDir);
}

