/*
 * GtkMenuToolButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.gtk.MenuToolButton;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkMenuToolButton extends Plumbing
{
    private GtkMenuToolButton() {}

    static final long createMenuToolButton(Widget iconWidget, String label) {
        long result;

        synchronized (lock) {
            result = gtk_menu_tool_button_new(pointerOf(iconWidget), label);

            return result;
        }
    }

    private static native final long gtk_menu_tool_button_new(long iconWidget, String label);

    static final long createMenuToolButtonFromStock(String stockId) {
        long result;

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_tool_button_new_from_stock(stockId);

            return result;
        }
    }

    private static native final long gtk_menu_tool_button_new_from_stock(String stockId);

    static final void setMenu(MenuToolButton self, Widget menu) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_tool_button_set_menu(pointerOf(self), pointerOf(menu));
        }
    }

    private static native final void gtk_menu_tool_button_set_menu(long self, long menu);

    static final Widget getMenu(MenuToolButton self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_tool_button_get_menu(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_menu_tool_button_get_menu(long self);

    static final void setArrowTooltip(MenuToolButton self, FIXME tooltips, String tipText, String tipPrivate) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTooltips*");
    }

    interface ShowMenuSignal extends Signal
    {
        void onShowMenu(MenuToolButton source);
    }

    static final void connect(MenuToolButton self, GtkMenuToolButton.ShowMenuSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkMenuToolButton.class, "show-menu", after);
    }

    protected static final void receiveShowMenu(Signal handler, long source) {
        ((GtkMenuToolButton.ShowMenuSignal) handler).onShowMenu((MenuToolButton) objectFor(source));
    }
}

