/*
 * GtkMisc.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Misc;
import org.gnome.gtk.Plumbing;

final class GtkMisc extends Plumbing
{
    private GtkMisc() {}

    static final void setAlignment(Misc self, float xalign, float yalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_misc_set_alignment(pointerOf(self), xalign, yalign);
        }
    }

    private static native final void gtk_misc_set_alignment(long self, float xalign, float yalign);

    static final void getAlignment(Misc self, float[] xalign, float[] yalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (xalign == null) {
            throw new IllegalArgumentException("xalign can't be null");
        }

        if (yalign == null) {
            throw new IllegalArgumentException("yalign can't be null");
        }

        synchronized (lock) {
            gtk_misc_get_alignment(pointerOf(self), xalign, yalign);
        }
    }

    private static native final void gtk_misc_get_alignment(long self, float[] xalign, float[] yalign);

    static final void setPadding(Misc self, int xpad, int ypad) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_misc_set_padding(pointerOf(self), xpad, ypad);
        }
    }

    private static native final void gtk_misc_set_padding(long self, int xpad, int ypad);

    static final void getPadding(Misc self, int[] xpad, int[] ypad) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (xpad == null) {
            throw new IllegalArgumentException("xpad can't be null");
        }

        if (ypad == null) {
            throw new IllegalArgumentException("ypad can't be null");
        }

        synchronized (lock) {
            gtk_misc_get_padding(pointerOf(self), xpad, ypad);
        }
    }

    private static native final void gtk_misc_get_padding(long self, int[] xpad, int[] ypad);
}

