/*
 * GtkNotebook.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.DirectionType;
import org.gnome.gtk.Notebook;
import org.gnome.gtk.NotebookTab;
import org.gnome.gtk.PackType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PositionType;
import org.gnome.gtk.Widget;

final class GtkNotebook extends Plumbing
{
    private GtkNotebook() {}

    static final long createNotebook() {
        long result;

        synchronized (lock) {
            result = gtk_notebook_new();

            return result;
        }
    }

    private static native final long gtk_notebook_new();

    static final int appendPage(Notebook self, Widget child, Widget tabLabel) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_append_page(pointerOf(self), pointerOf(child), pointerOf(tabLabel));

            return result;
        }
    }

    private static native final int gtk_notebook_append_page(long self, long child, long tabLabel);

    static final int appendPageMenu(Notebook self, Widget child, Widget tabLabel, Widget menuLabel) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_append_page_menu(pointerOf(self), pointerOf(child), pointerOf(tabLabel), pointerOf(menuLabel));

            return result;
        }
    }

    private static native final int gtk_notebook_append_page_menu(long self, long child, long tabLabel, long menuLabel);

    static final int prependPage(Notebook self, Widget child, Widget tabLabel) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_prepend_page(pointerOf(self), pointerOf(child), pointerOf(tabLabel));

            return result;
        }
    }

    private static native final int gtk_notebook_prepend_page(long self, long child, long tabLabel);

    static final int prependPageMenu(Notebook self, Widget child, Widget tabLabel, Widget menuLabel) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_prepend_page_menu(pointerOf(self), pointerOf(child), pointerOf(tabLabel), pointerOf(menuLabel));

            return result;
        }
    }

    private static native final int gtk_notebook_prepend_page_menu(long self, long child, long tabLabel, long menuLabel);

    static final int insertPage(Notebook self, Widget child, Widget tabLabel, int position) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_insert_page(pointerOf(self), pointerOf(child), pointerOf(tabLabel), position);

            return result;
        }
    }

    private static native final int gtk_notebook_insert_page(long self, long child, long tabLabel, int position);

    static final int insertPageMenu(Notebook self, Widget child, Widget tabLabel, Widget menuLabel, int position) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_insert_page_menu(pointerOf(self), pointerOf(child), pointerOf(tabLabel), pointerOf(menuLabel), position);

            return result;
        }
    }

    private static native final int gtk_notebook_insert_page_menu(long self, long child, long tabLabel, long menuLabel, int position);

    static final void removePage(Notebook self, int pageNum) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_remove_page(pointerOf(self), pageNum);
        }
    }

    private static native final void gtk_notebook_remove_page(long self, int pageNum);

    static final int getCurrentPage(Notebook self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_current_page(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_notebook_get_current_page(long self);

    static final Widget getNthPage(Notebook self, int pageNum) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_nth_page(pointerOf(self), pageNum);

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_notebook_get_nth_page(long self, int pageNum);

    static final int getNPages(Notebook self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_n_pages(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_notebook_get_n_pages(long self);

    static final int pageNum(Notebook self, Widget child) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_page_num(pointerOf(self), pointerOf(child));

            return result;
        }
    }

    private static native final int gtk_notebook_page_num(long self, long child);

    static final void setCurrentPage(Notebook self, int pageNum) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_current_page(pointerOf(self), pageNum);
        }
    }

    private static native final void gtk_notebook_set_current_page(long self, int pageNum);

    static final void nextPage(Notebook self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_next_page(pointerOf(self));
        }
    }

    private static native final void gtk_notebook_next_page(long self);

    static final void prevPage(Notebook self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_prev_page(pointerOf(self));
        }
    }

    private static native final void gtk_notebook_prev_page(long self);

    static final void setShowBorder(Notebook self, boolean showBorder) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_show_border(pointerOf(self), showBorder);
        }
    }

    private static native final void gtk_notebook_set_show_border(long self, boolean showBorder);

    static final boolean getShowBorder(Notebook self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_show_border(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_notebook_get_show_border(long self);

    static final void setShowTabs(Notebook self, boolean showTabs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_show_tabs(pointerOf(self), showTabs);
        }
    }

    private static native final void gtk_notebook_set_show_tabs(long self, boolean showTabs);

    static final boolean getShowTabs(Notebook self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_show_tabs(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_notebook_get_show_tabs(long self);

    static final void setTabPos(Notebook self, PositionType pos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pos == null) {
            throw new IllegalArgumentException("pos can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_tab_pos(pointerOf(self), numOf(pos));
        }
    }

    private static native final void gtk_notebook_set_tab_pos(long self, int pos);

    static final PositionType getTabPos(Notebook self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_tab_pos(pointerOf(self));

            return (PositionType) enumFor(PositionType.class, result);
        }
    }

    private static native final int gtk_notebook_get_tab_pos(long self);

    static final void setScrollable(Notebook self, boolean scrollable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_scrollable(pointerOf(self), scrollable);
        }
    }

    private static native final void gtk_notebook_set_scrollable(long self, boolean scrollable);

    static final boolean getScrollable(Notebook self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_scrollable(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_notebook_get_scrollable(long self);

    static final void popupEnable(Notebook self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_popup_enable(pointerOf(self));
        }
    }

    private static native final void gtk_notebook_popup_enable(long self);

    static final void popupDisable(Notebook self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_notebook_popup_disable(pointerOf(self));
        }
    }

    private static native final void gtk_notebook_popup_disable(long self);

    static final Widget getTabLabel(Notebook self, Widget child) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_tab_label(pointerOf(self), pointerOf(child));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_notebook_get_tab_label(long self, long child);

    static final void setTabLabel(Notebook self, Widget child, Widget tabLabel) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_tab_label(pointerOf(self), pointerOf(child), pointerOf(tabLabel));
        }
    }

    private static native final void gtk_notebook_set_tab_label(long self, long child, long tabLabel);

    static final void setTabLabelText(Notebook self, Widget child, String tabText) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (tabText == null) {
            throw new IllegalArgumentException("tabText can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_tab_label_text(pointerOf(self), pointerOf(child), tabText);
        }
    }

    private static native final void gtk_notebook_set_tab_label_text(long self, long child, String tabText);

    static final String getTabLabelText(Notebook self, Widget child) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_tab_label_text(pointerOf(self), pointerOf(child));

            return result;
        }
    }

    private static native final String gtk_notebook_get_tab_label_text(long self, long child);

    static final Widget getMenuLabel(Notebook self, Widget child) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_menu_label(pointerOf(self), pointerOf(child));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_notebook_get_menu_label(long self, long child);

    static final void setMenuLabel(Notebook self, Widget child, Widget menuLabel) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_menu_label(pointerOf(self), pointerOf(child), pointerOf(menuLabel));
        }
    }

    private static native final void gtk_notebook_set_menu_label(long self, long child, long menuLabel);

    static final void setMenuLabelText(Notebook self, Widget child, String menuText) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (menuText == null) {
            throw new IllegalArgumentException("menuText can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_menu_label_text(pointerOf(self), pointerOf(child), menuText);
        }
    }

    private static native final void gtk_notebook_set_menu_label_text(long self, long child, String menuText);

    static final String getMenuLabelText(Notebook self, Widget child) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_menu_label_text(pointerOf(self), pointerOf(child));

            return result;
        }
    }

    private static native final String gtk_notebook_get_menu_label_text(long self, long child);

    static final void queryTabLabelPacking(Notebook self, Widget child, boolean[] expand, boolean[] fill, PackType[] packType) {
        int[] _packType;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (expand == null) {
            throw new IllegalArgumentException("expand can't be null");
        }

        if (fill == null) {
            throw new IllegalArgumentException("fill can't be null");
        }

        if (packType == null) {
            throw new IllegalArgumentException("packType can't be null");
        }

        _packType = numsOf(packType);

        synchronized (lock) {
            gtk_notebook_query_tab_label_packing(pointerOf(self), pointerOf(child), expand, fill, _packType);
            fillEnumArray(PackType.class, packType, _packType);
        }
    }

    private static native final void gtk_notebook_query_tab_label_packing(long self, long child, boolean[] expand, boolean[] fill, int[] packType);

    static final void setTabLabelPacking(Notebook self, Widget child, boolean expand, boolean fill, PackType packType) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (packType == null) {
            throw new IllegalArgumentException("packType can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_tab_label_packing(pointerOf(self), pointerOf(child), expand, fill, numOf(packType));
        }
    }

    private static native final void gtk_notebook_set_tab_label_packing(long self, long child, boolean expand, boolean fill, int packType);

    static final void reorderChild(Notebook self, Widget child, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_notebook_reorder_child(pointerOf(self), pointerOf(child), position);
        }
    }

    private static native final void gtk_notebook_reorder_child(long self, long child, int position);

    interface SwitchPageSignal extends Signal
    {
        void onSwitchPage(Notebook source, long page, int pageNum);
    }

    static final void connect(Notebook self, GtkNotebook.SwitchPageSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkNotebook.class, "switch-page", after);
    }

    protected static final void receiveSwitchPage(Signal handler, long source, long page, int pageNum) {
        ((GtkNotebook.SwitchPageSignal) handler).onSwitchPage((Notebook) objectFor(source), page, pageNum);
    }

    interface SelectPageSignal extends Signal
    {
        boolean onSelectPage(Notebook source, boolean moveFocus);
    }

    static final void connect(Notebook self, GtkNotebook.SelectPageSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkNotebook.class, "select-page", after);
    }

    protected static final boolean receiveSelectPage(Signal handler, long source, boolean moveFocus) {
        boolean result;

        result = ((GtkNotebook.SelectPageSignal) handler).onSelectPage((Notebook) objectFor(source), moveFocus);

        return result;
    }

    interface FocusTabSignal extends Signal
    {
        boolean onFocusTab(Notebook source, NotebookTab type);
    }

    static final void connect(Notebook self, GtkNotebook.FocusTabSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkNotebook.class, "focus-tab", after);
    }

    protected static final boolean receiveFocusTab(Signal handler, long source, int type) {
        boolean result;

        result = ((GtkNotebook.FocusTabSignal) handler).onFocusTab((Notebook) objectFor(source), (NotebookTab) enumFor(NotebookTab.class, type));

        return result;
    }

    interface ChangeCurrentPageSignal extends Signal
    {
        boolean onChangeCurrentPage(Notebook source, int offset);
    }

    static final void connect(Notebook self, GtkNotebook.ChangeCurrentPageSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkNotebook.class, "change-current-page", after);
    }

    protected static final boolean receiveChangeCurrentPage(Signal handler, long source, int offset) {
        boolean result;

        result = ((GtkNotebook.ChangeCurrentPageSignal) handler).onChangeCurrentPage((Notebook) objectFor(source), offset);

        return result;
    }

    static final boolean getTabReorderable(Notebook self, Widget child) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_tab_reorderable(pointerOf(self), pointerOf(child));

            return result;
        }
    }

    private static native final boolean gtk_notebook_get_tab_reorderable(long self, long child);

    static final void setTabReorderable(Notebook self, Widget child, boolean reorderable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_tab_reorderable(pointerOf(self), pointerOf(child), reorderable);
        }
    }

    private static native final void gtk_notebook_set_tab_reorderable(long self, long child, boolean reorderable);

    static final boolean getTabDetachable(Notebook self, Widget child) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_notebook_get_tab_detachable(pointerOf(self), pointerOf(child));

            return result;
        }
    }

    private static native final boolean gtk_notebook_get_tab_detachable(long self, long child);

    static final void setTabDetachable(Notebook self, Widget child, boolean detachable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_notebook_set_tab_detachable(pointerOf(self), pointerOf(child), detachable);
        }
    }

    private static native final void gtk_notebook_set_tab_detachable(long self, long child, boolean detachable);

    interface ReorderTabSignal extends Signal
    {
        void onReorderTab(Notebook source, DirectionType direction, boolean moveToLast);
    }

    static final void connect(Notebook self, GtkNotebook.ReorderTabSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkNotebook.class, "reorder-tab", after);
    }

    protected static final void receiveReorderTab(Signal handler, long source, int direction, boolean moveToLast) {
        ((GtkNotebook.ReorderTabSignal) handler).onReorderTab((Notebook) objectFor(source), (DirectionType) enumFor(DirectionType.class, direction), moveToLast);
    }

    interface InsertPageSignal extends Signal
    {
        int onInsertPage(Notebook source, Widget child, Widget tabLabel, Widget menuLabel, int position);
    }

    static final void connect(Notebook self, GtkNotebook.InsertPageSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkNotebook.class, "insert-page", after);
    }

    protected static final int receiveInsertPage(Signal handler, long source, long child, long tabLabel, long menuLabel, int position) {
        int result;

        result = ((GtkNotebook.InsertPageSignal) handler).onInsertPage((Notebook) objectFor(source), (Widget) objectFor(child), (Widget) objectFor(tabLabel), (Widget) objectFor(menuLabel), position);

        return result;
    }
}

