/*
 * GtkObject.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Object;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.WidgetFlags;

final class GtkObject extends Plumbing
{
    private GtkObject() {}

    static final WidgetFlags flags(Object self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = GTK_OBJECT_FLAGS(pointerOf(self));

            return (WidgetFlags) flagFor(WidgetFlags.class, result);
        }
    }

    private static native final int GTK_OBJECT_FLAGS(long self);

    static final void setFlags(Object self, WidgetFlags flags) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            GTK_OBJECT_SET_FLAGS(pointerOf(self), numOf(flags));
        }
    }

    private static native final void GTK_OBJECT_SET_FLAGS(long self, int flags);

    static final void unsetFlags(Object self, WidgetFlags flags) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            GTK_OBJECT_UNSET_FLAGS(pointerOf(self), numOf(flags));
        }
    }

    private static native final void GTK_OBJECT_UNSET_FLAGS(long self, int flags);

    static final void destroy(Object self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_object_destroy(pointerOf(self));
        }
    }

    private static native final void gtk_object_destroy(long self);

    interface DestroySignal extends Signal
    {
        void onDestroy(Object source);
    }

    static final void connect(Object self, GtkObject.DestroySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkObject.class, "destroy", after);
    }

    protected static final void receiveDestroy(Signal handler, long source) {
        ((GtkObject.DestroySignal) handler).onDestroy((Object) objectFor(source));
    }
}

