/*
 * GtkPageSetup.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.PageOrientation;
import org.gnome.gtk.PageSetup;
import org.gnome.gtk.PaperSize;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Unit;

final class GtkPageSetup extends Plumbing
{
    private GtkPageSetup() {}

    static final long createPageSetup() {
        long result;

        synchronized (lock) {
            result = gtk_page_setup_new();

            return result;
        }
    }

    private static native final long gtk_page_setup_new();

    static final PageSetup copy(PageSetup self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_copy(pointerOf(self));

            return (PageSetup) objectFor(result);
        }
    }

    private static native final long gtk_page_setup_copy(long self);

    static final PageOrientation getOrientation(PageSetup self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_orientation(pointerOf(self));

            return (PageOrientation) enumFor(PageOrientation.class, result);
        }
    }

    private static native final int gtk_page_setup_get_orientation(long self);

    static final void setOrientation(PageSetup self, PageOrientation orientation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (orientation == null) {
            throw new IllegalArgumentException("orientation can't be null");
        }

        synchronized (lock) {
            gtk_page_setup_set_orientation(pointerOf(self), numOf(orientation));
        }
    }

    private static native final void gtk_page_setup_set_orientation(long self, int orientation);

    static final PaperSize getPaperSize(PageSetup self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_paper_size(pointerOf(self));

            return (PaperSize) boxedFor(PaperSize.class, result);
        }
    }

    private static native final long gtk_page_setup_get_paper_size(long self);

    static final void setPaperSize(PageSetup self, PaperSize size) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            gtk_page_setup_set_paper_size(pointerOf(self), pointerOf(size));
        }
    }

    private static native final void gtk_page_setup_set_paper_size(long self, long size);

    static final double getTopMargin(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_top_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_top_margin(long self, int unit);

    static final void setTopMargin(PageSetup self, double margin, Unit unit) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            gtk_page_setup_set_top_margin(pointerOf(self), margin, numOf(unit));
        }
    }

    private static native final void gtk_page_setup_set_top_margin(long self, double margin, int unit);

    static final double getBottomMargin(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_bottom_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_bottom_margin(long self, int unit);

    static final void setBottomMargin(PageSetup self, double margin, Unit unit) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            gtk_page_setup_set_bottom_margin(pointerOf(self), margin, numOf(unit));
        }
    }

    private static native final void gtk_page_setup_set_bottom_margin(long self, double margin, int unit);

    static final double getLeftMargin(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_left_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_left_margin(long self, int unit);

    static final void setLeftMargin(PageSetup self, double margin, Unit unit) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            gtk_page_setup_set_left_margin(pointerOf(self), margin, numOf(unit));
        }
    }

    private static native final void gtk_page_setup_set_left_margin(long self, double margin, int unit);

    static final double getRightMargin(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_right_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_right_margin(long self, int unit);

    static final void setRightMargin(PageSetup self, double margin, Unit unit) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            gtk_page_setup_set_right_margin(pointerOf(self), margin, numOf(unit));
        }
    }

    private static native final void gtk_page_setup_set_right_margin(long self, double margin, int unit);

    static final void setPaperSizeAndDefaultMargins(PageSetup self, PaperSize size) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            gtk_page_setup_set_paper_size_and_default_margins(pointerOf(self), pointerOf(size));
        }
    }

    private static native final void gtk_page_setup_set_paper_size_and_default_margins(long self, long size);

    static final double getPaperWidth(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_paper_width(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_paper_width(long self, int unit);

    static final double getPaperHeight(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_paper_height(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_paper_height(long self, int unit);

    static final double getPageWidth(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_page_width(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_page_width(long self, int unit);

    static final double getPageHeight(PageSetup self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_page_setup_get_page_height(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_page_setup_get_page_height(long self, int unit);
}

