/*
 * GtkPrintOperationPreview.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.PageSetup;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PrintContext;
import org.gnome.gtk.PrintOperationPreview;

final class GtkPrintOperationPreview extends Plumbing
{
    private GtkPrintOperationPreview() {}

    static final void renderPage(PrintOperationPreview self, int pageNr) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_preview_render_page(pointerOf((Object) self), pageNr);
        }
    }

    private static native final void gtk_print_operation_preview_render_page(long self, int pageNr);

    static final void endPreview(PrintOperationPreview self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_preview_end_preview(pointerOf((Object) self));
        }
    }

    private static native final void gtk_print_operation_preview_end_preview(long self);

    static final boolean isSelected(PrintOperationPreview self, int pageNr) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_operation_preview_is_selected(pointerOf((Object) self), pageNr);

            return result;
        }
    }

    private static native final boolean gtk_print_operation_preview_is_selected(long self, int pageNr);

    interface ReadySignal extends Signal
    {
        void onReady(PrintOperationPreview source, PrintContext context);
    }

    static final void connect(PrintOperationPreview self, GtkPrintOperationPreview.ReadySignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkPrintOperationPreview.class, "ready", after);
    }

    protected static final void receiveReady(Signal handler, long source, long context) {
        ((GtkPrintOperationPreview.ReadySignal) handler).onReady((PrintOperationPreview) objectFor(source), (PrintContext) objectFor(context));
    }

    interface GotPageSizeSignal extends Signal
    {
        void onGotPageSize(PrintOperationPreview source, PrintContext context, PageSetup pageSetup);
    }

    static final void connect(PrintOperationPreview self, GtkPrintOperationPreview.GotPageSizeSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkPrintOperationPreview.class, "got-page-size", after);
    }

    protected static final void receiveGotPageSize(Signal handler, long source, long context, long pageSetup) {
        ((GtkPrintOperationPreview.GotPageSizeSignal) handler).onGotPageSize((PrintOperationPreview) objectFor(source), (PrintContext) objectFor(context), (PageSetup) objectFor(pageSetup));
    }

    interface RenderPageSignal extends Signal
    {
        void onRenderPage(PrintOperationPreview source, int pageNr);
    }

    static final void connect(PrintOperationPreview self, GtkPrintOperationPreview.RenderPageSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkPrintOperationPreview.class, "render-page", after);
    }

    protected static final void receiveRenderPage(Signal handler, long source, int pageNr) {
        ((GtkPrintOperationPreview.RenderPageSignal) handler).onRenderPage((PrintOperationPreview) objectFor(source), pageNr);
    }

    interface IsSelectedSignal extends Signal
    {
        boolean onIsSelected(PrintOperationPreview source, int pageNr);
    }

    static final void connect(PrintOperationPreview self, GtkPrintOperationPreview.IsSelectedSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkPrintOperationPreview.class, "is-selected", after);
    }

    protected static final boolean receiveIsSelected(Signal handler, long source, int pageNr) {
        boolean result;

        result = ((GtkPrintOperationPreview.IsSelectedSignal) handler).onIsSelected((PrintOperationPreview) objectFor(source), pageNr);

        return result;
    }

    interface EndPreviewSignal extends Signal
    {
        void onEndPreview(PrintOperationPreview source);
    }

    static final void connect(PrintOperationPreview self, GtkPrintOperationPreview.EndPreviewSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkPrintOperationPreview.class, "end-preview", after);
    }

    protected static final void receiveEndPreview(Signal handler, long source) {
        ((GtkPrintOperationPreview.EndPreviewSignal) handler).onEndPreview((PrintOperationPreview) objectFor(source));
    }
}

