/*
 * GtkProgressBar.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ProgressBar;
import org.gnome.gtk.ProgressBarOrientation;
import org.gnome.pango.EllipsizeMode;

final class GtkProgressBar extends Plumbing
{
    private GtkProgressBar() {}

    static final long createProgressBar() {
        long result;

        synchronized (lock) {
            result = gtk_progress_bar_new();

            return result;
        }
    }

    private static native final long gtk_progress_bar_new();

    static final void pulse(ProgressBar self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_progress_bar_pulse(pointerOf(self));
        }
    }

    private static native final void gtk_progress_bar_pulse(long self);

    static final void setText(ProgressBar self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_progress_bar_set_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_progress_bar_set_text(long self, String text);

    static final void setFraction(ProgressBar self, double fraction) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_progress_bar_set_fraction(pointerOf(self), fraction);
        }
    }

    private static native final void gtk_progress_bar_set_fraction(long self, double fraction);

    static final void setPulseStep(ProgressBar self, double fraction) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_progress_bar_set_pulse_step(pointerOf(self), fraction);
        }
    }

    private static native final void gtk_progress_bar_set_pulse_step(long self, double fraction);

    static final void setOrientation(ProgressBar self, ProgressBarOrientation orientation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (orientation == null) {
            throw new IllegalArgumentException("orientation can't be null");
        }

        synchronized (lock) {
            gtk_progress_bar_set_orientation(pointerOf(self), numOf(orientation));
        }
    }

    private static native final void gtk_progress_bar_set_orientation(long self, int orientation);

    static final String getText(ProgressBar self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_progress_bar_get_text(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_progress_bar_get_text(long self);

    static final double getFraction(ProgressBar self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_progress_bar_get_fraction(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_progress_bar_get_fraction(long self);

    static final double getPulseStep(ProgressBar self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_progress_bar_get_pulse_step(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_progress_bar_get_pulse_step(long self);

    static final ProgressBarOrientation getOrientation(ProgressBar self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_progress_bar_get_orientation(pointerOf(self));

            return (ProgressBarOrientation) enumFor(ProgressBarOrientation.class, result);
        }
    }

    private static native final int gtk_progress_bar_get_orientation(long self);

    static final void setEllipsize(ProgressBar self, EllipsizeMode mode) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mode == null) {
            throw new IllegalArgumentException("mode can't be null");
        }

        synchronized (lock) {
            gtk_progress_bar_set_ellipsize(pointerOf(self), numOf(mode));
        }
    }

    private static native final void gtk_progress_bar_set_ellipsize(long self, int mode);

    static final EllipsizeMode getEllipsize(ProgressBar self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_progress_bar_get_ellipsize(pointerOf(self));

            return (EllipsizeMode) enumFor(EllipsizeMode.class, result);
        }
    }

    private static native final int gtk_progress_bar_get_ellipsize(long self);
}

