/*
 * GtkRadioAction.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RadioAction;

final class GtkRadioAction extends Plumbing
{
    private GtkRadioAction() {}

    static final long createRadioAction(String name, String label, String tooltip, String stockId, int value) {
        long result;

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        if (tooltip == null) {
            throw new IllegalArgumentException("tooltip can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_action_new(name, label, tooltip, stockId, value);

            return result;
        }
    }

    private static native final long gtk_radio_action_new(String name, String label, String tooltip, String stockId, int value);

    static final void setGroup(RadioAction self, RadioAction[] group) {
        long[] _group;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            gtk_radio_action_set_group(pointerOf(self), _group);
            fillObjectArray(group, _group);
        }
    }

    private static native final void gtk_radio_action_set_group(long self, long[] group);

    static final RadioAction[] getGroup(RadioAction self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_action_get_group(pointerOf(self));

            return (RadioAction[]) objectArrayFor(result, new RadioAction[result.length]);
        }
    }

    private static native final long[] gtk_radio_action_get_group(long self);

    static final int getCurrentValue(RadioAction self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_action_get_current_value(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_radio_action_get_current_value(long self);

    interface ChangedSignal extends Signal
    {
        void onChanged(RadioAction source, RadioAction current);
    }

    static final void connect(RadioAction self, GtkRadioAction.ChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRadioAction.class, "changed", after);
    }

    protected static final void receiveChanged(Signal handler, long source, long current) {
        ((GtkRadioAction.ChangedSignal) handler).onChanged((RadioAction) objectFor(source), (RadioAction) objectFor(current));
    }

    static final void setCurrentValue(RadioAction self, int currentValue) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_radio_action_set_current_value(pointerOf(self), currentValue);
        }
    }

    private static native final void gtk_radio_action_set_current_value(long self, int currentValue);
}

