/*
 * GtkRcStyle.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RcStyle;
import org.gnome.gtk.Settings;
import org.gnome.gtk.Style;

final class GtkRcStyle extends Plumbing
{
    private GtkRcStyle() {}

    static final RcStyle copy(RcStyle self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_rc_style_copy(pointerOf(self));

            return (RcStyle) objectFor(result);
        }
    }

    private static native final long gtk_rc_style_copy(long self);

    interface CreateRcStyleSignal extends Signal
    {
        RcStyle onCreateRcStyle(RcStyle source);
    }

    static final void connect(RcStyle self, GtkRcStyle.CreateRcStyleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRcStyle.class, "create-rc-style", after);
    }

    protected static final long receiveCreateRcStyle(Signal handler, long source) {
        RcStyle result;

        result = ((GtkRcStyle.CreateRcStyleSignal) handler).onCreateRcStyle((RcStyle) objectFor(source));

        return pointerOf(result);
    }

    interface ParseSignal extends Signal
    {
        int onParse(RcStyle source, Settings settings, FIXME scanner);
    }

    static final void connect(RcStyle self, GtkRcStyle.ParseSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRcStyle.class, "parse", after);
    }

    protected static final int receiveParse(Signal handler, long source, long settings, java.lang.Object scanner) {
        int result;

        result = ((GtkRcStyle.ParseSignal) handler).onParse((RcStyle) objectFor(source), (Settings) objectFor(settings), (FIXME) scanner);

        return result;
    }

    interface MergeSignal extends Signal
    {
        void onMerge(RcStyle source, RcStyle src);
    }

    static final void connect(RcStyle self, GtkRcStyle.MergeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRcStyle.class, "merge", after);
    }

    protected static final void receiveMerge(Signal handler, long source, long src) {
        ((GtkRcStyle.MergeSignal) handler).onMerge((RcStyle) objectFor(source), (RcStyle) objectFor(src));
    }

    interface CreateStyleSignal extends Signal
    {
        Style onCreateStyle(RcStyle source);
    }

    static final void connect(RcStyle self, GtkRcStyle.CreateStyleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRcStyle.class, "create-style", after);
    }

    protected static final long receiveCreateStyle(Signal handler, long source) {
        Style result;

        result = ((GtkRcStyle.CreateStyleSignal) handler).onCreateStyle((RcStyle) objectFor(source));

        return pointerOf(result);
    }
}

