/*
 * GtkRequisition.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Requisition;

final class GtkRequisition extends Plumbing
{
    private GtkRequisition() {}

    static final int getWidth(Requisition self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_requisition_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_requisition_get_width(long self);

    static final void setWidth(Requisition self, int width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_requisition_set_width(pointerOf(self), width);
        }
    }

    private static native final void gtk_requisition_set_width(long self, int width);

    static final int getHeight(Requisition self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_requisition_get_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_requisition_get_height(long self);

    static final void setHeight(Requisition self, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_requisition_set_height(pointerOf(self), height);
        }
    }

    private static native final void gtk_requisition_set_height(long self, int height);

    static final Requisition copy(Requisition self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_requisition_copy(pointerOf(self));

            return (Requisition) boxedFor(Requisition.class, result);
        }
    }

    private static native final long gtk_requisition_copy(long self);

    static final void free(Requisition self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_requisition_free(pointerOf(self));
        }
    }

    private static native final void gtk_requisition_free(long self);
}

