/*
 * GtkRuler.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.MetricType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Ruler;

final class GtkRuler extends Plumbing
{
    private GtkRuler() {}

    static final void setMetric(Ruler self, MetricType metric) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (metric == null) {
            throw new IllegalArgumentException("metric can't be null");
        }

        synchronized (lock) {
            gtk_ruler_set_metric(pointerOf(self), numOf(metric));
        }
    }

    private static native final void gtk_ruler_set_metric(long self, int metric);

    static final void setRange(Ruler self, double lower, double upper, double position, double maxSize) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_ruler_set_range(pointerOf(self), lower, upper, position, maxSize);
        }
    }

    private static native final void gtk_ruler_set_range(long self, double lower, double upper, double position, double maxSize);

    static final void drawTicks(Ruler self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_ruler_draw_ticks(pointerOf(self));
        }
    }

    private static native final void gtk_ruler_draw_ticks(long self);

    static final void drawPos(Ruler self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_ruler_draw_pos(pointerOf(self));
        }
    }

    private static native final void gtk_ruler_draw_pos(long self);

    static final MetricType getMetric(Ruler self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_ruler_get_metric(pointerOf(self));

            return (MetricType) enumFor(MetricType.class, result);
        }
    }

    private static native final int gtk_ruler_get_metric(long self);

    static final void getRange(Ruler self, double[] lower, double[] upper, double[] position, double[] maxSize) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (lower == null) {
            throw new IllegalArgumentException("lower can't be null");
        }

        if (upper == null) {
            throw new IllegalArgumentException("upper can't be null");
        }

        if (position == null) {
            throw new IllegalArgumentException("position can't be null");
        }

        if (maxSize == null) {
            throw new IllegalArgumentException("maxSize can't be null");
        }

        synchronized (lock) {
            gtk_ruler_get_range(pointerOf(self), lower, upper, position, maxSize);
        }
    }

    private static native final void gtk_ruler_get_range(long self, double[] lower, double[] upper, double[] position, double[] maxSize);

    interface DrawTicksSignal extends Signal
    {
        void onDrawTicks(Ruler source);
    }

    static final void connect(Ruler self, GtkRuler.DrawTicksSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRuler.class, "draw-ticks", after);
    }

    protected static final void receiveDrawTicks(Signal handler, long source) {
        ((GtkRuler.DrawTicksSignal) handler).onDrawTicks((Ruler) objectFor(source));
    }

    interface DrawPosSignal extends Signal
    {
        void onDrawPos(Ruler source);
    }

    static final void connect(Ruler self, GtkRuler.DrawPosSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRuler.class, "draw-pos", after);
    }

    protected static final void receiveDrawPos(Signal handler, long source) {
        ((GtkRuler.DrawPosSignal) handler).onDrawPos((Ruler) objectFor(source));
    }
}

