/*
 * GtkScale.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PositionType;
import org.gnome.gtk.Scale;
import org.gnome.pango.Layout;

final class GtkScale extends Plumbing
{
    private GtkScale() {}

    static final void setDigits(Scale self, int digits) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_scale_set_digits(pointerOf(self), digits);
        }
    }

    private static native final void gtk_scale_set_digits(long self, int digits);

    static final int getDigits(Scale self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scale_get_digits(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_scale_get_digits(long self);

    static final void setDrawValue(Scale self, boolean drawValue) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_scale_set_draw_value(pointerOf(self), drawValue);
        }
    }

    private static native final void gtk_scale_set_draw_value(long self, boolean drawValue);

    static final boolean getDrawValue(Scale self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scale_get_draw_value(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_scale_get_draw_value(long self);

    static final void setValuePos(Scale self, PositionType pos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pos == null) {
            throw new IllegalArgumentException("pos can't be null");
        }

        synchronized (lock) {
            gtk_scale_set_value_pos(pointerOf(self), numOf(pos));
        }
    }

    private static native final void gtk_scale_set_value_pos(long self, int pos);

    static final PositionType getValuePos(Scale self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scale_get_value_pos(pointerOf(self));

            return (PositionType) enumFor(PositionType.class, result);
        }
    }

    private static native final int gtk_scale_get_value_pos(long self);

    static final Layout getLayout(Scale self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scale_get_layout(pointerOf(self));

            return (Layout) objectFor(result);
        }
    }

    private static native final long gtk_scale_get_layout(long self);

    static final void getLayoutOffsets(Scale self, int[] x, int[] y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        synchronized (lock) {
            gtk_scale_get_layout_offsets(pointerOf(self), x, y);
        }
    }

    private static native final void gtk_scale_get_layout_offsets(long self, int[] x, int[] y);

    interface FormatValueSignal extends Signal
    {
        String onFormatValue(Scale source, double value);
    }

    static final void connect(Scale self, GtkScale.FormatValueSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScale.class, "format-value", after);
    }

    protected static final String receiveFormatValue(Signal handler, long source, double value) {
        String result;

        result = ((GtkScale.FormatValueSignal) handler).onFormatValue((Scale) objectFor(source), value);

        return result;
    }

    interface DrawValueSignal extends Signal
    {
        void onDrawValue(Scale source);
    }

    static final void connect(Scale self, GtkScale.DrawValueSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScale.class, "draw-value", after);
    }

    protected static final void receiveDrawValue(Signal handler, long source) {
        ((GtkScale.DrawValueSignal) handler).onDrawValue((Scale) objectFor(source));
    }

    interface GetLayoutOffsetsSignal extends Signal
    {
        void onGetLayoutOffsets(Scale source, int[] x, int[] y);
    }

    static final void connect(Scale self, GtkScale.GetLayoutOffsetsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScale.class, "get-layout-offsets", after);
    }

    protected static final void receiveGetLayoutOffsets(Signal handler, long source, int[] x, int[] y) {
        ((GtkScale.GetLayoutOffsetsSignal) handler).onGetLayoutOffsets((Scale) objectFor(source), x, y);
    }
}

