/*
 * GtkScaleButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ScaleButton;

final class GtkScaleButton extends Plumbing
{
    private GtkScaleButton() {}

    static final long createScaleButton(IconSize size, double min, double max, double step, String[] icons) {
        long result;

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        if (icons == null) {
            throw new IllegalArgumentException("icons can't be null");
        }

        synchronized (lock) {
            result = gtk_scale_button_new(numOf(size), min, max, step, icons);

            return result;
        }
    }

    private static native final long gtk_scale_button_new(int size, double min, double max, double step, String[] icons);

    static final void setAdjustment(ScaleButton self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (adjustment == null) {
            throw new IllegalArgumentException("adjustment can't be null");
        }

        synchronized (lock) {
            gtk_scale_button_set_adjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_scale_button_set_adjustment(long self, long adjustment);

    static final void setIcons(ScaleButton self, String[] icons) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (icons == null) {
            throw new IllegalArgumentException("icons can't be null");
        }

        synchronized (lock) {
            gtk_scale_button_set_icons(pointerOf(self), icons);
        }
    }

    private static native final void gtk_scale_button_set_icons(long self, String[] icons);

    static final void setValue(ScaleButton self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_scale_button_set_value(pointerOf(self), value);
        }
    }

    private static native final void gtk_scale_button_set_value(long self, double value);

    static final Adjustment getAdjustment(ScaleButton self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scale_button_get_adjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_scale_button_get_adjustment(long self);

    static final double getValue(ScaleButton self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scale_button_get_value(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_scale_button_get_value(long self);

    interface PopdownSignal extends Signal
    {
        void onPopdown(ScaleButton source);
    }

    static final void connect(ScaleButton self, GtkScaleButton.PopdownSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScaleButton.class, "popdown", after);
    }

    protected static final void receivePopdown(Signal handler, long source) {
        ((GtkScaleButton.PopdownSignal) handler).onPopdown((ScaleButton) objectFor(source));
    }

    interface PopupSignal extends Signal
    {
        void onPopup(ScaleButton source);
    }

    static final void connect(ScaleButton self, GtkScaleButton.PopupSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScaleButton.class, "popup", after);
    }

    protected static final void receivePopup(Signal handler, long source) {
        ((GtkScaleButton.PopupSignal) handler).onPopup((ScaleButton) objectFor(source));
    }

    interface ValueChangedSignal extends Signal
    {
        void onValueChanged(ScaleButton source, double value);
    }

    static final void connect(ScaleButton self, GtkScaleButton.ValueChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScaleButton.class, "value-changed", after);
    }

    protected static final void receiveValueChanged(Signal handler, long source, double value) {
        ((GtkScaleButton.ValueChangedSignal) handler).onValueChanged((ScaleButton) objectFor(source), value);
    }
}

