/*
 * GtkScrolledWindow.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.CornerType;
import org.gnome.gtk.DirectionType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PolicyType;
import org.gnome.gtk.ScrollType;
import org.gnome.gtk.ScrolledWindow;
import org.gnome.gtk.ShadowType;
import org.gnome.gtk.Widget;

final class GtkScrolledWindow extends Plumbing
{
    private GtkScrolledWindow() {}

    static final long createScrolledWindow(Adjustment hadjustment, Adjustment vadjustment) {
        long result;

        synchronized (lock) {
            result = gtk_scrolled_window_new(pointerOf(hadjustment), pointerOf(vadjustment));

            return result;
        }
    }

    private static native final long gtk_scrolled_window_new(long hadjustment, long vadjustment);

    static final void setHadjustment(ScrolledWindow self, Adjustment hadjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hadjustment == null) {
            throw new IllegalArgumentException("hadjustment can't be null");
        }

        synchronized (lock) {
            gtk_scrolled_window_set_hadjustment(pointerOf(self), pointerOf(hadjustment));
        }
    }

    private static native final void gtk_scrolled_window_set_hadjustment(long self, long hadjustment);

    static final void setVadjustment(ScrolledWindow self, Adjustment hadjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hadjustment == null) {
            throw new IllegalArgumentException("hadjustment can't be null");
        }

        synchronized (lock) {
            gtk_scrolled_window_set_vadjustment(pointerOf(self), pointerOf(hadjustment));
        }
    }

    private static native final void gtk_scrolled_window_set_vadjustment(long self, long hadjustment);

    static final Adjustment getHadjustment(ScrolledWindow self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scrolled_window_get_hadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_scrolled_window_get_hadjustment(long self);

    static final Adjustment getVadjustment(ScrolledWindow self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scrolled_window_get_vadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_scrolled_window_get_vadjustment(long self);

    static final Widget getHscrollbar(ScrolledWindow self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scrolled_window_get_hscrollbar(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_scrolled_window_get_hscrollbar(long self);

    static final Widget getVscrollbar(ScrolledWindow self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scrolled_window_get_vscrollbar(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_scrolled_window_get_vscrollbar(long self);

    static final void setPolicy(ScrolledWindow self, PolicyType hscrollbarPolicy, PolicyType vscrollbarPolicy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hscrollbarPolicy == null) {
            throw new IllegalArgumentException("hscrollbarPolicy can't be null");
        }

        if (vscrollbarPolicy == null) {
            throw new IllegalArgumentException("vscrollbarPolicy can't be null");
        }

        synchronized (lock) {
            gtk_scrolled_window_set_policy(pointerOf(self), numOf(hscrollbarPolicy), numOf(vscrollbarPolicy));
        }
    }

    private static native final void gtk_scrolled_window_set_policy(long self, int hscrollbarPolicy, int vscrollbarPolicy);

    static final void getPolicy(ScrolledWindow self, PolicyType[] hscrollbarPolicy, PolicyType[] vscrollbarPolicy) {
        int[] _hscrollbarPolicy;
        int[] _vscrollbarPolicy;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hscrollbarPolicy == null) {
            throw new IllegalArgumentException("hscrollbarPolicy can't be null");
        }

        if (vscrollbarPolicy == null) {
            throw new IllegalArgumentException("vscrollbarPolicy can't be null");
        }

        _hscrollbarPolicy = numsOf(hscrollbarPolicy);

        _vscrollbarPolicy = numsOf(vscrollbarPolicy);

        synchronized (lock) {
            gtk_scrolled_window_get_policy(pointerOf(self), _hscrollbarPolicy, _vscrollbarPolicy);
            fillEnumArray(PolicyType.class, hscrollbarPolicy, _hscrollbarPolicy);
            fillEnumArray(PolicyType.class, vscrollbarPolicy, _vscrollbarPolicy);
        }
    }

    private static native final void gtk_scrolled_window_get_policy(long self, int[] hscrollbarPolicy, int[] vscrollbarPolicy);

    static final void setPlacement(ScrolledWindow self, CornerType windowPlacement) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (windowPlacement == null) {
            throw new IllegalArgumentException("windowPlacement can't be null");
        }

        synchronized (lock) {
            gtk_scrolled_window_set_placement(pointerOf(self), numOf(windowPlacement));
        }
    }

    private static native final void gtk_scrolled_window_set_placement(long self, int windowPlacement);

    static final CornerType getPlacement(ScrolledWindow self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scrolled_window_get_placement(pointerOf(self));

            return (CornerType) enumFor(CornerType.class, result);
        }
    }

    private static native final int gtk_scrolled_window_get_placement(long self);

    static final void setShadowType(ScrolledWindow self, ShadowType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_scrolled_window_set_shadow_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gtk_scrolled_window_set_shadow_type(long self, int type);

    static final ShadowType getShadowType(ScrolledWindow self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_scrolled_window_get_shadow_type(pointerOf(self));

            return (ShadowType) enumFor(ShadowType.class, result);
        }
    }

    private static native final int gtk_scrolled_window_get_shadow_type(long self);

    static final void addWithViewport(ScrolledWindow self, Widget child) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_scrolled_window_add_with_viewport(pointerOf(self), pointerOf(child));
        }
    }

    private static native final void gtk_scrolled_window_add_with_viewport(long self, long child);

    interface ScrollChildSignal extends Signal
    {
        boolean onScrollChild(ScrolledWindow source, ScrollType scroll, boolean horizontal);
    }

    static final void connect(ScrolledWindow self, GtkScrolledWindow.ScrollChildSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScrolledWindow.class, "scroll-child", after);
    }

    protected static final boolean receiveScrollChild(Signal handler, long source, int scroll, boolean horizontal) {
        boolean result;

        result = ((GtkScrolledWindow.ScrollChildSignal) handler).onScrollChild((ScrolledWindow) objectFor(source), (ScrollType) enumFor(ScrollType.class, scroll), horizontal);

        return result;
    }

    interface MoveFocusOutSignal extends Signal
    {
        void onMoveFocusOut(ScrolledWindow source, DirectionType direction);
    }

    static final void connect(ScrolledWindow self, GtkScrolledWindow.MoveFocusOutSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkScrolledWindow.class, "move-focus-out", after);
    }

    protected static final void receiveMoveFocusOut(Signal handler, long source, int direction) {
        ((GtkScrolledWindow.MoveFocusOutSignal) handler).onMoveFocusOut((ScrolledWindow) objectFor(source), (DirectionType) enumFor(DirectionType.class, direction));
    }

    static final void unsetPlacement(ScrolledWindow self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_scrolled_window_unset_placement(pointerOf(self));
        }
    }

    private static native final void gtk_scrolled_window_unset_placement(long self);
}

