/*
 * GtkSizeGroup.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SizeGroup;
import org.gnome.gtk.SizeGroupMode;
import org.gnome.gtk.Widget;

final class GtkSizeGroup extends Plumbing
{
    private GtkSizeGroup() {}

    static final long createSizeGroup(SizeGroupMode mode) {
        long result;

        if (mode == null) {
            throw new IllegalArgumentException("mode can't be null");
        }

        synchronized (lock) {
            result = gtk_size_group_new(numOf(mode));

            return result;
        }
    }

    private static native final long gtk_size_group_new(int mode);

    static final void setMode(SizeGroup self, SizeGroupMode mode) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mode == null) {
            throw new IllegalArgumentException("mode can't be null");
        }

        synchronized (lock) {
            gtk_size_group_set_mode(pointerOf(self), numOf(mode));
        }
    }

    private static native final void gtk_size_group_set_mode(long self, int mode);

    static final SizeGroupMode getMode(SizeGroup self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_size_group_get_mode(pointerOf(self));

            return (SizeGroupMode) enumFor(SizeGroupMode.class, result);
        }
    }

    private static native final int gtk_size_group_get_mode(long self);

    static final void setIgnoreHidden(SizeGroup self, boolean ignoreHidden) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_size_group_set_ignore_hidden(pointerOf(self), ignoreHidden);
        }
    }

    private static native final void gtk_size_group_set_ignore_hidden(long self, boolean ignoreHidden);

    static final boolean getIgnoreHidden(SizeGroup self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_size_group_get_ignore_hidden(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_size_group_get_ignore_hidden(long self);

    static final void addWidget(SizeGroup self, Widget widget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        synchronized (lock) {
            gtk_size_group_add_widget(pointerOf(self), pointerOf(widget));
        }
    }

    private static native final void gtk_size_group_add_widget(long self, long widget);

    static final void removeWidget(SizeGroup self, Widget widget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        synchronized (lock) {
            gtk_size_group_remove_widget(pointerOf(self), pointerOf(widget));
        }
    }

    private static native final void gtk_size_group_remove_widget(long self, long widget);

    static final Widget[] getWidgets(SizeGroup self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_size_group_get_widgets(pointerOf(self));

            return (Widget[]) objectArrayFor(result, new Widget[result.length]);
        }
    }

    private static native final long[] gtk_size_group_get_widgets(long self);
}

