/*
 * GtkSpell.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.GlibException;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Spell;
import org.gnome.gtk.TextView;

final class GtkSpell extends Plumbing
{
    private GtkSpell() {}

    static final long createSpellAttach(TextView view, String lang) throws GlibException {
        long result;

        if (view == null) {
            throw new IllegalArgumentException("view can't be null");
        }

        synchronized (lock) {
            result = gtkspell_new_attach(pointerOf(view), lang);

            return result;
        }
    }

    private static native final long gtkspell_new_attach(long view, String lang) throws GlibException;

    static final void detach(Spell self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtkspell_detach(pointerOf(self));
        }
    }

    private static native final void gtkspell_detach(long self);

    static final boolean setLanguage(Spell self, String lang) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtkspell_set_language(pointerOf(self), lang);

            return result;
        }
    }

    private static native final boolean gtkspell_set_language(long self, String lang) throws GlibException;

    static final void recheckAll(Spell self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtkspell_recheck_all(pointerOf(self));
        }
    }

    private static native final void gtkspell_recheck_all(long self);

    static final Spell getFromTextView(TextView view) {
        long result;

        if (view == null) {
            throw new IllegalArgumentException("view can't be null");
        }

        synchronized (lock) {
            result = gtkspell_get_from_text_view(pointerOf(view));

            return (Spell) boxedFor(Spell.class, result);
        }
    }

    private static native final long gtkspell_get_from_text_view(long view);
}

