/*
 * GtkStatusIcon.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Screen;
import org.gnome.glib.Signal;
import org.gnome.gtk.ImageType;
import org.gnome.gtk.Orientation;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.StatusIcon;

final class GtkStatusIcon extends Plumbing
{
    private GtkStatusIcon() {}

    static final long createStatusIcon() {
        long result;

        synchronized (lock) {
            result = gtk_status_icon_new();

            return result;
        }
    }

    private static native final long gtk_status_icon_new();

    static final long createStatusIconFromPixbuf(Pixbuf pixbuf) {
        long result;

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_new_from_pixbuf(pointerOf(pixbuf));

            return result;
        }
    }

    private static native final long gtk_status_icon_new_from_pixbuf(long pixbuf);

    static final long createStatusIconFromFile(String filename) {
        long result;

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_new_from_file(filename);

            return result;
        }
    }

    private static native final long gtk_status_icon_new_from_file(String filename);

    static final long createStatusIconFromStock(String stockId) {
        long result;

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_new_from_stock(stockId);

            return result;
        }
    }

    private static native final long gtk_status_icon_new_from_stock(String stockId);

    static final long createStatusIconFromIconName(String iconName) {
        long result;

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_new_from_icon_name(iconName);

            return result;
        }
    }

    private static native final long gtk_status_icon_new_from_icon_name(String iconName);

    static final void setFromPixbuf(StatusIcon self, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_status_icon_set_from_pixbuf(pointerOf(self), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_status_icon_set_from_pixbuf(long self, long pixbuf);

    static final void setFromFile(StatusIcon self, String filename) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            gtk_status_icon_set_from_file(pointerOf(self), filename);
        }
    }

    private static native final void gtk_status_icon_set_from_file(long self, String filename);

    static final void setFromStock(StatusIcon self, String stockId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            gtk_status_icon_set_from_stock(pointerOf(self), stockId);
        }
    }

    private static native final void gtk_status_icon_set_from_stock(long self, String stockId);

    static final void setFromIconName(StatusIcon self, String iconName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        synchronized (lock) {
            gtk_status_icon_set_from_icon_name(pointerOf(self), iconName);
        }
    }

    private static native final void gtk_status_icon_set_from_icon_name(long self, String iconName);

    static final ImageType getStorageType(StatusIcon self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_get_storage_type(pointerOf(self));

            return (ImageType) enumFor(ImageType.class, result);
        }
    }

    private static native final int gtk_status_icon_get_storage_type(long self);

    static final Pixbuf getPixbuf(StatusIcon self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_get_pixbuf(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_status_icon_get_pixbuf(long self);

    static final String getStock(StatusIcon self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_get_stock(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_status_icon_get_stock(long self);

    static final String getIconName(StatusIcon self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_get_icon_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_status_icon_get_icon_name(long self);

    static final int getSize(StatusIcon self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_get_size(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_status_icon_get_size(long self);

    static final void setTooltip(StatusIcon self, String tooltipText) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_status_icon_set_tooltip(pointerOf(self), tooltipText);
        }
    }

    private static native final void gtk_status_icon_set_tooltip(long self, String tooltipText);

    static final void setVisible(StatusIcon self, boolean visible) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_status_icon_set_visible(pointerOf(self), visible);
        }
    }

    private static native final void gtk_status_icon_set_visible(long self, boolean visible);

    static final boolean getVisible(StatusIcon self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_get_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_status_icon_get_visible(long self);

    static final void setBlinking(StatusIcon self, boolean blinking) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_status_icon_set_blinking(pointerOf(self), blinking);
        }
    }

    private static native final void gtk_status_icon_set_blinking(long self, boolean blinking);

    static final boolean getBlinking(StatusIcon self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_get_blinking(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_status_icon_get_blinking(long self);

    static final boolean isEmbedded(StatusIcon self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_status_icon_is_embedded(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_status_icon_is_embedded(long self);

    static final boolean getGeometry(StatusIcon self, Screen[] screen, Rectangle area, Orientation[] orientation) {
        boolean result;
        long[] _screen;
        int[] _orientation;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (screen == null) {
            throw new IllegalArgumentException("screen can't be null");
        }

        if (area == null) {
            throw new IllegalArgumentException("area can't be null");
        }

        if (orientation == null) {
            throw new IllegalArgumentException("orientation can't be null");
        }

        _screen = pointersOf(screen);

        _orientation = numsOf(orientation);

        synchronized (lock) {
            result = gtk_status_icon_get_geometry(pointerOf(self), _screen, pointerOf(area), _orientation);
            fillObjectArray(screen, _screen);
            fillEnumArray(Orientation.class, orientation, _orientation);

            return result;
        }
    }

    private static native final boolean gtk_status_icon_get_geometry(long self, long[] screen, long area, int[] orientation);

    interface ActivateSignal extends Signal
    {
        void onActivate(StatusIcon source);
    }

    static final void connect(StatusIcon self, GtkStatusIcon.ActivateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStatusIcon.class, "activate", after);
    }

    protected static final void receiveActivate(Signal handler, long source) {
        ((GtkStatusIcon.ActivateSignal) handler).onActivate((StatusIcon) objectFor(source));
    }

    interface PopupMenuSignal extends Signal
    {
        void onPopupMenu(StatusIcon source, int button, int activateTime);
    }

    static final void connect(StatusIcon self, GtkStatusIcon.PopupMenuSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStatusIcon.class, "popup-menu", after);
    }

    protected static final void receivePopupMenu(Signal handler, long source, int button, int activateTime) {
        ((GtkStatusIcon.PopupMenuSignal) handler).onPopupMenu((StatusIcon) objectFor(source), button, activateTime);
    }

    interface SizeChangedSignal extends Signal
    {
        boolean onSizeChanged(StatusIcon source, int size);
    }

    static final void connect(StatusIcon self, GtkStatusIcon.SizeChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStatusIcon.class, "size-changed", after);
    }

    protected static final boolean receiveSizeChanged(Signal handler, long source, int size) {
        boolean result;

        result = ((GtkStatusIcon.SizeChangedSignal) handler).onSizeChanged((StatusIcon) objectFor(source), size);

        return result;
    }
}

