/*
 * GtkStatusbar.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Statusbar;

final class GtkStatusbar extends Plumbing
{
    private GtkStatusbar() {}

    static final long createStatusbar() {
        long result;

        synchronized (lock) {
            result = gtk_statusbar_new();

            return result;
        }
    }

    private static native final long gtk_statusbar_new();

    static final int getContextId(Statusbar self, String contextDescription) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (contextDescription == null) {
            throw new IllegalArgumentException("contextDescription can't be null");
        }

        synchronized (lock) {
            result = gtk_statusbar_get_context_id(pointerOf(self), contextDescription);

            return result;
        }
    }

    private static native final int gtk_statusbar_get_context_id(long self, String contextDescription);

    static final int push(Statusbar self, int contextId, String text) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            result = gtk_statusbar_push(pointerOf(self), contextId, text);

            return result;
        }
    }

    private static native final int gtk_statusbar_push(long self, int contextId, String text);

    static final void pop(Statusbar self, int contextId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_statusbar_pop(pointerOf(self), contextId);
        }
    }

    private static native final void gtk_statusbar_pop(long self, int contextId);

    static final void remove(Statusbar self, int contextId, int messageId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_statusbar_remove(pointerOf(self), contextId, messageId);
        }
    }

    private static native final void gtk_statusbar_remove(long self, int contextId, int messageId);

    static final void setHasResizeGrip(Statusbar self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_statusbar_set_has_resize_grip(pointerOf(self), setting);
        }
    }

    private static native final void gtk_statusbar_set_has_resize_grip(long self, boolean setting);

    static final boolean getHasResizeGrip(Statusbar self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_statusbar_get_has_resize_grip(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_statusbar_get_has_resize_grip(long self);

    interface TextPushedSignal extends Signal
    {
        void onTextPushed(Statusbar source, int contextId, String text);
    }

    static final void connect(Statusbar self, GtkStatusbar.TextPushedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStatusbar.class, "text-pushed", after);
    }

    protected static final void receiveTextPushed(Signal handler, long source, int contextId, String text) {
        ((GtkStatusbar.TextPushedSignal) handler).onTextPushed((Statusbar) objectFor(source), contextId, text);
    }

    interface TextPoppedSignal extends Signal
    {
        void onTextPopped(Statusbar source, int contextId, String text);
    }

    static final void connect(Statusbar self, GtkStatusbar.TextPoppedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStatusbar.class, "text-popped", after);
    }

    protected static final void receiveTextPopped(Signal handler, long source, int contextId, String text) {
        ((GtkStatusbar.TextPoppedSignal) handler).onTextPopped((Statusbar) objectFor(source), contextId, text);
    }
}

