/*
 * GtkStyle.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Color;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Point;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Window;
import org.gnome.gdk.WindowEdge;
import org.gnome.glib.Signal;
import org.gnome.gtk.ArrowType;
import org.gnome.gtk.ExpanderStyle;
import org.gnome.gtk.IconSet;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.IconSource;
import org.gnome.gtk.Orientation;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PositionType;
import org.gnome.gtk.RcStyle;
import org.gnome.gtk.ShadowType;
import org.gnome.gtk.StateType;
import org.gnome.gtk.Style;
import org.gnome.gtk.TextDirection;
import org.gnome.gtk.Widget;
import org.gnome.pango.Layout;

final class GtkStyle extends Plumbing
{
    private GtkStyle() {}

    static final long createStyle() {
        long result;

        synchronized (lock) {
            result = gtk_style_new();

            return result;
        }
    }

    private static native final long gtk_style_new();

    static final Style copy(Style self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_style_copy(pointerOf(self));

            return (Style) objectFor(result);
        }
    }

    private static native final long gtk_style_copy(long self);

    static final Style attach(Style self, Window window) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            result = gtk_style_attach(pointerOf(self), pointerOf(window));

            return (Style) objectFor(result);
        }
    }

    private static native final long gtk_style_attach(long self, long window);

    static final void detach(Style self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_style_detach(pointerOf(self));
        }
    }

    private static native final void gtk_style_detach(long self);

    static final void setBackground(Style self, Window window, StateType stateType) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        synchronized (lock) {
            gtk_style_set_background(pointerOf(self), pointerOf(window), numOf(stateType));
        }
    }

    private static native final void gtk_style_set_background(long self, long window, int stateType);

    static final void applyDefaultBackground(Style self, Window window, boolean setBg, StateType stateType, Rectangle area, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        synchronized (lock) {
            gtk_style_apply_default_background(pointerOf(self), pointerOf(window), setBg, numOf(stateType), pointerOf(area), x, y, width, height);
        }
    }

    private static native final void gtk_style_apply_default_background(long self, long window, boolean setBg, int stateType, long area, int x, int y, int width, int height);

    static final IconSet lookupIconSet(Style self, String stockId) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_style_lookup_icon_set(pointerOf(self), stockId);

            return (IconSet) boxedFor(IconSet.class, result);
        }
    }

    private static native final long gtk_style_lookup_icon_set(long self, String stockId);

    static final Pixbuf renderIcon(Style self, IconSource source, TextDirection direction, StateType state, IconSize size, Widget widget, String detail) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (source == null) {
            throw new IllegalArgumentException("source can't be null");
        }

        if (direction == null) {
            throw new IllegalArgumentException("direction can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            result = gtk_style_render_icon(pointerOf(self), pointerOf(source), numOf(direction), numOf(state), numOf(size), pointerOf(widget), detail);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_style_render_icon(long self, long source, int direction, int state, int size, long widget, String detail);

    static final void paintHline(Style self, Window window, StateType stateType, Rectangle area, Widget widget, String detail, int x1, int x2, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        synchronized (lock) {
            gtk_paint_hline(pointerOf(self), pointerOf(window), numOf(stateType), pointerOf(area), pointerOf(widget), detail, x1, x2, y);
        }
    }

    private static native final void gtk_paint_hline(long self, long window, int stateType, long area, long widget, String detail, int x1, int x2, int y);

    static final void paintVline(Style self, Window window, StateType stateType, Rectangle area, Widget widget, String detail, int y1, int y2, int x) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        synchronized (lock) {
            gtk_paint_vline(pointerOf(self), pointerOf(window), numOf(stateType), pointerOf(area), pointerOf(widget), detail, y1, y2, x);
        }
    }

    private static native final void gtk_paint_vline(long self, long window, int stateType, long area, long widget, String detail, int y1, int y2, int x);

    static final void paintShadow(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_shadow(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_shadow(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintPolygon(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, Point points, int npoints, boolean fill) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        if (points == null) {
            throw new IllegalArgumentException("points can't be null");
        }

        synchronized (lock) {
            gtk_paint_polygon(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, pointerOf(points), npoints, fill);
        }
    }

    private static native final void gtk_paint_polygon(long self, long window, int stateType, int shadowType, long area, long widget, String detail, long points, int npoints, boolean fill);

    static final void paintArrow(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, ArrowType arrowType, boolean fill, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        if (arrowType == null) {
            throw new IllegalArgumentException("arrowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_arrow(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, numOf(arrowType), fill, x, y, width, height);
        }
    }

    private static native final void gtk_paint_arrow(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int arrowType, boolean fill, int x, int y, int width, int height);

    static final void paintDiamond(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_diamond(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_diamond(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintBox(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_box(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_box(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintFlatBox(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_flat_box(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_flat_box(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintCheck(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_check(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_check(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintOption(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_option(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_option(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintTab(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        synchronized (lock) {
            gtk_paint_tab(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_tab(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintShadowGap(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height, PositionType gapSide, int gapX, int gapWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        if (gapSide == null) {
            throw new IllegalArgumentException("gapSide can't be null");
        }

        synchronized (lock) {
            gtk_paint_shadow_gap(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height, numOf(gapSide), gapX, gapWidth);
        }
    }

    private static native final void gtk_paint_shadow_gap(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height, int gapSide, int gapX, int gapWidth);

    static final void paintBoxGap(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height, PositionType gapSide, int gapX, int gapWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        if (gapSide == null) {
            throw new IllegalArgumentException("gapSide can't be null");
        }

        synchronized (lock) {
            gtk_paint_box_gap(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height, numOf(gapSide), gapX, gapWidth);
        }
    }

    private static native final void gtk_paint_box_gap(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height, int gapSide, int gapX, int gapWidth);

    static final void paintExtension(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height, PositionType gapSide) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        if (gapSide == null) {
            throw new IllegalArgumentException("gapSide can't be null");
        }

        synchronized (lock) {
            gtk_paint_extension(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height, numOf(gapSide));
        }
    }

    private static native final void gtk_paint_extension(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height, int gapSide);

    static final void paintFocus(Style self, Window window, StateType stateType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        synchronized (lock) {
            gtk_paint_focus(pointerOf(self), pointerOf(window), numOf(stateType), pointerOf(area), pointerOf(widget), detail, x, y, width, height);
        }
    }

    private static native final void gtk_paint_focus(long self, long window, int stateType, long area, long widget, String detail, int x, int y, int width, int height);

    static final void paintSlider(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height, Orientation orientation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        if (orientation == null) {
            throw new IllegalArgumentException("orientation can't be null");
        }

        synchronized (lock) {
            gtk_paint_slider(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height, numOf(orientation));
        }
    }

    private static native final void gtk_paint_slider(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height, int orientation);

    static final void paintHandle(Style self, Window window, StateType stateType, ShadowType shadowType, Rectangle area, Widget widget, String detail, int x, int y, int width, int height, Orientation orientation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (shadowType == null) {
            throw new IllegalArgumentException("shadowType can't be null");
        }

        if (orientation == null) {
            throw new IllegalArgumentException("orientation can't be null");
        }

        synchronized (lock) {
            gtk_paint_handle(pointerOf(self), pointerOf(window), numOf(stateType), numOf(shadowType), pointerOf(area), pointerOf(widget), detail, x, y, width, height, numOf(orientation));
        }
    }

    private static native final void gtk_paint_handle(long self, long window, int stateType, int shadowType, long area, long widget, String detail, int x, int y, int width, int height, int orientation);

    static final void paintExpander(Style self, Window window, StateType stateType, Rectangle area, Widget widget, String detail, int x, int y, ExpanderStyle expanderStyle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (expanderStyle == null) {
            throw new IllegalArgumentException("expanderStyle can't be null");
        }

        synchronized (lock) {
            gtk_paint_expander(pointerOf(self), pointerOf(window), numOf(stateType), pointerOf(area), pointerOf(widget), detail, x, y, numOf(expanderStyle));
        }
    }

    private static native final void gtk_paint_expander(long self, long window, int stateType, long area, long widget, String detail, int x, int y, int expanderStyle);

    static final void paintLayout(Style self, Window window, StateType stateType, boolean useText, Rectangle area, Widget widget, String detail, int x, int y, Layout layout) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (layout == null) {
            throw new IllegalArgumentException("layout can't be null");
        }

        synchronized (lock) {
            gtk_paint_layout(pointerOf(self), pointerOf(window), numOf(stateType), useText, pointerOf(area), pointerOf(widget), detail, x, y, pointerOf(layout));
        }
    }

    private static native final void gtk_paint_layout(long self, long window, int stateType, boolean useText, long area, long widget, String detail, int x, int y, long layout);

    static final void paintResizeGrip(Style self, Window window, StateType stateType, Rectangle area, Widget widget, String detail, WindowEdge edge, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (stateType == null) {
            throw new IllegalArgumentException("stateType can't be null");
        }

        if (edge == null) {
            throw new IllegalArgumentException("edge can't be null");
        }

        synchronized (lock) {
            gtk_paint_resize_grip(pointerOf(self), pointerOf(window), numOf(stateType), pointerOf(area), pointerOf(widget), detail, numOf(edge), x, y, width, height);
        }
    }

    private static native final void gtk_paint_resize_grip(long self, long window, int stateType, long area, long widget, String detail, int edge, int x, int y, int width, int height);

    interface RealizeSignal extends Signal
    {
        void onRealize(Style source);
    }

    static final void connect(Style self, GtkStyle.RealizeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStyle.class, "realize", after);
    }

    protected static final void receiveRealize(Signal handler, long source) {
        ((GtkStyle.RealizeSignal) handler).onRealize((Style) objectFor(source));
    }

    interface UnrealizeSignal extends Signal
    {
        void onUnrealize(Style source);
    }

    static final void connect(Style self, GtkStyle.UnrealizeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStyle.class, "unrealize", after);
    }

    protected static final void receiveUnrealize(Signal handler, long source) {
        ((GtkStyle.UnrealizeSignal) handler).onUnrealize((Style) objectFor(source));
    }

    interface CopySignal extends Signal
    {
        void onCopy(Style source, Style src);
    }

    static final void connect(Style self, GtkStyle.CopySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStyle.class, "copy", after);
    }

    protected static final void receiveCopy(Signal handler, long source, long src) {
        ((GtkStyle.CopySignal) handler).onCopy((Style) objectFor(source), (Style) objectFor(src));
    }

    interface CloneSignal extends Signal
    {
        Style onClone(Style source);
    }

    static final void connect(Style self, GtkStyle.CloneSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStyle.class, "clone", after);
    }

    protected static final long receiveClone(Signal handler, long source) {
        Style result;

        result = ((GtkStyle.CloneSignal) handler).onClone((Style) objectFor(source));

        return pointerOf(result);
    }

    interface InitFromRcSignal extends Signal
    {
        void onInitFromRc(Style source, RcStyle rcStyle);
    }

    static final void connect(Style self, GtkStyle.InitFromRcSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStyle.class, "init-from-rc", after);
    }

    protected static final void receiveInitFromRc(Signal handler, long source, long rcStyle) {
        ((GtkStyle.InitFromRcSignal) handler).onInitFromRc((Style) objectFor(source), (RcStyle) objectFor(rcStyle));
    }

    interface SetBackgroundSignal extends Signal
    {
        void onSetBackground(Style source, Window window, StateType stateType);
    }

    static final void connect(Style self, GtkStyle.SetBackgroundSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStyle.class, "set-background", after);
    }

    protected static final void receiveSetBackground(Signal handler, long source, long window, int stateType) {
        ((GtkStyle.SetBackgroundSignal) handler).onSetBackground((Style) objectFor(source), (Window) objectFor(window), (StateType) enumFor(StateType.class, stateType));
    }

    interface RenderIconSignal extends Signal
    {
        Pixbuf onRenderIcon(Style source, IconSource iconSource, TextDirection direction, StateType state, IconSize size, Widget widget, String detail);
    }

    static final void connect(Style self, GtkStyle.RenderIconSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkStyle.class, "render-icon", after);
    }

    protected static final long receiveRenderIcon(Signal handler, long source, long iconSource, int direction, int state, int size, long widget, String detail) {
        Pixbuf result;

        result = ((GtkStyle.RenderIconSignal) handler).onRenderIcon((Style) objectFor(source), (IconSource) boxedFor(IconSource.class, iconSource), (TextDirection) enumFor(TextDirection.class, direction), (StateType) enumFor(StateType.class, state), (IconSize) enumFor(IconSize.class, size), (Widget) objectFor(widget), detail);

        return pointerOf(result);
    }

    static final boolean lookupColor(Style self, String colorName, Color color) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colorName == null) {
            throw new IllegalArgumentException("colorName can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            result = gtk_style_lookup_color(pointerOf(self), colorName, pointerOf(color));

            return result;
        }
    }

    private static native final boolean gtk_style_lookup_color(long self, String colorName, long color);
}

