/*
 * GtkTextBuffer.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Pixbuf;
import org.gnome.glib.GlibException;
import org.gnome.glib.Signal;
import org.gnome.gtk.Clipboard;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TextBuffer;
import org.gnome.gtk.TextChildAnchor;
import org.gnome.gtk.TextIter;
import org.gnome.gtk.TextMark;
import org.gnome.gtk.TextTag;
import org.gnome.gtk.TextTagTable;

final class GtkTextBuffer extends Plumbing
{
    private GtkTextBuffer() {}

    static final long createTextBuffer(TextTagTable table) {
        long result;

        if (table == null) {
            throw new IllegalArgumentException("table can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_new(pointerOf(table));

            return result;
        }
    }

    private static native final long gtk_text_buffer_new(long table);

    static final int getLineCount(TextBuffer self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_line_count(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_buffer_get_line_count(long self);

    static final int getCharCount(TextBuffer self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_char_count(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_buffer_get_char_count(long self);

    static final TextTagTable getTagTable(TextBuffer self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_tag_table(pointerOf(self));

            return (TextTagTable) objectFor(result);
        }
    }

    private static native final long gtk_text_buffer_get_tag_table(long self);

    static final void setText(TextBuffer self, String text, int len) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_set_text(pointerOf(self), text, len);
        }
    }

    private static native final void gtk_text_buffer_set_text(long self, String text, int len);

    static final void insert(TextBuffer self, TextIter iter, String text, int len) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_insert(pointerOf(self), pointerOf(iter), text, len);
        }
    }

    private static native final void gtk_text_buffer_insert(long self, long iter, String text, int len);

    static final void insertAtCursor(TextBuffer self, String text, int len) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_insert_at_cursor(pointerOf(self), text, len);
        }
    }

    private static native final void gtk_text_buffer_insert_at_cursor(long self, String text, int len);

    static final boolean insertInteractive(TextBuffer self, TextIter iter, String text, int len, boolean defaultEditable) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_insert_interactive(pointerOf(self), pointerOf(iter), text, len, defaultEditable);

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_insert_interactive(long self, long iter, String text, int len, boolean defaultEditable);

    static final boolean insertInteractiveAtCursor(TextBuffer self, String text, int len, boolean defaultEditable) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_insert_interactive_at_cursor(pointerOf(self), text, len, defaultEditable);

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_insert_interactive_at_cursor(long self, String text, int len, boolean defaultEditable);

    static final void insertRange(TextBuffer self, TextIter iter, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_insert_range(pointerOf(self), pointerOf(iter), pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_insert_range(long self, long iter, long start, long end);

    static final boolean insertRangeInteractive(TextBuffer self, TextIter iter, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end, boolean defaultEditable) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_insert_range_interactive(pointerOf(self), pointerOf(iter), pointerOf(start), pointerOf(end), defaultEditable);

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_insert_range_interactive(long self, long iter, long start, long end, boolean defaultEditable);

    static final void insertWithTags(TextBuffer self, TextIter iter, String text, int len, TextTag firstTag) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_insert_with_tags(pointerOf(self), pointerOf(iter), text, len, pointerOf(firstTag));
        }
    }

    private static native final void gtk_text_buffer_insert_with_tags(long self, long iter, String text, int len, long firstTag);

    static final void insertWithTagsByName(TextBuffer self, TextIter iter, String text, int len, String firstTagName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        if (firstTagName == null) {
            throw new IllegalArgumentException("firstTagName can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_insert_with_tags_by_name(pointerOf(self), pointerOf(iter), text, len, firstTagName);
        }
    }

    private static native final void gtk_text_buffer_insert_with_tags_by_name(long self, long iter, String text, int len, String firstTagName);

    static final void delete(TextBuffer self, TextIter start, TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_delete(pointerOf(self), pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_delete(long self, long start, long end);

    static final boolean deleteInteractive(TextBuffer self, TextIter startIter, TextIter endIter, boolean defaultEditable) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (startIter == null) {
            throw new IllegalArgumentException("startIter can't be null");
        }

        if (endIter == null) {
            throw new IllegalArgumentException("endIter can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_delete_interactive(pointerOf(self), pointerOf(startIter), pointerOf(endIter), defaultEditable);

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_delete_interactive(long self, long startIter, long endIter, boolean defaultEditable);

    static final String getText(TextBuffer self, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end, boolean includeHiddenChars) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_text(pointerOf(self), pointerOf(start), pointerOf(end), includeHiddenChars);

            return result;
        }
    }

    private static native final String gtk_text_buffer_get_text(long self, long start, long end, boolean includeHiddenChars);

    static final String getSlice(TextBuffer self, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end, boolean includeHiddenChars) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_slice(pointerOf(self), pointerOf(start), pointerOf(end), includeHiddenChars);

            return result;
        }
    }

    private static native final String gtk_text_buffer_get_slice(long self, long start, long end, boolean includeHiddenChars);

    static final void insertPixbuf(TextBuffer self, TextIter iter, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_insert_pixbuf(pointerOf(self), pointerOf(iter), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_text_buffer_insert_pixbuf(long self, long iter, long pixbuf);

    static final void insertChildAnchor(TextBuffer self, TextIter iter, TextChildAnchor anchor) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (anchor == null) {
            throw new IllegalArgumentException("anchor can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_insert_child_anchor(pointerOf(self), pointerOf(iter), pointerOf(anchor));
        }
    }

    private static native final void gtk_text_buffer_insert_child_anchor(long self, long iter, long anchor);

    static final TextChildAnchor createChildAnchor(TextBuffer self, TextIter iter) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_create_child_anchor(pointerOf(self), pointerOf(iter));

            return (TextChildAnchor) objectFor(result);
        }
    }

    private static native final long gtk_text_buffer_create_child_anchor(long self, long iter);

    static final TextMark createMark(TextBuffer self, String markName, org.gnome.gtk.TextIter where, boolean leftGravity) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (where == null) {
            throw new IllegalArgumentException("where can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_create_mark(pointerOf(self), markName, pointerOf(where), leftGravity);

            return (TextMark) objectFor(result);
        }
    }

    private static native final long gtk_text_buffer_create_mark(long self, String markName, long where, boolean leftGravity);

    static final void moveMark(TextBuffer self, TextMark mark, org.gnome.gtk.TextIter where) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mark == null) {
            throw new IllegalArgumentException("mark can't be null");
        }

        if (where == null) {
            throw new IllegalArgumentException("where can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_move_mark(pointerOf(self), pointerOf(mark), pointerOf(where));
        }
    }

    private static native final void gtk_text_buffer_move_mark(long self, long mark, long where);

    static final void deleteMark(TextBuffer self, TextMark mark) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mark == null) {
            throw new IllegalArgumentException("mark can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_delete_mark(pointerOf(self), pointerOf(mark));
        }
    }

    private static native final void gtk_text_buffer_delete_mark(long self, long mark);

    static final TextMark getMark(TextBuffer self, String name) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_mark(pointerOf(self), name);

            return (TextMark) objectFor(result);
        }
    }

    private static native final long gtk_text_buffer_get_mark(long self, String name);

    static final void moveMarkByName(TextBuffer self, String name, org.gnome.gtk.TextIter where) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (where == null) {
            throw new IllegalArgumentException("where can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_move_mark_by_name(pointerOf(self), name, pointerOf(where));
        }
    }

    private static native final void gtk_text_buffer_move_mark_by_name(long self, String name, long where);

    static final void deleteMarkByName(TextBuffer self, String name) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_delete_mark_by_name(pointerOf(self), name);
        }
    }

    private static native final void gtk_text_buffer_delete_mark_by_name(long self, String name);

    static final TextMark getInsert(TextBuffer self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_insert(pointerOf(self));

            return (TextMark) objectFor(result);
        }
    }

    private static native final long gtk_text_buffer_get_insert(long self);

    static final TextMark getSelectionBound(TextBuffer self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_selection_bound(pointerOf(self));

            return (TextMark) objectFor(result);
        }
    }

    private static native final long gtk_text_buffer_get_selection_bound(long self);

    static final void placeCursor(TextBuffer self, org.gnome.gtk.TextIter where) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (where == null) {
            throw new IllegalArgumentException("where can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_place_cursor(pointerOf(self), pointerOf(where));
        }
    }

    private static native final void gtk_text_buffer_place_cursor(long self, long where);

    static final void selectRange(TextBuffer self, org.gnome.gtk.TextIter ins, org.gnome.gtk.TextIter bound) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (ins == null) {
            throw new IllegalArgumentException("ins can't be null");
        }

        if (bound == null) {
            throw new IllegalArgumentException("bound can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_select_range(pointerOf(self), pointerOf(ins), pointerOf(bound));
        }
    }

    private static native final void gtk_text_buffer_select_range(long self, long ins, long bound);

    static final void applyTag(TextBuffer self, TextTag tag, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (tag == null) {
            throw new IllegalArgumentException("tag can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_apply_tag(pointerOf(self), pointerOf(tag), pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_apply_tag(long self, long tag, long start, long end);

    static final void removeTag(TextBuffer self, TextTag tag, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (tag == null) {
            throw new IllegalArgumentException("tag can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_remove_tag(pointerOf(self), pointerOf(tag), pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_remove_tag(long self, long tag, long start, long end);

    static final void applyTagByName(TextBuffer self, String name, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_apply_tag_by_name(pointerOf(self), name, pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_apply_tag_by_name(long self, String name, long start, long end);

    static final void removeTagByName(TextBuffer self, String name, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_remove_tag_by_name(pointerOf(self), name, pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_remove_tag_by_name(long self, String name, long start, long end);

    static final void removeAllTags(TextBuffer self, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_remove_all_tags(pointerOf(self), pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_remove_all_tags(long self, long start, long end);

    static final TextTag createTag(TextBuffer self, String tagName, String firstPropertyName) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (tagName == null) {
            throw new IllegalArgumentException("tagName can't be null");
        }

        if (firstPropertyName == null) {
            throw new IllegalArgumentException("firstPropertyName can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_create_tag(pointerOf(self), tagName, firstPropertyName);

            return (TextTag) objectFor(result);
        }
    }

    private static native final long gtk_text_buffer_create_tag(long self, String tagName, String firstPropertyName);

    static final void getIterAtLineOffset(TextBuffer self, TextIter iter, int lineNumber, int charOffset) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_iter_at_line_offset(pointerOf(self), pointerOf(iter), lineNumber, charOffset);
        }
    }

    private static native final void gtk_text_buffer_get_iter_at_line_offset(long self, long iter, int lineNumber, int charOffset);

    static final void getIterAtLineIndex(TextBuffer self, TextIter iter, int lineNumber, int byteIndex) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_iter_at_line_index(pointerOf(self), pointerOf(iter), lineNumber, byteIndex);
        }
    }

    private static native final void gtk_text_buffer_get_iter_at_line_index(long self, long iter, int lineNumber, int byteIndex);

    static final void getIterAtOffset(TextBuffer self, TextIter iter, int charOffset) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_iter_at_offset(pointerOf(self), pointerOf(iter), charOffset);
        }
    }

    private static native final void gtk_text_buffer_get_iter_at_offset(long self, long iter, int charOffset);

    static final void getIterAtLine(TextBuffer self, TextIter iter, int lineNumber) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_iter_at_line(pointerOf(self), pointerOf(iter), lineNumber);
        }
    }

    private static native final void gtk_text_buffer_get_iter_at_line(long self, long iter, int lineNumber);

    static final void getStartIter(TextBuffer self, TextIter iter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_start_iter(pointerOf(self), pointerOf(iter));
        }
    }

    private static native final void gtk_text_buffer_get_start_iter(long self, long iter);

    static final void getEndIter(TextBuffer self, TextIter iter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_end_iter(pointerOf(self), pointerOf(iter));
        }
    }

    private static native final void gtk_text_buffer_get_end_iter(long self, long iter);

    static final void getBounds(TextBuffer self, TextIter start, TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_bounds(pointerOf(self), pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_text_buffer_get_bounds(long self, long start, long end);

    static final void getIterAtMark(TextBuffer self, TextIter iter, TextMark mark) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (mark == null) {
            throw new IllegalArgumentException("mark can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_iter_at_mark(pointerOf(self), pointerOf(iter), pointerOf(mark));
        }
    }

    private static native final void gtk_text_buffer_get_iter_at_mark(long self, long iter, long mark);

    static final void getIterAtChildAnchor(TextBuffer self, TextIter iter, TextChildAnchor anchor) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (anchor == null) {
            throw new IllegalArgumentException("anchor can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_get_iter_at_child_anchor(pointerOf(self), pointerOf(iter), pointerOf(anchor));
        }
    }

    private static native final void gtk_text_buffer_get_iter_at_child_anchor(long self, long iter, long anchor);

    static final boolean getModified(TextBuffer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_modified(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_get_modified(long self);

    static final void setModified(TextBuffer self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_set_modified(pointerOf(self), setting);
        }
    }

    private static native final void gtk_text_buffer_set_modified(long self, boolean setting);

    static final void addSelectionClipboard(TextBuffer self, Clipboard clipboard) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (clipboard == null) {
            throw new IllegalArgumentException("clipboard can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_add_selection_clipboard(pointerOf(self), pointerOf(clipboard));
        }
    }

    private static native final void gtk_text_buffer_add_selection_clipboard(long self, long clipboard);

    static final void removeSelectionClipboard(TextBuffer self, Clipboard clipboard) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (clipboard == null) {
            throw new IllegalArgumentException("clipboard can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_remove_selection_clipboard(pointerOf(self), pointerOf(clipboard));
        }
    }

    private static native final void gtk_text_buffer_remove_selection_clipboard(long self, long clipboard);

    static final void cutClipboard(TextBuffer self, Clipboard clipboard, boolean defaultEditable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (clipboard == null) {
            throw new IllegalArgumentException("clipboard can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_cut_clipboard(pointerOf(self), pointerOf(clipboard), defaultEditable);
        }
    }

    private static native final void gtk_text_buffer_cut_clipboard(long self, long clipboard, boolean defaultEditable);

    static final void copyClipboard(TextBuffer self, Clipboard clipboard) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (clipboard == null) {
            throw new IllegalArgumentException("clipboard can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_copy_clipboard(pointerOf(self), pointerOf(clipboard));
        }
    }

    private static native final void gtk_text_buffer_copy_clipboard(long self, long clipboard);

    static final void pasteClipboard(TextBuffer self, Clipboard clipboard, TextIter overrideLocation, boolean defaultEditable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (clipboard == null) {
            throw new IllegalArgumentException("clipboard can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_paste_clipboard(pointerOf(self), pointerOf(clipboard), pointerOf(overrideLocation), defaultEditable);
        }
    }

    private static native final void gtk_text_buffer_paste_clipboard(long self, long clipboard, long overrideLocation, boolean defaultEditable);

    static final boolean getSelectionBounds(TextBuffer self, TextIter start, TextIter end) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_selection_bounds(pointerOf(self), pointerOf(start), pointerOf(end));

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_get_selection_bounds(long self, long start, long end);

    static final boolean deleteSelection(TextBuffer self, boolean interactive, boolean defaultEditable) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_delete_selection(pointerOf(self), interactive, defaultEditable);

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_delete_selection(long self, boolean interactive, boolean defaultEditable);

    static final void beginUserAction(TextBuffer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_begin_user_action(pointerOf(self));
        }
    }

    private static native final void gtk_text_buffer_begin_user_action(long self);

    static final void endUserAction(TextBuffer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_buffer_end_user_action(pointerOf(self));
        }
    }

    private static native final void gtk_text_buffer_end_user_action(long self);

    static final boolean backspace(TextBuffer self, TextIter iter, boolean interactive, boolean defaultEditable) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_backspace(pointerOf(self), pointerOf(iter), interactive, defaultEditable);

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_backspace(long self, long iter, boolean interactive, boolean defaultEditable);

    interface InsertTextSignal extends Signal
    {
        void onInsertText(TextBuffer source, TextIter pos, String text, int length);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.InsertTextSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "insert-text", after);
    }

    protected static final void receiveInsertText(Signal handler, long source, long pos, String text, int length) {
        ((GtkTextBuffer.InsertTextSignal) handler).onInsertText((TextBuffer) objectFor(source), (TextIter) boxedFor(TextIter.class, pos), text, length);
    }

    interface InsertPixbufSignal extends Signal
    {
        void onInsertPixbuf(TextBuffer source, TextIter pos, Pixbuf pixbuf);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.InsertPixbufSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "insert-pixbuf", after);
    }

    protected static final void receiveInsertPixbuf(Signal handler, long source, long pos, long pixbuf) {
        ((GtkTextBuffer.InsertPixbufSignal) handler).onInsertPixbuf((TextBuffer) objectFor(source), (TextIter) boxedFor(TextIter.class, pos), (Pixbuf) objectFor(pixbuf));
    }

    interface InsertChildAnchorSignal extends Signal
    {
        void onInsertChildAnchor(TextBuffer source, TextIter pos, TextChildAnchor anchor);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.InsertChildAnchorSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "insert-child-anchor", after);
    }

    protected static final void receiveInsertChildAnchor(Signal handler, long source, long pos, long anchor) {
        ((GtkTextBuffer.InsertChildAnchorSignal) handler).onInsertChildAnchor((TextBuffer) objectFor(source), (TextIter) boxedFor(TextIter.class, pos), (TextChildAnchor) objectFor(anchor));
    }

    interface DeleteRangeSignal extends Signal
    {
        void onDeleteRange(TextBuffer source, TextIter start, TextIter end);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.DeleteRangeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "delete-range", after);
    }

    protected static final void receiveDeleteRange(Signal handler, long source, long start, long end) {
        ((GtkTextBuffer.DeleteRangeSignal) handler).onDeleteRange((TextBuffer) objectFor(source), (TextIter) boxedFor(TextIter.class, start), (TextIter) boxedFor(TextIter.class, end));
    }

    interface ChangedSignal extends Signal
    {
        void onChanged(TextBuffer source);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.ChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "changed", after);
    }

    protected static final void receiveChanged(Signal handler, long source) {
        ((GtkTextBuffer.ChangedSignal) handler).onChanged((TextBuffer) objectFor(source));
    }

    interface ModifiedChangedSignal extends Signal
    {
        void onModifiedChanged(TextBuffer source);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.ModifiedChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "modified-changed", after);
    }

    protected static final void receiveModifiedChanged(Signal handler, long source) {
        ((GtkTextBuffer.ModifiedChangedSignal) handler).onModifiedChanged((TextBuffer) objectFor(source));
    }

    interface MarkSetSignal extends Signal
    {
        void onMarkSet(TextBuffer source, org.gnome.gtk.TextIter location, TextMark mark);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.MarkSetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "mark-set", after);
    }

    protected static final void receiveMarkSet(Signal handler, long source, long location, long mark) {
        ((GtkTextBuffer.MarkSetSignal) handler).onMarkSet((TextBuffer) objectFor(source), (org.gnome.gtk.TextIter) boxedFor(org.gnome.gtk.TextIter.class, location), (TextMark) objectFor(mark));
    }

    interface MarkDeletedSignal extends Signal
    {
        void onMarkDeleted(TextBuffer source, TextMark mark);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.MarkDeletedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "mark-deleted", after);
    }

    protected static final void receiveMarkDeleted(Signal handler, long source, long mark) {
        ((GtkTextBuffer.MarkDeletedSignal) handler).onMarkDeleted((TextBuffer) objectFor(source), (TextMark) objectFor(mark));
    }

    interface ApplyTagSignal extends Signal
    {
        void onApplyTag(TextBuffer source, TextTag tag, org.gnome.gtk.TextIter startChar, org.gnome.gtk.TextIter endChar);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.ApplyTagSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "apply-tag", after);
    }

    protected static final void receiveApplyTag(Signal handler, long source, long tag, long startChar, long endChar) {
        ((GtkTextBuffer.ApplyTagSignal) handler).onApplyTag((TextBuffer) objectFor(source), (TextTag) objectFor(tag), (org.gnome.gtk.TextIter) boxedFor(org.gnome.gtk.TextIter.class, startChar), (org.gnome.gtk.TextIter) boxedFor(org.gnome.gtk.TextIter.class, endChar));
    }

    interface RemoveTagSignal extends Signal
    {
        void onRemoveTag(TextBuffer source, TextTag tag, org.gnome.gtk.TextIter startChar, org.gnome.gtk.TextIter endChar);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.RemoveTagSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "remove-tag", after);
    }

    protected static final void receiveRemoveTag(Signal handler, long source, long tag, long startChar, long endChar) {
        ((GtkTextBuffer.RemoveTagSignal) handler).onRemoveTag((TextBuffer) objectFor(source), (TextTag) objectFor(tag), (org.gnome.gtk.TextIter) boxedFor(org.gnome.gtk.TextIter.class, startChar), (org.gnome.gtk.TextIter) boxedFor(org.gnome.gtk.TextIter.class, endChar));
    }

    interface BeginUserActionSignal extends Signal
    {
        void onBeginUserAction(TextBuffer source);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.BeginUserActionSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "begin-user-action", after);
    }

    protected static final void receiveBeginUserAction(Signal handler, long source) {
        ((GtkTextBuffer.BeginUserActionSignal) handler).onBeginUserAction((TextBuffer) objectFor(source));
    }

    interface EndUserActionSignal extends Signal
    {
        void onEndUserAction(TextBuffer source);
    }

    static final void connect(TextBuffer self, GtkTextBuffer.EndUserActionSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextBuffer.class, "end-user-action", after);
    }

    protected static final void receiveEndUserAction(Signal handler, long source) {
        ((GtkTextBuffer.EndUserActionSignal) handler).onEndUserAction((TextBuffer) objectFor(source));
    }

    static final boolean getHasSelection(TextBuffer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_buffer_get_has_selection(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_text_buffer_get_has_selection(long self);

    static final FIXME getCopyTargetList(TextBuffer self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTargetList*");
    }

    static final FIXME getPasteTargetList(TextBuffer self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTargetList*");
    }

    static final FIXME registerSerializeFormat(TextBuffer self, String mimeType, FIXME function, FIXME userData, FIXME userDataDestroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final FIXME registerSerializeTagset(TextBuffer self, String tagsetName) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final FIXME registerDeserializeFormat(TextBuffer self, String mimeType, FIXME function, FIXME userData, FIXME userDataDestroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final FIXME registerDeserializeTagset(TextBuffer self, String tagsetName) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void unregisterSerializeFormat(TextBuffer self, FIXME format) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void unregisterDeserializeFormat(TextBuffer self, FIXME format) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void deserializeSetCanCreateTags(TextBuffer self, FIXME format, boolean canCreateTags) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final boolean deserializeGetCanCreateTags(TextBuffer self, FIXME format) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final FIXME getSerializeFormats(TextBuffer self, int[] nFormats) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom*");
    }

    static final FIXME getDeserializeFormats(TextBuffer self, int[] nFormats) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom*");
    }

    static final FIXME serialize(TextBuffer self, TextBuffer contentBuffer, FIXME format, org.gnome.gtk.TextIter start, org.gnome.gtk.TextIter end, long[] length) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guint8*");
    }

    static final boolean deserialize(TextBuffer self, TextBuffer contentBuffer, FIXME format, TextIter iter, FIXME data, long length) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }
}

