/*
 * GtkTextTag.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Event;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TextIter;
import org.gnome.gtk.TextTag;

final class GtkTextTag extends Plumbing
{
    private GtkTextTag() {}

    static final long createTextTag(String name) {
        long result;

        synchronized (lock) {
            result = gtk_text_tag_new(name);

            return result;
        }
    }

    private static native final long gtk_text_tag_new(String name);

    static final int getPriority(TextTag self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_tag_get_priority(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_tag_get_priority(long self);

    static final void setPriority(TextTag self, int priority) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_tag_set_priority(pointerOf(self), priority);
        }
    }

    private static native final void gtk_text_tag_set_priority(long self, int priority);

    static final boolean event(TextTag self, Object eventObject, Event event, TextIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (eventObject == null) {
            throw new IllegalArgumentException("eventObject can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_text_tag_event(pointerOf(self), pointerOf(eventObject), pointerOf(event), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_text_tag_event(long self, long eventObject, long event, long iter);

    interface EventSignal extends Signal
    {
        boolean onEvent(TextTag source, Object eventObject, Event event, TextIter iter);
    }

    static final void connect(TextTag self, GtkTextTag.EventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextTag.class, "event", after);
    }

    protected static final boolean receiveEvent(Signal handler, long source, long eventObject, long event, long iter) {
        boolean result;

        result = ((GtkTextTag.EventSignal) handler).onEvent((TextTag) objectFor(source), (Object) objectFor(eventObject), (Event) boxedFor(Event.class, event), (TextIter) boxedFor(TextIter.class, iter));

        return result;
    }
}

