/*
 * GtkTextTagTable.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TextTag;
import org.gnome.gtk.TextTagTable;

final class GtkTextTagTable extends Plumbing
{
    private GtkTextTagTable() {}

    static final long createTextTagTable() {
        long result;

        synchronized (lock) {
            result = gtk_text_tag_table_new();

            return result;
        }
    }

    private static native final long gtk_text_tag_table_new();

    static final void add(TextTagTable self, TextTag tag) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (tag == null) {
            throw new IllegalArgumentException("tag can't be null");
        }

        synchronized (lock) {
            gtk_text_tag_table_add(pointerOf(self), pointerOf(tag));
        }
    }

    private static native final void gtk_text_tag_table_add(long self, long tag);

    static final void remove(TextTagTable self, TextTag tag) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (tag == null) {
            throw new IllegalArgumentException("tag can't be null");
        }

        synchronized (lock) {
            gtk_text_tag_table_remove(pointerOf(self), pointerOf(tag));
        }
    }

    private static native final void gtk_text_tag_table_remove(long self, long tag);

    static final TextTag lookup(TextTagTable self, String name) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = gtk_text_tag_table_lookup(pointerOf(self), name);

            return (TextTag) objectFor(result);
        }
    }

    private static native final long gtk_text_tag_table_lookup(long self, String name);

    static final void foreach(TextTagTable self, FIXME func, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTextTagTableForeach");
    }

    static final int getSize(TextTagTable self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_tag_table_get_size(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_tag_table_get_size(long self);

    interface TagChangedSignal extends Signal
    {
        void onTagChanged(TextTagTable source, TextTag tag, boolean sizeChanged);
    }

    static final void connect(TextTagTable self, GtkTextTagTable.TagChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextTagTable.class, "tag-changed", after);
    }

    protected static final void receiveTagChanged(Signal handler, long source, long tag, boolean sizeChanged) {
        ((GtkTextTagTable.TagChangedSignal) handler).onTagChanged((TextTagTable) objectFor(source), (TextTag) objectFor(tag), sizeChanged);
    }

    interface TagAddedSignal extends Signal
    {
        void onTagAdded(TextTagTable source, TextTag tag);
    }

    static final void connect(TextTagTable self, GtkTextTagTable.TagAddedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextTagTable.class, "tag-added", after);
    }

    protected static final void receiveTagAdded(Signal handler, long source, long tag) {
        ((GtkTextTagTable.TagAddedSignal) handler).onTagAdded((TextTagTable) objectFor(source), (TextTag) objectFor(tag));
    }

    interface TagRemovedSignal extends Signal
    {
        void onTagRemoved(TextTagTable source, TextTag tag);
    }

    static final void connect(TextTagTable self, GtkTextTagTable.TagRemovedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTextTagTable.class, "tag-removed", after);
    }

    protected static final void receiveTagRemoved(Signal handler, long source, long tag) {
        ((GtkTextTagTable.TagRemovedSignal) handler).onTagRemoved((TextTagTable) objectFor(source), (TextTag) objectFor(tag));
    }
}

