/*
 * GtkToggleAction.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ToggleAction;

final class GtkToggleAction extends Plumbing
{
    private GtkToggleAction() {}

    static final long createToggleAction(String name, String label, String tooltip, String stockId) {
        long result;

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        if (tooltip == null) {
            throw new IllegalArgumentException("tooltip can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_action_new(name, label, tooltip, stockId);

            return result;
        }
    }

    private static native final long gtk_toggle_action_new(String name, String label, String tooltip, String stockId);

    static final void toggled(ToggleAction self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_action_toggled(pointerOf(self));
        }
    }

    private static native final void gtk_toggle_action_toggled(long self);

    static final void setActive(ToggleAction self, boolean isActive) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_action_set_active(pointerOf(self), isActive);
        }
    }

    private static native final void gtk_toggle_action_set_active(long self, boolean isActive);

    static final boolean getActive(ToggleAction self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_action_get_active(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_toggle_action_get_active(long self);

    static final void setDrawAsRadio(ToggleAction self, boolean drawAsRadio) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_action_set_draw_as_radio(pointerOf(self), drawAsRadio);
        }
    }

    private static native final void gtk_toggle_action_set_draw_as_radio(long self, boolean drawAsRadio);

    static final boolean getDrawAsRadio(ToggleAction self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_action_get_draw_as_radio(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_toggle_action_get_draw_as_radio(long self);

    interface ToggledSignal extends Signal
    {
        void onToggled(ToggleAction source);
    }

    static final void connect(ToggleAction self, GtkToggleAction.ToggledSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkToggleAction.class, "toggled", after);
    }

    protected static final void receiveToggled(Signal handler, long source) {
        ((GtkToggleAction.ToggledSignal) handler).onToggled((ToggleAction) objectFor(source));
    }
}

