/*
 * GtkToggleButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ToggleButton;

final class GtkToggleButton extends Plumbing
{
    private GtkToggleButton() {}

    static final long createToggleButton() {
        long result;

        synchronized (lock) {
            result = gtk_toggle_button_new();

            return result;
        }
    }

    private static native final long gtk_toggle_button_new();

    static final long createToggleButtonWithLabel(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_button_new_with_label(label);

            return result;
        }
    }

    private static native final long gtk_toggle_button_new_with_label(String label);

    static final long createToggleButtonWithMnemonic(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_button_new_with_mnemonic(label);

            return result;
        }
    }

    private static native final long gtk_toggle_button_new_with_mnemonic(String label);

    static final void setMode(ToggleButton self, boolean drawIndicator) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_button_set_mode(pointerOf(self), drawIndicator);
        }
    }

    private static native final void gtk_toggle_button_set_mode(long self, boolean drawIndicator);

    static final boolean getMode(ToggleButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_button_get_mode(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_toggle_button_get_mode(long self);

    static final void setActive(ToggleButton self, boolean isActive) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_button_set_active(pointerOf(self), isActive);
        }
    }

    private static native final void gtk_toggle_button_set_active(long self, boolean isActive);

    static final boolean getActive(ToggleButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_button_get_active(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_toggle_button_get_active(long self);

    static final void toggled(ToggleButton self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_button_toggled(pointerOf(self));
        }
    }

    private static native final void gtk_toggle_button_toggled(long self);

    static final void setInconsistent(ToggleButton self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_button_set_inconsistent(pointerOf(self), setting);
        }
    }

    private static native final void gtk_toggle_button_set_inconsistent(long self, boolean setting);

    static final boolean getInconsistent(ToggleButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_button_get_inconsistent(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_toggle_button_get_inconsistent(long self);

    interface ToggledSignal extends Signal
    {
        void onToggled(ToggleButton source);
    }

    static final void connect(ToggleButton self, GtkToggleButton.ToggledSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkToggleButton.class, "toggled", after);
    }

    protected static final void receiveToggled(Signal handler, long source) {
        ((GtkToggleButton.ToggledSignal) handler).onToggled((ToggleButton) objectFor(source));
    }
}

