/*
 * GtkToggleToolButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ToggleToolButton;

final class GtkToggleToolButton extends Plumbing
{
    private GtkToggleToolButton() {}

    static final long createToggleToolButton() {
        long result;

        synchronized (lock) {
            result = gtk_toggle_tool_button_new();

            return result;
        }
    }

    private static native final long gtk_toggle_tool_button_new();

    static final long createToggleToolButtonFromStock(String stockId) {
        long result;

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_tool_button_new_from_stock(stockId);

            return result;
        }
    }

    private static native final long gtk_toggle_tool_button_new_from_stock(String stockId);

    static final void setActive(ToggleToolButton self, boolean isActive) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_toggle_tool_button_set_active(pointerOf(self), isActive);
        }
    }

    private static native final void gtk_toggle_tool_button_set_active(long self, boolean isActive);

    static final boolean getActive(ToggleToolButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_toggle_tool_button_get_active(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_toggle_tool_button_get_active(long self);

    interface ToggledSignal extends Signal
    {
        void onToggled(ToggleToolButton source);
    }

    static final void connect(ToggleToolButton self, GtkToggleToolButton.ToggledSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkToggleToolButton.class, "toggled", after);
    }

    protected static final void receiveToggled(Signal handler, long source) {
        ((GtkToggleToolButton.ToggledSignal) handler).onToggled((ToggleToolButton) objectFor(source));
    }
}

