/*
 * GtkToolButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ToolButton;
import org.gnome.gtk.Widget;

final class GtkToolButton extends Plumbing
{
    private GtkToolButton() {}

    static final long createToolButton(Widget iconWidget, String label) {
        long result;

        synchronized (lock) {
            result = gtk_tool_button_new(pointerOf(iconWidget), label);

            return result;
        }
    }

    private static native final long gtk_tool_button_new(long iconWidget, String label);

    static final long createToolButtonFromStock(String stockId) {
        long result;

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_button_new_from_stock(stockId);

            return result;
        }
    }

    private static native final long gtk_tool_button_new_from_stock(String stockId);

    static final void setLabel(ToolButton self, String label) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_button_set_label(pointerOf(self), label);
        }
    }

    private static native final void gtk_tool_button_set_label(long self, String label);

    static final String getLabel(ToolButton self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_button_get_label(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_tool_button_get_label(long self);

    static final void setUseUnderline(ToolButton self, boolean useUnderline) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_button_set_use_underline(pointerOf(self), useUnderline);
        }
    }

    private static native final void gtk_tool_button_set_use_underline(long self, boolean useUnderline);

    static final boolean getUseUnderline(ToolButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_button_get_use_underline(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tool_button_get_use_underline(long self);

    static final void setStockId(ToolButton self, String stockId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_button_set_stock_id(pointerOf(self), stockId);
        }
    }

    private static native final void gtk_tool_button_set_stock_id(long self, String stockId);

    static final void setIconName(ToolButton self, String iconName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_button_set_icon_name(pointerOf(self), iconName);
        }
    }

    private static native final void gtk_tool_button_set_icon_name(long self, String iconName);

    static final String getIconName(ToolButton self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_button_get_icon_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_tool_button_get_icon_name(long self);

    static final String getStockId(ToolButton self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_button_get_stock_id(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_tool_button_get_stock_id(long self);

    static final void setIconWidget(ToolButton self, Widget iconWidget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_button_set_icon_widget(pointerOf(self), pointerOf(iconWidget));
        }
    }

    private static native final void gtk_tool_button_set_icon_widget(long self, long iconWidget);

    static final Widget getIconWidget(ToolButton self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_button_get_icon_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_tool_button_get_icon_widget(long self);

    static final void setLabelWidget(ToolButton self, Widget labelWidget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_button_set_label_widget(pointerOf(self), pointerOf(labelWidget));
        }
    }

    private static native final void gtk_tool_button_set_label_widget(long self, long labelWidget);

    static final Widget getLabelWidget(ToolButton self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_button_get_label_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_tool_button_get_label_widget(long self);

    interface ClickedSignal extends Signal
    {
        void onClicked(ToolButton source);
    }

    static final void connect(ToolButton self, GtkToolButton.ClickedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkToolButton.class, "clicked", after);
    }

    protected static final void receiveClicked(Signal handler, long source) {
        ((GtkToolButton.ClickedSignal) handler).onClicked((ToolButton) objectFor(source));
    }
}

