/*
 * GtkTreeDragDest.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SelectionData;
import org.gnome.gtk.TreeDragDest;
import org.gnome.gtk.TreePath;

final class GtkTreeDragDest extends Plumbing
{
    private GtkTreeDragDest() {}

    static final boolean dragDataReceived(TreeDragDest self, TreePath dest, SelectionData selectionData) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        if (selectionData == null) {
            throw new IllegalArgumentException("selectionData can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_drag_dest_drag_data_received(pointerOf((Object) self), pointerOf(dest), pointerOf(selectionData));

            return result;
        }
    }

    private static native final boolean gtk_tree_drag_dest_drag_data_received(long self, long dest, long selectionData);

    static final boolean rowDropPossible(TreeDragDest self, TreePath destPath, SelectionData selectionData) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (destPath == null) {
            throw new IllegalArgumentException("destPath can't be null");
        }

        if (selectionData == null) {
            throw new IllegalArgumentException("selectionData can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_drag_dest_row_drop_possible(pointerOf((Object) self), pointerOf(destPath), pointerOf(selectionData));

            return result;
        }
    }

    private static native final boolean gtk_tree_drag_dest_row_drop_possible(long self, long destPath, long selectionData);

    interface DragDataReceivedSignal extends Signal
    {
        boolean onDragDataReceived(TreeDragDest source, TreePath dest, SelectionData selectionData);
    }

    static final void connect(TreeDragDest self, GtkTreeDragDest.DragDataReceivedSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeDragDest.class, "drag-data-received", after);
    }

    protected static final boolean receiveDragDataReceived(Signal handler, long source, long dest, long selectionData) {
        boolean result;

        result = ((GtkTreeDragDest.DragDataReceivedSignal) handler).onDragDataReceived((TreeDragDest) objectFor(source), (TreePath) boxedFor(TreePath.class, dest), (SelectionData) boxedFor(SelectionData.class, selectionData));

        return result;
    }

    interface RowDropPossibleSignal extends Signal
    {
        boolean onRowDropPossible(TreeDragDest source, TreePath destPath, SelectionData selectionData);
    }

    static final void connect(TreeDragDest self, GtkTreeDragDest.RowDropPossibleSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeDragDest.class, "row-drop-possible", after);
    }

    protected static final boolean receiveRowDropPossible(Signal handler, long source, long destPath, long selectionData) {
        boolean result;

        result = ((GtkTreeDragDest.RowDropPossibleSignal) handler).onRowDropPossible((TreeDragDest) objectFor(source), (TreePath) boxedFor(TreePath.class, destPath), (SelectionData) boxedFor(SelectionData.class, selectionData));

        return result;
    }
}

