/*
 * GtkTreeDragSource.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SelectionData;
import org.gnome.gtk.TreeDragSource;
import org.gnome.gtk.TreePath;

final class GtkTreeDragSource extends Plumbing
{
    private GtkTreeDragSource() {}

    static final boolean rowDraggable(TreeDragSource self, TreePath path) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_drag_source_row_draggable(pointerOf((Object) self), pointerOf(path));

            return result;
        }
    }

    private static native final boolean gtk_tree_drag_source_row_draggable(long self, long path);

    static final boolean dragDataDelete(TreeDragSource self, TreePath path) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_drag_source_drag_data_delete(pointerOf((Object) self), pointerOf(path));

            return result;
        }
    }

    private static native final boolean gtk_tree_drag_source_drag_data_delete(long self, long path);

    static final boolean dragDataGet(TreeDragSource self, TreePath path, SelectionData selectionData) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        if (selectionData == null) {
            throw new IllegalArgumentException("selectionData can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_drag_source_drag_data_get(pointerOf((Object) self), pointerOf(path), pointerOf(selectionData));

            return result;
        }
    }

    private static native final boolean gtk_tree_drag_source_drag_data_get(long self, long path, long selectionData);

    interface RowDraggableSignal extends Signal
    {
        boolean onRowDraggable(TreeDragSource source, TreePath path);
    }

    static final void connect(TreeDragSource self, GtkTreeDragSource.RowDraggableSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeDragSource.class, "row-draggable", after);
    }

    protected static final boolean receiveRowDraggable(Signal handler, long source, long path) {
        boolean result;

        result = ((GtkTreeDragSource.RowDraggableSignal) handler).onRowDraggable((TreeDragSource) objectFor(source), (TreePath) boxedFor(TreePath.class, path));

        return result;
    }

    interface DragDataGetSignal extends Signal
    {
        boolean onDragDataGet(TreeDragSource source, TreePath path, SelectionData selectionData);
    }

    static final void connect(TreeDragSource self, GtkTreeDragSource.DragDataGetSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeDragSource.class, "drag-data-get", after);
    }

    protected static final boolean receiveDragDataGet(Signal handler, long source, long path, long selectionData) {
        boolean result;

        result = ((GtkTreeDragSource.DragDataGetSignal) handler).onDragDataGet((TreeDragSource) objectFor(source), (TreePath) boxedFor(TreePath.class, path), (SelectionData) boxedFor(SelectionData.class, selectionData));

        return result;
    }

    interface DragDataDeleteSignal extends Signal
    {
        boolean onDragDataDelete(TreeDragSource source, TreePath path);
    }

    static final void connect(TreeDragSource self, GtkTreeDragSource.DragDataDeleteSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeDragSource.class, "drag-data-delete", after);
    }

    protected static final boolean receiveDragDataDelete(Signal handler, long source, long path) {
        boolean result;

        result = ((GtkTreeDragSource.DragDataDeleteSignal) handler).onDragDataDelete((TreeDragSource) objectFor(source), (TreePath) boxedFor(TreePath.class, path));

        return result;
    }
}

