/*
 * GtkTreePath.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreePath;

final class GtkTreePath extends Plumbing
{
    private GtkTreePath() {}

    static final long createTreePath() {
        long result;

        synchronized (lock) {
            result = gtk_tree_path_new();

            return result;
        }
    }

    private static native final long gtk_tree_path_new();

    static final long createTreePathFromString(String path) {
        long result;

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_new_from_string(path);

            return result;
        }
    }

    private static native final long gtk_tree_path_new_from_string(String path);

    static final String toString(TreePath self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_to_string(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_tree_path_to_string(long self);

    static final void appendIndex(TreePath self, int index) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_path_append_index(pointerOf(self), index);
        }
    }

    private static native final void gtk_tree_path_append_index(long self, int index);

    static final void prependIndex(TreePath self, int index) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_path_prepend_index(pointerOf(self), index);
        }
    }

    private static native final void gtk_tree_path_prepend_index(long self, int index);

    static final int getDepth(TreePath self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_get_depth(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_path_get_depth(long self);

    static final int[] getIndices(TreePath self) {
        int[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_get_indices(pointerOf(self));

            return result;
        }
    }

    private static native final int[] gtk_tree_path_get_indices(long self);

    static final void free(TreePath self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_path_free(pointerOf(self));
        }
    }

    private static native final void gtk_tree_path_free(long self);

    static final TreePath copy(TreePath self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_copy(pointerOf(self));

            return (TreePath) boxedFor(TreePath.class, result);
        }
    }

    private static native final long gtk_tree_path_copy(long self);

    static final int compare(TreePath self, org.gnome.gtk.TreePath b) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (b == null) {
            throw new IllegalArgumentException("b can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_compare(pointerOf(self), pointerOf(b));

            return result;
        }
    }

    private static native final int gtk_tree_path_compare(long self, long b);

    static final void next(TreePath self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_path_next(pointerOf(self));
        }
    }

    private static native final void gtk_tree_path_next(long self);

    static final int prev(TreePath self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_prev(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_path_prev(long self);

    static final int up(TreePath self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_up(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_path_up(long self);

    static final void down(TreePath self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_path_down(pointerOf(self));
        }
    }

    private static native final void gtk_tree_path_down(long self);

    static final boolean isAncestor(TreePath self, TreePath descendant) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (descendant == null) {
            throw new IllegalArgumentException("descendant can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_is_ancestor(pointerOf(self), pointerOf(descendant));

            return result;
        }
    }

    private static native final boolean gtk_tree_path_is_ancestor(long self, long descendant);

    static final boolean isDescendant(TreePath self, TreePath ancestor) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (ancestor == null) {
            throw new IllegalArgumentException("ancestor can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_path_is_descendant(pointerOf(self), pointerOf(ancestor));

            return result;
        }
    }

    private static native final boolean gtk_tree_path_is_descendant(long self, long ancestor);
}

