/*
 * GtkTreeRowReference.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Object;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreeModel;
import org.gnome.gtk.TreePath;
import org.gnome.gtk.TreeRowReference;

final class GtkTreeRowReference extends Plumbing
{
    private GtkTreeRowReference() {}

    static final long createTreeRowReference(TreeModel model, TreePath path) {
        long result;

        if (model == null) {
            throw new IllegalArgumentException("model can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_row_reference_new(pointerOf(model), pointerOf(path));

            return result;
        }
    }

    private static native final long gtk_tree_row_reference_new(long model, long path);

    static final long createTreeRowReferenceProxy(Object proxy, TreeModel model, TreePath path) {
        long result;

        if (proxy == null) {
            throw new IllegalArgumentException("proxy can't be null");
        }

        if (model == null) {
            throw new IllegalArgumentException("model can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_row_reference_new_proxy(pointerOf(proxy), pointerOf(model), pointerOf(path));

            return result;
        }
    }

    private static native final long gtk_tree_row_reference_new_proxy(long proxy, long model, long path);

    static final TreePath getPath(TreeRowReference self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_row_reference_get_path(pointerOf(self));

            return (TreePath) boxedFor(TreePath.class, result);
        }
    }

    private static native final long gtk_tree_row_reference_get_path(long self);

    static final TreeModel getModel(TreeRowReference self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_row_reference_get_model(pointerOf(self));

            return (TreeModel) objectFor(result);
        }
    }

    private static native final long gtk_tree_row_reference_get_model(long self);

    static final boolean valid(TreeRowReference self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_row_reference_valid(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_row_reference_valid(long self);

    static final TreeRowReference copy(TreeRowReference self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_row_reference_copy(pointerOf(self));

            return (TreeRowReference) boxedFor(TreeRowReference.class, result);
        }
    }

    private static native final long gtk_tree_row_reference_copy(long self);

    static final void free(TreeRowReference self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_row_reference_free(pointerOf(self));
        }
    }

    private static native final void gtk_tree_row_reference_free(long self);
}

