/*
 * GtkTreeSortable.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SortType;
import org.gnome.gtk.TreeSortable;

final class GtkTreeSortable extends Plumbing
{
    private GtkTreeSortable() {}

    static final void sortColumnChanged(TreeSortable self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_sortable_sort_column_changed(pointerOf((Object) self));
        }
    }

    private static native final void gtk_tree_sortable_sort_column_changed(long self);

    static final boolean getSortColumnId(TreeSortable self, int[] sortColumnId, SortType[] order) {
        boolean result;
        int[] _order;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (sortColumnId == null) {
            throw new IllegalArgumentException("sortColumnId can't be null");
        }

        if (order == null) {
            throw new IllegalArgumentException("order can't be null");
        }

        _order = numsOf(order);

        synchronized (lock) {
            result = gtk_tree_sortable_get_sort_column_id(pointerOf((Object) self), sortColumnId, _order);
            fillEnumArray(SortType.class, order, _order);

            return result;
        }
    }

    private static native final boolean gtk_tree_sortable_get_sort_column_id(long self, int[] sortColumnId, int[] order);

    static final void setSortColumnId(TreeSortable self, int sortColumnId, SortType order) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (order == null) {
            throw new IllegalArgumentException("order can't be null");
        }

        synchronized (lock) {
            gtk_tree_sortable_set_sort_column_id(pointerOf((Object) self), sortColumnId, numOf(order));
        }
    }

    private static native final void gtk_tree_sortable_set_sort_column_id(long self, int sortColumnId, int order);

    static final void setSortFunc(TreeSortable self, int sortColumnId, FIXME sortFunc, FIXME userData, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTreeIterCompareFunc");
    }

    static final void setDefaultSortFunc(TreeSortable self, FIXME sortFunc, FIXME userData, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTreeIterCompareFunc");
    }

    static final boolean hasDefaultSortFunc(TreeSortable self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_sortable_has_default_sort_func(pointerOf((Object) self));

            return result;
        }
    }

    private static native final boolean gtk_tree_sortable_has_default_sort_func(long self);

    interface SortColumnChangedSignal extends Signal
    {
        void onSortColumnChanged(TreeSortable source);
    }

    static final void connect(TreeSortable self, GtkTreeSortable.SortColumnChangedSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeSortable.class, "sort-column-changed", after);
    }

    protected static final void receiveSortColumnChanged(Signal handler, long source) {
        ((GtkTreeSortable.SortColumnChangedSignal) handler).onSortColumnChanged((TreeSortable) objectFor(source));
    }

    interface GetSortColumnIdSignal extends Signal
    {
        boolean onGetSortColumnId(TreeSortable source, int[] sortColumnId, SortType[] order);
    }

    static final void connect(TreeSortable self, GtkTreeSortable.GetSortColumnIdSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeSortable.class, "get-sort-column-id", after);
    }

    protected static final boolean receiveGetSortColumnId(Signal handler, long source, int[] sortColumnId, int[] order) {
        boolean result;

        result = ((GtkTreeSortable.GetSortColumnIdSignal) handler).onGetSortColumnId((TreeSortable) objectFor(source), sortColumnId, null);

        return result;
    }

    interface SetSortColumnIdSignal extends Signal
    {
        void onSetSortColumnId(TreeSortable source, int sortColumnId, SortType order);
    }

    static final void connect(TreeSortable self, GtkTreeSortable.SetSortColumnIdSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeSortable.class, "set-sort-column-id", after);
    }

    protected static final void receiveSetSortColumnId(Signal handler, long source, int sortColumnId, int order) {
        ((GtkTreeSortable.SetSortColumnIdSignal) handler).onSetSortColumnId((TreeSortable) objectFor(source), sortColumnId, (SortType) enumFor(SortType.class, order));
    }

    interface SetSortFuncSignal extends Signal
    {
        void onSetSortFunc(TreeSortable source, int sortColumnId, FIXME func, FIXME data, FIXME destroy);
    }

    static final void connect(TreeSortable self, GtkTreeSortable.SetSortFuncSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeSortable.class, "set-sort-func", after);
    }

    protected static final void receiveSetSortFunc(Signal handler, long source, int sortColumnId, java.lang.Object func, java.lang.Object data, java.lang.Object destroy) {
        ((GtkTreeSortable.SetSortFuncSignal) handler).onSetSortFunc((TreeSortable) objectFor(source), sortColumnId, (FIXME) func, (FIXME) data, (FIXME) destroy);
    }

    interface SetDefaultSortFuncSignal extends Signal
    {
        void onSetDefaultSortFunc(TreeSortable source, FIXME func, FIXME data, FIXME destroy);
    }

    static final void connect(TreeSortable self, GtkTreeSortable.SetDefaultSortFuncSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeSortable.class, "set-default-sort-func", after);
    }

    protected static final void receiveSetDefaultSortFunc(Signal handler, long source, java.lang.Object func, java.lang.Object data, java.lang.Object destroy) {
        ((GtkTreeSortable.SetDefaultSortFuncSignal) handler).onSetDefaultSortFunc((TreeSortable) objectFor(source), (FIXME) func, (FIXME) data, (FIXME) destroy);
    }

    interface HasDefaultSortFuncSignal extends Signal
    {
        boolean onHasDefaultSortFunc(TreeSortable source);
    }

    static final void connect(TreeSortable self, GtkTreeSortable.HasDefaultSortFuncSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, GtkTreeSortable.class, "has-default-sort-func", after);
    }

    protected static final boolean receiveHasDefaultSortFunc(Signal handler, long source) {
        boolean result;

        result = ((GtkTreeSortable.HasDefaultSortFuncSignal) handler).onHasDefaultSortFunc((TreeSortable) objectFor(source));

        return result;
    }
}

