/*
 * GtkViewport.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ShadowType;
import org.gnome.gtk.Viewport;

final class GtkViewport extends Plumbing
{
    private GtkViewport() {}

    static final long createViewport(Adjustment hadjustment, Adjustment vadjustment) {
        long result;

        if (hadjustment == null) {
            throw new IllegalArgumentException("hadjustment can't be null");
        }

        if (vadjustment == null) {
            throw new IllegalArgumentException("vadjustment can't be null");
        }

        synchronized (lock) {
            result = gtk_viewport_new(pointerOf(hadjustment), pointerOf(vadjustment));

            return result;
        }
    }

    private static native final long gtk_viewport_new(long hadjustment, long vadjustment);

    static final Adjustment getHadjustment(Viewport self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_viewport_get_hadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_viewport_get_hadjustment(long self);

    static final Adjustment getVadjustment(Viewport self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_viewport_get_vadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_viewport_get_vadjustment(long self);

    static final void setHadjustment(Viewport self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_viewport_set_hadjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_viewport_set_hadjustment(long self, long adjustment);

    static final void setVadjustment(Viewport self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_viewport_set_vadjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_viewport_set_vadjustment(long self, long adjustment);

    static final void setShadowType(Viewport self, ShadowType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_viewport_set_shadow_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gtk_viewport_set_shadow_type(long self, int type);

    static final ShadowType getShadowType(Viewport self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_viewport_get_shadow_type(pointerOf(self));

            return (ShadowType) enumFor(ShadowType.class, result);
        }
    }

    private static native final int gtk_viewport_get_shadow_type(long self);

    interface SetScrollAdjustmentsSignal extends Signal
    {
        void onSetScrollAdjustments(Viewport source, Adjustment hadjustment, Adjustment vadjustment);
    }

    static final void connect(Viewport self, GtkViewport.SetScrollAdjustmentsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkViewport.class, "set-scroll-adjustments", after);
    }

    protected static final void receiveSetScrollAdjustments(Signal handler, long source, long hadjustment, long vadjustment) {
        ((GtkViewport.SetScrollAdjustmentsSignal) handler).onSetScrollAdjustments((Viewport) objectFor(source), (Adjustment) objectFor(hadjustment), (Adjustment) objectFor(vadjustment));
    }
}

