/*
 * GtkWidget.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.Object;
import org.gnome.gdk.Bitmap;
import org.gnome.gdk.Color;
import org.gnome.gdk.Colormap;
import org.gnome.gdk.Display;
import org.gnome.gdk.DragAction;
import org.gnome.gdk.DragContext;
import org.gnome.gdk.DragProtocol;
import org.gnome.gdk.Event;
import org.gnome.gdk.EventButton;
import org.gnome.gdk.EventConfigure;
import org.gnome.gdk.EventCrossing;
import org.gnome.gdk.EventExpose;
import org.gnome.gdk.EventFocus;
import org.gnome.gdk.EventKey;
import org.gnome.gdk.EventScroll;
import org.gnome.gdk.EventVisibility;
import org.gnome.gdk.ExtensionMode;
import org.gnome.gdk.ModifierType;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Pixmap;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Region;
import org.gnome.gdk.Screen;
import org.gnome.gdk.Visual;
import org.gnome.gdk.Window;
import org.gnome.glib.Signal;
import org.gnome.glib.Value;
import org.gnome.gtk.AccelFlags;
import org.gnome.gtk.AccelGroup;
import org.gnome.gtk.Action;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Allocation;
import org.gnome.gtk.Clipboard;
import org.gnome.gtk.DestDefaults;
import org.gnome.gtk.DirectionType;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.Menu;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RcStyle;
import org.gnome.gtk.Requisition;
import org.gnome.gtk.SelectionData;
import org.gnome.gtk.Settings;
import org.gnome.gtk.StateType;
import org.gnome.gtk.Style;
import org.gnome.gtk.TextDirection;
import org.gnome.gtk.Tooltip;
import org.gnome.gtk.Widget;
import org.gnome.gtk.WidgetHelpType;
import org.gnome.pango.Context;
import org.gnome.pango.FontDescription;
import org.gnome.pango.Layout;

final class GtkWidget extends Plumbing
{
    private GtkWidget() {}

    static final FIXME getAllocation(Widget self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkAllocation");
    }

    static final boolean dragCheckThreshold(Widget self, int startX, int startY, int currentX, int currentY) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_drag_check_threshold(pointerOf(self), startX, startY, currentX, currentY);

            return result;
        }
    }

    private static native final boolean gtk_drag_check_threshold(long self, int startX, int startY, int currentX, int currentY);

    static final void dragGetData(Widget self, DragContext context, FIXME target, int time) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void dragHighlight(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_highlight(pointerOf(self));
        }
    }

    private static native final void gtk_drag_highlight(long self);

    static final void dragUnhighlight(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_unhighlight(pointerOf(self));
        }
    }

    private static native final void gtk_drag_unhighlight(long self);

    static final void dragDestSet(Widget self, DestDefaults flags, FIXME targets, int nTargets, DragAction actions) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkTargetEntry*");
    }

    static final void dragDestSetProxy(Widget self, Window proxyWindow, DragProtocol protocol, boolean useCoordinates) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (proxyWindow == null) {
            throw new IllegalArgumentException("proxyWindow can't be null");
        }

        if (protocol == null) {
            throw new IllegalArgumentException("protocol can't be null");
        }

        synchronized (lock) {
            gtk_drag_dest_set_proxy(pointerOf(self), pointerOf(proxyWindow), numOf(protocol), useCoordinates);
        }
    }

    private static native final void gtk_drag_dest_set_proxy(long self, long proxyWindow, int protocol, boolean useCoordinates);

    static final void dragDestUnset(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_dest_unset(pointerOf(self));
        }
    }

    private static native final void gtk_drag_dest_unset(long self);

    static final FIXME dragDestFindTarget(Widget self, DragContext context, FIXME targetList) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final FIXME dragDestGetTargetList(Widget self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTargetList*");
    }

    static final void dragDestSetTargetList(Widget self, FIXME targetList) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTargetList*");
    }

    static final void dragSourceSet(Widget self, ModifierType startButtonMask, FIXME targets, int nTargets, DragAction actions) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkTargetEntry*");
    }

    static final void dragSourceUnset(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_unset(pointerOf(self));
        }
    }

    private static native final void gtk_drag_source_unset(long self);

    static final void dragSourceSetIcon(Widget self, Colormap colormap, Pixmap pixmap, Bitmap mask) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colormap == null) {
            throw new IllegalArgumentException("colormap can't be null");
        }

        if (pixmap == null) {
            throw new IllegalArgumentException("pixmap can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_set_icon(pointerOf(self), pointerOf(colormap), pointerOf(pixmap), pointerOf(mask));
        }
    }

    private static native final void gtk_drag_source_set_icon(long self, long colormap, long pixmap, long mask);

    static final void dragSourceSetIconPixbuf(Widget self, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_set_icon_pixbuf(pointerOf(self), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_drag_source_set_icon_pixbuf(long self, long pixbuf);

    static final void dragSourceSetIconStock(Widget self, String stockId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_set_icon_stock(pointerOf(self), stockId);
        }
    }

    private static native final void gtk_drag_source_set_icon_stock(long self, String stockId);

    static final void dragSourceSetIconName(Widget self, String iconName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_set_icon_name(pointerOf(self), iconName);
        }
    }

    private static native final void gtk_drag_source_set_icon_name(long self, String iconName);

    static final FIXME dragSourceGetTargetList(Widget self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTargetList*");
    }

    static final void dragSourceSetTargetList(Widget self, FIXME targetList) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTargetList*");
    }

    static final DragContext dragBegin(Widget self, FIXME targets, DragAction actions, int button, Event event) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTargetList*");
    }

    static final void dragDestAddTextTargets(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_dest_add_text_targets(pointerOf(self));
        }
    }

    private static native final void gtk_drag_dest_add_text_targets(long self);

    static final void dragDestAddImageTargets(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_dest_add_image_targets(pointerOf(self));
        }
    }

    private static native final void gtk_drag_dest_add_image_targets(long self);

    static final void dragDestAddUriTargets(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_dest_add_uri_targets(pointerOf(self));
        }
    }

    private static native final void gtk_drag_dest_add_uri_targets(long self);

    static final void dragSourceAddTextTargets(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_add_text_targets(pointerOf(self));
        }
    }

    private static native final void gtk_drag_source_add_text_targets(long self);

    static final void dragSourceAddImageTargets(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_add_image_targets(pointerOf(self));
        }
    }

    private static native final void gtk_drag_source_add_image_targets(long self);

    static final void dragSourceAddUriTargets(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_source_add_uri_targets(pointerOf(self));
        }
    }

    private static native final void gtk_drag_source_add_uri_targets(long self);

    static final void grabAdd(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_grab_add(pointerOf(self));
        }
    }

    private static native final void gtk_grab_add(long self);

    static final void grabRemove(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_grab_remove(pointerOf(self));
        }
    }

    private static native final void gtk_grab_remove(long self);

    static final void propagateEvent(Widget self, Event event) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            gtk_propagate_event(pointerOf(self), pointerOf(event));
        }
    }

    private static native final void gtk_propagate_event(long self, long event);

    static final Menu[] menuGetForAttachWidget(Widget self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_get_for_attach_widget(pointerOf(self));

            return (Menu[]) objectArrayFor(result, new Menu[result.length]);
        }
    }

    private static native final long[] gtk_menu_get_for_attach_widget(long self);

    static final Style rcGetStyle(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_rc_get_style(pointerOf(self));

            return (Style) objectFor(result);
        }
    }

    private static native final long gtk_rc_get_style(long self);

    static final boolean selectionOwnerSet(Widget self, FIXME selection, int time) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void selectionAddTarget(Widget self, FIXME selection, FIXME target, int info) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void selectionAddTargets(Widget self, FIXME selection, FIXME targets, int ntargets) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void selectionClearTargets(Widget self, FIXME selection) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final boolean selectionConvert(Widget self, FIXME selection, FIXME target, int time) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void selectionRemoveAll(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_selection_remove_all(pointerOf(self));
        }
    }

    private static native final void gtk_selection_remove_all(long self);

    static final boolean selectionClear(Widget self, FIXME event) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkEventSelection*");
    }

    static final long createWidget(FIXME type, String firstPropertyName) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GType");
    }

    static final void destroy(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_destroy(pointerOf(self));
        }
    }

    private static native final void gtk_widget_destroy(long self);

    static final void destroyed(Widget self, Widget[] widgetPointer) {
        long[] _widgetPointer;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widgetPointer == null) {
            throw new IllegalArgumentException("widgetPointer can't be null");
        }

        _widgetPointer = pointersOf(widgetPointer);

        synchronized (lock) {
            gtk_widget_destroyed(pointerOf(self), _widgetPointer);
            fillObjectArray(widgetPointer, _widgetPointer);
        }
    }

    private static native final void gtk_widget_destroyed(long self, long[] widgetPointer);

    static final void unparent(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_unparent(pointerOf(self));
        }
    }

    private static native final void gtk_widget_unparent(long self);

    static final void show(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_show(pointerOf(self));
        }
    }

    private static native final void gtk_widget_show(long self);

    static final void showNow(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_show_now(pointerOf(self));
        }
    }

    private static native final void gtk_widget_show_now(long self);

    static final void hide(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_hide(pointerOf(self));
        }
    }

    private static native final void gtk_widget_hide(long self);

    static final void showAll(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_show_all(pointerOf(self));
        }
    }

    private static native final void gtk_widget_show_all(long self);

    static final void hideAll(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_hide_all(pointerOf(self));
        }
    }

    private static native final void gtk_widget_hide_all(long self);

    static final void setNoShowAll(Widget self, boolean noShowAll) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_no_show_all(pointerOf(self), noShowAll);
        }
    }

    private static native final void gtk_widget_set_no_show_all(long self, boolean noShowAll);

    static final boolean getNoShowAll(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_no_show_all(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_get_no_show_all(long self);

    static final void map(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_map(pointerOf(self));
        }
    }

    private static native final void gtk_widget_map(long self);

    static final void unmap(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_unmap(pointerOf(self));
        }
    }

    private static native final void gtk_widget_unmap(long self);

    static final void realize(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_realize(pointerOf(self));
        }
    }

    private static native final void gtk_widget_realize(long self);

    static final void unrealize(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_unrealize(pointerOf(self));
        }
    }

    private static native final void gtk_widget_unrealize(long self);

    static final void queueDraw(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_queue_draw(pointerOf(self));
        }
    }

    private static native final void gtk_widget_queue_draw(long self);

    static final void queueDrawArea(Widget self, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_queue_draw_area(pointerOf(self), x, y, width, height);
        }
    }

    private static native final void gtk_widget_queue_draw_area(long self, int x, int y, int width, int height);

    static final void queueResize(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_queue_resize(pointerOf(self));
        }
    }

    private static native final void gtk_widget_queue_resize(long self);

    static final void queueResizeNoRedraw(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_queue_resize_no_redraw(pointerOf(self));
        }
    }

    private static native final void gtk_widget_queue_resize_no_redraw(long self);

    static final void sizeRequest(Widget self, Requisition requisition) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (requisition == null) {
            throw new IllegalArgumentException("requisition can't be null");
        }

        synchronized (lock) {
            gtk_widget_size_request(pointerOf(self), pointerOf(requisition));
        }
    }

    private static native final void gtk_widget_size_request(long self, long requisition);

    static final void sizeAllocate(Widget self, Allocation allocation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (allocation == null) {
            throw new IllegalArgumentException("allocation can't be null");
        }

        synchronized (lock) {
            gtk_widget_size_allocate(pointerOf(self), pointerOf(allocation));
        }
    }

    private static native final void gtk_widget_size_allocate(long self, long allocation);

    static final void getChildRequisition(Widget self, Requisition requisition) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (requisition == null) {
            throw new IllegalArgumentException("requisition can't be null");
        }

        synchronized (lock) {
            gtk_widget_get_child_requisition(pointerOf(self), pointerOf(requisition));
        }
    }

    private static native final void gtk_widget_get_child_requisition(long self, long requisition);

    static final void addAccelerator(Widget self, String accelSignal, AccelGroup accelGroup, int accelKey, ModifierType accelMods, AccelFlags accelFlags) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelSignal == null) {
            throw new IllegalArgumentException("accelSignal can't be null");
        }

        if (accelGroup == null) {
            throw new IllegalArgumentException("accelGroup can't be null");
        }

        if (accelMods == null) {
            throw new IllegalArgumentException("accelMods can't be null");
        }

        if (accelFlags == null) {
            throw new IllegalArgumentException("accelFlags can't be null");
        }

        synchronized (lock) {
            gtk_widget_add_accelerator(pointerOf(self), accelSignal, pointerOf(accelGroup), accelKey, numOf(accelMods), numOf(accelFlags));
        }
    }

    private static native final void gtk_widget_add_accelerator(long self, String accelSignal, long accelGroup, int accelKey, int accelMods, int accelFlags);

    static final boolean removeAccelerator(Widget self, AccelGroup accelGroup, int accelKey, ModifierType accelMods) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelGroup == null) {
            throw new IllegalArgumentException("accelGroup can't be null");
        }

        if (accelMods == null) {
            throw new IllegalArgumentException("accelMods can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_remove_accelerator(pointerOf(self), pointerOf(accelGroup), accelKey, numOf(accelMods));

            return result;
        }
    }

    private static native final boolean gtk_widget_remove_accelerator(long self, long accelGroup, int accelKey, int accelMods);

    static final void setAccelPath(Widget self, String accelPath, AccelGroup accelGroup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_accel_path(pointerOf(self), accelPath, pointerOf(accelGroup));
        }
    }

    private static native final void gtk_widget_set_accel_path(long self, String accelPath, long accelGroup);

    static final FIXME listAccelClosures(Widget self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList*");
    }

    static final boolean canActivateAccel(Widget self, int signalId) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_can_activate_accel(pointerOf(self), signalId);

            return result;
        }
    }

    private static native final boolean gtk_widget_can_activate_accel(long self, int signalId);

    static final boolean mnemonicActivate(Widget self, boolean groupCycling) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_mnemonic_activate(pointerOf(self), groupCycling);

            return result;
        }
    }

    private static native final boolean gtk_widget_mnemonic_activate(long self, boolean groupCycling);

    static final boolean event(Widget self, Event event) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_event(pointerOf(self), pointerOf(event));

            return result;
        }
    }

    private static native final boolean gtk_widget_event(long self, long event);

    static final int sendExpose(Widget self, Event event) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_send_expose(pointerOf(self), pointerOf(event));

            return result;
        }
    }

    private static native final int gtk_widget_send_expose(long self, long event);

    static final boolean activate(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_activate(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_activate(long self);

    static final boolean setScrollAdjustments(Widget self, Adjustment hadjustment, Adjustment vadjustment) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_set_scroll_adjustments(pointerOf(self), pointerOf(hadjustment), pointerOf(vadjustment));

            return result;
        }
    }

    private static native final boolean gtk_widget_set_scroll_adjustments(long self, long hadjustment, long vadjustment);

    static final void reparent(Widget self, Widget newParent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (newParent == null) {
            throw new IllegalArgumentException("newParent can't be null");
        }

        synchronized (lock) {
            gtk_widget_reparent(pointerOf(self), pointerOf(newParent));
        }
    }

    private static native final void gtk_widget_reparent(long self, long newParent);

    static final boolean intersect(Widget self, Rectangle area, Rectangle intersection) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (area == null) {
            throw new IllegalArgumentException("area can't be null");
        }

        if (intersection == null) {
            throw new IllegalArgumentException("intersection can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_intersect(pointerOf(self), pointerOf(area), pointerOf(intersection));

            return result;
        }
    }

    private static native final boolean gtk_widget_intersect(long self, long area, long intersection);

    static final Region regionIntersect(Widget self, Region region) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (region == null) {
            throw new IllegalArgumentException("region can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_region_intersect(pointerOf(self), pointerOf(region));

            return (Region) boxedFor(Region.class, result);
        }
    }

    private static native final long gtk_widget_region_intersect(long self, long region);

    static final void freezeChildNotify(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_freeze_child_notify(pointerOf(self));
        }
    }

    private static native final void gtk_widget_freeze_child_notify(long self);

    static final void childNotify(Widget self, String childProperty) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childProperty == null) {
            throw new IllegalArgumentException("childProperty can't be null");
        }

        synchronized (lock) {
            gtk_widget_child_notify(pointerOf(self), childProperty);
        }
    }

    private static native final void gtk_widget_child_notify(long self, String childProperty);

    static final void thawChildNotify(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_thaw_child_notify(pointerOf(self));
        }
    }

    private static native final void gtk_widget_thaw_child_notify(long self);

    static final boolean isFocus(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_is_focus(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_is_focus(long self);

    static final void grabFocus(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_grab_focus(pointerOf(self));
        }
    }

    private static native final void gtk_widget_grab_focus(long self);

    static final void grabDefault(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_grab_default(pointerOf(self));
        }
    }

    private static native final void gtk_widget_grab_default(long self);

    static final void setName(Widget self, String name) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_name(pointerOf(self), name);
        }
    }

    private static native final void gtk_widget_set_name(long self, String name);

    static final String getName(Widget self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_widget_get_name(long self);

    static final void setState(Widget self, StateType state) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_state(pointerOf(self), numOf(state));
        }
    }

    private static native final void gtk_widget_set_state(long self, int state);

    static final void setSensitive(Widget self, boolean sensitive) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_sensitive(pointerOf(self), sensitive);
        }
    }

    private static native final void gtk_widget_set_sensitive(long self, boolean sensitive);

    static final void setAppPaintable(Widget self, boolean appPaintable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_app_paintable(pointerOf(self), appPaintable);
        }
    }

    private static native final void gtk_widget_set_app_paintable(long self, boolean appPaintable);

    static final void setDoubleBuffered(Widget self, boolean doubleBuffered) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_double_buffered(pointerOf(self), doubleBuffered);
        }
    }

    private static native final void gtk_widget_set_double_buffered(long self, boolean doubleBuffered);

    static final void setRedrawOnAllocate(Widget self, boolean redrawOnAllocate) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_redraw_on_allocate(pointerOf(self), redrawOnAllocate);
        }
    }

    private static native final void gtk_widget_set_redraw_on_allocate(long self, boolean redrawOnAllocate);

    static final void setParent(Widget self, Widget parent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_parent(pointerOf(self), pointerOf(parent));
        }
    }

    private static native final void gtk_widget_set_parent(long self, long parent);

    static final void setParentWindow(Widget self, Window parentWindow) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (parentWindow == null) {
            throw new IllegalArgumentException("parentWindow can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_parent_window(pointerOf(self), pointerOf(parentWindow));
        }
    }

    private static native final void gtk_widget_set_parent_window(long self, long parentWindow);

    static final void setChildVisible(Widget self, boolean isVisible) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_child_visible(pointerOf(self), isVisible);
        }
    }

    private static native final void gtk_widget_set_child_visible(long self, boolean isVisible);

    static final boolean getChildVisible(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_child_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_get_child_visible(long self);

    static final Widget getParent(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_parent(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_parent(long self);

    static final Window getParentWindow(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_parent_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_parent_window(long self);

    static final boolean childFocus(Widget self, DirectionType direction) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (direction == null) {
            throw new IllegalArgumentException("direction can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_child_focus(pointerOf(self), numOf(direction));

            return result;
        }
    }

    private static native final boolean gtk_widget_child_focus(long self, int direction);

    static final void setSizeRequest(Widget self, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_size_request(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_widget_set_size_request(long self, int width, int height);

    static final void getSizeRequest(Widget self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gtk_widget_get_size_request(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_widget_get_size_request(long self, int[] width, int[] height);

    static final void setEvents(Widget self, int events) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_events(pointerOf(self), events);
        }
    }

    private static native final void gtk_widget_set_events(long self, int events);

    static final void addEvents(Widget self, int events) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_add_events(pointerOf(self), events);
        }
    }

    private static native final void gtk_widget_add_events(long self, int events);

    static final void setExtensionEvents(Widget self, ExtensionMode mode) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mode == null) {
            throw new IllegalArgumentException("mode can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_extension_events(pointerOf(self), numOf(mode));
        }
    }

    private static native final void gtk_widget_set_extension_events(long self, int mode);

    static final ExtensionMode getExtensionEvents(Widget self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_extension_events(pointerOf(self));

            return (ExtensionMode) enumFor(ExtensionMode.class, result);
        }
    }

    private static native final int gtk_widget_get_extension_events(long self);

    static final Widget getToplevel(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_toplevel(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_toplevel(long self);

    static final Widget getAncestor(Widget self, FIXME widgetType) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GType");
    }

    static final Colormap getColormap(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_colormap(pointerOf(self));

            return (Colormap) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_colormap(long self);

    static final Visual getVisual(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_visual(pointerOf(self));

            return (Visual) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_visual(long self);

    static final Screen getScreen(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_screen(pointerOf(self));

            return (Screen) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_screen(long self);

    static final boolean hasScreen(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_has_screen(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_has_screen(long self);

    static final Display getDisplay(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_display(pointerOf(self));

            return (Display) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_display(long self);

    static final Window getRootWindow(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_root_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_root_window(long self);

    static final Settings getSettings(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_settings(pointerOf(self));

            return (Settings) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_settings(long self);

    static final Clipboard getClipboard(Widget self, FIXME selection) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final Object getAccessible(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_accessible(pointerOf(self));

            return (Object) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_accessible(long self);

    static final void setColormap(Widget self, Colormap colormap) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colormap == null) {
            throw new IllegalArgumentException("colormap can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_colormap(pointerOf(self), pointerOf(colormap));
        }
    }

    private static native final void gtk_widget_set_colormap(long self, long colormap);

    static final int getEvents(Widget self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_events(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_widget_get_events(long self);

    static final void getPointer(Widget self, int[] x, int[] y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        synchronized (lock) {
            gtk_widget_get_pointer(pointerOf(self), x, y);
        }
    }

    private static native final void gtk_widget_get_pointer(long self, int[] x, int[] y);

    static final boolean isAncestor(Widget self, Widget ancestor) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (ancestor == null) {
            throw new IllegalArgumentException("ancestor can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_is_ancestor(pointerOf(self), pointerOf(ancestor));

            return result;
        }
    }

    private static native final boolean gtk_widget_is_ancestor(long self, long ancestor);

    static final boolean translateCoordinates(Widget self, Widget destWidget, int srcX, int srcY, int[] destX, int[] destY) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (destWidget == null) {
            throw new IllegalArgumentException("destWidget can't be null");
        }

        if (destX == null) {
            throw new IllegalArgumentException("destX can't be null");
        }

        if (destY == null) {
            throw new IllegalArgumentException("destY can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_translate_coordinates(pointerOf(self), pointerOf(destWidget), srcX, srcY, destX, destY);

            return result;
        }
    }

    private static native final boolean gtk_widget_translate_coordinates(long self, long destWidget, int srcX, int srcY, int[] destX, int[] destY);

    static final boolean hideOnDelete(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_hide_on_delete(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_hide_on_delete(long self);

    static final void setStyle(Widget self, Style style) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_style(pointerOf(self), pointerOf(style));
        }
    }

    private static native final void gtk_widget_set_style(long self, long style);

    static final void ensureStyle(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_ensure_style(pointerOf(self));
        }
    }

    private static native final void gtk_widget_ensure_style(long self);

    static final Style getStyle(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_style(pointerOf(self));

            return (Style) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_style(long self);

    static final void modifyStyle(Widget self, RcStyle style) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (style == null) {
            throw new IllegalArgumentException("style can't be null");
        }

        synchronized (lock) {
            gtk_widget_modify_style(pointerOf(self), pointerOf(style));
        }
    }

    private static native final void gtk_widget_modify_style(long self, long style);

    static final RcStyle getModifierStyle(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_modifier_style(pointerOf(self));

            return (RcStyle) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_modifier_style(long self);

    static final void modifyFg(Widget self, StateType state, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        synchronized (lock) {
            gtk_widget_modify_fg(pointerOf(self), numOf(state), pointerOf(color));
        }
    }

    private static native final void gtk_widget_modify_fg(long self, int state, long color);

    static final void modifyBg(Widget self, StateType state, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        synchronized (lock) {
            gtk_widget_modify_bg(pointerOf(self), numOf(state), pointerOf(color));
        }
    }

    private static native final void gtk_widget_modify_bg(long self, int state, long color);

    static final void modifyText(Widget self, StateType state, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        synchronized (lock) {
            gtk_widget_modify_text(pointerOf(self), numOf(state), pointerOf(color));
        }
    }

    private static native final void gtk_widget_modify_text(long self, int state, long color);

    static final void modifyBase(Widget self, StateType state, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        synchronized (lock) {
            gtk_widget_modify_base(pointerOf(self), numOf(state), pointerOf(color));
        }
    }

    private static native final void gtk_widget_modify_base(long self, int state, long color);

    static final void modifyFont(Widget self, FontDescription fontDesc) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_modify_font(pointerOf(self), pointerOf(fontDesc));
        }
    }

    private static native final void gtk_widget_modify_font(long self, long fontDesc);

    static final Context createPangoContext(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_create_pango_context(pointerOf(self));

            return (Context) objectFor(result);
        }
    }

    private static native final long gtk_widget_create_pango_context(long self);

    static final Context getPangoContext(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_pango_context(pointerOf(self));

            return (Context) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_pango_context(long self);

    static final Layout createPangoLayout(Widget self, String text) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_create_pango_layout(pointerOf(self), text);

            return (Layout) objectFor(result);
        }
    }

    private static native final long gtk_widget_create_pango_layout(long self, String text);

    static final Pixbuf renderIcon(Widget self, String stockId, IconSize size, String detail) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_render_icon(pointerOf(self), stockId, numOf(size), detail);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_widget_render_icon(long self, String stockId, int size, String detail);

    static final void setCompositeName(Widget self, String name) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_composite_name(pointerOf(self), name);
        }
    }

    private static native final void gtk_widget_set_composite_name(long self, String name);

    static final String getCompositeName(Widget self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_composite_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_widget_get_composite_name(long self);

    static final void resetRcStyles(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_reset_rc_styles(pointerOf(self));
        }
    }

    private static native final void gtk_widget_reset_rc_styles(long self);

    static final void styleGetProperty(Widget self, String propertyName, Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (propertyName == null) {
            throw new IllegalArgumentException("propertyName can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            gtk_widget_style_get_property(pointerOf(self), propertyName, pointerOf(value));
        }
    }

    private static native final void gtk_widget_style_get_property(long self, String propertyName, long value);

    static final void styleGetValist(Widget self, String firstPropertyName, FIXME varArgs) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("va_list");
    }

    static final void styleGet(Widget self, String firstPropertyName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (firstPropertyName == null) {
            throw new IllegalArgumentException("firstPropertyName can't be null");
        }

        synchronized (lock) {
            gtk_widget_style_get(pointerOf(self), firstPropertyName);
        }
    }

    private static native final void gtk_widget_style_get(long self, String firstPropertyName);

    static final void setDirection(Widget self, TextDirection dir) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dir == null) {
            throw new IllegalArgumentException("dir can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_direction(pointerOf(self), numOf(dir));
        }
    }

    private static native final void gtk_widget_set_direction(long self, int dir);

    static final TextDirection getDirection(Widget self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_direction(pointerOf(self));

            return (TextDirection) enumFor(TextDirection.class, result);
        }
    }

    private static native final int gtk_widget_get_direction(long self);

    static final void shapeCombineMask(Widget self, Bitmap shapeMask, int offsetX, int offsetY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (shapeMask == null) {
            throw new IllegalArgumentException("shapeMask can't be null");
        }

        synchronized (lock) {
            gtk_widget_shape_combine_mask(pointerOf(self), pointerOf(shapeMask), offsetX, offsetY);
        }
    }

    private static native final void gtk_widget_shape_combine_mask(long self, long shapeMask, int offsetX, int offsetY);

    static final void resetShapes(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_reset_shapes(pointerOf(self));
        }
    }

    private static native final void gtk_widget_reset_shapes(long self);

    static final void path(Widget self, int[] pathLength, String[] path, String[] pathReversed) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pathLength == null) {
            throw new IllegalArgumentException("pathLength can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        if (pathReversed == null) {
            throw new IllegalArgumentException("pathReversed can't be null");
        }

        synchronized (lock) {
            gtk_widget_path(pointerOf(self), pathLength, path, pathReversed);
        }
    }

    private static native final void gtk_widget_path(long self, int[] pathLength, String[] path, String[] pathReversed);

    static final void classPath(Widget self, int[] pathLength, String[] path, String[] pathReversed) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pathLength == null) {
            throw new IllegalArgumentException("pathLength can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        if (pathReversed == null) {
            throw new IllegalArgumentException("pathReversed can't be null");
        }

        synchronized (lock) {
            gtk_widget_class_path(pointerOf(self), pathLength, path, pathReversed);
        }
    }

    private static native final void gtk_widget_class_path(long self, int[] pathLength, String[] path, String[] pathReversed);

    static final FIXME listMnemonicLabels(Widget self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList*");
    }

    static final void addMnemonicLabel(Widget self, Widget label) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            gtk_widget_add_mnemonic_label(pointerOf(self), pointerOf(label));
        }
    }

    private static native final void gtk_widget_add_mnemonic_label(long self, long label);

    static final void removeMnemonicLabel(Widget self, Widget label) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            gtk_widget_remove_mnemonic_label(pointerOf(self), pointerOf(label));
        }
    }

    private static native final void gtk_widget_remove_mnemonic_label(long self, long label);

    interface DispatchChildPropertiesChangedSignal extends Signal
    {
        void onDispatchChildPropertiesChanged(Widget source, int nPspecs, FIXME pspecs);
    }

    static final void connect(Widget self, GtkWidget.DispatchChildPropertiesChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "dispatch-child-properties-changed", after);
    }

    protected static final void receiveDispatchChildPropertiesChanged(Signal handler, long source, int nPspecs, java.lang.Object pspecs) {
        ((GtkWidget.DispatchChildPropertiesChangedSignal) handler).onDispatchChildPropertiesChanged((Widget) objectFor(source), nPspecs, (FIXME) pspecs);
    }

    interface ShowSignal extends Signal
    {
        void onShow(Widget source);
    }

    static final void connect(Widget self, GtkWidget.ShowSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "show", after);
    }

    protected static final void receiveShow(Signal handler, long source) {
        ((GtkWidget.ShowSignal) handler).onShow((Widget) objectFor(source));
    }

    interface ShowAllSignal extends Signal
    {
        void onShowAll(Widget source);
    }

    static final void connect(Widget self, GtkWidget.ShowAllSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "show-all", after);
    }

    protected static final void receiveShowAll(Signal handler, long source) {
        ((GtkWidget.ShowAllSignal) handler).onShowAll((Widget) objectFor(source));
    }

    interface HideSignal extends Signal
    {
        void onHide(Widget source);
    }

    static final void connect(Widget self, GtkWidget.HideSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "hide", after);
    }

    protected static final void receiveHide(Signal handler, long source) {
        ((GtkWidget.HideSignal) handler).onHide((Widget) objectFor(source));
    }

    interface HideAllSignal extends Signal
    {
        void onHideAll(Widget source);
    }

    static final void connect(Widget self, GtkWidget.HideAllSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "hide-all", after);
    }

    protected static final void receiveHideAll(Signal handler, long source) {
        ((GtkWidget.HideAllSignal) handler).onHideAll((Widget) objectFor(source));
    }

    interface MapSignal extends Signal
    {
        void onMap(Widget source);
    }

    static final void connect(Widget self, GtkWidget.MapSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "map", after);
    }

    protected static final void receiveMap(Signal handler, long source) {
        ((GtkWidget.MapSignal) handler).onMap((Widget) objectFor(source));
    }

    interface UnmapSignal extends Signal
    {
        void onUnmap(Widget source);
    }

    static final void connect(Widget self, GtkWidget.UnmapSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "unmap", after);
    }

    protected static final void receiveUnmap(Signal handler, long source) {
        ((GtkWidget.UnmapSignal) handler).onUnmap((Widget) objectFor(source));
    }

    interface RealizeSignal extends Signal
    {
        void onRealize(Widget source);
    }

    static final void connect(Widget self, GtkWidget.RealizeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "realize", after);
    }

    protected static final void receiveRealize(Signal handler, long source) {
        ((GtkWidget.RealizeSignal) handler).onRealize((Widget) objectFor(source));
    }

    interface UnrealizeSignal extends Signal
    {
        void onUnrealize(Widget source);
    }

    static final void connect(Widget self, GtkWidget.UnrealizeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "unrealize", after);
    }

    protected static final void receiveUnrealize(Signal handler, long source) {
        ((GtkWidget.UnrealizeSignal) handler).onUnrealize((Widget) objectFor(source));
    }

    interface SizeRequestSignal extends Signal
    {
        void onSizeRequest(Widget source, Requisition requisition);
    }

    static final void connect(Widget self, GtkWidget.SizeRequestSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "size-request", after);
    }

    protected static final void receiveSizeRequest(Signal handler, long source, long requisition) {
        ((GtkWidget.SizeRequestSignal) handler).onSizeRequest((Widget) objectFor(source), (Requisition) boxedFor(Requisition.class, requisition));
    }

    interface SizeAllocateSignal extends Signal
    {
        void onSizeAllocate(Widget source, Allocation allocation);
    }

    static final void connect(Widget self, GtkWidget.SizeAllocateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "size-allocate", after);
    }

    protected static final void receiveSizeAllocate(Signal handler, long source, long allocation) {
        ((GtkWidget.SizeAllocateSignal) handler).onSizeAllocate((Widget) objectFor(source), (Allocation) boxedFor(Allocation.class, allocation));
    }

    interface StateChangedSignal extends Signal
    {
        void onStateChanged(Widget source, StateType previousState);
    }

    static final void connect(Widget self, GtkWidget.StateChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "state-changed", after);
    }

    protected static final void receiveStateChanged(Signal handler, long source, int previousState) {
        ((GtkWidget.StateChangedSignal) handler).onStateChanged((Widget) objectFor(source), (StateType) enumFor(StateType.class, previousState));
    }

    interface ParentSetSignal extends Signal
    {
        void onParentSet(Widget source, Widget previousParent);
    }

    static final void connect(Widget self, GtkWidget.ParentSetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "parent-set", after);
    }

    protected static final void receiveParentSet(Signal handler, long source, long previousParent) {
        ((GtkWidget.ParentSetSignal) handler).onParentSet((Widget) objectFor(source), (Widget) objectFor(previousParent));
    }

    interface HierarchyChangedSignal extends Signal
    {
        void onHierarchyChanged(Widget source, Widget previousToplevel);
    }

    static final void connect(Widget self, GtkWidget.HierarchyChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "hierarchy-changed", after);
    }

    protected static final void receiveHierarchyChanged(Signal handler, long source, long previousToplevel) {
        ((GtkWidget.HierarchyChangedSignal) handler).onHierarchyChanged((Widget) objectFor(source), (Widget) objectFor(previousToplevel));
    }

    interface StyleSetSignal extends Signal
    {
        void onStyleSet(Widget source, Style previousStyle);
    }

    static final void connect(Widget self, GtkWidget.StyleSetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "style-set", after);
    }

    protected static final void receiveStyleSet(Signal handler, long source, long previousStyle) {
        ((GtkWidget.StyleSetSignal) handler).onStyleSet((Widget) objectFor(source), (Style) objectFor(previousStyle));
    }

    interface DirectionChangedSignal extends Signal
    {
        void onDirectionChanged(Widget source, TextDirection previousDirection);
    }

    static final void connect(Widget self, GtkWidget.DirectionChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "direction-changed", after);
    }

    protected static final void receiveDirectionChanged(Signal handler, long source, int previousDirection) {
        ((GtkWidget.DirectionChangedSignal) handler).onDirectionChanged((Widget) objectFor(source), (TextDirection) enumFor(TextDirection.class, previousDirection));
    }

    interface GrabNotifySignal extends Signal
    {
        void onGrabNotify(Widget source, boolean wasGrabbed);
    }

    static final void connect(Widget self, GtkWidget.GrabNotifySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "grab-notify", after);
    }

    protected static final void receiveGrabNotify(Signal handler, long source, boolean wasGrabbed) {
        ((GtkWidget.GrabNotifySignal) handler).onGrabNotify((Widget) objectFor(source), wasGrabbed);
    }

    interface ChildNotifySignal extends Signal
    {
        void onChildNotify(Widget source, FIXME pspec);
    }

    static final void connect(Widget self, GtkWidget.ChildNotifySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "child-notify", after);
    }

    protected static final void receiveChildNotify(Signal handler, long source, java.lang.Object pspec) {
        ((GtkWidget.ChildNotifySignal) handler).onChildNotify((Widget) objectFor(source), (FIXME) pspec);
    }

    interface MnemonicActivateSignal extends Signal
    {
        boolean onMnemonicActivate(Widget source, boolean groupCycling);
    }

    static final void connect(Widget self, GtkWidget.MnemonicActivateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "mnemonic-activate", after);
    }

    protected static final boolean receiveMnemonicActivate(Signal handler, long source, boolean groupCycling) {
        boolean result;

        result = ((GtkWidget.MnemonicActivateSignal) handler).onMnemonicActivate((Widget) objectFor(source), groupCycling);

        return result;
    }

    interface GrabFocusSignal extends Signal
    {
        void onGrabFocus(Widget source);
    }

    static final void connect(Widget self, GtkWidget.GrabFocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "grab-focus", after);
    }

    protected static final void receiveGrabFocus(Signal handler, long source) {
        ((GtkWidget.GrabFocusSignal) handler).onGrabFocus((Widget) objectFor(source));
    }

    interface FocusSignal extends Signal
    {
        boolean onFocus(Widget source, DirectionType direction);
    }

    static final void connect(Widget self, GtkWidget.FocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "focus", after);
    }

    protected static final boolean receiveFocus(Signal handler, long source, int direction) {
        boolean result;

        result = ((GtkWidget.FocusSignal) handler).onFocus((Widget) objectFor(source), (DirectionType) enumFor(DirectionType.class, direction));

        return result;
    }

    interface EventSignal extends Signal
    {
        boolean onEvent(Widget source, Event event);
    }

    static final void connect(Widget self, GtkWidget.EventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "event", after);
    }

    protected static final boolean receiveEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.EventSignal) handler).onEvent((Widget) objectFor(source), (Event) boxedFor(Event.class, event));

        return result;
    }

    interface ButtonPressEventSignal extends Signal
    {
        boolean onButtonPressEvent(Widget source, EventButton event);
    }

    static final void connect(Widget self, GtkWidget.ButtonPressEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "button-press-event", after);
    }

    protected static final boolean receiveButtonPressEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.ButtonPressEventSignal) handler).onButtonPressEvent((Widget) objectFor(source), (EventButton) boxedFor(EventButton.class, event));

        return result;
    }

    interface ButtonReleaseEventSignal extends Signal
    {
        boolean onButtonReleaseEvent(Widget source, EventButton event);
    }

    static final void connect(Widget self, GtkWidget.ButtonReleaseEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "button-release-event", after);
    }

    protected static final boolean receiveButtonReleaseEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.ButtonReleaseEventSignal) handler).onButtonReleaseEvent((Widget) objectFor(source), (EventButton) boxedFor(EventButton.class, event));

        return result;
    }

    interface ScrollEventSignal extends Signal
    {
        boolean onScrollEvent(Widget source, EventScroll event);
    }

    static final void connect(Widget self, GtkWidget.ScrollEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "scroll-event", after);
    }

    protected static final boolean receiveScrollEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.ScrollEventSignal) handler).onScrollEvent((Widget) objectFor(source), (EventScroll) boxedFor(EventScroll.class, event));

        return result;
    }

    interface MotionNotifyEventSignal extends Signal
    {
        boolean onMotionNotifyEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.MotionNotifyEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "motion-notify-event", after);
    }

    protected static final boolean receiveMotionNotifyEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.MotionNotifyEventSignal) handler).onMotionNotifyEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface DeleteEventSignal extends Signal
    {
        boolean onDeleteEvent(Widget source, Event event);
    }

    static final void connect(Widget self, GtkWidget.DeleteEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "delete-event", after);
    }

    protected static final boolean receiveDeleteEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.DeleteEventSignal) handler).onDeleteEvent((Widget) objectFor(source), (Event) boxedFor(Event.class, event));

        return result;
    }

    interface DestroyEventSignal extends Signal
    {
        boolean onDestroyEvent(Widget source, Event event);
    }

    static final void connect(Widget self, GtkWidget.DestroyEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "destroy-event", after);
    }

    protected static final boolean receiveDestroyEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.DestroyEventSignal) handler).onDestroyEvent((Widget) objectFor(source), (Event) boxedFor(Event.class, event));

        return result;
    }

    interface ExposeEventSignal extends Signal
    {
        boolean onExposeEvent(Widget source, EventExpose event);
    }

    static final void connect(Widget self, GtkWidget.ExposeEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "expose-event", after);
    }

    protected static final boolean receiveExposeEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.ExposeEventSignal) handler).onExposeEvent((Widget) objectFor(source), (EventExpose) boxedFor(EventExpose.class, event));

        return result;
    }

    interface KeyPressEventSignal extends Signal
    {
        boolean onKeyPressEvent(Widget source, EventKey event);
    }

    static final void connect(Widget self, GtkWidget.KeyPressEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "key-press-event", after);
    }

    protected static final boolean receiveKeyPressEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.KeyPressEventSignal) handler).onKeyPressEvent((Widget) objectFor(source), (EventKey) boxedFor(EventKey.class, event));

        return result;
    }

    interface KeyReleaseEventSignal extends Signal
    {
        boolean onKeyReleaseEvent(Widget source, EventKey event);
    }

    static final void connect(Widget self, GtkWidget.KeyReleaseEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "key-release-event", after);
    }

    protected static final boolean receiveKeyReleaseEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.KeyReleaseEventSignal) handler).onKeyReleaseEvent((Widget) objectFor(source), (EventKey) boxedFor(EventKey.class, event));

        return result;
    }

    interface EnterNotifyEventSignal extends Signal
    {
        boolean onEnterNotifyEvent(Widget source, EventCrossing event);
    }

    static final void connect(Widget self, GtkWidget.EnterNotifyEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "enter-notify-event", after);
    }

    protected static final boolean receiveEnterNotifyEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.EnterNotifyEventSignal) handler).onEnterNotifyEvent((Widget) objectFor(source), (EventCrossing) boxedFor(EventCrossing.class, event));

        return result;
    }

    interface LeaveNotifyEventSignal extends Signal
    {
        boolean onLeaveNotifyEvent(Widget source, EventCrossing event);
    }

    static final void connect(Widget self, GtkWidget.LeaveNotifyEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "leave-notify-event", after);
    }

    protected static final boolean receiveLeaveNotifyEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.LeaveNotifyEventSignal) handler).onLeaveNotifyEvent((Widget) objectFor(source), (EventCrossing) boxedFor(EventCrossing.class, event));

        return result;
    }

    interface ConfigureEventSignal extends Signal
    {
        boolean onConfigureEvent(Widget source, EventConfigure event);
    }

    static final void connect(Widget self, GtkWidget.ConfigureEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "configure-event", after);
    }

    protected static final boolean receiveConfigureEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.ConfigureEventSignal) handler).onConfigureEvent((Widget) objectFor(source), (EventConfigure) boxedFor(EventConfigure.class, event));

        return result;
    }

    interface FocusInEventSignal extends Signal
    {
        boolean onFocusInEvent(Widget source, EventFocus event);
    }

    static final void connect(Widget self, GtkWidget.FocusInEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "focus-in-event", after);
    }

    protected static final boolean receiveFocusInEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.FocusInEventSignal) handler).onFocusInEvent((Widget) objectFor(source), (EventFocus) boxedFor(EventFocus.class, event));

        return result;
    }

    interface FocusOutEventSignal extends Signal
    {
        boolean onFocusOutEvent(Widget source, EventFocus event);
    }

    static final void connect(Widget self, GtkWidget.FocusOutEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "focus-out-event", after);
    }

    protected static final boolean receiveFocusOutEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.FocusOutEventSignal) handler).onFocusOutEvent((Widget) objectFor(source), (EventFocus) boxedFor(EventFocus.class, event));

        return result;
    }

    interface MapEventSignal extends Signal
    {
        boolean onMapEvent(Widget source, Event event);
    }

    static final void connect(Widget self, GtkWidget.MapEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "map-event", after);
    }

    protected static final boolean receiveMapEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.MapEventSignal) handler).onMapEvent((Widget) objectFor(source), (Event) boxedFor(Event.class, event));

        return result;
    }

    interface UnmapEventSignal extends Signal
    {
        boolean onUnmapEvent(Widget source, Event event);
    }

    static final void connect(Widget self, GtkWidget.UnmapEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "unmap-event", after);
    }

    protected static final boolean receiveUnmapEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.UnmapEventSignal) handler).onUnmapEvent((Widget) objectFor(source), (Event) boxedFor(Event.class, event));

        return result;
    }

    interface PropertyNotifyEventSignal extends Signal
    {
        boolean onPropertyNotifyEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.PropertyNotifyEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "property-notify-event", after);
    }

    protected static final boolean receivePropertyNotifyEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.PropertyNotifyEventSignal) handler).onPropertyNotifyEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface SelectionClearEventSignal extends Signal
    {
        boolean onSelectionClearEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.SelectionClearEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "selection-clear-event", after);
    }

    protected static final boolean receiveSelectionClearEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.SelectionClearEventSignal) handler).onSelectionClearEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface SelectionRequestEventSignal extends Signal
    {
        boolean onSelectionRequestEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.SelectionRequestEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "selection-request-event", after);
    }

    protected static final boolean receiveSelectionRequestEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.SelectionRequestEventSignal) handler).onSelectionRequestEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface SelectionNotifyEventSignal extends Signal
    {
        boolean onSelectionNotifyEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.SelectionNotifyEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "selection-notify-event", after);
    }

    protected static final boolean receiveSelectionNotifyEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.SelectionNotifyEventSignal) handler).onSelectionNotifyEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface ProximityInEventSignal extends Signal
    {
        boolean onProximityInEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.ProximityInEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "proximity-in-event", after);
    }

    protected static final boolean receiveProximityInEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.ProximityInEventSignal) handler).onProximityInEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface ProximityOutEventSignal extends Signal
    {
        boolean onProximityOutEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.ProximityOutEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "proximity-out-event", after);
    }

    protected static final boolean receiveProximityOutEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.ProximityOutEventSignal) handler).onProximityOutEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface VisibilityNotifyEventSignal extends Signal
    {
        boolean onVisibilityNotifyEvent(Widget source, EventVisibility event);
    }

    static final void connect(Widget self, GtkWidget.VisibilityNotifyEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "visibility-notify-event", after);
    }

    protected static final boolean receiveVisibilityNotifyEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.VisibilityNotifyEventSignal) handler).onVisibilityNotifyEvent((Widget) objectFor(source), (EventVisibility) boxedFor(EventVisibility.class, event));

        return result;
    }

    interface ClientEventSignal extends Signal
    {
        boolean onClientEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.ClientEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "client-event", after);
    }

    protected static final boolean receiveClientEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.ClientEventSignal) handler).onClientEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface NoExposeEventSignal extends Signal
    {
        boolean onNoExposeEvent(Widget source, Event event);
    }

    static final void connect(Widget self, GtkWidget.NoExposeEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "no-expose-event", after);
    }

    protected static final boolean receiveNoExposeEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWidget.NoExposeEventSignal) handler).onNoExposeEvent((Widget) objectFor(source), (Event) boxedFor(Event.class, event));

        return result;
    }

    interface WindowStateEventSignal extends Signal
    {
        boolean onWindowStateEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.WindowStateEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "window-state-event", after);
    }

    protected static final boolean receiveWindowStateEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.WindowStateEventSignal) handler).onWindowStateEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    interface SelectionGetSignal extends Signal
    {
        void onSelectionGet(Widget source, SelectionData selectionData, int info, int time);
    }

    static final void connect(Widget self, GtkWidget.SelectionGetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "selection-get", after);
    }

    protected static final void receiveSelectionGet(Signal handler, long source, long selectionData, int info, int time) {
        ((GtkWidget.SelectionGetSignal) handler).onSelectionGet((Widget) objectFor(source), (SelectionData) boxedFor(SelectionData.class, selectionData), info, time);
    }

    interface SelectionReceivedSignal extends Signal
    {
        void onSelectionReceived(Widget source, SelectionData selectionData, int time);
    }

    static final void connect(Widget self, GtkWidget.SelectionReceivedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "selection-received", after);
    }

    protected static final void receiveSelectionReceived(Signal handler, long source, long selectionData, int time) {
        ((GtkWidget.SelectionReceivedSignal) handler).onSelectionReceived((Widget) objectFor(source), (SelectionData) boxedFor(SelectionData.class, selectionData), time);
    }

    interface DragBeginSignal extends Signal
    {
        void onDragBegin(Widget source, DragContext context);
    }

    static final void connect(Widget self, GtkWidget.DragBeginSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-begin", after);
    }

    protected static final void receiveDragBegin(Signal handler, long source, long context) {
        ((GtkWidget.DragBeginSignal) handler).onDragBegin((Widget) objectFor(source), (DragContext) objectFor(context));
    }

    interface DragEndSignal extends Signal
    {
        void onDragEnd(Widget source, DragContext context);
    }

    static final void connect(Widget self, GtkWidget.DragEndSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-end", after);
    }

    protected static final void receiveDragEnd(Signal handler, long source, long context) {
        ((GtkWidget.DragEndSignal) handler).onDragEnd((Widget) objectFor(source), (DragContext) objectFor(context));
    }

    interface DragDataGetSignal extends Signal
    {
        void onDragDataGet(Widget source, DragContext context, SelectionData selectionData, int info, int time);
    }

    static final void connect(Widget self, GtkWidget.DragDataGetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-data-get", after);
    }

    protected static final void receiveDragDataGet(Signal handler, long source, long context, long selectionData, int info, int time) {
        ((GtkWidget.DragDataGetSignal) handler).onDragDataGet((Widget) objectFor(source), (DragContext) objectFor(context), (SelectionData) boxedFor(SelectionData.class, selectionData), info, time);
    }

    interface DragDataDeleteSignal extends Signal
    {
        void onDragDataDelete(Widget source, DragContext context);
    }

    static final void connect(Widget self, GtkWidget.DragDataDeleteSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-data-delete", after);
    }

    protected static final void receiveDragDataDelete(Signal handler, long source, long context) {
        ((GtkWidget.DragDataDeleteSignal) handler).onDragDataDelete((Widget) objectFor(source), (DragContext) objectFor(context));
    }

    interface DragLeaveSignal extends Signal
    {
        void onDragLeave(Widget source, DragContext context, int time);
    }

    static final void connect(Widget self, GtkWidget.DragLeaveSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-leave", after);
    }

    protected static final void receiveDragLeave(Signal handler, long source, long context, int time) {
        ((GtkWidget.DragLeaveSignal) handler).onDragLeave((Widget) objectFor(source), (DragContext) objectFor(context), time);
    }

    interface DragMotionSignal extends Signal
    {
        boolean onDragMotion(Widget source, DragContext context, int x, int y, int time);
    }

    static final void connect(Widget self, GtkWidget.DragMotionSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-motion", after);
    }

    protected static final boolean receiveDragMotion(Signal handler, long source, long context, int x, int y, int time) {
        boolean result;

        result = ((GtkWidget.DragMotionSignal) handler).onDragMotion((Widget) objectFor(source), (DragContext) objectFor(context), x, y, time);

        return result;
    }

    interface DragDropSignal extends Signal
    {
        boolean onDragDrop(Widget source, DragContext context, int x, int y, int time);
    }

    static final void connect(Widget self, GtkWidget.DragDropSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-drop", after);
    }

    protected static final boolean receiveDragDrop(Signal handler, long source, long context, int x, int y, int time) {
        boolean result;

        result = ((GtkWidget.DragDropSignal) handler).onDragDrop((Widget) objectFor(source), (DragContext) objectFor(context), x, y, time);

        return result;
    }

    interface DragDataReceivedSignal extends Signal
    {
        void onDragDataReceived(Widget source, DragContext context, int x, int y, SelectionData selectionData, int info, int time);
    }

    static final void connect(Widget self, GtkWidget.DragDataReceivedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "drag-data-received", after);
    }

    protected static final void receiveDragDataReceived(Signal handler, long source, long context, int x, int y, long selectionData, int info, int time) {
        ((GtkWidget.DragDataReceivedSignal) handler).onDragDataReceived((Widget) objectFor(source), (DragContext) objectFor(context), x, y, (SelectionData) boxedFor(SelectionData.class, selectionData), info, time);
    }

    interface PopupMenuSignal extends Signal
    {
        boolean onPopupMenu(Widget source);
    }

    static final void connect(Widget self, GtkWidget.PopupMenuSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "popup-menu", after);
    }

    protected static final boolean receivePopupMenu(Signal handler, long source) {
        boolean result;

        result = ((GtkWidget.PopupMenuSignal) handler).onPopupMenu((Widget) objectFor(source));

        return result;
    }

    interface ShowHelpSignal extends Signal
    {
        boolean onShowHelp(Widget source, WidgetHelpType helpType);
    }

    static final void connect(Widget self, GtkWidget.ShowHelpSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "show-help", after);
    }

    protected static final boolean receiveShowHelp(Signal handler, long source, int helpType) {
        boolean result;

        result = ((GtkWidget.ShowHelpSignal) handler).onShowHelp((Widget) objectFor(source), (WidgetHelpType) enumFor(WidgetHelpType.class, helpType));

        return result;
    }

    interface GetAccessibleSignal extends Signal
    {
        Object onGetAccessible(Widget source);
    }

    static final void connect(Widget self, GtkWidget.GetAccessibleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "get-accessible", after);
    }

    protected static final long receiveGetAccessible(Signal handler, long source) {
        Object result;

        result = ((GtkWidget.GetAccessibleSignal) handler).onGetAccessible((Widget) objectFor(source));

        return pointerOf(result);
    }

    interface ScreenChangedSignal extends Signal
    {
        void onScreenChanged(Widget source, Screen previousScreen);
    }

    static final void connect(Widget self, GtkWidget.ScreenChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "screen-changed", after);
    }

    protected static final void receiveScreenChanged(Signal handler, long source, long previousScreen) {
        ((GtkWidget.ScreenChangedSignal) handler).onScreenChanged((Widget) objectFor(source), (Screen) objectFor(previousScreen));
    }

    interface CanActivateAccelSignal extends Signal
    {
        boolean onCanActivateAccel(Widget source, int signalId);
    }

    static final void connect(Widget self, GtkWidget.CanActivateAccelSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "can-activate-accel", after);
    }

    protected static final boolean receiveCanActivateAccel(Signal handler, long source, int signalId) {
        boolean result;

        result = ((GtkWidget.CanActivateAccelSignal) handler).onCanActivateAccel((Widget) objectFor(source), signalId);

        return result;
    }

    interface GrabBrokenEventSignal extends Signal
    {
        boolean onGrabBrokenEvent(Widget source, FIXME event);
    }

    static final void connect(Widget self, GtkWidget.GrabBrokenEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "grab-broken-event", after);
    }

    protected static final boolean receiveGrabBrokenEvent(Signal handler, long source, java.lang.Object event) {
        boolean result;

        result = ((GtkWidget.GrabBrokenEventSignal) handler).onGrabBrokenEvent((Widget) objectFor(source), (FIXME) event);

        return result;
    }

    static final Action getAction(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_action(pointerOf(self));

            return (Action) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_action(long self);

    static final void dragDestSetTrackMotion(Widget self, boolean trackMotion) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_drag_dest_set_track_motion(pointerOf(self), trackMotion);
        }
    }

    private static native final void gtk_drag_dest_set_track_motion(long self, boolean trackMotion);

    static final boolean dragDestGetTrackMotion(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_drag_dest_get_track_motion(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_drag_dest_get_track_motion(long self);

    static final boolean isComposited(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_is_composited(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_is_composited(long self);

    static final void inputShapeCombineMask(Widget self, Bitmap shapeMask, int offsetX, int offsetY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_input_shape_combine_mask(pointerOf(self), pointerOf(shapeMask), offsetX, offsetY);
        }
    }

    private static native final void gtk_widget_input_shape_combine_mask(long self, long shapeMask, int offsetX, int offsetY);

    static final String getTooltipMarkup(Widget self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_tooltip_markup(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_widget_get_tooltip_markup(long self);

    static final void setTooltipMarkup(Widget self, String markup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_tooltip_markup(pointerOf(self), markup);
        }
    }

    private static native final void gtk_widget_set_tooltip_markup(long self, String markup);

    static final String getTooltipText(Widget self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_tooltip_text(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_widget_get_tooltip_text(long self);

    static final void setTooltipText(Widget self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_tooltip_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_widget_set_tooltip_text(long self, String text);

    static final org.gnome.gtk.Window getTooltipWindow(Widget self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_tooltip_window(pointerOf(self));

            return (org.gnome.gtk.Window) objectFor(result);
        }
    }

    private static native final long gtk_widget_get_tooltip_window(long self);

    static final void setTooltipWindow(Widget self, org.gnome.gtk.Window customWindow) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_tooltip_window(pointerOf(self), pointerOf(customWindow));
        }
    }

    private static native final void gtk_widget_set_tooltip_window(long self, long customWindow);

    static final boolean getHasTooltip(Widget self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_get_has_tooltip(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_widget_get_has_tooltip(long self);

    static final void setHasTooltip(Widget self, boolean hasTooltip) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_set_has_tooltip(pointerOf(self), hasTooltip);
        }
    }

    private static native final void gtk_widget_set_has_tooltip(long self, boolean hasTooltip);

    static final void triggerTooltipQuery(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_trigger_tooltip_query(pointerOf(self));
        }
    }

    private static native final void gtk_widget_trigger_tooltip_query(long self);

    static final void errorBell(Widget self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_error_bell(pointerOf(self));
        }
    }

    private static native final void gtk_widget_error_bell(long self);

    static final boolean keynavFailed(Widget self, DirectionType direction) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (direction == null) {
            throw new IllegalArgumentException("direction can't be null");
        }

        synchronized (lock) {
            result = gtk_widget_keynav_failed(pointerOf(self), numOf(direction));

            return result;
        }
    }

    private static native final boolean gtk_widget_keynav_failed(long self, int direction);

    static final void modifyCursor(Widget self, org.gnome.gdk.Color primary, org.gnome.gdk.Color secondary) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_widget_modify_cursor(pointerOf(self), pointerOf(primary), pointerOf(secondary));
        }
    }

    private static native final void gtk_widget_modify_cursor(long self, long primary, long secondary);

    interface QueryTooltipSignal extends Signal
    {
        boolean onQueryTooltip(Widget source, int x, int y, boolean keyboardMode, Tooltip tooltip);
    }

    static final void connect(Widget self, GtkWidget.QueryTooltipSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "query-tooltip", after);
    }

    protected static final boolean receiveQueryTooltip(Signal handler, long source, int x, int y, boolean keyboardMode, long tooltip) {
        boolean result;

        result = ((GtkWidget.QueryTooltipSignal) handler).onQueryTooltip((Widget) objectFor(source), x, y, keyboardMode, (Tooltip) objectFor(tooltip));

        return result;
    }

    interface CompositedChangedSignal extends Signal
    {
        void onCompositedChanged(Widget source);
    }

    static final void connect(Widget self, GtkWidget.CompositedChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWidget.class, "composited-changed", after);
    }

    protected static final void receiveCompositedChanged(Signal handler, long source) {
        ((GtkWidget.CompositedChangedSignal) handler).onCompositedChanged((Widget) objectFor(source));
    }
}

