/*
 * GtkWindow.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Event;
import org.gnome.gdk.EventKey;
import org.gnome.gdk.Geometry;
import org.gnome.gdk.Gravity;
import org.gnome.gdk.ModifierType;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Screen;
import org.gnome.gdk.WindowEdge;
import org.gnome.gdk.WindowHints;
import org.gnome.gdk.WindowTypeHint;
import org.gnome.glib.GlibException;
import org.gnome.glib.Signal;
import org.gnome.gtk.AccelGroup;
import org.gnome.gtk.DirectionType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;
import org.gnome.gtk.Window;
import org.gnome.gtk.WindowGroup;
import org.gnome.gtk.WindowPosition;
import org.gnome.gtk.WindowType;

final class GtkWindow extends Plumbing
{
    private GtkWindow() {}

    static final boolean tooltipsGetInfoFromTipWindow(Window self, FIXME tooltips, Widget[] currentWidget) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTooltips**");
    }

    static final long createWindow(WindowType type) {
        long result;

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            result = gtk_window_new(numOf(type));

            return result;
        }
    }

    private static native final long gtk_window_new(int type);

    static final void setTitle(Window self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_window_set_title(pointerOf(self), title);
        }
    }

    private static native final void gtk_window_set_title(long self, String title);

    static final String getTitle(Window self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_window_get_title(long self);

    static final void setWmclass(Window self, String wmclassName, String wmclassClass) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (wmclassName == null) {
            throw new IllegalArgumentException("wmclassName can't be null");
        }

        if (wmclassClass == null) {
            throw new IllegalArgumentException("wmclassClass can't be null");
        }

        synchronized (lock) {
            gtk_window_set_wmclass(pointerOf(self), wmclassName, wmclassClass);
        }
    }

    private static native final void gtk_window_set_wmclass(long self, String wmclassName, String wmclassClass);

    static final void setRole(Window self, String role) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (role == null) {
            throw new IllegalArgumentException("role can't be null");
        }

        synchronized (lock) {
            gtk_window_set_role(pointerOf(self), role);
        }
    }

    private static native final void gtk_window_set_role(long self, String role);

    static final String getRole(Window self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_role(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_window_get_role(long self);

    static final void addAccelGroup(Window self, AccelGroup accelGroup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelGroup == null) {
            throw new IllegalArgumentException("accelGroup can't be null");
        }

        synchronized (lock) {
            gtk_window_add_accel_group(pointerOf(self), pointerOf(accelGroup));
        }
    }

    private static native final void gtk_window_add_accel_group(long self, long accelGroup);

    static final void removeAccelGroup(Window self, AccelGroup accelGroup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelGroup == null) {
            throw new IllegalArgumentException("accelGroup can't be null");
        }

        synchronized (lock) {
            gtk_window_remove_accel_group(pointerOf(self), pointerOf(accelGroup));
        }
    }

    private static native final void gtk_window_remove_accel_group(long self, long accelGroup);

    static final void setPosition(Window self, WindowPosition position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (position == null) {
            throw new IllegalArgumentException("position can't be null");
        }

        synchronized (lock) {
            gtk_window_set_position(pointerOf(self), numOf(position));
        }
    }

    private static native final void gtk_window_set_position(long self, int position);

    static final boolean activateFocus(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_activate_focus(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_activate_focus(long self);

    static final void setFocus(Window self, Widget focus) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_focus(pointerOf(self), pointerOf(focus));
        }
    }

    private static native final void gtk_window_set_focus(long self, long focus);

    static final Widget getFocus(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_focus(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_window_get_focus(long self);

    static final void setDefault(Window self, Widget defaultWidget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_default(pointerOf(self), pointerOf(defaultWidget));
        }
    }

    private static native final void gtk_window_set_default(long self, long defaultWidget);

    static final boolean activateDefault(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_activate_default(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_activate_default(long self);

    static final void setTransientFor(Window self, Window parent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_transient_for(pointerOf(self), pointerOf(parent));
        }
    }

    private static native final void gtk_window_set_transient_for(long self, long parent);

    static final Window getTransientFor(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_transient_for(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gtk_window_get_transient_for(long self);

    static final void setTypeHint(Window self, WindowTypeHint hint) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hint == null) {
            throw new IllegalArgumentException("hint can't be null");
        }

        synchronized (lock) {
            gtk_window_set_type_hint(pointerOf(self), numOf(hint));
        }
    }

    private static native final void gtk_window_set_type_hint(long self, int hint);

    static final WindowTypeHint getTypeHint(Window self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_type_hint(pointerOf(self));

            return (WindowTypeHint) enumFor(WindowTypeHint.class, result);
        }
    }

    private static native final int gtk_window_get_type_hint(long self);

    static final void setSkipTaskbarHint(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_skip_taskbar_hint(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_skip_taskbar_hint(long self, boolean setting);

    static final boolean getSkipTaskbarHint(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_skip_taskbar_hint(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_skip_taskbar_hint(long self);

    static final void setSkipPagerHint(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_skip_pager_hint(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_skip_pager_hint(long self, boolean setting);

    static final boolean getSkipPagerHint(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_skip_pager_hint(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_skip_pager_hint(long self);

    static final void setUrgencyHint(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_urgency_hint(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_urgency_hint(long self, boolean setting);

    static final boolean getUrgencyHint(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_urgency_hint(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_urgency_hint(long self);

    static final void setAcceptFocus(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_accept_focus(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_accept_focus(long self, boolean setting);

    static final boolean getAcceptFocus(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_accept_focus(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_accept_focus(long self);

    static final void setDestroyWithParent(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_destroy_with_parent(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_destroy_with_parent(long self, boolean setting);

    static final boolean getDestroyWithParent(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_destroy_with_parent(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_destroy_with_parent(long self);

    static final void setResizable(Window self, boolean resizable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_resizable(pointerOf(self), resizable);
        }
    }

    private static native final void gtk_window_set_resizable(long self, boolean resizable);

    static final boolean getResizable(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_resizable(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_resizable(long self);

    static final void setGravity(Window self, Gravity gravity) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gravity == null) {
            throw new IllegalArgumentException("gravity can't be null");
        }

        synchronized (lock) {
            gtk_window_set_gravity(pointerOf(self), numOf(gravity));
        }
    }

    private static native final void gtk_window_set_gravity(long self, int gravity);

    static final Gravity getGravity(Window self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_gravity(pointerOf(self));

            return (Gravity) enumFor(Gravity.class, result);
        }
    }

    private static native final int gtk_window_get_gravity(long self);

    static final void setGeometryHints(Window self, Widget geometryWidget, Geometry geometry, WindowHints geomMask) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (geometryWidget == null) {
            throw new IllegalArgumentException("geometryWidget can't be null");
        }

        if (geometry == null) {
            throw new IllegalArgumentException("geometry can't be null");
        }

        if (geomMask == null) {
            throw new IllegalArgumentException("geomMask can't be null");
        }

        synchronized (lock) {
            gtk_window_set_geometry_hints(pointerOf(self), pointerOf(geometryWidget), pointerOf(geometry), numOf(geomMask));
        }
    }

    private static native final void gtk_window_set_geometry_hints(long self, long geometryWidget, long geometry, int geomMask);

    static final void setScreen(Window self, Screen screen) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (screen == null) {
            throw new IllegalArgumentException("screen can't be null");
        }

        synchronized (lock) {
            gtk_window_set_screen(pointerOf(self), pointerOf(screen));
        }
    }

    private static native final void gtk_window_set_screen(long self, long screen);

    static final Screen getScreen(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_screen(pointerOf(self));

            return (Screen) objectFor(result);
        }
    }

    private static native final long gtk_window_get_screen(long self);

    static final boolean isActive(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_is_active(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_is_active(long self);

    static final boolean hasToplevelFocus(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_has_toplevel_focus(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_has_toplevel_focus(long self);

    static final void setHasFrame(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_has_frame(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_has_frame(long self, boolean setting);

    static final boolean getHasFrame(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_has_frame(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_has_frame(long self);

    static final void setFrameDimensions(Window self, int left, int top, int right, int bottom) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_frame_dimensions(pointerOf(self), left, top, right, bottom);
        }
    }

    private static native final void gtk_window_set_frame_dimensions(long self, int left, int top, int right, int bottom);

    static final void getFrameDimensions(Window self, int[] left, int[] top, int[] right, int[] bottom) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (left == null) {
            throw new IllegalArgumentException("left can't be null");
        }

        if (top == null) {
            throw new IllegalArgumentException("top can't be null");
        }

        if (right == null) {
            throw new IllegalArgumentException("right can't be null");
        }

        if (bottom == null) {
            throw new IllegalArgumentException("bottom can't be null");
        }

        synchronized (lock) {
            gtk_window_get_frame_dimensions(pointerOf(self), left, top, right, bottom);
        }
    }

    private static native final void gtk_window_get_frame_dimensions(long self, int[] left, int[] top, int[] right, int[] bottom);

    static final void setDecorated(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_decorated(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_decorated(long self, boolean setting);

    static final boolean getDecorated(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_decorated(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_decorated(long self);

    static final void setIconList(Window self, Pixbuf[] list) {
        long[] _list;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (list == null) {
            throw new IllegalArgumentException("list can't be null");
        }

        _list = pointersOf(list);

        synchronized (lock) {
            gtk_window_set_icon_list(pointerOf(self), _list);
            fillObjectArray(list, _list);
        }
    }

    private static native final void gtk_window_set_icon_list(long self, long[] list);

    static final Pixbuf[] getIconList(Window self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_icon_list(pointerOf(self));

            return (Pixbuf[]) objectArrayFor(result, new Pixbuf[result.length]);
        }
    }

    private static native final long[] gtk_window_get_icon_list(long self);

    static final void setIcon(Window self, Pixbuf icon) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_icon(pointerOf(self), pointerOf(icon));
        }
    }

    private static native final void gtk_window_set_icon(long self, long icon);

    static final void setIconFromFile(Window self, String filename) throws GlibException {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            gtk_window_set_icon_from_file(pointerOf(self), filename);
        }
    }

    private static native final void gtk_window_set_icon_from_file(long self, String filename) throws GlibException;

    static final Pixbuf getIcon(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_icon(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_window_get_icon(long self);

    static final void setModal(Window self, boolean modal) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_modal(pointerOf(self), modal);
        }
    }

    private static native final void gtk_window_set_modal(long self, boolean modal);

    static final boolean getModal(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_modal(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_modal(long self);

    static final void addMnemonic(Window self, int keyval, Widget target) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (target == null) {
            throw new IllegalArgumentException("target can't be null");
        }

        synchronized (lock) {
            gtk_window_add_mnemonic(pointerOf(self), keyval, pointerOf(target));
        }
    }

    private static native final void gtk_window_add_mnemonic(long self, int keyval, long target);

    static final void removeMnemonic(Window self, int keyval, Widget target) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (target == null) {
            throw new IllegalArgumentException("target can't be null");
        }

        synchronized (lock) {
            gtk_window_remove_mnemonic(pointerOf(self), keyval, pointerOf(target));
        }
    }

    private static native final void gtk_window_remove_mnemonic(long self, int keyval, long target);

    static final boolean mnemonicActivate(Window self, int keyval, ModifierType modifier) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (modifier == null) {
            throw new IllegalArgumentException("modifier can't be null");
        }

        synchronized (lock) {
            result = gtk_window_mnemonic_activate(pointerOf(self), keyval, numOf(modifier));

            return result;
        }
    }

    private static native final boolean gtk_window_mnemonic_activate(long self, int keyval, int modifier);

    static final void setMnemonicModifier(Window self, ModifierType modifier) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (modifier == null) {
            throw new IllegalArgumentException("modifier can't be null");
        }

        synchronized (lock) {
            gtk_window_set_mnemonic_modifier(pointerOf(self), numOf(modifier));
        }
    }

    private static native final void gtk_window_set_mnemonic_modifier(long self, int modifier);

    static final ModifierType getMnemonicModifier(Window self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_mnemonic_modifier(pointerOf(self));

            return (ModifierType) flagFor(ModifierType.class, result);
        }
    }

    private static native final int gtk_window_get_mnemonic_modifier(long self);

    static final boolean activateKey(Window self, EventKey event) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            result = gtk_window_activate_key(pointerOf(self), pointerOf(event));

            return result;
        }
    }

    private static native final boolean gtk_window_activate_key(long self, long event);

    static final boolean propagateKeyEvent(Window self, EventKey event) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            result = gtk_window_propagate_key_event(pointerOf(self), pointerOf(event));

            return result;
        }
    }

    private static native final boolean gtk_window_propagate_key_event(long self, long event);

    static final void present(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_present(pointerOf(self));
        }
    }

    private static native final void gtk_window_present(long self);

    static final void presentWithTime(Window self, int timestamp) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_present_with_time(pointerOf(self), timestamp);
        }
    }

    private static native final void gtk_window_present_with_time(long self, int timestamp);

    static final void iconify(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_iconify(pointerOf(self));
        }
    }

    private static native final void gtk_window_iconify(long self);

    static final void deiconify(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_deiconify(pointerOf(self));
        }
    }

    private static native final void gtk_window_deiconify(long self);

    static final void stick(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_stick(pointerOf(self));
        }
    }

    private static native final void gtk_window_stick(long self);

    static final void unstick(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_unstick(pointerOf(self));
        }
    }

    private static native final void gtk_window_unstick(long self);

    static final void maximize(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_maximize(pointerOf(self));
        }
    }

    private static native final void gtk_window_maximize(long self);

    static final void unmaximize(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_unmaximize(pointerOf(self));
        }
    }

    private static native final void gtk_window_unmaximize(long self);

    static final void fullscreen(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_fullscreen(pointerOf(self));
        }
    }

    private static native final void gtk_window_fullscreen(long self);

    static final void unfullscreen(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_unfullscreen(pointerOf(self));
        }
    }

    private static native final void gtk_window_unfullscreen(long self);

    static final void setKeepAbove(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_keep_above(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_keep_above(long self, boolean setting);

    static final void setKeepBelow(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_keep_below(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_keep_below(long self, boolean setting);

    static final void beginResizeDrag(Window self, WindowEdge edge, int button, int rootX, int rootY, int timestamp) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (edge == null) {
            throw new IllegalArgumentException("edge can't be null");
        }

        synchronized (lock) {
            gtk_window_begin_resize_drag(pointerOf(self), numOf(edge), button, rootX, rootY, timestamp);
        }
    }

    private static native final void gtk_window_begin_resize_drag(long self, int edge, int button, int rootX, int rootY, int timestamp);

    static final void beginMoveDrag(Window self, int button, int rootX, int rootY, int timestamp) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_begin_move_drag(pointerOf(self), button, rootX, rootY, timestamp);
        }
    }

    private static native final void gtk_window_begin_move_drag(long self, int button, int rootX, int rootY, int timestamp);

    static final void setDefaultSize(Window self, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_default_size(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_window_set_default_size(long self, int width, int height);

    static final void getDefaultSize(Window self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gtk_window_get_default_size(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_window_get_default_size(long self, int[] width, int[] height);

    static final void resize(Window self, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_resize(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_window_resize(long self, int width, int height);

    static final void getSize(Window self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gtk_window_get_size(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_window_get_size(long self, int[] width, int[] height);

    static final void move(Window self, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_move(pointerOf(self), x, y);
        }
    }

    private static native final void gtk_window_move(long self, int x, int y);

    static final void getPosition(Window self, int[] rootX, int[] rootY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rootX == null) {
            throw new IllegalArgumentException("rootX can't be null");
        }

        if (rootY == null) {
            throw new IllegalArgumentException("rootY can't be null");
        }

        synchronized (lock) {
            gtk_window_get_position(pointerOf(self), rootX, rootY);
        }
    }

    private static native final void gtk_window_get_position(long self, int[] rootX, int[] rootY);

    static final boolean parseGeometry(Window self, String geometry) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (geometry == null) {
            throw new IllegalArgumentException("geometry can't be null");
        }

        synchronized (lock) {
            result = gtk_window_parse_geometry(pointerOf(self), geometry);

            return result;
        }
    }

    private static native final boolean gtk_window_parse_geometry(long self, String geometry);

    static final void reshowWithInitialSize(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_reshow_with_initial_size(pointerOf(self));
        }
    }

    private static native final void gtk_window_reshow_with_initial_size(long self);

    static final void removeEmbeddedXid(Window self, int xid) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_remove_embedded_xid(pointerOf(self), xid);
        }
    }

    private static native final void gtk_window_remove_embedded_xid(long self, int xid);

    static final void addEmbeddedXid(Window self, int xid) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_add_embedded_xid(pointerOf(self), xid);
        }
    }

    private static native final void gtk_window_add_embedded_xid(long self, int xid);

    static final void setFocusOnMap(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_focus_on_map(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_focus_on_map(long self, boolean setting);

    static final boolean getFocusOnMap(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_focus_on_map(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_focus_on_map(long self);

    static final void setIconName(Window self, String name) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_icon_name(pointerOf(self), name);
        }
    }

    private static native final void gtk_window_set_icon_name(long self, String name);

    static final String getIconName(Window self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_icon_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_window_get_icon_name(long self);

    interface SetFocusSignal extends Signal
    {
        void onSetFocus(Window source, Widget focus);
    }

    static final void connect(Window self, GtkWindow.SetFocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWindow.class, "set-focus", after);
    }

    protected static final void receiveSetFocus(Signal handler, long source, long focus) {
        ((GtkWindow.SetFocusSignal) handler).onSetFocus((Window) objectFor(source), (Widget) objectFor(focus));
    }

    interface FrameEventSignal extends Signal
    {
        boolean onFrameEvent(Window source, Event event);
    }

    static final void connect(Window self, GtkWindow.FrameEventSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWindow.class, "frame-event", after);
    }

    protected static final boolean receiveFrameEvent(Signal handler, long source, long event) {
        boolean result;

        result = ((GtkWindow.FrameEventSignal) handler).onFrameEvent((Window) objectFor(source), (Event) boxedFor(Event.class, event));

        return result;
    }

    interface ActivateFocusSignal extends Signal
    {
        void onActivateFocus(Window source);
    }

    static final void connect(Window self, GtkWindow.ActivateFocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWindow.class, "activate-focus", after);
    }

    protected static final void receiveActivateFocus(Signal handler, long source) {
        ((GtkWindow.ActivateFocusSignal) handler).onActivateFocus((Window) objectFor(source));
    }

    interface ActivateDefaultSignal extends Signal
    {
        void onActivateDefault(Window source);
    }

    static final void connect(Window self, GtkWindow.ActivateDefaultSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWindow.class, "activate-default", after);
    }

    protected static final void receiveActivateDefault(Signal handler, long source) {
        ((GtkWindow.ActivateDefaultSignal) handler).onActivateDefault((Window) objectFor(source));
    }

    interface MoveFocusSignal extends Signal
    {
        void onMoveFocus(Window source, DirectionType direction);
    }

    static final void connect(Window self, GtkWindow.MoveFocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWindow.class, "move-focus", after);
    }

    protected static final void receiveMoveFocus(Signal handler, long source, int direction) {
        ((GtkWindow.MoveFocusSignal) handler).onMoveFocus((Window) objectFor(source), (DirectionType) enumFor(DirectionType.class, direction));
    }

    interface KeysChangedSignal extends Signal
    {
        void onKeysChanged(Window source);
    }

    static final void connect(Window self, GtkWindow.KeysChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkWindow.class, "keys-changed", after);
    }

    protected static final void receiveKeysChanged(Signal handler, long source) {
        ((GtkWindow.KeysChangedSignal) handler).onKeysChanged((Window) objectFor(source));
    }

    static final void setDeletable(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_deletable(pointerOf(self), setting);
        }
    }

    private static native final void gtk_window_set_deletable(long self, boolean setting);

    static final boolean getDeletable(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_deletable(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_window_get_deletable(long self);

    static final WindowGroup getGroup(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_group(pointerOf(self));

            return (WindowGroup) objectFor(result);
        }
    }

    private static native final long gtk_window_get_group(long self);

    static final void setDefaultIcon(Pixbuf icon) {
        if (icon == null) {
            throw new IllegalArgumentException("icon can't be null");
        }

        synchronized (lock) {
            gtk_window_set_default_icon(pointerOf(icon));
        }
    }

    private static native final void gtk_window_set_default_icon(long icon);

    static final double getOpacity(Window self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_window_get_opacity(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_window_get_opacity(long self);

    static final void setOpacity(Window self, double opacity) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_window_set_opacity(pointerOf(self), opacity);
        }
    }

    private static native final void gtk_window_set_opacity(long self, double opacity);

    static final void setStartupId(Window self, String startupId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (startupId == null) {
            throw new IllegalArgumentException("startupId can't be null");
        }

        synchronized (lock) {
            gtk_window_set_startup_id(pointerOf(self), startupId);
        }
    }

    private static native final void gtk_window_set_startup_id(long self, String startupId);
}

