/*
 * NotifyNotification.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <libnotify/notification.h>
#include "bindings_java.h"
#include "org_gnome_notify_NotifyNotification.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _summary,
	jstring _body,
	jstring _icon,
	jlong _attach
)
{
	NotifyNotification* result;
	jlong _result;
	const gchar* summary;
	const gchar* body;
	const gchar* icon;
	GtkWidget* attach;

	// convert parameter summary
	summary = (const gchar*) (*env)->GetStringUTFChars(env, _summary, NULL);
	if (summary == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter body
	if (_body == NULL) {
		body = NULL;
	} else {
		body = (const gchar*) (*env)->GetStringUTFChars(env, _body, NULL);
		if (body == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter icon
	if (_icon == NULL) {
		icon = NULL;
	} else {
		icon = (const gchar*) (*env)->GetStringUTFChars(env, _icon, NULL);
		if (icon == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter attach
	attach = (GtkWidget*) _attach;

	// call function
	result = notify_notification_new(summary, body, icon, attach);

	// cleanup parameter summary
	(*env)->ReleaseStringUTFChars(env, _summary, summary);

	// cleanup parameter body
	if (body != NULL) {
		(*env)->ReleaseStringUTFChars(env, _body, body);
	}

	// cleanup parameter icon
	if (icon != NULL) {
		(*env)->ReleaseStringUTFChars(env, _icon, icon);
	}

	// cleanup parameter attach

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1new_1with_1status_1icon
(
	JNIEnv* env,
	jclass cls,
	jstring _summary,
	jstring _body,
	jstring _icon,
	jlong _statusIcon
)
{
	NotifyNotification* result;
	jlong _result;
	const gchar* summary;
	const gchar* body;
	const gchar* icon;
	GtkStatusIcon* statusIcon;

	// convert parameter summary
	summary = (const gchar*) (*env)->GetStringUTFChars(env, _summary, NULL);
	if (summary == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter body
	if (_body == NULL) {
		body = NULL;
	} else {
		body = (const gchar*) (*env)->GetStringUTFChars(env, _body, NULL);
		if (body == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter icon
	if (_icon == NULL) {
		icon = NULL;
	} else {
		icon = (const gchar*) (*env)->GetStringUTFChars(env, _icon, NULL);
		if (icon == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter statusIcon
	statusIcon = (GtkStatusIcon*) _statusIcon;

	// call function
	result = notify_notification_new_with_status_icon(summary, body, icon, statusIcon);

	// cleanup parameter summary
	(*env)->ReleaseStringUTFChars(env, _summary, summary);

	// cleanup parameter body
	if (body != NULL) {
		(*env)->ReleaseStringUTFChars(env, _body, body);
	}

	// cleanup parameter icon
	if (icon != NULL) {
		(*env)->ReleaseStringUTFChars(env, _icon, icon);
	}

	// cleanup parameter statusIcon

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1update
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _summary,
	jstring _body,
	jstring _icon
)
{
	gboolean result;
	jboolean _result;
	NotifyNotification* self;
	const gchar* summary;
	const gchar* body;
	const gchar* icon;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter summary
	summary = (const gchar*) (*env)->GetStringUTFChars(env, _summary, NULL);
	if (summary == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter body
	if (_body == NULL) {
		body = NULL;
	} else {
		body = (const gchar*) (*env)->GetStringUTFChars(env, _body, NULL);
		if (body == NULL) {
			return  JNI_FALSE; // Java Exception already thrown
		}
	}

	// convert parameter icon
	if (_icon == NULL) {
		icon = NULL;
	} else {
		icon = (const gchar*) (*env)->GetStringUTFChars(env, _icon, NULL);
		if (icon == NULL) {
			return  JNI_FALSE; // Java Exception already thrown
		}
	}

	// call function
	result = notify_notification_update(self, summary, body, icon);

	// cleanup parameter self

	// cleanup parameter summary
	(*env)->ReleaseStringUTFChars(env, _summary, summary);

	// cleanup parameter body
	if (body != NULL) {
		(*env)->ReleaseStringUTFChars(env, _body, body);
	}

	// cleanup parameter icon
	if (icon != NULL) {
		(*env)->ReleaseStringUTFChars(env, _icon, icon);
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1attach_1to_1widget
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _attach
)
{
	NotifyNotification* self;
	GtkWidget* attach;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter attach
	attach = (GtkWidget*) _attach;

	// call function
	notify_notification_attach_to_widget(self, attach);

	// cleanup parameter self

	// cleanup parameter attach
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1attach_1to_1status_1icon
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _statusIcon
)
{
	NotifyNotification* self;
	GtkStatusIcon* statusIcon;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter statusIcon
	statusIcon = (GtkStatusIcon*) _statusIcon;

	// call function
	notify_notification_attach_to_status_icon(self, statusIcon);

	// cleanup parameter self

	// cleanup parameter statusIcon
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1geometry_1hints
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _screen,
	jint _x,
	jint _y
)
{
	NotifyNotification* self;
	GdkScreen* screen;
	gint x;
	gint y;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter screen
	screen = (GdkScreen*) _screen;

	// convert parameter x
	x = (gint) _x;

	// convert parameter y
	y = (gint) _y;

	// call function
	notify_notification_set_geometry_hints(self, screen, x, y);

	// cleanup parameter self

	// cleanup parameter screen

	// cleanup parameter x

	// cleanup parameter y
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1show
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	NotifyNotification* self;
	GError* error = NULL;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// call function
	result = notify_notification_show(self, &error);

	// cleanup parameter self

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  JNI_FALSE;
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1timeout
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _timeout
)
{
	NotifyNotification* self;
	gint timeout;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter timeout
	timeout = (gint) _timeout;

	// call function
	notify_notification_set_timeout(self, timeout);

	// cleanup parameter self

	// cleanup parameter timeout
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1category
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category
)
{
	NotifyNotification* self;
	const char* category;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter category
	category = (const char*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	notify_notification_set_category(self, category);

	// cleanup parameter self

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1urgency
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _urgency
)
{
	NotifyNotification* self;
	NotifyUrgency urgency;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter urgency
	urgency = (NotifyUrgency) _urgency;

	// call function
	notify_notification_set_urgency(self, urgency);

	// cleanup parameter self

	// cleanup parameter urgency
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1icon_1from_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _icon
)
{
	NotifyNotification* self;
	GdkPixbuf* icon;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter icon
	icon = (GdkPixbuf*) _icon;

	// call function
	notify_notification_set_icon_from_pixbuf(self, icon);

	// cleanup parameter self

	// cleanup parameter icon
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1hint_1int32
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jint _value
)
{
	NotifyNotification* self;
	const gchar* key;
	gint value;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (gint) _value;

	// call function
	notify_notification_set_hint_int32(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1hint_1double
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jdouble _value
)
{
	NotifyNotification* self;
	const gchar* key;
	gdouble value;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (gdouble) _value;

	// call function
	notify_notification_set_hint_double(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1hint_1string
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jstring _value
)
{
	NotifyNotification* self;
	const gchar* key;
	const gchar* value;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (const gchar*) (*env)->GetStringUTFChars(env, _value, NULL);
	if (value == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	notify_notification_set_hint_string(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
	(*env)->ReleaseStringUTFChars(env, _value, value);
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1set_1hint_1byte
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _key,
	jchar _value
)
{
	NotifyNotification* self;
	const gchar* key;
	guchar value;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// convert parameter key
	key = (const gchar*) (*env)->GetStringUTFChars(env, _key, NULL);
	if (key == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter value
	value = (guchar) _value;

	// call function
	notify_notification_set_hint_byte(self, key, value);

	// cleanup parameter self

	// cleanup parameter key
	(*env)->ReleaseStringUTFChars(env, _key, key);

	// cleanup parameter value
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1clear_1hints
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	NotifyNotification* self;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// call function
	notify_notification_clear_hints(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1clear_1actions
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	NotifyNotification* self;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// call function
	notify_notification_clear_actions(self);

	// cleanup parameter self
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_notify_NotifyNotification_notify_1notification_1close
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	NotifyNotification* self;
	GError* error = NULL;

	// convert parameter self
	self = (NotifyNotification*) _self;

	// call function
	result = notify_notification_close(self, &error);

	// cleanup parameter self

	// check for error
	if (error) {
		bindings_java_throw_gerror(env, error);
		return  JNI_FALSE;
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
