/*
 * PangoAttrList.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.pango.AttrIterator;
import org.gnome.pango.Attribute;
import org.gnome.pango.AttributeList;
import org.gnome.pango.Plumbing;

final class PangoAttrList extends Plumbing
{
    private PangoAttrList() {}

    static final long createAttributeList() {
        long result;

        synchronized (lock) {
            result = pango_attr_list_new();

            return result;
        }
    }

    private static native final long pango_attr_list_new();

    static final void ref(AttributeList self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_attr_list_ref(pointerOf(self));
        }
    }

    private static native final void pango_attr_list_ref(long self);

    static final void unref(AttributeList self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_attr_list_unref(pointerOf(self));
        }
    }

    private static native final void pango_attr_list_unref(long self);

    static final AttributeList copy(AttributeList self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attr_list_copy(pointerOf(self));

            return (AttributeList) boxedFor(AttributeList.class, result);
        }
    }

    private static native final long pango_attr_list_copy(long self);

    static final void insert(AttributeList self, Attribute attr) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (attr == null) {
            throw new IllegalArgumentException("attr can't be null");
        }

        synchronized (lock) {
            pango_attr_list_insert(pointerOf(self), pointerOf(attr));
        }
    }

    private static native final void pango_attr_list_insert(long self, long attr);

    static final void insertBefore(AttributeList self, Attribute attr) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (attr == null) {
            throw new IllegalArgumentException("attr can't be null");
        }

        synchronized (lock) {
            pango_attr_list_insert_before(pointerOf(self), pointerOf(attr));
        }
    }

    private static native final void pango_attr_list_insert_before(long self, long attr);

    static final void change(AttributeList self, Attribute attr) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (attr == null) {
            throw new IllegalArgumentException("attr can't be null");
        }

        synchronized (lock) {
            pango_attr_list_change(pointerOf(self), pointerOf(attr));
        }
    }

    private static native final void pango_attr_list_change(long self, long attr);

    static final void splice(AttributeList self, AttributeList other, int pos, int len) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (other == null) {
            throw new IllegalArgumentException("other can't be null");
        }

        synchronized (lock) {
            pango_attr_list_splice(pointerOf(self), pointerOf(other), pos, len);
        }
    }

    private static native final void pango_attr_list_splice(long self, long other, int pos, int len);

    static final AttributeList filter(AttributeList self, FIXME func, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoAttrFilterFunc");
    }

    static final AttrIterator getIterator(AttributeList self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attr_list_get_iterator(pointerOf(self));

            return (AttrIterator) boxedFor(AttrIterator.class, result);
        }
    }

    private static native final long pango_attr_list_get_iterator(long self);
}

