/*
 * PangoAttribute.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.gnome.pango.Attribute;
import org.gnome.pango.FontDescription;
import org.gnome.pango.Gravity;
import org.gnome.pango.GravityHint;
import org.gnome.pango.Language;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Style;
import org.gnome.pango.Underline;
import org.gnome.pango.Variant;
import org.gnome.pango.Weight;

final class PangoAttribute extends Plumbing
{
    private PangoAttribute() {}

    static final int getStartIndex(Attribute self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attribute_get_start_index(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_attribute_get_start_index(long self);

    static final void setStartIndex(Attribute self, int startIndex) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_attribute_set_start_index(pointerOf(self), startIndex);
        }
    }

    private static native final void pango_attribute_set_start_index(long self, int startIndex);

    static final int getEndIndex(Attribute self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attribute_get_end_index(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_attribute_get_end_index(long self);

    static final void setEndIndex(Attribute self, int endIndex) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_attribute_set_end_index(pointerOf(self), endIndex);
        }
    }

    private static native final void pango_attribute_set_end_index(long self, int endIndex);

    static final Attribute copy(Attribute self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attribute_copy(pointerOf(self));

            return (Attribute) boxedFor(Attribute.class, result);
        }
    }

    private static native final long pango_attribute_copy(long self);

    static final void destroy(Attribute self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_attribute_destroy(pointerOf(self));
        }
    }

    private static native final void pango_attribute_destroy(long self);

    static final boolean equal(Attribute self, org.gnome.pango.Attribute attr2) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (attr2 == null) {
            throw new IllegalArgumentException("attr2 can't be null");
        }

        synchronized (lock) {
            result = pango_attribute_equal(pointerOf(self), pointerOf(attr2));

            return result;
        }
    }

    private static native final boolean pango_attribute_equal(long self, long attr2);

    static final long createAttributeLanguage(Language language) {
        long result;

        if (language == null) {
            throw new IllegalArgumentException("language can't be null");
        }

        synchronized (lock) {
            result = pango_attr_language_new(pointerOf(language));

            return result;
        }
    }

    private static native final long pango_attr_language_new(long language);

    static final long createAttributeForeground(char red, char green, char blue) {
        long result;

        synchronized (lock) {
            result = pango_attr_foreground_new(red, green, blue);

            return result;
        }
    }

    private static native final long pango_attr_foreground_new(char red, char green, char blue);

    static final long createAttributeBackground(char red, char green, char blue) {
        long result;

        synchronized (lock) {
            result = pango_attr_background_new(red, green, blue);

            return result;
        }
    }

    private static native final long pango_attr_background_new(char red, char green, char blue);

    static final long createAttributeSize(int size) {
        long result;

        synchronized (lock) {
            result = pango_attr_size_new(size);

            return result;
        }
    }

    private static native final long pango_attr_size_new(int size);

    static final long createAttributeStyle(Style style) {
        long result;

        if (style == null) {
            throw new IllegalArgumentException("style can't be null");
        }

        synchronized (lock) {
            result = pango_attr_style_new(numOf(style));

            return result;
        }
    }

    private static native final long pango_attr_style_new(int style);

    static final long createAttributeWeight(Weight weight) {
        long result;

        if (weight == null) {
            throw new IllegalArgumentException("weight can't be null");
        }

        synchronized (lock) {
            result = pango_attr_weight_new(numOf(weight));

            return result;
        }
    }

    private static native final long pango_attr_weight_new(int weight);

    static final long createAttributeVariant(Variant variant) {
        long result;

        if (variant == null) {
            throw new IllegalArgumentException("variant can't be null");
        }

        synchronized (lock) {
            result = pango_attr_variant_new(numOf(variant));

            return result;
        }
    }

    private static native final long pango_attr_variant_new(int variant);

    static final long createAttributeFontDescription(FontDescription desc) {
        long result;

        if (desc == null) {
            throw new IllegalArgumentException("desc can't be null");
        }

        synchronized (lock) {
            result = pango_attr_font_desc_new(pointerOf(desc));

            return result;
        }
    }

    private static native final long pango_attr_font_desc_new(long desc);

    static final long createAttributeUnderline(Underline underline) {
        long result;

        if (underline == null) {
            throw new IllegalArgumentException("underline can't be null");
        }

        synchronized (lock) {
            result = pango_attr_underline_new(numOf(underline));

            return result;
        }
    }

    private static native final long pango_attr_underline_new(int underline);

    static final long createAttributeUnderlineColor(char red, char green, char blue) {
        long result;

        synchronized (lock) {
            result = pango_attr_underline_color_new(red, green, blue);

            return result;
        }
    }

    private static native final long pango_attr_underline_color_new(char red, char green, char blue);

    static final long createAttributeFallback(boolean fallback) {
        long result;

        synchronized (lock) {
            result = pango_attr_fallback_new(fallback);

            return result;
        }
    }

    private static native final long pango_attr_fallback_new(boolean fallback);

    static final long createAttributeGravity(Gravity gravity) {
        long result;

        if (gravity == null) {
            throw new IllegalArgumentException("gravity can't be null");
        }

        synchronized (lock) {
            result = pango_attr_gravity_new(numOf(gravity));

            return result;
        }
    }

    private static native final long pango_attr_gravity_new(int gravity);

    static final long createAttributeGravityHint(GravityHint hint) {
        long result;

        if (hint == null) {
            throw new IllegalArgumentException("hint can't be null");
        }

        synchronized (lock) {
            result = pango_attr_gravity_hint_new(numOf(hint));

            return result;
        }
    }

    private static native final long pango_attr_gravity_hint_new(int hint);
}

