/*
 * PangoFontFace.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.pango.FontDescription;
import org.gnome.pango.FontFace;
import org.gnome.pango.Plumbing;

final class PangoFontFace extends Plumbing
{
    private PangoFontFace() {}

    static final FontDescription describe(FontFace self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_face_describe(pointerOf(self));

            return (FontDescription) boxedFor(FontDescription.class, result);
        }
    }

    private static native final long pango_font_face_describe(long self);

    static final String getFaceName(FontFace self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_face_get_face_name(pointerOf(self));

            return result;
        }
    }

    private static native final String pango_font_face_get_face_name(long self);

    static final void listSizes(FontFace self, FIXME sizes, int[] nSizes) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("int**");
    }

    interface GetFaceNameSignal extends Signal
    {
        String onGetFaceName(FontFace source);
    }

    static final void connect(FontFace self, PangoFontFace.GetFaceNameSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontFace.class, "get-face-name", after);
    }

    protected static final String receiveGetFaceName(Signal handler, long source) {
        String result;

        result = ((PangoFontFace.GetFaceNameSignal) handler).onGetFaceName((FontFace) objectFor(source));

        return result;
    }

    interface DescribeSignal extends Signal
    {
        FontDescription onDescribe(FontFace source);
    }

    static final void connect(FontFace self, PangoFontFace.DescribeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontFace.class, "describe", after);
    }

    protected static final long receiveDescribe(Signal handler, long source) {
        FontDescription result;

        result = ((PangoFontFace.DescribeSignal) handler).onDescribe((FontFace) objectFor(source));

        return pointerOf(result);
    }

    interface ListSizesSignal extends Signal
    {
        void onListSizes(FontFace source, FIXME sizes, int[] nSizes);
    }

    static final void connect(FontFace self, PangoFontFace.ListSizesSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontFace.class, "list-sizes", after);
    }

    protected static final void receiveListSizes(Signal handler, long source, java.lang.Object sizes, int[] nSizes) {
        ((PangoFontFace.ListSizesSignal) handler).onListSizes((FontFace) objectFor(source), (FIXME) sizes, nSizes);
    }
}

