/*
 * PangoFontFamily.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.pango.FontFamily;
import org.gnome.pango.Plumbing;

final class PangoFontFamily extends Plumbing
{
    private PangoFontFamily() {}

    static final void listFaces(FontFamily self, FIXME faces, int[] nFaces) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoFontFace***");
    }

    static final String getName(FontFamily self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_family_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String pango_font_family_get_name(long self);

    static final boolean isMonospace(FontFamily self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_family_is_monospace(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_font_family_is_monospace(long self);

    interface ListFacesSignal extends Signal
    {
        void onListFaces(FontFamily source, FIXME faces, int[] nFaces);
    }

    static final void connect(FontFamily self, PangoFontFamily.ListFacesSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontFamily.class, "list-faces", after);
    }

    protected static final void receiveListFaces(Signal handler, long source, java.lang.Object faces, int[] nFaces) {
        ((PangoFontFamily.ListFacesSignal) handler).onListFaces((FontFamily) objectFor(source), (FIXME) faces, nFaces);
    }

    interface GetNameSignal extends Signal
    {
        String onGetName(FontFamily source);
    }

    static final void connect(FontFamily self, PangoFontFamily.GetNameSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontFamily.class, "get-name", after);
    }

    protected static final String receiveGetName(Signal handler, long source) {
        String result;

        result = ((PangoFontFamily.GetNameSignal) handler).onGetName((FontFamily) objectFor(source));

        return result;
    }

    interface IsMonospaceSignal extends Signal
    {
        boolean onIsMonospace(FontFamily source);
    }

    static final void connect(FontFamily self, PangoFontFamily.IsMonospaceSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontFamily.class, "is-monospace", after);
    }

    protected static final boolean receiveIsMonospace(Signal handler, long source) {
        boolean result;

        result = ((PangoFontFamily.IsMonospaceSignal) handler).onIsMonospace((FontFamily) objectFor(source));

        return result;
    }
}

