/*
 * PangoFontMap.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.pango.Context;
import org.gnome.pango.Font;
import org.gnome.pango.FontDescription;
import org.gnome.pango.FontMap;
import org.gnome.pango.Fontset;
import org.gnome.pango.Language;
import org.gnome.pango.Plumbing;

final class PangoFontMap extends Plumbing
{
    private PangoFontMap() {}

    static final Font loadFont(FontMap self, Context context, FontDescription desc) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (context == null) {
            throw new IllegalArgumentException("context can't be null");
        }

        if (desc == null) {
            throw new IllegalArgumentException("desc can't be null");
        }

        synchronized (lock) {
            result = pango_font_map_load_font(pointerOf(self), pointerOf(context), pointerOf(desc));

            return (Font) objectFor(result);
        }
    }

    private static native final long pango_font_map_load_font(long self, long context, long desc);

    static final Fontset loadFontset(FontMap self, Context context, FontDescription desc, Language language) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (context == null) {
            throw new IllegalArgumentException("context can't be null");
        }

        if (desc == null) {
            throw new IllegalArgumentException("desc can't be null");
        }

        if (language == null) {
            throw new IllegalArgumentException("language can't be null");
        }

        synchronized (lock) {
            result = pango_font_map_load_fontset(pointerOf(self), pointerOf(context), pointerOf(desc), pointerOf(language));

            return (Fontset) objectFor(result);
        }
    }

    private static native final long pango_font_map_load_fontset(long self, long context, long desc, long language);

    static final void listFamilies(FontMap self, FIXME families, int[] nFamilies) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoFontFamily***");
    }

    interface LoadFontSignal extends Signal
    {
        Font onLoadFont(FontMap source, Context context, FontDescription desc);
    }

    static final void connect(FontMap self, PangoFontMap.LoadFontSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontMap.class, "load-font", after);
    }

    protected static final long receiveLoadFont(Signal handler, long source, long context, long desc) {
        Font result;

        result = ((PangoFontMap.LoadFontSignal) handler).onLoadFont((FontMap) objectFor(source), (Context) objectFor(context), (FontDescription) boxedFor(FontDescription.class, desc));

        return pointerOf(result);
    }

    interface ListFamiliesSignal extends Signal
    {
        void onListFamilies(FontMap source, FIXME families, int[] nFamilies);
    }

    static final void connect(FontMap self, PangoFontMap.ListFamiliesSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontMap.class, "list-families", after);
    }

    protected static final void receiveListFamilies(Signal handler, long source, java.lang.Object families, int[] nFamilies) {
        ((PangoFontMap.ListFamiliesSignal) handler).onListFamilies((FontMap) objectFor(source), (FIXME) families, nFamilies);
    }

    interface LoadFontsetSignal extends Signal
    {
        Fontset onLoadFontset(FontMap source, Context context, FontDescription desc, Language language);
    }

    static final void connect(FontMap self, PangoFontMap.LoadFontsetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontMap.class, "load-fontset", after);
    }

    protected static final long receiveLoadFontset(Signal handler, long source, long context, long desc, long language) {
        Fontset result;

        result = ((PangoFontMap.LoadFontsetSignal) handler).onLoadFontset((FontMap) objectFor(source), (Context) objectFor(context), (FontDescription) boxedFor(FontDescription.class, desc), (Language) boxedFor(Language.class, language));

        return pointerOf(result);
    }
}

