/*
 * PangoFontMetrics.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.gnome.pango.FontMetrics;
import org.gnome.pango.Plumbing;

final class PangoFontMetrics extends Plumbing
{
    private PangoFontMetrics() {}

    static final FontMetrics ref(FontMetrics self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_ref(pointerOf(self));

            return (FontMetrics) boxedFor(FontMetrics.class, result);
        }
    }

    private static native final long pango_font_metrics_ref(long self);

    static final void unref(FontMetrics self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_font_metrics_unref(pointerOf(self));
        }
    }

    private static native final void pango_font_metrics_unref(long self);

    static final int getAscent(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_ascent(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_ascent(long self);

    static final int getDescent(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_descent(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_descent(long self);

    static final int getApproximateCharWidth(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_approximate_char_width(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_approximate_char_width(long self);

    static final int getApproximateDigitWidth(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_approximate_digit_width(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_approximate_digit_width(long self);

    static final int getUnderlinePosition(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_underline_position(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_underline_position(long self);

    static final int getUnderlineThickness(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_underline_thickness(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_underline_thickness(long self);

    static final int getStrikethroughPosition(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_strikethrough_position(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_strikethrough_position(long self);

    static final int getStrikethroughThickness(FontMetrics self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_metrics_get_strikethrough_thickness(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_font_metrics_get_strikethrough_thickness(long self);
}

