/*
 * PangoGlyphString.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.gnome.pango.Analysis;
import org.gnome.pango.Font;
import org.gnome.pango.GlyphInfo;
import org.gnome.pango.GlyphString;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Rectangle;

final class PangoGlyphString extends Plumbing
{
    private PangoGlyphString() {}

    static final int getNumGlyphs(GlyphString self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_glyph_string_get_num_glyphs(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_glyph_string_get_num_glyphs(long self);

    static final void setNumGlyphs(GlyphString self, int numGlyphs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_set_num_glyphs(pointerOf(self), numGlyphs);
        }
    }

    private static native final void pango_glyph_string_set_num_glyphs(long self, int numGlyphs);

    static final GlyphInfo getGlyphs(GlyphString self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_glyph_string_get_glyphs(pointerOf(self));

            return (GlyphInfo) boxedFor(GlyphInfo.class, result);
        }
    }

    private static native final long pango_glyph_string_get_glyphs(long self);

    static final void setGlyphs(GlyphString self, GlyphInfo glyphs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (glyphs == null) {
            throw new IllegalArgumentException("glyphs can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_set_glyphs(pointerOf(self), pointerOf(glyphs));
        }
    }

    private static native final void pango_glyph_string_set_glyphs(long self, long glyphs);

    static final int[] getLogClusters(GlyphString self) {
        int[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_glyph_string_get_log_clusters(pointerOf(self));

            return result;
        }
    }

    private static native final int[] pango_glyph_string_get_log_clusters(long self);

    static final void setLogClusters(GlyphString self, int[] logClusters) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (logClusters == null) {
            throw new IllegalArgumentException("logClusters can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_set_log_clusters(pointerOf(self), logClusters);
        }
    }

    private static native final void pango_glyph_string_set_log_clusters(long self, int[] logClusters);

    static final long createGlyphString() {
        long result;

        synchronized (lock) {
            result = pango_glyph_string_new();

            return result;
        }
    }

    private static native final long pango_glyph_string_new();

    static final void setSize(GlyphString self, int newLen) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_set_size(pointerOf(self), newLen);
        }
    }

    private static native final void pango_glyph_string_set_size(long self, int newLen);

    static final GlyphString copy(GlyphString self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_glyph_string_copy(pointerOf(self));

            return (GlyphString) boxedFor(GlyphString.class, result);
        }
    }

    private static native final long pango_glyph_string_copy(long self);

    static final void free(GlyphString self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_free(pointerOf(self));
        }
    }

    private static native final void pango_glyph_string_free(long self);

    static final void extents(GlyphString self, Font font, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (font == null) {
            throw new IllegalArgumentException("font can't be null");
        }

        if (inkRect == null) {
            throw new IllegalArgumentException("inkRect can't be null");
        }

        if (logicalRect == null) {
            throw new IllegalArgumentException("logicalRect can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_extents(pointerOf(self), pointerOf(font), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_glyph_string_extents(long self, long font, long inkRect, long logicalRect);

    static final void extentsRange(GlyphString self, int start, int end, Font font, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (font == null) {
            throw new IllegalArgumentException("font can't be null");
        }

        if (inkRect == null) {
            throw new IllegalArgumentException("inkRect can't be null");
        }

        if (logicalRect == null) {
            throw new IllegalArgumentException("logicalRect can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_extents_range(pointerOf(self), start, end, pointerOf(font), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_glyph_string_extents_range(long self, int start, int end, long font, long inkRect, long logicalRect);

    static final void getLogicalWidths(GlyphString self, String text, int length, int embeddingLevel, int[] logicalWidths) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        if (logicalWidths == null) {
            throw new IllegalArgumentException("logicalWidths can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_get_logical_widths(pointerOf(self), text, length, embeddingLevel, logicalWidths);
        }
    }

    private static native final void pango_glyph_string_get_logical_widths(long self, String text, int length, int embeddingLevel, int[] logicalWidths);

    static final void indexToX(GlyphString self, String text, int length, Analysis analysis, int index, boolean trailing, int[] xPos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        if (analysis == null) {
            throw new IllegalArgumentException("analysis can't be null");
        }

        if (xPos == null) {
            throw new IllegalArgumentException("xPos can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_index_to_x(pointerOf(self), text, length, pointerOf(analysis), index, trailing, xPos);
        }
    }

    private static native final void pango_glyph_string_index_to_x(long self, String text, int length, long analysis, int index, boolean trailing, int[] xPos);

    static final void xToIndex(GlyphString self, String text, int length, Analysis analysis, int xPos, int[] index, int[] trailing) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        if (analysis == null) {
            throw new IllegalArgumentException("analysis can't be null");
        }

        if (index == null) {
            throw new IllegalArgumentException("index can't be null");
        }

        if (trailing == null) {
            throw new IllegalArgumentException("trailing can't be null");
        }

        synchronized (lock) {
            pango_glyph_string_x_to_index(pointerOf(self), text, length, pointerOf(analysis), xPos, index, trailing);
        }
    }

    private static native final void pango_glyph_string_x_to_index(long self, String text, int length, long analysis, int xPos, int[] index, int[] trailing);
}

