/*
 * PangoLayout.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.pango.Alignment;
import org.gnome.pango.AttributeList;
import org.gnome.pango.Context;
import org.gnome.pango.EllipsizeMode;
import org.gnome.pango.FontDescription;
import org.gnome.pango.Layout;
import org.gnome.pango.LayoutIter;
import org.gnome.pango.LayoutLine;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Rectangle;
import org.gnome.pango.TabArray;
import org.gnome.pango.WrapMode;

final class PangoLayout extends Plumbing
{
    private PangoLayout() {}

    static final long createLayout(Context context) {
        long result;

        if (context == null) {
            throw new IllegalArgumentException("context can't be null");
        }

        synchronized (lock) {
            result = pango_layout_new(pointerOf(context));

            return result;
        }
    }

    private static native final long pango_layout_new(long context);

    static final long createLayoutFromCairo(org.freedesktop.cairo.Context context) {
        long result;

        if (context == null) {
            throw new IllegalArgumentException("context can't be null");
        }

        synchronized (lock) {
            result = pango_cairo_create_layout(pointerOf(context));

            return result;
        }
    }

    private static native final long pango_cairo_create_layout(long context);

    static final Layout copy(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_copy(pointerOf(self));

            return (Layout) objectFor(result);
        }
    }

    private static native final long pango_layout_copy(long self);

    static final Context getContext(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_context(pointerOf(self));

            return (Context) objectFor(result);
        }
    }

    private static native final long pango_layout_get_context(long self);

    static final void setAttributes(Layout self, AttributeList attrs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_attributes(pointerOf(self), pointerOf(attrs));
        }
    }

    private static native final void pango_layout_set_attributes(long self, long attrs);

    static final AttributeList getAttributes(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_attributes(pointerOf(self));

            return (AttributeList) boxedFor(AttributeList.class, result);
        }
    }

    private static native final long pango_layout_get_attributes(long self);

    static final void setText(Layout self, String text, int length) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            pango_layout_set_text(pointerOf(self), text, length);
        }
    }

    private static native final void pango_layout_set_text(long self, String text, int length);

    static final String getText(Layout self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_text(pointerOf(self));

            return result;
        }
    }

    private static native final String pango_layout_get_text(long self);

    static final void setMarkup(Layout self, String markup, int length) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (markup == null) {
            throw new IllegalArgumentException("markup can't be null");
        }

        synchronized (lock) {
            pango_layout_set_markup(pointerOf(self), markup, length);
        }
    }

    private static native final void pango_layout_set_markup(long self, String markup, int length);

    static final void setMarkupWithAccel(Layout self, String markup, int length, char accelMarker, FIXME accelChar) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gunichar*");
    }

    static final void setFontDescription(Layout self, FontDescription desc) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_font_description(pointerOf(self), pointerOf(desc));
        }
    }

    private static native final void pango_layout_set_font_description(long self, long desc);

    static final FontDescription getFontDescription(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_font_description(pointerOf(self));

            return (FontDescription) boxedFor(FontDescription.class, result);
        }
    }

    private static native final long pango_layout_get_font_description(long self);

    static final void setWidth(Layout self, int width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_width(pointerOf(self), width);
        }
    }

    private static native final void pango_layout_set_width(long self, int width);

    static final int getWidth(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_get_width(long self);

    static final void setWrap(Layout self, WrapMode wrap) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (wrap == null) {
            throw new IllegalArgumentException("wrap can't be null");
        }

        synchronized (lock) {
            pango_layout_set_wrap(pointerOf(self), numOf(wrap));
        }
    }

    private static native final void pango_layout_set_wrap(long self, int wrap);

    static final WrapMode getWrap(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_wrap(pointerOf(self));

            return (WrapMode) enumFor(WrapMode.class, result);
        }
    }

    private static native final int pango_layout_get_wrap(long self);

    static final boolean isWrapped(Layout self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_is_wrapped(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_is_wrapped(long self);

    static final void setIndent(Layout self, int indent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_indent(pointerOf(self), indent);
        }
    }

    private static native final void pango_layout_set_indent(long self, int indent);

    static final int getIndent(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_indent(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_get_indent(long self);

    static final void setSpacing(Layout self, int spacing) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_spacing(pointerOf(self), spacing);
        }
    }

    private static native final void pango_layout_set_spacing(long self, int spacing);

    static final int getSpacing(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_spacing(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_get_spacing(long self);

    static final void setJustify(Layout self, boolean justify) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_justify(pointerOf(self), justify);
        }
    }

    private static native final void pango_layout_set_justify(long self, boolean justify);

    static final boolean getJustify(Layout self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_justify(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_get_justify(long self);

    static final void setAutoDir(Layout self, boolean autoDir) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_auto_dir(pointerOf(self), autoDir);
        }
    }

    private static native final void pango_layout_set_auto_dir(long self, boolean autoDir);

    static final boolean getAutoDir(Layout self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_auto_dir(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_get_auto_dir(long self);

    static final void setAlignment(Layout self, Alignment alignment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (alignment == null) {
            throw new IllegalArgumentException("alignment can't be null");
        }

        synchronized (lock) {
            pango_layout_set_alignment(pointerOf(self), numOf(alignment));
        }
    }

    private static native final void pango_layout_set_alignment(long self, int alignment);

    static final Alignment getAlignment(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_alignment(pointerOf(self));

            return (Alignment) enumFor(Alignment.class, result);
        }
    }

    private static native final int pango_layout_get_alignment(long self);

    static final void setTabs(Layout self, TabArray tabs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_tabs(pointerOf(self), pointerOf(tabs));
        }
    }

    private static native final void pango_layout_set_tabs(long self, long tabs);

    static final TabArray getTabs(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_tabs(pointerOf(self));

            return (TabArray) boxedFor(TabArray.class, result);
        }
    }

    private static native final long pango_layout_get_tabs(long self);

    static final void setSingleParagraphMode(Layout self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_set_single_paragraph_mode(pointerOf(self), setting);
        }
    }

    private static native final void pango_layout_set_single_paragraph_mode(long self, boolean setting);

    static final boolean getSingleParagraphMode(Layout self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_single_paragraph_mode(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_get_single_paragraph_mode(long self);

    static final void setEllipsize(Layout self, EllipsizeMode ellipsize) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (ellipsize == null) {
            throw new IllegalArgumentException("ellipsize can't be null");
        }

        synchronized (lock) {
            pango_layout_set_ellipsize(pointerOf(self), numOf(ellipsize));
        }
    }

    private static native final void pango_layout_set_ellipsize(long self, int ellipsize);

    static final EllipsizeMode getEllipsize(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_ellipsize(pointerOf(self));

            return (EllipsizeMode) enumFor(EllipsizeMode.class, result);
        }
    }

    private static native final int pango_layout_get_ellipsize(long self);

    static final boolean isEllipsized(Layout self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_is_ellipsized(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_is_ellipsized(long self);

    static final int getUnknownGlyphsCount(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_unknown_glyphs_count(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_get_unknown_glyphs_count(long self);

    static final void contextChanged(Layout self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_context_changed(pointerOf(self));
        }
    }

    private static native final void pango_layout_context_changed(long self);

    static final void getLogAttrs(Layout self, FIXME attrs, int[] nAttrs) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoLogAttr**");
    }

    static final void indexToPos(Layout self, int index, Rectangle pos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pos == null) {
            throw new IllegalArgumentException("pos can't be null");
        }

        synchronized (lock) {
            pango_layout_index_to_pos(pointerOf(self), index, pointerOf(pos));
        }
    }

    private static native final void pango_layout_index_to_pos(long self, int index, long pos);

    static final void getCursorPos(Layout self, int index, Rectangle strongPos, Rectangle weakPos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (strongPos == null) {
            throw new IllegalArgumentException("strongPos can't be null");
        }

        if (weakPos == null) {
            throw new IllegalArgumentException("weakPos can't be null");
        }

        synchronized (lock) {
            pango_layout_get_cursor_pos(pointerOf(self), index, pointerOf(strongPos), pointerOf(weakPos));
        }
    }

    private static native final void pango_layout_get_cursor_pos(long self, int index, long strongPos, long weakPos);

    static final void moveCursorVisually(Layout self, boolean strong, int oldIndex, int oldTrailing, int direction, int[] newIndex, int[] newTrailing) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (newIndex == null) {
            throw new IllegalArgumentException("newIndex can't be null");
        }

        if (newTrailing == null) {
            throw new IllegalArgumentException("newTrailing can't be null");
        }

        synchronized (lock) {
            pango_layout_move_cursor_visually(pointerOf(self), strong, oldIndex, oldTrailing, direction, newIndex, newTrailing);
        }
    }

    private static native final void pango_layout_move_cursor_visually(long self, boolean strong, int oldIndex, int oldTrailing, int direction, int[] newIndex, int[] newTrailing);

    static final boolean xyToIndex(Layout self, int x, int y, int[] index, int[] trailing) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (index == null) {
            throw new IllegalArgumentException("index can't be null");
        }

        if (trailing == null) {
            throw new IllegalArgumentException("trailing can't be null");
        }

        synchronized (lock) {
            result = pango_layout_xy_to_index(pointerOf(self), x, y, index, trailing);

            return result;
        }
    }

    private static native final boolean pango_layout_xy_to_index(long self, int x, int y, int[] index, int[] trailing);

    static final void getExtents(Layout self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_get_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_get_extents(long self, long inkRect, long logicalRect);

    static final void getPixelExtents(Layout self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_get_pixel_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_get_pixel_extents(long self, long inkRect, long logicalRect);

    static final void getSize(Layout self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_get_size(pointerOf(self), width, height);
        }
    }

    private static native final void pango_layout_get_size(long self, int[] width, int[] height);

    static final void getPixelSize(Layout self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_get_pixel_size(pointerOf(self), width, height);
        }
    }

    private static native final void pango_layout_get_pixel_size(long self, int[] width, int[] height);

    static final int getLineCount(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_line_count(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_get_line_count(long self);

    static final LayoutLine getLine(Layout self, int line) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_line(pointerOf(self), line);

            return (LayoutLine) boxedFor(LayoutLine.class, result);
        }
    }

    private static native final long pango_layout_get_line(long self, int line);

    static final LayoutLine getLineReadonly(Layout self, int line) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_line_readonly(pointerOf(self), line);

            return (LayoutLine) boxedFor(LayoutLine.class, result);
        }
    }

    private static native final long pango_layout_get_line_readonly(long self, int line);

    static final LayoutLine[] getLines(Layout self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_lines(pointerOf(self));

            return (LayoutLine[]) boxedArrayFor(LayoutLine.class, result, new LayoutLine[result.length]);
        }
    }

    private static native final long[] pango_layout_get_lines(long self);

    static final LayoutLine[] getLinesReadonly(Layout self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_lines_readonly(pointerOf(self));

            return (LayoutLine[]) boxedArrayFor(LayoutLine.class, result, new LayoutLine[result.length]);
        }
    }

    private static native final long[] pango_layout_get_lines_readonly(long self);

    static final LayoutIter getIter(Layout self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_iter(pointerOf(self));

            return (LayoutIter) boxedFor(LayoutIter.class, result);
        }
    }

    private static native final long pango_layout_get_iter(long self);

    static final int getBaseline(Layout self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_get_baseline(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_get_baseline(long self);
}

