/*
 * PangoLayoutIter.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.pango.LayoutIter;
import org.gnome.pango.LayoutLine;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Rectangle;

final class PangoLayoutIter extends Plumbing
{
    private PangoLayoutIter() {}

    static final void free(LayoutIter self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_iter_free(pointerOf(self));
        }
    }

    private static native final void pango_layout_iter_free(long self);

    static final int getIndex(LayoutIter self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_get_index(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_iter_get_index(long self);

    static final FIXME getRun(LayoutIter self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoLayoutRun*");
    }

    static final FIXME getRunReadonly(LayoutIter self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoLayoutRun*");
    }

    static final LayoutLine getLine(LayoutIter self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_get_line(pointerOf(self));

            return (LayoutLine) boxedFor(LayoutLine.class, result);
        }
    }

    private static native final long pango_layout_iter_get_line(long self);

    static final LayoutLine getLineReadonly(LayoutIter self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_get_line_readonly(pointerOf(self));

            return (LayoutLine) boxedFor(LayoutLine.class, result);
        }
    }

    private static native final long pango_layout_iter_get_line_readonly(long self);

    static final boolean atLastLine(LayoutIter self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_at_last_line(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_iter_at_last_line(long self);

    static final boolean nextChar(LayoutIter self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_next_char(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_iter_next_char(long self);

    static final boolean nextCluster(LayoutIter self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_next_cluster(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_iter_next_cluster(long self);

    static final boolean nextRun(LayoutIter self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_next_run(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_iter_next_run(long self);

    static final boolean nextLine(LayoutIter self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_next_line(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_layout_iter_next_line(long self);

    static final void getCharExtents(LayoutIter self, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (logicalRect == null) {
            throw new IllegalArgumentException("logicalRect can't be null");
        }

        synchronized (lock) {
            pango_layout_iter_get_char_extents(pointerOf(self), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_iter_get_char_extents(long self, long logicalRect);

    static final void getClusterExtents(LayoutIter self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (inkRect == null) {
            throw new IllegalArgumentException("inkRect can't be null");
        }

        if (logicalRect == null) {
            throw new IllegalArgumentException("logicalRect can't be null");
        }

        synchronized (lock) {
            pango_layout_iter_get_cluster_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_iter_get_cluster_extents(long self, long inkRect, long logicalRect);

    static final void getRunExtents(LayoutIter self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (inkRect == null) {
            throw new IllegalArgumentException("inkRect can't be null");
        }

        if (logicalRect == null) {
            throw new IllegalArgumentException("logicalRect can't be null");
        }

        synchronized (lock) {
            pango_layout_iter_get_run_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_iter_get_run_extents(long self, long inkRect, long logicalRect);

    static final void getLineExtents(LayoutIter self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (inkRect == null) {
            throw new IllegalArgumentException("inkRect can't be null");
        }

        if (logicalRect == null) {
            throw new IllegalArgumentException("logicalRect can't be null");
        }

        synchronized (lock) {
            pango_layout_iter_get_line_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_iter_get_line_extents(long self, long inkRect, long logicalRect);

    static final void getLineYrange(LayoutIter self, int[] y0, int[] y1) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (y0 == null) {
            throw new IllegalArgumentException("y0 can't be null");
        }

        if (y1 == null) {
            throw new IllegalArgumentException("y1 can't be null");
        }

        synchronized (lock) {
            pango_layout_iter_get_line_yrange(pointerOf(self), y0, y1);
        }
    }

    private static native final void pango_layout_iter_get_line_yrange(long self, int[] y0, int[] y1);

    static final void getLayoutExtents(LayoutIter self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (inkRect == null) {
            throw new IllegalArgumentException("inkRect can't be null");
        }

        if (logicalRect == null) {
            throw new IllegalArgumentException("logicalRect can't be null");
        }

        synchronized (lock) {
            pango_layout_iter_get_layout_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_iter_get_layout_extents(long self, long inkRect, long logicalRect);

    static final int getBaseline(LayoutIter self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_iter_get_baseline(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_iter_get_baseline(long self);
}

