/*
 * PangoLayoutLine.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.pango.LayoutLine;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Rectangle;

final class PangoLayoutLine extends Plumbing
{
    private PangoLayoutLine() {}

    static final int getStartIndex(LayoutLine self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_line_get_start_index(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_line_get_start_index(long self);

    static final void setStartIndex(LayoutLine self, int startIndex) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_set_start_index(pointerOf(self), startIndex);
        }
    }

    private static native final void pango_layout_line_set_start_index(long self, int startIndex);

    static final int getLength(LayoutLine self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_line_get_length(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_line_get_length(long self);

    static final void setLength(LayoutLine self, int length) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_set_length(pointerOf(self), length);
        }
    }

    private static native final void pango_layout_line_set_length(long self, int length);

    static final FIXME getRuns(LayoutLine self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GSList*");
    }

    static final void setRuns(LayoutLine self, FIXME runs) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GSList*");
    }

    static final int getIsParagraphStart(LayoutLine self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_line_get_is_paragraph_start(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_line_get_is_paragraph_start(long self);

    static final void setIsParagraphStart(LayoutLine self, int isParagraphStart) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_set_is_paragraph_start(pointerOf(self), isParagraphStart);
        }
    }

    private static native final void pango_layout_line_set_is_paragraph_start(long self, int isParagraphStart);

    static final int getResolvedDir(LayoutLine self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_layout_line_get_resolved_dir(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_layout_line_get_resolved_dir(long self);

    static final void setResolvedDir(LayoutLine self, int resolvedDir) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_set_resolved_dir(pointerOf(self), resolvedDir);
        }
    }

    private static native final void pango_layout_line_set_resolved_dir(long self, int resolvedDir);

    static final void ref(LayoutLine self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_ref(pointerOf(self));
        }
    }

    private static native final void pango_layout_line_ref(long self);

    static final void unref(LayoutLine self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_unref(pointerOf(self));
        }
    }

    private static native final void pango_layout_line_unref(long self);

    static final boolean xToIndex(LayoutLine self, int xPos, int[] index, int[] trailing) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (index == null) {
            throw new IllegalArgumentException("index can't be null");
        }

        if (trailing == null) {
            throw new IllegalArgumentException("trailing can't be null");
        }

        synchronized (lock) {
            result = pango_layout_line_x_to_index(pointerOf(self), xPos, index, trailing);

            return result;
        }
    }

    private static native final boolean pango_layout_line_x_to_index(long self, int xPos, int[] index, int[] trailing);

    static final void indexToX(LayoutLine self, int index, boolean trailing, int[] xPos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (xPos == null) {
            throw new IllegalArgumentException("xPos can't be null");
        }

        synchronized (lock) {
            pango_layout_line_index_to_x(pointerOf(self), index, trailing, xPos);
        }
    }

    private static native final void pango_layout_line_index_to_x(long self, int index, boolean trailing, int[] xPos);

    static final void getXRanges(LayoutLine self, int startIndex, int endIndex, FIXME ranges, int[] nRanges) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("int**");
    }

    static final void getExtents(LayoutLine self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_get_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_line_get_extents(long self, long inkRect, long logicalRect);

    static final void getPixelExtents(LayoutLine self, Rectangle inkRect, Rectangle logicalRect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_layout_line_get_pixel_extents(pointerOf(self), pointerOf(inkRect), pointerOf(logicalRect));
        }
    }

    private static native final void pango_layout_line_get_pixel_extents(long self, long inkRect, long logicalRect);
}

