/*
 * PangoMatrix.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.gnome.pango.Matrix;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Rectangle;

final class PangoMatrix extends Plumbing
{
    private PangoMatrix() {}

    static final Matrix copy(Matrix self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_matrix_copy(pointerOf(self));

            return (Matrix) boxedFor(Matrix.class, result);
        }
    }

    private static native final long pango_matrix_copy(long self);

    static final void free(Matrix self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_matrix_free(pointerOf(self));
        }
    }

    private static native final void pango_matrix_free(long self);

    static final void translate(Matrix self, double tx, double ty) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_matrix_translate(pointerOf(self), tx, ty);
        }
    }

    private static native final void pango_matrix_translate(long self, double tx, double ty);

    static final void scale(Matrix self, double scaleX, double scaleY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_matrix_scale(pointerOf(self), scaleX, scaleY);
        }
    }

    private static native final void pango_matrix_scale(long self, double scaleX, double scaleY);

    static final void rotate(Matrix self, double degrees) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_matrix_rotate(pointerOf(self), degrees);
        }
    }

    private static native final void pango_matrix_rotate(long self, double degrees);

    static final void concat(Matrix self, org.gnome.pango.Matrix newMatrix) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (newMatrix == null) {
            throw new IllegalArgumentException("newMatrix can't be null");
        }

        synchronized (lock) {
            pango_matrix_concat(pointerOf(self), pointerOf(newMatrix));
        }
    }

    private static native final void pango_matrix_concat(long self, long newMatrix);

    static final void transformPoint(Matrix self, double[] x, double[] y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        synchronized (lock) {
            pango_matrix_transform_point(pointerOf(self), x, y);
        }
    }

    private static native final void pango_matrix_transform_point(long self, double[] x, double[] y);

    static final void transformDistance(Matrix self, double[] dx, double[] dy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dx == null) {
            throw new IllegalArgumentException("dx can't be null");
        }

        if (dy == null) {
            throw new IllegalArgumentException("dy can't be null");
        }

        synchronized (lock) {
            pango_matrix_transform_distance(pointerOf(self), dx, dy);
        }
    }

    private static native final void pango_matrix_transform_distance(long self, double[] dx, double[] dy);

    static final void transformRectangle(Matrix self, Rectangle rect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rect == null) {
            throw new IllegalArgumentException("rect can't be null");
        }

        synchronized (lock) {
            pango_matrix_transform_rectangle(pointerOf(self), pointerOf(rect));
        }
    }

    private static native final void pango_matrix_transform_rectangle(long self, long rect);

    static final void transformPixelRectangle(Matrix self, Rectangle rect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rect == null) {
            throw new IllegalArgumentException("rect can't be null");
        }

        synchronized (lock) {
            pango_matrix_transform_pixel_rectangle(pointerOf(self), pointerOf(rect));
        }
    }

    private static native final void pango_matrix_transform_pixel_rectangle(long self, long rect);
}

