/*
 * PangoTabArray.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.pango.Plumbing;
import org.gnome.pango.TabAlign;
import org.gnome.pango.TabArray;

final class PangoTabArray extends Plumbing
{
    private PangoTabArray() {}

    static final long createTabArray(int initialSize, boolean positionsInPixels) {
        long result;

        synchronized (lock) {
            result = pango_tab_array_new(initialSize, positionsInPixels);

            return result;
        }
    }

    private static native final long pango_tab_array_new(int initialSize, boolean positionsInPixels);

    static final long createTabArrayWithPositions(int size, boolean positionsInPixels, TabAlign firstAlignment, int firstPosition) {
        long result;

        if (firstAlignment == null) {
            throw new IllegalArgumentException("firstAlignment can't be null");
        }

        synchronized (lock) {
            result = pango_tab_array_new_with_positions(size, positionsInPixels, numOf(firstAlignment), firstPosition);

            return result;
        }
    }

    private static native final long pango_tab_array_new_with_positions(int size, boolean positionsInPixels, int firstAlignment, int firstPosition);

    static final TabArray copy(TabArray self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_tab_array_copy(pointerOf(self));

            return (TabArray) boxedFor(TabArray.class, result);
        }
    }

    private static native final long pango_tab_array_copy(long self);

    static final void free(TabArray self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_tab_array_free(pointerOf(self));
        }
    }

    private static native final void pango_tab_array_free(long self);

    static final int getSize(TabArray self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_tab_array_get_size(pointerOf(self));

            return result;
        }
    }

    private static native final int pango_tab_array_get_size(long self);

    static final void resize(TabArray self, int newSize) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_tab_array_resize(pointerOf(self), newSize);
        }
    }

    private static native final void pango_tab_array_resize(long self, int newSize);

    static final void setTab(TabArray self, int tabIndex, TabAlign alignment, int location) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (alignment == null) {
            throw new IllegalArgumentException("alignment can't be null");
        }

        synchronized (lock) {
            pango_tab_array_set_tab(pointerOf(self), tabIndex, numOf(alignment), location);
        }
    }

    private static native final void pango_tab_array_set_tab(long self, int tabIndex, int alignment, int location);

    static final void getTab(TabArray self, int tabIndex, TabAlign[] alignment, int[] location) {
        int[] _alignment;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (alignment == null) {
            throw new IllegalArgumentException("alignment can't be null");
        }

        if (location == null) {
            throw new IllegalArgumentException("location can't be null");
        }

        _alignment = numsOf(alignment);

        synchronized (lock) {
            pango_tab_array_get_tab(pointerOf(self), tabIndex, _alignment, location);
            fillEnumArray(TabAlign.class, alignment, _alignment);
        }
    }

    private static native final void pango_tab_array_get_tab(long self, int tabIndex, int[] alignment, int[] location);

    static final void getTabs(TabArray self, FIXME alignments, FIXME locations) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoTabAlign**");
    }

    static final boolean getPositionsInPixels(TabArray self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_tab_array_get_positions_in_pixels(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_tab_array_get_positions_in_pixels(long self);
}

