/*
 * ScreenshotCapture.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.screenshot;

import org.gnome.gdk.Pixbuf;
import org.gnome.screenshot.Plumbing;

final class ScreenshotCapture extends Plumbing
{
    private ScreenshotCapture() {}

    static final Pixbuf capture(boolean windowOnly, boolean includeBorder, String borderEffect) {
        long result;

        if (borderEffect == null) {
            throw new IllegalArgumentException("borderEffect can't be null");
        }

        synchronized (lock) {
            result = gnome_screenshot_capture(windowOnly, includeBorder, borderEffect);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gnome_screenshot_capture(boolean windowOnly, boolean includeBorder, String borderEffect);
}

