/*
 * GtkSourceBuffer.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourcebuffer.h>
#include "bindings_java.h"
#include "org_gnome_sourceview_GtkSourceBuffer.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1new
(
	JNIEnv* env,
	jclass cls,
	jlong _table
)
{
	GtkSourceBuffer* result;
	jlong _result;
	GtkTextTagTable* table;

	// convert parameter table
	table = (GtkTextTagTable*) _table;

	// call function
	result = gtk_source_buffer_new(table);

	// cleanup parameter table

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1new_1with_1language
(
	JNIEnv* env,
	jclass cls,
	jlong _language
)
{
	GtkSourceBuffer* result;
	jlong _result;
	GtkSourceLanguage* language;

	// convert parameter language
	language = (GtkSourceLanguage*) _language;

	// call function
	result = gtk_source_buffer_new_with_language(language);

	// cleanup parameter language

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1get_1highlight_1syntax
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	result = gtk_source_buffer_get_highlight_syntax(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1set_1highlight_1syntax
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _highlight
)
{
	GtkSourceBuffer* self;
	gboolean highlight;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter highlight
	highlight = (gboolean) _highlight;

	// call function
	gtk_source_buffer_set_highlight_syntax(self, highlight);

	// cleanup parameter self

	// cleanup parameter highlight
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1get_1highlight_1matching_1brackets
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	result = gtk_source_buffer_get_highlight_matching_brackets(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1set_1highlight_1matching_1brackets
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _highlight
)
{
	GtkSourceBuffer* self;
	gboolean highlight;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter highlight
	highlight = (gboolean) _highlight;

	// call function
	gtk_source_buffer_set_highlight_matching_brackets(self, highlight);

	// cleanup parameter self

	// cleanup parameter highlight
}

JNIEXPORT jint JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1get_1max_1undo_1levels
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gint result;
	jint _result;
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	result = gtk_source_buffer_get_max_undo_levels(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1set_1max_1undo_1levels
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _maxUndoLevels
)
{
	GtkSourceBuffer* self;
	gint maxUndoLevels;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter maxUndoLevels
	maxUndoLevels = (gint) _maxUndoLevels;

	// call function
	gtk_source_buffer_set_max_undo_levels(self, maxUndoLevels);

	// cleanup parameter self

	// cleanup parameter maxUndoLevels
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1get_1language
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceLanguage* result;
	jlong _result;
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	result = gtk_source_buffer_get_language(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1set_1language
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _language
)
{
	GtkSourceBuffer* self;
	GtkSourceLanguage* language;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter language
	language = (GtkSourceLanguage*) _language;

	// call function
	gtk_source_buffer_set_language(self, language);

	// cleanup parameter self

	// cleanup parameter language
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1can_1undo
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	result = gtk_source_buffer_can_undo(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1can_1redo
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	result = gtk_source_buffer_can_redo(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1undo
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	gtk_source_buffer_undo(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1redo
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	gtk_source_buffer_redo(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1begin_1not_1undoable_1action
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	gtk_source_buffer_begin_not_undoable_action(self);

	// cleanup parameter self
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1end_1not_1undoable_1action
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	gtk_source_buffer_end_not_undoable_action(self);

	// cleanup parameter self
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1get_1style_1scheme
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceStyleScheme* result;
	jlong _result;
	GtkSourceBuffer* self;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// call function
	result = gtk_source_buffer_get_style_scheme(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1set_1style_1scheme
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _scheme
)
{
	GtkSourceBuffer* self;
	GtkSourceStyleScheme* scheme;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter scheme
	scheme = (GtkSourceStyleScheme*) _scheme;

	// call function
	gtk_source_buffer_set_style_scheme(self, scheme);

	// cleanup parameter self

	// cleanup parameter scheme
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1ensure_1highlight
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _start,
	jlong _end
)
{
	GtkSourceBuffer* self;
	GtkTextIter* start;
	GtkTextIter* end;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter start
	start = (GtkTextIter*) _start;

	// convert parameter end
	end = (GtkTextIter*) _end;

	// call function
	gtk_source_buffer_ensure_highlight(self, start, end);

	// cleanup parameter self

	// cleanup parameter start

	// cleanup parameter end
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1create_1source_1mark
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name,
	jstring _category,
	jlong _where
)
{
	GtkSourceMark* result;
	jlong _result;
	GtkSourceBuffer* self;
	const gchar* name;
	const gchar* category;
	const GtkTextIter* where;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter name
	if (_name == NULL) {
		name = NULL;
	} else {
		name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
		if (name == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return 0L; // Java Exception already thrown
	}

	// convert parameter where
	where = (const GtkTextIter*) _where;

	// call function
	result = gtk_source_buffer_create_source_mark(self, name, category, where);

	// cleanup parameter self

	// cleanup parameter name
	if (name != NULL) {
		(*env)->ReleaseStringUTFChars(env, _name, name);
	}

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// cleanup parameter where

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1forward_1iter_1to_1source_1mark
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jstring _category
)
{
	gboolean result;
	jboolean _result;
	GtkSourceBuffer* self;
	GtkTextIter* iter;
	const gchar* category;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter iter
	iter = (GtkTextIter*) _iter;

	// convert parameter category
	if (_category == NULL) {
		category = NULL;
	} else {
		category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
		if (category == NULL) {
			return  JNI_FALSE; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_source_buffer_forward_iter_to_source_mark(self, iter, category);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter category
	if (category != NULL) {
		(*env)->ReleaseStringUTFChars(env, _category, category);
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1backward_1iter_1to_1source_1mark
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _iter,
	jstring _category
)
{
	gboolean result;
	jboolean _result;
	GtkSourceBuffer* self;
	GtkTextIter* iter;
	const gchar* category;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter iter
	iter = (GtkTextIter*) _iter;

	// convert parameter category
	if (_category == NULL) {
		category = NULL;
	} else {
		category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
		if (category == NULL) {
			return  JNI_FALSE; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_source_buffer_backward_iter_to_source_mark(self, iter, category);

	// cleanup parameter self

	// cleanup parameter iter

	// cleanup parameter category
	if (category != NULL) {
		(*env)->ReleaseStringUTFChars(env, _category, category);
	}

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceBuffer_gtk_1source_1buffer_1remove_1source_1marks
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jlong _start,
	jlong _end,
	jstring _category
)
{
	GtkSourceBuffer* self;
	GtkTextIter* start;
	GtkTextIter* end;
	const gchar* category;

	// convert parameter self
	self = (GtkSourceBuffer*) _self;

	// convert parameter start
	start = (GtkTextIter*) _start;

	// convert parameter end
	end = (GtkTextIter*) _end;

	// convert parameter category
	if (_category == NULL) {
		category = NULL;
	} else {
		category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
		if (category == NULL) {
			return; // Java Exception already thrown
		}
	}

	// call function
	gtk_source_buffer_remove_source_marks(self, start, end, category);

	// cleanup parameter self

	// cleanup parameter start

	// cleanup parameter end

	// cleanup parameter category
	if (category != NULL) {
		(*env)->ReleaseStringUTFChars(env, _category, category);
	}
}
