/*
 * GtkSourceLanguageManager.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourcelanguagemanager.h>
#include "bindings_java.h"
#include "org_gnome_sourceview_GtkSourceLanguageManager.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceLanguageManager_gtk_1source_1language_1manager_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkSourceLanguageManager* result;
	jlong _result;

	// call function
	result = gtk_source_language_manager_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceLanguageManager_gtk_1source_1language_1manager_1get_1default
(
	JNIEnv* env,
	jclass cls
)
{
	GtkSourceLanguageManager* result;
	jlong _result;

	// call function
	result = gtk_source_language_manager_get_default();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceLanguageManager_gtk_1source_1language_1manager_1get_1language_1ids
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar** result;
	jobjectArray _result;
	GtkSourceLanguageManager* self;

	// convert parameter self
	self = (GtkSourceLanguageManager*) _self;

	// call function
	result = gtk_source_language_manager_get_language_ids(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceLanguageManager_gtk_1source_1language_1manager_1get_1language
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _id
)
{
	GtkSourceLanguage* result;
	jlong _result;
	GtkSourceLanguageManager* self;
	const gchar* id;

	// convert parameter self
	self = (GtkSourceLanguageManager*) _self;

	// convert parameter id
	id = (const gchar*) (*env)->GetStringUTFChars(env, _id, NULL);
	if (id == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_source_language_manager_get_language(self, id);

	// cleanup parameter self

	// cleanup parameter id
	(*env)->ReleaseStringUTFChars(env, _id, id);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceLanguageManager_gtk_1source_1language_1manager_1get_1search_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar** result;
	jobjectArray _result;
	GtkSourceLanguageManager* self;

	// convert parameter self
	self = (GtkSourceLanguageManager*) _self;

	// call function
	result = gtk_source_language_manager_get_search_path(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceLanguageManager_gtk_1source_1language_1manager_1set_1search_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jobjectArray _dirs
)
{
	GtkSourceLanguageManager* self;
	gchar** dirs;

	// convert parameter self
	self = (GtkSourceLanguageManager*) _self;

	// convert parameter dirs
	dirs = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _dirs);
	if (dirs == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_source_language_manager_set_search_path(self, dirs);

	// cleanup parameter self

	// cleanup parameter dirs
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)dirs, _dirs);
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceLanguageManager_gtk_1source_1language_1manager_1guess_1language
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _filename,
	jstring _contentType
)
{
	GtkSourceLanguage* result;
	jlong _result;
	GtkSourceLanguageManager* self;
	const gchar* filename;
	const gchar* contentType;

	// convert parameter self
	self = (GtkSourceLanguageManager*) _self;

	// convert parameter filename
	if (_filename == NULL) {
		filename = NULL;
	} else {
		filename = (const gchar*) (*env)->GetStringUTFChars(env, _filename, NULL);
		if (filename == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter contentType
	if (_contentType == NULL) {
		contentType = NULL;
	} else {
		contentType = (const gchar*) (*env)->GetStringUTFChars(env, _contentType, NULL);
		if (contentType == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_source_language_manager_guess_language(self, filename, contentType);

	// cleanup parameter self

	// cleanup parameter filename
	if (filename != NULL) {
		(*env)->ReleaseStringUTFChars(env, _filename, filename);
	}

	// cleanup parameter contentType
	if (contentType != NULL) {
		(*env)->ReleaseStringUTFChars(env, _contentType, contentType);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
