/*
 * GtkSourceMark.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.sourceview;

import org.gnome.sourceview.Mark;
import org.gnome.sourceview.Plumbing;

final class GtkSourceMark extends Plumbing
{
    private GtkSourceMark() {}

    static final long createMark(String name, String category) {
        long result;

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        synchronized (lock) {
            result = gtk_source_mark_new(name, category);

            return result;
        }
    }

    private static native final long gtk_source_mark_new(String name, String category);

    static final String getCategory(Mark self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_mark_get_category(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_mark_get_category(long self);

    static final Mark next(Mark self, String category) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_mark_next(pointerOf(self), category);

            return (Mark) objectFor(result);
        }
    }

    private static native final long gtk_source_mark_next(long self, String category);

    static final Mark prev(Mark self, String category) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_mark_prev(pointerOf(self), category);

            return (Mark) objectFor(result);
        }
    }

    private static native final long gtk_source_mark_prev(long self, String category);
}

