/*
 * GtkSourceStyleScheme.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourcestylescheme.h>
#include "bindings_java.h"
#include "org_gnome_sourceview_GtkSourceStyleScheme.h"

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceStyleScheme_gtk_1source_1style_1scheme_1get_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceStyleScheme* self;

	// convert parameter self
	self = (GtkSourceStyleScheme*) _self;

	// call function
	result = gtk_source_style_scheme_get_id(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceStyleScheme_gtk_1source_1style_1scheme_1get_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceStyleScheme* self;

	// convert parameter self
	self = (GtkSourceStyleScheme*) _self;

	// call function
	result = gtk_source_style_scheme_get_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceStyleScheme_gtk_1source_1style_1scheme_1get_1description
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceStyleScheme* self;

	// convert parameter self
	self = (GtkSourceStyleScheme*) _self;

	// call function
	result = gtk_source_style_scheme_get_description(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceStyleScheme_gtk_1source_1style_1scheme_1get_1authors
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar** result;
	jobjectArray _result;
	GtkSourceStyleScheme* self;

	// convert parameter self
	self = (GtkSourceStyleScheme*) _self;

	// call function
	result = gtk_source_style_scheme_get_authors(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceStyleScheme_gtk_1source_1style_1scheme_1get_1filename
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceStyleScheme* self;

	// convert parameter self
	self = (GtkSourceStyleScheme*) _self;

	// call function
	result = gtk_source_style_scheme_get_filename(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceStyleScheme_gtk_1source_1style_1scheme_1get_1style
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _styleName
)
{
	GtkSourceStyle* result;
	jlong _result;
	GtkSourceStyleScheme* self;
	const gchar* styleName;

	// convert parameter self
	self = (GtkSourceStyleScheme*) _self;

	// convert parameter styleName
	styleName = (const gchar*) (*env)->GetStringUTFChars(env, _styleName, NULL);
	if (styleName == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_source_style_scheme_get_style(self, styleName);

	// cleanup parameter self

	// cleanup parameter styleName
	(*env)->ReleaseStringUTFChars(env, _styleName, styleName);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
