/*
 * GtkSourceStyleScheme.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.sourceview;

import org.gnome.sourceview.Plumbing;
import org.gnome.sourceview.Style;
import org.gnome.sourceview.StyleScheme;

final class GtkSourceStyleScheme extends Plumbing
{
    private GtkSourceStyleScheme() {}

    static final String getId(StyleScheme self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_get_id(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_style_scheme_get_id(long self);

    static final String getName(StyleScheme self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_style_scheme_get_name(long self);

    static final String getDescription(StyleScheme self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_get_description(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_style_scheme_get_description(long self);

    static final String[] getAuthors(StyleScheme self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_get_authors(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_style_scheme_get_authors(long self);

    static final String getFilename(StyleScheme self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_get_filename(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_style_scheme_get_filename(long self);

    static final Style getStyle(StyleScheme self, String styleName) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (styleName == null) {
            throw new IllegalArgumentException("styleName can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_get_style(pointerOf(self), styleName);

            return (Style) objectFor(result);
        }
    }

    private static native final long gtk_source_style_scheme_get_style(long self, String styleName);
}

