/*
 * GtkSourceStyleSchemeManager.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourcestyleschememanager.h>
#include "bindings_java.h"
#include "org_gnome_sourceview_GtkSourceStyleSchemeManager.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkSourceStyleSchemeManager* result;
	jlong _result;

	// call function
	result = gtk_source_style_scheme_manager_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1set_1search_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jobjectArray _path
)
{
	GtkSourceStyleSchemeManager* self;
	gchar** path;

	// convert parameter self
	self = (GtkSourceStyleSchemeManager*) _self;

	// convert parameter path
	path = (gchar**) bindings_java_convert_strarray_to_gchararray(env, _path);
	if (path == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_source_style_scheme_manager_set_search_path(self, path);

	// cleanup parameter self

	// cleanup parameter path
	bindings_java_convert_gchararray_to_strarray(env, (gchar**)path, _path);
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1get_1search_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar** result;
	jobjectArray _result;
	GtkSourceStyleSchemeManager* self;

	// convert parameter self
	self = (GtkSourceStyleSchemeManager*) _self;

	// call function
	result = gtk_source_style_scheme_manager_get_search_path(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1append_1search_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _path
)
{
	GtkSourceStyleSchemeManager* self;
	const gchar* path;

	// convert parameter self
	self = (GtkSourceStyleSchemeManager*) _self;

	// convert parameter path
	path = (const gchar*) (*env)->GetStringUTFChars(env, _path, NULL);
	if (path == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_source_style_scheme_manager_append_search_path(self, path);

	// cleanup parameter self

	// cleanup parameter path
	(*env)->ReleaseStringUTFChars(env, _path, path);
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1prepend_1search_1path
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _path
)
{
	GtkSourceStyleSchemeManager* self;
	const gchar* path;

	// convert parameter self
	self = (GtkSourceStyleSchemeManager*) _self;

	// convert parameter path
	path = (const gchar*) (*env)->GetStringUTFChars(env, _path, NULL);
	if (path == NULL) {
		return; // Java Exception already thrown
	}

	// call function
	gtk_source_style_scheme_manager_prepend_search_path(self, path);

	// cleanup parameter self

	// cleanup parameter path
	(*env)->ReleaseStringUTFChars(env, _path, path);
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1get_1scheme_1ids
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar** result;
	jobjectArray _result;
	GtkSourceStyleSchemeManager* self;

	// convert parameter self
	self = (GtkSourceStyleSchemeManager*) _self;

	// call function
	result = gtk_source_style_scheme_manager_get_scheme_ids(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1get_1scheme
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _schemeId
)
{
	GtkSourceStyleScheme* result;
	jlong _result;
	GtkSourceStyleSchemeManager* self;
	const gchar* schemeId;

	// convert parameter self
	self = (GtkSourceStyleSchemeManager*) _self;

	// convert parameter schemeId
	schemeId = (const gchar*) (*env)->GetStringUTFChars(env, _schemeId, NULL);
	if (schemeId == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_source_style_scheme_manager_get_scheme(self, schemeId);

	// cleanup parameter self

	// cleanup parameter schemeId
	(*env)->ReleaseStringUTFChars(env, _schemeId, schemeId);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceStyleSchemeManager_gtk_1source_1style_1scheme_1manager_1force_1rescan
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceStyleSchemeManager* self;

	// convert parameter self
	self = (GtkSourceStyleSchemeManager*) _self;

	// call function
	gtk_source_style_scheme_manager_force_rescan(self);

	// cleanup parameter self
}
