/*
 * GtkSourceView.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.sourceview;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Color;
import org.gnome.gdk.Pixbuf;
import org.gnome.glib.Signal;
import org.gnome.sourceview.Plumbing;
import org.gnome.sourceview.SmartHomeEndType;
import org.gnome.sourceview.SourceBuffer;
import org.gnome.sourceview.SourceView;

final class GtkSourceView extends Plumbing
{
    private GtkSourceView() {}

    static final long createSourceView() {
        long result;

        synchronized (lock) {
            result = gtk_source_view_new();

            return result;
        }
    }

    private static native final long gtk_source_view_new();

    static final long createSourceViewWithBuffer(SourceBuffer buffer) {
        long result;

        if (buffer == null) {
            throw new IllegalArgumentException("buffer can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_new_with_buffer(pointerOf(buffer));

            return result;
        }
    }

    private static native final long gtk_source_view_new_with_buffer(long buffer);

    static final void setShowLineNumbers(SourceView self, boolean show) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_show_line_numbers(pointerOf(self), show);
        }
    }

    private static native final void gtk_source_view_set_show_line_numbers(long self, boolean show);

    static final boolean getShowLineNumbers(SourceView self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_show_line_numbers(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_show_line_numbers(long self);

    static final void setIndentWidth(SourceView self, int width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_indent_width(pointerOf(self), width);
        }
    }

    private static native final void gtk_source_view_set_indent_width(long self, int width);

    static final int getIndentWidth(SourceView self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_indent_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_source_view_get_indent_width(long self);

    static final void setTabWidth(SourceView self, int width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_tab_width(pointerOf(self), width);
        }
    }

    private static native final void gtk_source_view_set_tab_width(long self, int width);

    static final int getTabWidth(SourceView self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_tab_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_source_view_get_tab_width(long self);

    static final void setAutoIndent(SourceView self, boolean enable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_auto_indent(pointerOf(self), enable);
        }
    }

    private static native final void gtk_source_view_set_auto_indent(long self, boolean enable);

    static final boolean getAutoIndent(SourceView self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_auto_indent(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_auto_indent(long self);

    static final void setInsertSpacesInsteadOfTabs(SourceView self, boolean enable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_insert_spaces_instead_of_tabs(pointerOf(self), enable);
        }
    }

    private static native final void gtk_source_view_set_insert_spaces_instead_of_tabs(long self, boolean enable);

    static final boolean getInsertSpacesInsteadOfTabs(SourceView self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_insert_spaces_instead_of_tabs(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_insert_spaces_instead_of_tabs(long self);

    static final void setIndentOnTab(SourceView self, boolean enable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_indent_on_tab(pointerOf(self), enable);
        }
    }

    private static native final void gtk_source_view_set_indent_on_tab(long self, boolean enable);

    static final boolean getIndentOnTab(SourceView self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_indent_on_tab(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_indent_on_tab(long self);

    static final void setHighlightCurrentLine(SourceView self, boolean show) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_highlight_current_line(pointerOf(self), show);
        }
    }

    private static native final void gtk_source_view_set_highlight_current_line(long self, boolean show);

    static final boolean getHighlightCurrentLine(SourceView self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_highlight_current_line(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_highlight_current_line(long self);

    static final void setShowRightMargin(SourceView self, boolean show) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_show_right_margin(pointerOf(self), show);
        }
    }

    private static native final void gtk_source_view_set_show_right_margin(long self, boolean show);

    static final boolean getShowRightMargin(SourceView self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_show_right_margin(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_show_right_margin(long self);

    static final void setRightMarginPosition(SourceView self, int pos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_right_margin_position(pointerOf(self), pos);
        }
    }

    private static native final void gtk_source_view_set_right_margin_position(long self, int pos);

    static final int getRightMarginPosition(SourceView self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_right_margin_position(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_source_view_get_right_margin_position(long self);

    static final void setShowLineMarks(SourceView self, boolean show) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_show_line_marks(pointerOf(self), show);
        }
    }

    private static native final void gtk_source_view_set_show_line_marks(long self, boolean show);

    static final boolean getShowLineMarks(SourceView self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_show_line_marks(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_show_line_marks(long self);

    static final void setMarkCategoryPixbuf(SourceView self, String category, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_mark_category_pixbuf(pointerOf(self), category, pointerOf(pixbuf));
        }
    }

    private static native final void gtk_source_view_set_mark_category_pixbuf(long self, String category, long pixbuf);

    static final Pixbuf getMarkCategoryPixbuf(SourceView self, String category) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_mark_category_pixbuf(pointerOf(self), category);

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_source_view_get_mark_category_pixbuf(long self, String category);

    static final void setMarkCategoryPriority(SourceView self, String category, int priority) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_mark_category_priority(pointerOf(self), category, priority);
        }
    }

    private static native final void gtk_source_view_set_mark_category_priority(long self, String category, int priority);

    static final int getMarkCategoryPriority(SourceView self, String category) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_mark_category_priority(pointerOf(self), category);

            return result;
        }
    }

    private static native final int gtk_source_view_get_mark_category_priority(long self, String category);

    static final void setSmartHomeEnd(SourceView self, SmartHomeEndType smartHe) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (smartHe == null) {
            throw new IllegalArgumentException("smartHe can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_smart_home_end(pointerOf(self), numOf(smartHe));
        }
    }

    private static native final void gtk_source_view_set_smart_home_end(long self, int smartHe);

    static final SmartHomeEndType getSmartHomeEnd(SourceView self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_smart_home_end(pointerOf(self));

            return (SmartHomeEndType) enumFor(SmartHomeEndType.class, result);
        }
    }

    private static native final int gtk_source_view_get_smart_home_end(long self);

    static final void setDrawSpaces(SourceView self, FIXME flags) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkSourceDrawSpacesFlags");
    }

    static final FIXME getDrawSpaces(SourceView self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkSourceDrawSpacesFlags");
    }

    static final void setMarkCategoryBackground(SourceView self, String category, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        synchronized (lock) {
            gtk_source_view_set_mark_category_background(pointerOf(self), category, pointerOf(color));
        }
    }

    private static native final void gtk_source_view_set_mark_category_background(long self, String category, long color);

    static final boolean getMarkCategoryBackground(SourceView self, String category, org.gnome.gdk.Color dest) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        synchronized (lock) {
            result = gtk_source_view_get_mark_category_background(pointerOf(self), category, pointerOf(dest));

            return result;
        }
    }

    private static native final boolean gtk_source_view_get_mark_category_background(long self, String category, long dest);

    interface UndoSignal extends Signal
    {
        void onUndo(SourceView source);
    }

    static final void connect(SourceView self, GtkSourceView.UndoSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkSourceView.class, "undo", after);
    }

    protected static final void receiveUndo(Signal handler, long source) {
        ((GtkSourceView.UndoSignal) handler).onUndo((SourceView) objectFor(source));
    }

    interface RedoSignal extends Signal
    {
        void onRedo(SourceView source);
    }

    static final void connect(SourceView self, GtkSourceView.RedoSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkSourceView.class, "redo", after);
    }

    protected static final void receiveRedo(Signal handler, long source) {
        ((GtkSourceView.RedoSignal) handler).onRedo((SourceView) objectFor(source));
    }
}

