/*
 * GtkPrintJob.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.unixprint;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.freedesktop.cairo.Surface;
import org.gnome.glib.GlibException;
import org.gnome.glib.Signal;
import org.gnome.gtk.PageSetup;
import org.gnome.gtk.PrintSettings;
import org.gnome.gtk.PrintStatus;
import org.gnome.unixprint.Plumbing;
import org.gnome.unixprint.PrintJob;
import org.gnome.unixprint.Printer;

final class GtkPrintJob extends Plumbing
{
    private GtkPrintJob() {}

    static final long createPrintJob(String title, Printer printer, PrintSettings settings, PageSetup pageSetup) {
        long result;

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        if (printer == null) {
            throw new IllegalArgumentException("printer can't be null");
        }

        if (settings == null) {
            throw new IllegalArgumentException("settings can't be null");
        }

        if (pageSetup == null) {
            throw new IllegalArgumentException("pageSetup can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_new(title, pointerOf(printer), pointerOf(settings), pointerOf(pageSetup));

            return result;
        }
    }

    private static native final long gtk_print_job_new(String title, long printer, long settings, long pageSetup);

    static final PrintSettings getSettings(PrintJob self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_get_settings(pointerOf(self));

            return (PrintSettings) objectFor(result);
        }
    }

    private static native final long gtk_print_job_get_settings(long self);

    static final Printer getPrinter(PrintJob self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_get_printer(pointerOf(self));

            return (Printer) objectFor(result);
        }
    }

    private static native final long gtk_print_job_get_printer(long self);

    static final String getTitle(PrintJob self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_print_job_get_title(long self);

    static final PrintStatus getStatus(PrintJob self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_get_status(pointerOf(self));

            return (PrintStatus) enumFor(PrintStatus.class, result);
        }
    }

    private static native final int gtk_print_job_get_status(long self);

    static final boolean setSourceFile(PrintJob self, String filename) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_set_source_file(pointerOf(self), filename);

            return result;
        }
    }

    private static native final boolean gtk_print_job_set_source_file(long self, String filename) throws GlibException;

    static final Surface getSurface(PrintJob self) throws GlibException {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_get_surface(pointerOf(self));

            return (Surface) entityFor(Surface.class,  result);
        }
    }

    private static native final long gtk_print_job_get_surface(long self) throws GlibException;

    static final void setTrackPrintStatus(PrintJob self, boolean trackStatus) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_job_set_track_print_status(pointerOf(self), trackStatus);
        }
    }

    private static native final void gtk_print_job_set_track_print_status(long self, boolean trackStatus);

    static final boolean getTrackPrintStatus(PrintJob self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_job_get_track_print_status(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_print_job_get_track_print_status(long self);

    static final boolean send(PrintJob self, FIXME callback, FIXME userData, FIXME dnotify) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkPrintJobCompleteFunc");
    }

    interface StatusChangedSignal extends Signal
    {
        void onStatusChanged(PrintJob source);
    }

    static final void connect(PrintJob self, GtkPrintJob.StatusChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintJob.class, "status-changed", after);
    }

    protected static final void receiveStatusChanged(Signal handler, long source) {
        ((GtkPrintJob.StatusChangedSignal) handler).onStatusChanged((PrintJob) objectFor(source));
    }
}

