/*
 * GtkPrinter.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.unixprint;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.unixprint.Plumbing;
import org.gnome.unixprint.PrintCapabilities;
import org.gnome.unixprint.Printer;

final class GtkPrinter extends Plumbing
{
    private GtkPrinter() {}

    static final long createPrinter(String name, FIXME backend, boolean isVirtual) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkPrintBackend*");
    }

    static final FIXME getBackend(Printer self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkPrintBackend*");
    }

    static final String getName(Printer self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_printer_get_name(long self);

    static final String getStateMessage(Printer self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_get_state_message(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_printer_get_state_message(long self);

    static final String getDescription(Printer self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_get_description(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_printer_get_description(long self);

    static final String getLocation(Printer self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_get_location(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_printer_get_location(long self);

    static final String getIconName(Printer self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_get_icon_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_printer_get_icon_name(long self);

    static final int getJobCount(Printer self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_get_job_count(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_printer_get_job_count(long self);

    static final boolean isActive(Printer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_is_active(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_printer_is_active(long self);

    static final boolean isVirtual(Printer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_is_virtual(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_printer_is_virtual(long self);

    static final boolean isDefault(Printer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_is_default(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_printer_is_default(long self);

    static final boolean acceptsPdf(Printer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_accepts_pdf(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_printer_accepts_pdf(long self);

    static final boolean acceptsPs(Printer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_accepts_ps(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_printer_accepts_ps(long self);

    static final int compare(Printer self, Printer b) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (b == null) {
            throw new IllegalArgumentException("b can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_compare(pointerOf(self), pointerOf(b));

            return result;
        }
    }

    private static native final int gtk_printer_compare(long self, long b);

    static final PrintCapabilities getCapabilities(Printer self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_get_capabilities(pointerOf(self));

            return (PrintCapabilities) flagFor(PrintCapabilities.class, result);
        }
    }

    private static native final int gtk_printer_get_capabilities(long self);

    static final boolean hasDetails(Printer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_printer_has_details(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_printer_has_details(long self);

    static final FIXME listPapers(Printer self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList*");
    }

    static final void requestDetails(Printer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_printer_request_details(pointerOf(self));
        }
    }

    private static native final void gtk_printer_request_details(long self);

    interface DetailsAcquiredSignal extends Signal
    {
        void onDetailsAcquired(Printer source, boolean success);
    }

    static final void connect(Printer self, GtkPrinter.DetailsAcquiredSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrinter.class, "details-acquired", after);
    }

    protected static final void receiveDetailsAcquired(Signal handler, long source, boolean success) {
        ((GtkPrinter.DetailsAcquiredSignal) handler).onDetailsAcquired((Printer) objectFor(source), success);
    }
}

