package org.eclipse.swt.tests.junit;

import java.io.PrintWriter;
import java.io.PrintStream;
import java.io.StringWriter;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import junit.framework.AssertionFailedError;
import junit.framework.Test;
import junit.framework.TestListener;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.File;

public class SWTTestListener implements TestListener
{
	private String currentClass = null;
	private boolean failed;

	public SWTTestListener(){
	}
	public void addError(Test test, Throwable t){
		System.out.println("[ERROR] " + t.toString());
		failed = true;
	}

	public void addFailure(Test test, AssertionFailedError t){
		System.out.println("[FAIL]  " + t.getMessage());
		failed = true;
	}

	private static Pattern regex = Pattern.compile("\\(.*\\)");
	public void startTest(Test test){
		failed = false;
		String testClassName = test.getClass().getName();
		if ((currentClass == null) || (!(currentClass.equals(testClassName)))){
			currentClass = testClassName;
			System.out.println(" ------- " + currentClass);
		}

		Matcher m = regex.matcher(test.toString());
		String testCaseName = m.replaceFirst("()");
		System.out.print(testCaseName + "   ");
		
		try {
			PrintWriter out_ts = new PrintWriter(new BufferedWriter(new FileWriter("testcase.total.temp", true)));
			out_ts.println(test.toString());
			out_ts.close();
		} catch (IOException e){
		}
	}

	public void endTest(Test test){
		if (failed) {
			return;
		}
		System.out.println("[PASS]");
	
		try {
			PrintWriter out_ts = new PrintWriter(new BufferedWriter(new FileWriter("testcase.pass.temp", true)));
			out_ts.println(test.toString());
			out_ts.close();
		} catch (IOException e){
		}
	}
}
