package org.eclipse.swt.tests.junit;

import junit.framework.*;
import junit.textui.*;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.widgets.*;
import java.util.Vector;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;

public class bug419729 extends SwtTestCase{
	public bug419729(String name){
		super(name);
	}

	public static void main(String[] args){
		TestRunner.run(suite());
	}

	protected void setUp(){
	}
		
	protected void tearDown(){
	}

	public static Test suite(){
		TestSuite suite = new TestSuite();
		java.util.Vector methodNames = methodNames();
		//java.util.Vector methodNames = new java.util.Vector();
		//methodNames.addElement("test_bug419729");
		java.util.Enumeration e = methodNames.elements();
		while (e.hasMoreElements()){
			suite.addTest(new bug419729((String)e.nextElement()));
		}
		return suite;
	}
	
	public static java.util.Vector methodNames(){
		java.util.Vector methodNames = new java.util.Vector();
		methodNames.addElement("test_bug419729");
		return methodNames;
	}

	public void test_bug419729(){
		final int SEND_EVENT = 0;
		final int RECEIVE_EVENT = 1;
		final int SEND_MENU_SHOW = 2;
		final int RECV_MENU_SHOW = 3;
		final int SEND_RADIO_SEL = 4;
		final int RECV_RADIO_SEL = 5;

		final boolean[] ActivateEvent = new boolean[] { false, false, false, false, false, false };

		final Display display = new Display();

		final Shell shell = new Shell(display);
		shell.setLayout(new FillLayout());

		final Menu menuBar = new Menu(shell, SWT.BAR);
		final MenuItem fileMenuBarItem = createMenuItem(SWT.CASCADE, "File", menuBar);
		final Menu fileMenu = new Menu(shell, SWT.DROP_DOWN);
		fileMenu.addListener(SWT.Show, new Listener() {

			@Override
			public void handleEvent(Event e) {
				if (ActivateEvent[SEND_MENU_SHOW])
			ActivateEvent[RECV_MENU_SHOW] = true;
			}
		});

		fileMenuBarItem.setMenu(fileMenu);
		shell.setMenuBar(menuBar);
		assertTrue(shell.getMenuBar() == menuBar);

		shell.addListener(SWT.Activate, new Listener() {
			@Override
			public void handleEvent(Event event) {
				if (ActivateEvent[SEND_EVENT])
			ActivateEvent[RECEIVE_EVENT] = true;

		final MenuItem[] items = fileMenu.getItems();
		for (MenuItem item : items) {
			item.dispose();
		}

		MenuItem pushItem = createMenuItem(SWT.PUSH, "Push", fileMenu);
		MenuItem checkItem = createMenuItem(SWT.CHECK, "Check", fileMenu);
		MenuItem radioItem = createMenuItem(SWT.RADIO, "Radio", fileMenu);
		radioItem.addListener(SWT.Selection, new Listener() {
			@Override
			public void handleEvent(Event event) {
				// System.err.println("Radio.Selection");
				if (ActivateEvent[SEND_RADIO_SEL])
			ActivateEvent[RECV_RADIO_SEL] = true;
			}
		});

		for (MenuItem item : fileMenu.getItems()) {
			if (item.getStyle() == SWT.CHECK || item.getStyle() == SWT.RADIO) {
				item.setSelection(false);
				assertEquals(item.getSelection(), false);
				item.setSelection(true);
				assertTrue(item.getSelection());
			}
		}

			}
		});

		final Menu menu = new Menu(shell, SWT.POP_UP);
		createMenuItem(SWT.PUSH, "Push", menu);
		createMenuItem(SWT.CHECK, "Check", menu);
		createMenuItem(SWT.RADIO, "Radio", menu);

		final Button button = new Button(shell, SWT.PUSH);
		button.setText("Click Me");
		button.addListener(SWT.Selection, new Listener() {
			@Override
			public void handleEvent(Event event) {
				final Point location = display.map(button.getParent(), null, button.getLocation());
				final Point size = button.getSize();
				menu.setLocation(location.x, location.y + size.y);
				menu.setVisible(true);
			}
		});




		//////////////
		//Test Start
		//////////////




		long startTime;
		shell.setSize(shell.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		shell.open();
		{
			startTime = System.currentTimeMillis();
			while(System.currentTimeMillis() - startTime < 2000){
				if(!display.readAndDispatch())
					display.sleep();
			}
		}

		ActivateEvent[SEND_EVENT] = true;
		shell.notifyListeners(SWT.Activate, null);
		{
			/*
			   startTime = System.currentTimeMillis();
			   while(System.currentTimeMillis() - startTime < 2000){
			   if(!display.readAndDispatch())
			   display.sleep();
			   }
			 */
		}


		assertTrue(ActivateEvent[SEND_EVENT]);

		while(ActivateEvent[RECEIVE_EVENT] == false){
			if(!display.readAndDispatch())
				display.sleep();
		}
		//assertTrue(ActivateEvent[RECEIVE_EVENT]);

		for (MenuItem item : fileMenu.getItems()) {
			if (item.getStyle() == SWT.RADIO)
				assertTrue(item.getSelection());
		}

		////////////////////////////////////////////////////////RADIO BUTTON TEST


		System.err.println("Creating slave threads for Mouse events...");

		new Thread(new Runnable() {

			@Override
			public void run() {
				try { Thread.sleep(1000);  } catch (Exception e) {}
				Event event;
				System.err.println("Clicking file Menu");
				ActivateEvent[SEND_MENU_SHOW] = true;

				event = new Event();
				event.type = SWT.MouseMove; 
				event.x = 85;
				event.y = 15;
				while(!display.post(event))
			System.err.println("MouseMove not posted");
		try {	Thread.sleep(200);	} catch (Exception e) {	}
		event = new Event();
		event.type = SWT.MouseDown;
		event.button = 1;
		while (!display.post(event)) 
			System.err.println("MouseDown not posted");
		try {	Thread.sleep(10);	} catch (Exception e) {	}
		event = new Event();
		event.type = SWT.MouseUp;
		event.button = 1;
		while (!display.post(event)) 
			System.err.println("MouseUp not posted");

		try {	Thread.sleep(1000);	} catch (Exception e) {	}

		System.err.println("Clicking radio button");
		ActivateEvent[SEND_RADIO_SEL] = true;

		event = new Event();
		event.type = SWT.MouseMove; 
		event.x = 85;
		event.y = 95;
		while (!display.post(event)) 
			System.err.println("MouseMove not posted");
		try {	Thread.sleep(200);	} catch (Exception e) {	}
		event = new Event();
		event.type = SWT.MouseDown;
		event.button = 1;
		while (!display.post(event)) 
			System.err.println("MouseDown not posted");
		try {	Thread.sleep(10);	} catch (Exception e) {	}
		event = new Event();
		event.type = SWT.MouseUp;
		event.button = 1;
		while (!display.post(event)) 
			System.err.println("MouseUp not posted");

		try {	Thread.sleep(1000);	} catch (Exception e) {	}
		System.err.println("Slave out");

			}
		}).start();



		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
			System.err.println("MENU:"+ActivateEvent[RECV_MENU_SHOW]);
			System.err.println("RADO:"+ActivateEvent[RECV_RADIO_SEL]);
			if(ActivateEvent[RECV_RADIO_SEL] && ActivateEvent[RECV_MENU_SHOW])
				break;
		}

		/*
		 * System.err.println(MouseInfo.getPointerInfo().getLocation().getX());
		 * System.err.println(MouseInfo.getPointerInfo().getLocation().getY());
		 */

		////////////////////////////////////WRAP_UP
		menu.dispose();
		display.dispose();
	}
	/*
		Display display = new Display();
		Shell shell = new Shell(display);
		shell.setLayout(new FillLayout());

		Menu menuBar = new Menu(shell, SWT.BAR);
		MenuItem fileMenuBarItem = createMenuItem(SWT.CASCADE, "File", menuBar);
		final Menu fileMenu = new Menu(shell, SWT.DROP_DOWN);
		fileMenuBarItem.setMenu(fileMenu);
		shell.setMenuBar(menuBar);

		shell.addListener(SWT.Activate, new Listener() {
				@Override
				public void handleEvent(Event event) {
				for (MenuItem item : fileMenu.getItems()) {
					item.dispose();
				}
		//		createMenuItem(SWT.PUSH, "Push", fileMenu);
		//		createMenuItem(SWT.CHECK, "Check", fileMenu);
				createMenuItem(SWT.RADIO, "Radio", fileMenu);
				}
				});

		   final Menu menu = new Menu(shell, SWT.POP_UP);
		   createMenuItem(SWT.PUSH, "Push", menu);
		   createMenuItem(SWT.CHECK, "Check", menu);
		   createMenuItem(SWT.RADIO, "Radio", menu);

		   final Button button = new Button(shell, SWT.PUSH);
		   button.setText("Click Me");
		   button.addListener(SWT.Selection, new Listener() {
		   @Override
		   public void handleEvent(Event event) {
		   final Point location = display.map(button.getParent(), null, button.getLocation());
		   final Point size = button.getSize();
		   menu.setLocation(location.x, location.y + size.y);
		   menu.setVisible(true);
		   }
		   });

		shell.setSize(shell.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		shell.open();

		int i=0;
		while (!shell.isDisposed()) {
			shell.sendEvent(SWT.Activate, null, true);
			if (!display.readAndDispatch()) {
				display.sleep();
			}
			if (i == 100)
				break;
			else
				i++;
		}
		display.dispose();
	}
		 */

	private MenuItem createMenuItem(int style, String text, Menu menu) 
	{
		final MenuItem item = new MenuItem(menu, style);
		item.setText(text);
		return item;
	}
}
